//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                                     БАЗОВЫЕ ФУНКЦИИ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//=================================================================================================
//=================================================================================================
//                              Инициализация параметров
//=================================================================================================
void initProject(){
if(vInit){return;} vInit=1;
i2cAdrLcd1=0x27;                                //--Адрес i2c Lcd1;
i2cAdrLcd2=0x3E;                                //--Адрес i2c Lcd2;
spiCsLcd3        =RT_HW_Base.device.spi.cs1;    //--Номер пина SPI.cs Lcd3; 
pinControl       =RT_HW_Base.device.pin.control;//--Номер пина Control;
pinLed           =RT_HW_Base.device.pin.led;    //--Номер пина Led;
pinButton        =RT_HW_Base.device.pin.button; //--Номер пина Кнопки;
pinPWM           =RT_HW_Base.device.pin.pwm;    //--Номер пина PWM;
pinADC           =RT_HW_Base.device.pin.adc;    //--Номер пина ADC;
spiPinMAX6675cs  =RT_HW_Base.device.spi.cs3;    //--Номер пина SPI MAX6675.cs;
spnPinMAX6675sck =RT_HW_Base.readArrPGM(RT_HW_PGM_PIN_SPN_ID,0); //--сохранение пина SPN.sck;  
spnPinMAX6675miso=RT_HW_Base.readArrPGM(RT_HW_PGM_PIN_SPN_ID,1); //--сохранение пина SPN.miso;
spnPinMAX6675mosi=RT_HW_Base.readArrPGM(RT_HW_PGM_PIN_SPN_ID,2); //--сохранение пина SPN.mosi;  
spnPinMAX6675cs  =RT_HW_Base.readArrPGM(RT_HW_PGM_PIN_SPN_ID,3); //--сохранение пина SPN.cs;  
};
//=================================================================================================
//                              ВЫВОД НА КОНСОЛЬ ЗАГОЛОВКОВ 
//=================================================================================================
void consoleHead(){
RT_HW_Base.consoleCR(3);
RT_HW_Base.consoleHead(String(F("Main parameters")),'='); RT_HW_Base.mess.modePin='T'; RT_HW_Base.consoleBoardGeneral();   
RT_HW_Base.consoleHead(String(F("Add parameters")));      RT_HW_Base.mess.modePin='T'; RT_HW_Base.consoleBoardAdd(); 
RT_HW_Base.consoleHead(String(F("Task parameters")));     RT_HW_Base.consoleShedulerParameters();
//RT_HW_Base.consoleHead(String(F("PGM array")));           RT_HW_Base.mess.modePin='T'; RT_HW_Base.consoleFromPGM();
RT_HW_Base.consoleHead(String(F("Available pins")));      RT_HW_Base.mess.modePin='A'; RT_HW_Base.consolePinsAll();        
RT_HW_Base.consoleHead(String(F("Interface")));           RT_HW_Base.mess.modePin='T'; RT_HW_Base.consoleInterface(); 
RT_HW_Base.consoleHead(String(F("System & test pins")));  RT_HW_Base.mess.modePin='T'; RT_HW_Base.consolePinsSystem(); RT_HW_Base.consolePinsTest();  
RT_HW_Base.consoleHead(String(F("Scan i2c")));            RT_HW_Base.mess.modePin='T'; RT_HW_Base.i2cScanBus(0);   
RT_HW_Base.consoleLine('+'); 
}
//=====================================================================================================
//                              ОПРОС ADC, ЗАПИСЬ PWM
//=====================================================================================================
void fncADC(){
if(idPinADC.dir==0){idPinADC.pin=pinADC;}       //--Настройка ADC;
RT_HW_Base.pinAnalogRead(idPinADC);             //--Чтение ADC;
vADCF=filterADC.filtered(idPinADC.vNorm);       //--Фильтрация ADC;
vADCPrc=(uint32_t)vADCF*100/4095;               //--Преобразование ADC с фильтром 0-4095 в %(0-100);
};
//=====================================================================================================
//                              ЗАПИСЬ PWM
//=====================================================================================================
void fncPWM(){
if(idPinPWM.dir==0){idPinPWM.pin=pinPWM; idPinPWM.channel=0; idPinPWM.freq=1000; idPinPWM.depth=16;} //--Настройка PWM, freq=1000Hz,тип выхода('N','O')-нормальный; разрядность 16;
RT_HW_Base.pinPWM(idPinPWM,vADCF);  vPWM=idPinPWM.var;                                               //--Запись PWM;
};
//=====================================================================================================
//                              ОПРОС КНОПКИ
//=====================================================================================================
void fncButton(){
if(idPinButton.dir==0) {idPinButton.pin=pinButton; idPinButton.mode='U'; idChatButton.period=50;} //--Настройка параметров;
vButton=!RT_HW_Base.pinDigitalRead(idPinButton);           //--Чтение кнопки с подтянутым пином к Vcc;
vChatBut=RT_HW_Base.chatterV8(idChatButton,vButton);       //--Защита от дребезга значения с кнопки;
};
//=================================================================================================
//                              ГЕНЕРАТОРЫ ТЕСТОВЫХ ПЕРЕМЕННЫХ
//=================================================================================================
void fncGen(){
//-----------------------------Генератор бегущей единицы 1-8, пила 100ms ------------------------------
if(idCntRUN8.reset){RT_HW_Base.counterReset(idCntRUN8,8,1,1,1);}   //--init счетчика:верхняя(Top=8) граница, нижняя граница(Buttom=0),шаг изменения(Step=1); нач.знач.(Begin=0);
if(RT_HW_Base.generatorEvent(idGenRUN8,100)){genRUN8=RT_HW_Base.dc8(RT_HW_Base.counterT(idCntRUN8));}; //--Периодический(100ms) выполнение "Счетчик-Треугольник";            
//-----------------------------Генератор треугольника 0-4095 для DAC,100ms-----------------------------
if(idCntDAC.reset){RT_HW_Base.counterReset(idCntDAC,4095,0,100,0);}  //--init счетчика:верхняя(Top=4095) граница, нижняя граница(Buttom=0),шаг изменения(Step=100); нач.знач.(Begin=0);
if(RT_HW_Base.generatorEvent(idGenDAC,100)) {genDAC=RT_HW_Base.counterT(idCntDAC);}   //--Периодическое(100ms) выполнение "Счетчик-Треугольник";
};
//=====================================================================================================
