//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                                     СЕНСОРЫ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//=================================================================================================
//                                      DHT22 через pin
//=================================================================================================
void sns_DHT22(){
if(shedDHT22.custom==0){RT_HW_Base.setTaskID(shedDHT22,2200);}          //--Настройка периодического вызова с периодом 2200ms;
if(devDHT22.custom==0){devDHT22.setParam(RT_HW_Base.device.dev.dht22);} //--Настройка параметров сенсора;
devDHT22.run=RT_HW_Base.directTask(shedDHT22);                          //--Чтение события запуска измерения от планировщика directTask();
devDHT22.direct();                                                      //--Управление сенсором;
if(devDHT22.fresh){devDHT22.fresh=0; vDHT22Temp=devDHT22.vTemp; vDHT22Hum=devDHT22.vHum; vDHT22ok=devDHT22.ok;} //--Обновление измеренных данных;
};
//=================================================================================================
//                                      DS1820 через pin(1-Wire)
//=================================================================================================
void sns_DS1820(){
if(devDS1820.custom==0){RT_HW_ds1820.setParam(devDS1820,RT_HW_Base.device.dev.oneWBus);} //--Настройка параметров сенсора;
if(shedDS1820.custom==0){RT_HW_Base.setTaskID(shedDS1820,2200);} //--Настройка периодического вызова с периодом 2200ms;
devDS1820.run=RT_HW_Base.directTask(shedDS1820);                 //--Чтение события запуска измерения от планировщика directTask()
RT_HW_ds1820.direct(devNW,devDS1820);                            //--Управление сенсором; 
if(devDS1820.fresh){devDS1820.fresh=0; vDS1820Temp=devDS1820.vTemp; vDS1820ok=devDS1820.ok;} //--Обновление измеренных данных;
};
//=================================================================================================
//                                      HC-SR04 через pinTrig(Echo соединен с Trig через R=470 Ом)
//=================================================================================================
void sns_SR04(){
if(devSR04.custom==0){devSR04.custom=1; devSR04.extPinTrig=RT_HW_Base.device.dev.srTrig; devSR04.maxLen=400;} //--Настройка параметров сенсора;
if(shedSR04.custom==0){RT_HW_Base.setTaskID(shedSR04,75,25);}        //--Настройка периодического вызова с периодом 75ms;
devSR04.run=RT_HW_Base.directTask(shedSR04);                       //--Чтение события запуска измерения от планировщика directTask();
RT_HW_sr04.direct(devSR04);                                     //--Управление сенсором;
if(devSR04.state==1) {devSR04.state++;  attachInterrupt(devSR04.numIRQ, RT_HW_IRQ_SR04_handler_devSR04,CHANGE);}
if(devSR04.fresh){devSR04.fresh=0;  devSR04.LenMcs=ftrSR04.filtered(devSR04.echoMcs); 
                  devSR04.Len=round(devSR04.LenMcs * devSR04.speedSoundAir/10.0) ;  if(devSR04.Len>devSR04.maxLen){devSR04.Len=devSR04.maxLen;}
                  vSR04Len=devSR04.Len;  vSR04ok=devSR04.ok;} //--Обновление измеренных данных;
};
//=================================================================================================
//                       CMBTHP.i2c (комбинированный сенсор AHTXX(T,H)+BMP280(P)
//  RT_HW_AHTXX   dvCMAHT;   RT_HW_STRUCT_SHED_TASK shCMAHT; float vCMTemp,vCMHum,vCMPress;  uint8_t vCMok; 
//  RT_HW_BME280  dvCMBMP;  RT_HW_STRUCT_SHED_TASK shCMBMP;      
//=================================================================================================
void sns_CMTHP(){
if(shedCMBMP.custom==0) {RT_HW_Base.setTaskID(shedCMBMP, 2600); } //--Настройка периодического опроса температуры с периодом 2600ms;
if(devCMBMP.custom==0){devCMBMP.setParam('I',i2cAdrAHT,0,0); devCMBMP.permitHum=0; devCMBMP.permitTemp=0;} //--Настройка параметров сенсора(i2c('I'),adr,busspeed,блокировка Hum,Temp);
//------------------
if(shedCMAHT.custom==0){RT_HW_Base.setTaskID(shedCMAHT,2200);}    //--Настройка периодического опроса с периодом 2200ms;
if(devCMAHT.custom==0) {devCMAHT.setParam(i2cAdrBMP,0,0);}        //--Настройка параметров сенсора(адрес,номер шины,скорость);
//------------------
devCMBMP.runPress=RT_HW_Base.directTask(shedCMBMP);               //--Чтение события запуска измерения давления    от планировщика directTask();   
devCMBMP.direct();                                                //--Управление сенсором BMP;   
//------------------
devCMAHT.run=RT_HW_Base.directTask(shedCMAHT);                    //--Чтение события запуска измерения от планировщика directTask();
devCMAHT.direct();                                                //--Управление сенсором AHTxx;
//------------------
if(devCMAHT.fresh || devCMBMP.fresh){ 
  devCMAHT.fresh=devCMBMP.fresh=0; if(devCMAHT.ok && devCMBMP.ok){vCMTHPok=1;} else{vCMTHPok=0;} 
 vCMTemp=devCMAHT.vTemp; vCMHum=devCMAHT.vHum; vCMPress=devCMBMP.vPress;} //--Обновление измеренных данных;
};
//=================================================================================================
//                                      SHT3X.i2c
//=================================================================================================
void sns_SHT3X(){
if(shedSHT3X.custom==0){RT_HW_Base.setTaskID(shedSHT3X,2200);} //--Настройка периодического опроса с периодом 2200ms;
if(devSHT3X.custom==0){devSHT3X.setParam(0x44,0,0);}           //--Настройка параметров сенсора(адрес,номер шины,скорость);
devSHT3X.run=RT_HW_Base.directTask(shedSHT3X);                 //--Чтение события запуска измерения от планировщика directTask();
devSHT3X.direct();                                             //--Управление сенсором;
if(devSHT3X.fresh){devSHT3X.fresh=0; vSHT3XTemp=devSHT3X.vTemp; vSHT3XHum=devSHT3X.vHum; vSHT3Xok=devSHT3X.ok;} //--Обновление измеренных данных;
};
//=================================================================================================
//                                      HTU21.i2c
//=================================================================================================
void sns_HTU21(){
if(shedHTU21Temp.custom==0){RT_HW_Base.setTaskID(shedHTU21Temp,2200);}//--Настройка периодического опроса температуры с периодом 2200ms;
if(shedHTU21Hum.custom==0) {RT_HW_Base.setTaskID(shedHTU21Hum, 2500);}//--Настройка периодического опроса влажности   с периодом 2500ms;
if(devHTU21.custom==0){devHTU21.setParam(0x40,0,0);}                //--Настройка параметров сенсора(адрес,номер шины,скорость);
devHTU21.runTemp=RT_HW_Base.directTask(shedHTU21Temp);               //--Чтение события запуска измерения температуры от планировщика directTask();
devHTU21.runHum= RT_HW_Base.directTask(shedHTU21Hum);                //--Чтение события запуска измерения влажности   от планировщика directTask();
devHTU21.direct();                                           //--Управление сенсором;
if(devHTU21.fresh){devHTU21.fresh=0; vHTU21Temp=devHTU21.vTemp; vHTU21Hum=devHTU21.vHum; vHTU21ok=devHTU21.ok;} //--Обновление измеренных данных;
};
//=================================================================================================
//                                     BH1750
//=================================================================================================
void sns_BH1750(){
if(shedBH1750.custom==0){RT_HW_Base.setTaskID(shedBH1750,2200);}//--Настройка периодического вызова с периодом 2200ms;
if(devBH1750.custom==0){devBH1750.setParam(0x23,0,0);}          //--Настройка параметров сенсора(адрес,номер шины,скорость);
devBH1750.run=RT_HW_Base.directTask(shedBH1750);                  //--Чтение события запуска измерения от планировщика directTask();
devBH1750.direct();                                             //--Управление сенсором;
if(devBH1750.fresh){devBH1750.fresh=0; vBH1750Lux=devBH1750.vLux; vBH1750ok=devBH1750.ok;} //--Обновление измеренных данных;
};
//=================================================================================================
//                                     MAX6675.SPI
//=================================================================================================
void sns_spiMAX6675(){
if(spiDevMAX6675.custom==0){RT_HW_max6675.setParamSPI(spiDevMAX6675,spiPinMAX6675cs,0);}  //--Настройка параметров сенсора cs, номер шины;) 
if(spiShedMAX6675.custom==0){RT_HW_Base.setTaskID(spiShedMAX6675,1200);} //--Настройка вызова сенсора (периодический вызов, периодом=1200ms);                        
spiDevMAX6675.run=RT_HW_Base.directTask(spiShedMAX6675);                 //--Чтение события запуска измерения от планировщика directTask()                      
RT_HW_max6675.direct(spiDevMAX6675);                                     //--Вызов функции MAX6675();                                              
if(spiDevMAX6675.fresh){spiDevMAX6675.fresh=0; spiMAX6675temp=spiDevMAX6675.vTemp; spiMAX6675ok=spiDevMAX6675.ok;} //--Ообновление данных;
};
//=================================================================================================
//                                     MAX6675.SPN
//=================================================================================================
void sns_spnMAX6675(){
if(spnDevMAX6675.custom==0) {RT_HW_max6675.setParamSPN(spnDevMAX6675,spnPinMAX6675sck,spnPinMAX6675miso,spnPinMAX6675mosi,spnPinMAX6675cs,0);} //--Настройка: id, 
if(spnShedMAX6675.custom==0){RT_HW_Base.setTaskID(spnShedMAX6675,1200);} //--Настройка периодического вызова с периодом 1200ms;
spnDevMAX6675.run=RT_HW_Base.directTask(spnShedMAX6675);                  //--Чтение события запуска измерения от планировщика directTask()                      
RT_HW_max6675.direct(spnDevMAX6675);                                          
if(spnDevMAX6675.fresh){spnDevMAX6675.fresh=0; spnMAX6675temp=spnDevMAX6675.vTemp; spnMAX6675ok=spnDevMAX6675.ok;} //--Обновление измеренных данных;
};
