//=================================================================================================
//                              Инициализация параметров
//=================================================================================================
void initProject(){
if(vInit){return;} vInit=1;
adrLcd=0x27;                              //--Адрес i2c LCD;
pinControl=RT_HW_Base.device.pin.control; //--Номер пина Control;
pinLed    =RT_HW_Base.device.pin.led;     //--Номер пина Led;
pinButton =RT_HW_Base.device.pin.button;  //--Номер пина Кнопки;
pinPWM    =RT_HW_Base.device.pin.pwm;     //--Номер пина PWM;
pinADC    =RT_HW_Base.device.pin.adc;     //--Номер пина ADC;
pinServo  =RT_HW_Base.device.pin.servo;   //--Номер пина Servo;
pinSR04   =RT_HW_Base.device.dev.srTrig;  //--Номер пина HC-SR04;
pinDS1820 =RT_HW_Base.device.dev.oneWBus; //--Номер пина DS1820; 
pinCShc595=RT_HW_Base.device.spi.cs0;     //--Номер пина cs 74HC595; 
};  
//=================================================================================================
//                              Вывод на консоль заголовков
//=================================================================================================
void consoleHead(){              
RT_HW_Base.consoleCR(3);
RT_HW_Base.consoleHead(String(F("Main parameters")),'='); RT_HW_Base.mess.modePin='T'; RT_HW_Base.consoleBoardGeneral();   
RT_HW_Base.consoleHead(String(F("Add parameters")));      RT_HW_Base.mess.modePin='T'; RT_HW_Base.consoleBoardAdd(); 
//RT_HW_Base.consoleHead(String(F("Task parameters")));     RT_HW_Base.consoleShedulerParameters();
//RT_HW_Base.consoleHead(String(F("PGM array")));           RT_HW_Base.mess.modePin='T'; RT_HW_Base.consoleFromPGM();
//RT_HW_Base.consoleHead(String(F("Available pins")));      RT_HW_Base.mess.modePin='A'; RT_HW_Base.consolePinsAll();        
RT_HW_Base.consoleHead(String(F("Interface")));           RT_HW_Base.mess.modePin='T'; RT_HW_Base.consoleInterface(); 
RT_HW_Base.consoleHead(String(F("System & test pins")));  RT_HW_Base.mess.modePin='T'; RT_HW_Base.consolePinsSystem(); RT_HW_Base.consolePinsTest();  
RT_HW_Base.consoleHead(String(F("Scan i2c")));            RT_HW_Base.mess.modePin='T'; RT_HW_Base.i2cScanBus(0);   
RT_HW_Base.consoleLine('+'); 
};
//=================================================================================================
//                              Счетчики
//=================================================================================================
void cntTest(){
//-----------------------------Генератор треугольника 0-4095 для DAC,100ms-------------------------
if(idCntDAC.reset){RT_HW_Base.counterReset(idCntDAC,4095,0,100,0);}  //--init счетчика:верхняя(Top=4095) граница, нижняя граница(Buttom=0),шаг изменения(Step=100); нач.знач.(Begin=0);
if(RT_HW_Base.generatorEvent(idGenDAC,100)) {genDAC=RT_HW_Base.counterT(idCntDAC);}   //--Периодическое(100ms) выполнение "Счетчик-Треугольник";
//-----------------------------Генератор бегущая единица-------------------------------------------
if(idCnt595.reset){RT_HW_Base.counterReset(idCnt595,8,1,1,1);}
if(RT_HW_Base.generatorEvent(idGen595,50)){gen595=RT_HW_Base.counterT(idCnt595);  gen595=RT_HW_Base.dc8(gen595);}
//-----------------------------Генератор для серводвигателя----------------------------------------
if(idCntServo.reset==1){RT_HW_Base.counterReset(idCntServo,4095,0,20,0);} //--top,bottom,step,begin);
if(RT_HW_Base.generatorEvent(idGenServo,10)){RT_HW_Base.counterT(idCntServo);} 
};
//=================================================================================================
//                              Чтение ADC
//=================================================================================================
void getAnalog(){
if(idPinADC.dir==0){idPinADC.pin=pinADC;}   //--Настройка ADC;
RT_HW_Base.pinAnalogRead (idPinADC);        //--Чтение ADC;
vADCF=filterADC.filtered(idPinADC.vNorm);   //--Фильтрация ADC;
};
//=================================================================================================
//                              Запись PWM
//=================================================================================================
void setPWM(){
if(RT_HW_Base.console.all){
if(idPinPWM.dir==0){idPinPWM.pin=pinPWM; idPinPWM.channel=0; idPinPWM.freq=50; idPinPWM.depth=16;} //--Настройка PWM;
RT_HW_Base.pinPWM(idPinPWM,vADCF);
}
};
//=================================================================================================
//                              Запись SERVO
//=================================================================================================
void setServo(){
if(idPinServo.dir==0){idPinServo.pin=pinServo; idPinServo.channel=2; RT_HW_Base.pinServoSet_MG90S(idPinServo); //--Настройка параметров Servo;
                      idPinServo.minWidth=560; idPinServo.maxWidth=2450;  //--Подстройка параметров;
                     }
idPinServo.var=RT_HW_Base.pinServoNormSYS(idPinServo,vADCF); //--Вывод значение ADC;
RT_HW_Base.pinServo(idPinServo);                    
};
//=================================================================================================
//                      Чтение кнопки с защитой от дребезга 50мс
//=================================================================================================
void getButton(){
if(idPinButton.dir==0) {idPinButton.pin=pinButton; idPinButton.mode='U'; idChatButton.period=50;} //--Настройка параметров;
vButton=!RT_HW_Base.pinDigitalRead(idPinButton);           //--Чтение кнопки с подтянутым пином к Vcc;
vChatBut=RT_HW_Base.chatterV8(idChatButton,vButton);       //--Защита от дребезга значения с кнопки;
};  //++++END GenVar_Button()
//=================================================================================================
//                                      DS1820.pin через 1-Wire
//=================================================================================================
void snsDS1820(){
if(dvDS1820.custom==0){RT_HW_ds1820.setParam(dvDS1820,pinDS1820);} //--Настройка параметров сенсора;
if(shDS1820.custom==0){RT_HW_Base.setTaskID(shDS1820,2200);} //--Настройка периодического вызова с периодом 2200ms;
dvDS1820.run=RT_HW_Base.directTask(shDS1820);                 //--Чтение события запуска измерения от планировщика directTask()
RT_HW_ds1820.direct(dvNW,dvDS1820);                         //--Управление сенсором; 
if(dvDS1820.fresh){dvDS1820.fresh=0; vDS1820Temp=dvDS1820.vTemp; vDS1820ok=dvDS1820.ok;} //--Обновление измеренных данных;
};
//=================================================================================================
//                                      HC-SR04.pinTrig(Echo соединен с Trig через R=470 Ом)
//=================================================================================================
void snsSR04(){
if(dvSR04.custom==0){dvSR04.custom=1; dvSR04.extPinTrig=pinSR04; dvSR04.maxLen=400;} //--Настройка параметров сенсора;
if(shSR04.custom==0){RT_HW_Base.setTaskID(shSR04,75,25);}       //--Настройка периодического вызова с периодом 75ms;
dvSR04.run=RT_HW_Base.directTask(shSR04);                       //--Чтение события запуска измерения от планировщика directTask();
RT_HW_sr04.direct(dvSR04);                                      //--Управление сенсором;
if(dvSR04.state==1) {dvSR04.state++;  attachInterrupt(dvSR04.numIRQ, RT_HW_IRQ_SR04_handler_dvSR04,CHANGE);}
if(dvSR04.fresh){dvSR04.fresh=0; dvSR04.LenMcs=ftrSR04.filtered(dvSR04.echoMcs); 
                 dvSR04.Len=round(dvSR04.LenMcs * dvSR04.speedSoundAir/10.0) ;  if(dvSR04.Len>dvSR04.maxLen){dvSR04.Len=dvSR04.maxLen;}
                 vSR04Len=dvSR04.Len;  vSR04ok=dvSR04.ok;} //--Обновление измеренных данных;
};
//=================================================================================================
//                                      74HC595.SPI
//=================================================================================================
void extSPIhc595  (uint8_t  var){  
if(shSPIhc595.custom==0){RT_HW_Base.setTaskID(shSPIhc595,'Q',25,25,25);}                  //--init:'A'-вывод по измен или периодически; не чаще 50ms; период.(2500ms); тик генератора=25ms;
if(dvSPIhc595.custom==0){dvSPIhc595.setParam(1,pinCShc595,0,4000000);}       //--Установка параметров: bitOrder,cs,bus,speed;
   dvSPIhc595.run=RT_HW_Base.directTask(shSPIhc595);         //--Генератор управляющих сигналов [run-0,1,2];
   dvSPIhc595.var=var; dvSPIhc595.direct();
};
//==================================================================================================
