//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                     ПЕРЕМЕННЫЕ, ПАРАМЕТРЫ, ОБЪЕКТЫ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//============================Системные переменные===============================================================================================
uint8_t  vInit=0;                                                         //--Флаг инициализации параметров;
uint32_t vSpeedMCU=0;   uint16_t vSpeedSmall=0;   //--Переменные для скорости процессора (speedMCU=SpeedMCU/1000);
RT_HW_FILTER_RING_AVERAGE<uint32_t,10> filterSpeed; uint32_t vSpeedMCUF;  //--Параметры для фильтра скорости MCU;
uint8_t  adrLcd1,adrLcd2;  uint8_t pinCS_lcd;                              //--Адрес LCD;
uint8_t  pinSPN_sck,pinSPN_mosi,pinSPN_miso, pinSPN_cs;                       //--Пины программного SPI(SPN);
//---------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_ID   idPinControl;uint8_t pinControl;         //--Объект и переменная для пина "Контроль";
RT_HW_PIN_DIR_ID   idPinLed;    uint8_t pinLed;             //--Объект и переменная для пина "Led на плате";                    
RT_HW_PIN_PWM_ID   idPinPWM;    uint8_t pinPWM;             //--Объект и переменная для пина PWM;
//-------------------------------Кнопка с защитой от дребезга----------------------------------------
RT_HW_PIN_DIR_ID   idPinButton; uint8_t pinButton; uint8_t vButton;  //--Объект и переменные для пина "Button на плате";  
RT_HW_CHAT_V8_ID   idChatButton;                   uint8_t vChatBut; //--Объекты и переменные для обработки кнопки с защитой от дребезга;
//-------------------------------ADC с фильрацией----------------------------------------------------
RT_HW_PIN_ADC_ID   idPinADC;    uint8_t pinADC; uint16_t vADCF; uint16_t agoADC; //--Объект и переменная для ADС;
RT_HW_FILTER_RING_AVERAGE<uint32_t,5>  filterADC;           //--Параметры для для фильтра ADC(скользящий среднего значения 5-го порядка); 
//-------------------------------Управление серво----------------------------------------------------
RT_HW_PIN_SERVO_ID idPinServo; uint8_t pinServo;           //--Объект и переменная для пина Servo;
RT_HW_GENERATOR_EVENT_ID idGenServo; RT_HW_COUNTER_ID  idCntServo;
//-------------------------------Тестовые пины-------------------------------------------------------
//RT_HW_PIN_DIR_ID idPinDebug1,idPinDebug2,idPinDebug3;                 //--Объекты для пинов отладки; 
//------------------------------CS SPI---------------------------------------------------------------
RT_HW_PIN_DIR_ID idPinCS0,idPinCS1,idPinCS2,idPinCS3;                 //--Объекты для CS SPI;
//==============================Генераторы+счетчики=============================================================================================
RT_HW_GENERATOR_EVENT_ID idGenChar;  uint8_t  cntChar=0;          char     vChar='X';  //--Для генератора символов; 
RT_HW_GENERATOR_EVENT_ID idGenRUN8;   RT_HW_COUNTER_ID idCntRUN8;  uint8_t   genRUN8=0;   //--Для генератора бегущей "1" 0-8; 
RT_HW_GENERATOR_EVENT_ID idGenRUN16;  RT_HW_COUNTER_ID idCntRUN16; uint16_t  genRUN16=0;  //--Для генератора бегущей "1" 0-16; 
RT_HW_GENERATOR_EVENT_ID idGenRUN24;  RT_HW_COUNTER_ID idCntRUN24; uint32_t  genRUN24=0;  //--Для генератора бегущей "1" 0-24;   
RT_HW_GENERATOR_EVENT_ID idGenRUN32;  RT_HW_COUNTER_ID idCntRUN32; uint32_t  genRUN32=0;  //--Для генератора бегущей "1" 0-32;   
RT_HW_GENERATOR_EVENT_ID idGenDAC;    RT_HW_COUNTER_ID idCntDAC;   int16_t   genDAC=0;    //--Для генераторо 0-4095 DAC;

RT_HW_GENERATOR_EVENT_ID idGenA;  RT_HW_COUNTER_ID idCntA;  uint8_t  genA=0;  //--Для генератора бегущей "1"; 
RT_HW_GENERATOR_EVENT_ID idGenB;  RT_HW_COUNTER_ID idCntB;  uint8_t  genB=0;  //--Для генератора бегущей "1"; 
//==============================Сенсоры=========================================================================================================
//------Сенсоры i2c----------------------------------------------------------------------------------------------------------------------------- 
RT_HW_BH1750  dvBH1750;  RT_HW_STRUCT_SHED_TASK shBH1750;                                 uint16_t vBH1750Lux;            uint8_t vBH1750ok=0;   
RT_HW_AHTXX   dvAHTXX;   RT_HW_STRUCT_SHED_TASK shAHTXX;                                  float vAHTXXTemp,  vAHTXXHum;   uint8_t vAHTXXok;    
RT_HW_HTU21   dvHTU21;   RT_HW_STRUCT_SHED_TASK shHTU21Temp, shHTU21Hum;                  float vHTU21Temp, vHTU21Hum;    uint8_t vHTU21ok; 
RT_HW_SHT3X   dvSHT3X;   RT_HW_STRUCT_SHED_TASK shSHT3X;                                  float vSHT3XTemp, vSHT3XHum;    uint8_t vSHT3Xok=0;
RT_HW_BMP180  dvBMP180;  RT_HW_STRUCT_SHED_TASK shBMP180Temp,shBMP180Press;               float vBMP180Temp,vBMP180Press; uint8_t vBMP180ok=0;
RT_HW_BME280  dvBMP280;  RT_HW_STRUCT_SHED_TASK shBMP280Temp,shBMP280Press;               float vBMP280Temp,vBMP280Press; uint8_t vBMP280ok=0;
//RT_HW_BME280  dvBME280;  RT_HW_STRUCT_SHED_TASK shBME280Temp,shBME280Press,shBME280Hum;   float vBME280Temp,vBME280Press,vBME280Hum; uint8_t vBME280ok=0;
//------Комбинированный сенсор AHT+BMP280(i2c)-------------------------------------------------------------------------------------------------- 
RT_HW_AHTXX   dvCMAHT;   RT_HW_STRUCT_SHED_TASK shCMAHT; float vCMTemp,vCMHum,vCMPress;  uint8_t vCMok; 
RT_HW_BME280  dvCMBMP;   RT_HW_STRUCT_SHED_TASK shCMBMP;    
//------Сенсоры через пины----------------------------------------------------------------------------------------------------------------------
RT_HW_DHT22   dvDHT22;  uint8_t pinDHT22; RT_HW_STRUCT_SHED_TASK shDHT22; float vDHT22Temp, vDHT22Hum; uint8_t vDHT22ok;  
RT_HW_STRUCT_DS1820_ID  dvDS1820; uint8_t pinDS1820; RT_HW_ONEWIRE dvNW; RT_HW_STRUCT_SHED_TASK shDS1820; float vDS1820Temp; uint8_t vDS1820ok; 
//------Сенсоры SPI,SPN-------------------------------------------------------------------------------------------------------------------------
RT_HW_STRUCT_MAX6675_ID dvMAX6675; uint8_t pinCS_max6675; RT_HW_STRUCT_SHED_TASK shMAX6675;  float vMAX6675Temp; uint8_t vMAX6675ok;
RT_HW_STRUCT_MAX6675_ID dvMAX6675x; RT_HW_STRUCT_SHED_TASK shMAX6675x; float vMAX6675xTemp;  uint8_t vMAX6675xok;
//==============================Сенсор HC-SR04==================================================================================================
RT_HW_STRUCT_SR04_ID dvSR04; uint8_t pinSR04; RT_HW_STRUCT_SHED_TASK shSR04; uint16_t vSR04Len;  uint8_t vSR04ok;
RT_HW_FILTER_MEDIAN_3    <uint16_t>    ftrSR04;     uint16_t vSR04LenF;   //--Параметры для фильтра HC-SR04(медианный 3-го порядка);
RT_HW_IRAM_ATTR void RT_HW_IRQ_SR04_handler_dvSR04(){ //++++Обработчик прерываний HC-SR04------------
  if(dvSR04.state==2) {if( RT_HW_PIN_DIR_READ(dvSR04.ddPin)){dvSR04.timeBegin=micros(); dvSR04.state=3;}}
  if(dvSR04.state==3) {if(!RT_HW_PIN_DIR_READ(dvSR04.ddPin)){dvSR04.timeEnd  =micros(); dvSR04.state=4;}}}
//=============================Расширители 74HC595==============================================================================================
uint8_t pinCS_hc595; 
RT_HW_SPIhc595   dvSPIhc595;    RT_HW_STRUCT_SHED_TASK shSPIhc595;
RT_HW_SPIhc595x2 dvSPIhc595x2;  RT_HW_STRUCT_SHED_TASK shSPIhc595x2;
RT_HW_SPIhc595x3 dvSPIhc595x3;  RT_HW_STRUCT_SHED_TASK shSPIhc595x3;
RT_HW_SPIhc595x4 dvSPIhc595x4;  RT_HW_STRUCT_SHED_TASK shSPIhc595x4;
//=============================Расширители 74HC165==============================================================================================
RT_HW_SPIhc165   dvSPIhc165;  uint8_t pinCS_hc165; RT_HW_STRUCT_SHED_TASK shSPIhc165;   uint8_t vSPIhc165;
//=============================Расширители MCP4725==============================================================================================  
RT_HW_MCP4725    dvMCP4725;     RT_HW_STRUCT_SHED_TASK shMCP4725; 
//=============================Расширители MCP23017=============================================================================================
RT_HW_MCP23x17   dvMCP23x17;    RT_HW_STRUCT_SHED_TASK shMCP23x17in, shMCP23x17out; 
//=============================Задатчики для Nextion и ModBus===================================================================================
uint8_t vNXSL1=24, vNXSL2=67, vNXBTN=0x55;  //--Задатчики для Nextion; 
uint8_t vMBSL1=34, vMBSL2=74, vMBBTN=0xAA;  //--Задатчики для ModBus;
//============================Вспомогательные Переменные========================================================================================
uint8_t  agoDDR=255;  uint8_t  agoSTEP=255;  uint8_t  agoRUN=255;   //--Переменные для отладки;
//==============================================================================================================================================
