//=================================================================================================
//                              Инициализация параметров
//=================================================================================================
void initProject(){
if(vInit){return;} vInit=1;
adrLcd1=0x27;                             //--Адрес i2c LCD1;
adrLcd2=0x3E;                             //--Адрес i2c LCD2;
pinControl=RT_HW_Base.device.pin.control; //--Номер пина Control;
pinLed    =RT_HW_Base.device.pin.led;     //--Номер пина Led;
pinButton =RT_HW_Base.device.pin.button;  //--Номер пина Кнопки;
pinPWM    =RT_HW_Base.device.pin.pwm;     //--Номер пина PWM;
pinADC    =RT_HW_Base.device.pin.adc;     //--Номер пина ADC;
pinServo  =RT_HW_Base.device.pin.servo;   //--Номер пина Servo;
pinSR04   =RT_HW_Base.device.dev.srTrig;  //--Номер пина HC-SR04;
pinDS1820 =RT_HW_Base.device.dev.oneWBus; //--Номер пина DS1820; 
pinCS_hc595  =RT_HW_Base.device.spi.cs0;     //--Номер пина cs 74HC595; 
pinCS_lcd    =RT_HW_Base.device.spi.cs1;     //--Номер пина cs LCD HD44780; 
pinCS_hc165  =RT_HW_Base.device.spi.cs2;     //--Номер пина cs 74HC165;
pinCS_max6675=RT_HW_Base.device.spi.cs3;     //--Номер пина cs 74HC165;
pinSPN_sck =RT_HW_Base.readArrPGM(RT_HW_PGM_PIN_SPN_ID,0); //--сохранение пина SPN.sck;  
pinSPN_miso=RT_HW_Base.readArrPGM(RT_HW_PGM_PIN_SPN_ID,1); //--сохранение пина SPN.miso;
pinSPN_mosi=RT_HW_Base.readArrPGM(RT_HW_PGM_PIN_SPN_ID,2); //--сохранение пина SPN.mosi;  
pinSPN_cs  =RT_HW_Base.readArrPGM(RT_HW_PGM_PIN_SPN_ID,3); //--сохранение пина SPN.cs;  
};
//=====================================================================================================
//                              ВЫВОД НА КОНСОЛЬ ЗАГОЛОВКОВ 
//=====================================================================================================
void consoleHead(){              
RT_HW_Base.consoleCR(3);
RT_HW_Base.consoleHead(String(F("Main parameters")),'='); RT_HW_Base.mess.modePin='T'; RT_HW_Base.consoleBoardGeneral();   
RT_HW_Base.consoleHead(String(F("Add parameters")));      RT_HW_Base.mess.modePin='T'; RT_HW_Base.consoleBoardAdd(); 
RT_HW_Base.consoleHead(String(F("Task parameters")));     RT_HW_Base.consoleShedulerParameters();
RT_HW_Base.consoleHead(String(F("PGM array")));           RT_HW_Base.mess.modePin='T'; RT_HW_Base.consoleFromPGM();
RT_HW_Base.consoleHead(String(F("Available pins")));      RT_HW_Base.mess.modePin='A'; RT_HW_Base.consolePinsAll();        
RT_HW_Base.consoleHead(String(F("Interface")));           RT_HW_Base.mess.modePin='T'; RT_HW_Base.consoleInterface(); 
RT_HW_Base.consoleHead(String(F("System & test pins")));  RT_HW_Base.mess.modePin='T'; RT_HW_Base.consolePinsSystem(); RT_HW_Base.consolePinsTest();  
RT_HW_Base.consoleHead(String(F("Scan i2c")));            RT_HW_Base.mess.modePin='T'; RT_HW_Base.i2cScanBus(0);   
RT_HW_Base.consoleLine('+'); 
};
//=====================================================================================================
//                              ГЕНЕРАТОРЫ ТЕСТОВЫХ ПЕРЕМЕННЫХ
//=====================================================================================================
void generatorVar(){
//-----------------------------Генератор символов------------------------------------------------------
if(RT_HW_Base.generatorEvent(idGenChar, 1000)){vChar='A'+cntChar; if(++cntChar>5){cntChar=0;}} //--Генератор(1000ms)символов 'A',....;
//-----------------------------Генератор бегущей единицы 1-8, пила 100ms ------------------------------
if(idCntRUN8.reset){RT_HW_Base.counterReset(idCntRUN8,8,1,1,1);}   //--init счетчика:верхняя(Top=8) граница, нижняя граница(Buttom=0),шаг изменения(Step=1); нач.знач.(Begin=0);
if(RT_HW_Base.generatorEvent(idGenRUN8,100)){genRUN8=RT_HW_Base.dc8(RT_HW_Base.counterT(idCntRUN8));}; //--Периодический(100ms) выполнение "Счетчик-Треугольник";            
//-----------------------------Генератор бегущей единицы 1-16, пила 100ms ------------------------------
if(idCntRUN16.reset){RT_HW_Base.counterReset(idCntRUN16,16,0,1,0);}   //--init счетчика:верхняя(Top=16) граница, нижняя граница(Buttom=0),шаг изменения(Step=1); нач.знач.(Begin=0);
if(RT_HW_Base.generatorEvent(idGenRUN16,50)){genRUN16=RT_HW_Base.dc16(RT_HW_Base.counterS(idCntRUN16));}; //--Периодический(100ms) выполнение "Счетчик-Пила"; 
//-----------------------------Генератор бегущей единицы 1-24, пила 100ms ------------------------------
if(idCntRUN24.reset){RT_HW_Base.counterReset(idCntRUN24,24,0,1,0);}   //--init счетчика:верхняя(Top=24) граница, нижняя граница(Buttom=0),шаг изменения(Step=1); нач.знач.(Begin=0);
if(RT_HW_Base.generatorEvent(idGenRUN24,25)){genRUN24=RT_HW_Base.dc24(RT_HW_Base.counterS(idCntRUN24));}; //--Периодический(100ms) выполнение "Счетчик-Пила"; 
//-----------------------------Генератор бегущей единицы 1-32, пила 100ms ------------------------------
if(idCntRUN32.reset){RT_HW_Base.counterReset(idCntRUN32,32,0,1,0);}   //--init счетчика:верхняя(Top=32) граница, нижняя граница(Buttom=0),шаг изменения(Step=1); нач.знач.(Begin=0);
if(RT_HW_Base.generatorEvent(idGenRUN32,5)){genRUN32=RT_HW_Base.dc32(RT_HW_Base.counterT(idCntRUN32));}; //--Периодический(100ms) выполнение "Счетчик-Пила";  
//-----------------------------Генератор треугольника 0-4095 для DAC,100ms-----------------------------
if(idCntDAC.reset){RT_HW_Base.counterReset(idCntDAC,4095,0,100,0);}  //--init счетчика:верхняя(Top=4095) граница, нижняя граница(Buttom=0),шаг изменения(Step=100); нач.знач.(Begin=0);
if(RT_HW_Base.generatorEvent(idGenDAC,100)) {genDAC=RT_HW_Base.counterT(idCntDAC);}   //--Периодическое(100ms) выполнение "Счетчик-Треугольник";
//-----------------------------Генератор для серводвигателя----------------------------------------
if(idCntServo.reset==1){RT_HW_Base.counterReset(idCntServo,4095,0,20,0);} //--top,bottom,step,begin);
if(RT_HW_Base.generatorEvent(idGenServo,10)){RT_HW_Base.counterT(idCntServo);} 
//-----------------------------------------------------------------------------------------------------
};  //++++END GenVar()
//=================================================================================================
//                              Чтение ADC
//=================================================================================================
void getAnalog(){
if(idPinADC.dir==0){idPinADC.pin=pinADC;}   //--Настройка ADC;
RT_HW_Base.pinAnalogRead (idPinADC);        //--Чтение ADC;
vADCF=filterADC.filtered(idPinADC.vNorm);   //--Фильтрация ADC;
};
//=================================================================================================
//                              Запись PWM
//=================================================================================================
void setPWM(){
if(idPinPWM.dir==0){idPinPWM.pin=pinPWM; idPinPWM.channel=0; idPinPWM.freq=50; idPinPWM.depth=16;} //--Настройка PWM;
RT_HW_Base.pinPWM(idPinPWM,vADCF);
};
//=================================================================================================
//                              Запись SERVO
//=================================================================================================
void setServo(){
if(idPinServo.dir==0){idPinServo.pin=pinServo; idPinServo.channel=2; RT_HW_Base.pinServoSet_MG90S(idPinServo); //--Настройка параметров Servo;
                      idPinServo.minWidth=560; idPinServo.maxWidth=2450;  //--Подстройка параметров;
                     }
idPinServo.var=RT_HW_Base.pinServoNormSYS(idPinServo,vADCF); //--Вывод значение ADC;
RT_HW_Base.pinServo(idPinServo);                    
};
//=================================================================================================
//                      Чтение кнопки с защитой от дребезга 50мс
//=================================================================================================
void getButton(){
if(idPinButton.dir==0) {idPinButton.pin=pinButton; idPinButton.mode='U'; idChatButton.period=50;} //--Настройка параметров;
vButton=!RT_HW_Base.pinDigitalRead(idPinButton);           //--Чтение кнопки с подтянутым пином к Vcc;
vChatBut=RT_HW_Base.chatterV8(idChatButton,vButton);       //--Защита от дребезга значения с кнопки;
};  //++++END GenVar_Button()

//=====================================================================================================
