//===================================================================================================
//    ТЕСТ (ДЛЯ РАЗЛИЧНЫХ ПЛАТ) ПЛАТЫ,LCD i2c.16x2, i2c.20x4, SPI.20x4, сенсоры, расширители
// (для настройки IDE для работы с многими платами читать в тесте TEST_Board_v02 вкладкe Readme.hpp)
//===================================================================================================
#include "RT_HW_BASE.h"   
#include "RT_HW_LCD44780.h"
#include "RT_HW_SENSORS.h" 
#include "RT_HW_EXTENDERS.h" 
//---------------------------------------------------------------------------------------------------
#include "Aobj.hpp"     //--Объектов,переменных,констант;
#include "Bfunc.hpp"    //--Функции;
#include "Csns.hpp"     //--Сенсоры;
#include "Dext.hpp"     //--Расширители ввода-вывода;
#include "Lcd1.hpp"     //--Дисплей 1(16x2,i2c);
#include "Lcd2.hpp"     //--Дисплей 2(20x4,i2c);
#include "Lcd3.hpp"     //--Дисплей 3(20x4,SPI);
//===================================================================================================
void setup(){}
//===================================================================================================
void loop(){
initProject();              //--Инициализация параметров;
RT_HW_Base.sheduler();      //--Диспетчер;
RT_HW_Base.consoleBegin();  //--Инициализация консоли;
if(RT_HW_Base.shed.eventSec){vSpeedMCU=RT_HW_Base.shed.cycle; vSpeedMCUF=filterSpeed.filtered(vSpeedMCU); vSpeedSmall=round(((float)vSpeedMCUF)/1000);} //--Получение быстродействия MCU;
RT_HW_Base.pinDigitalWrite(idPinControl,pinControl,RT_HW_Base.shed.control);    //--Вывод loop() на контрольный пин;
RT_HW_Base.pinDigitalWrite(idPinLed,    pinLed,    RT_HW_Base.shed.blink500); //--Вывод меандра 500ms на Led; 
//=====================Вывод заголовков============================================================
if(RT_HW_Base.console.head){consoleHead();}             //--Вывод заголовков; 
//=====================Вспомогательные функции=====================================================
if(RT_HW_Base.shed.frdm.num==2){generatorVar();}  //--Генератор тестовых значений;
//=====================ПИНЫ========================================================================
if(RT_HW_Base.shed.fast.num==2) {getAnalog();}          //--Чтение ADC; 
if(RT_HW_Base.shed.fast.num==2) {setPWM();}             //--Запись PWM; 
if(RT_HW_Base.shed.frdm.num==10){getButton();}          //--Чтение кнопки с защитой от дребезга;
if(RT_HW_Base.shed.frdm.num==14){setServo();}           //--Запись Servo; 
//=====================ДИСПЛЕИ LCD HD44780=========================================================
if(RT_HW_Base.shed.frdm.num==40){Lcd1();}         //--Управление дисплеем 1(16x2,i2c,0x27);
if(RT_HW_Base.shed.frdm.num==44){Lcd2();}         //--Управление дисплеем 2(20x4,i2c,0x3E);
if(RT_HW_Base.shed.frdm.num==46){Lcd3();}         //--Управление дисплеем 3(20x4,SPI,RT_HW_Base.device.spi.cs1);
//=====================СЕНСОРЫ i2c=================================================================
//if(RT_HW_Base.shed.frdm.num==10){snsAHTXX();}   //--Управление сенсором AHTXX;
//if(RT_HW_Base.shed.frdm.num==10){snsBMP180();}  //--Управление сенсором BMP180;
//if(RT_HW_Base.shed.frdm.num==10){snsBMP280();}  //--Управление сенсором BMP280;
if(RT_HW_Base.shed.frdm.num==10){snsCMTHP();}   //--Управление сенсором AHTXX(T,H) и BMP280(P);
if(RT_HW_Base.shed.frdm.num==12){snsSHT3X();}   //--Управление сенсором SHT3X;
if(RT_HW_Base.shed.frdm.num==14){snsHTU21();}   //--Управление сенсором HTU21;
if(RT_HW_Base.shed.frdm.num==20){snsBH1750();}  //--Управление сенсором BH1750;  
//=====================СЕНСОРЫ SPI,SPN=============================================================
if(RT_HW_Base.shed.frdm.num==22){snsMAX6675();} //--Управление сенсором MAX6675.SPI;  
if(RT_HW_Base.shed.frdm.num==24){snsMAX6675x();} //--Управление сенсором MAX6675.SPN;
//=====================СЕНСОРЫ через пины==========================================================  
if(RT_HW_Base.shed.frdm.num==26){snsDHT22();}    //--Управление сенсором DHT22;
if(RT_HW_Base.shed.frdm.num==28){snsDS1820();}   //--Управление сенсором DS1820 (по шине 1-Wire);  
if(RT_HW_Base.shed.frdm.num==30){snsSR04();}     //--Управление сенсором HC-SR04 (по прерываниям);  
//=====================РАСШИРИТЕЛИ i2c=============================================================
if(RT_HW_Base.shed.frdm.num==32){extMCP4725(genDAC);}  //--Вывод DAC MCP4725;
if(RT_HW_Base.shed.frdm.num==34){genForTestMCP23017(); extMCP23017();}
//=====================РАСШИРИТЕЛИ SPI,SPN=========================================================
if(RT_HW_Base.shed.frdm.num==36){extSPIhc595  (genRUN8);}     //--74HC595,бегущая "1";
//if(RT_HW_Base.shed.frdm.num==36){extSPIhc595x2(genRUN16);}    //--74HC595,бегущая "1";
//if(RT_HW_Base.shed.frdm.num==36){extSPIhc595x3(genRUN24);}    //--74HC595,бегущая "1";
//if(RT_HW_Base.shed.frdm.num==36){extSPIhc595x4(genRUN32);}    //--74HC595,бегущая "1";
//if(RT_HW_Base.shed.frdm.num==38){extSPIhc165();}    //--74HC595,бегущая "1";
//=================================================================================================            
//-------------------------------------------------------------------------------------------------  
}; //++++END loop()================================================================================
//--------------------------------------------------------------------------
