 #include "RT_HW_BASE.h"
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.Структура рабочих буферов; 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++				  
struct RT_HW_STRUCT_BUFF	{uint8_t bf8,vu8; int8_t vi8; int16_t vi16; uint16_t vu16; uint32_t vu32;};
struct RT_HW_STRUCT_INDEX	{uint8_t i,j,m;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						2.Структура для работы с консолью
// dir-этапы; ok-флаг готовности консоли; head-флаг разрешения вывода заголовков (включается на один цикл при ok=1); all-разрешение вывода после вывода заголовков;
// numUart: =0-8-аппаратные UART; =9-программный UART;  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
struct RT_HW_STRUCT_CONSOLE {uint8_t dir=0; uint8_t ok=0; uint8_t head=0; uint8_t all=0; uint8_t numUart=0; uint8_t idx; uint8_t arr[6];};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						3.Структуры системных параметров
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct RT_HW_STRUCT_BOARD   {uint8_t  codeArch, codeBoard;};			//--Параметры контр.(архитектура и пр.);
struct RT_HW_STRUCT_DEPTH 	{uint8_t  sys,adc,adcDrift,adcNull,tch,pwm,dac;};//--Разрешения устройств и дрейфы ADC;
struct RT_HW_STRUCT_PWM   	{uint8_t  qntChannel=16; uint16_t channel; uint8_t idx; uint16_t freq;}; //--Макс.кол-во каналов,биты занятости каналов, частота;
struct RT_HW_STRUCT_TIMER   {uint8_t  qnt=16;        uint16_t busy=0;}; //--Макс.кол-во таймеров,,биты занятости таймеров;
struct RT_HW_STRUCT_PIN_SPI {uint8_t  cs0,cs1,cs2,cs3;};				//--Тестовые пины       SPI->cs0,cs1,cs2,cs3;
struct RT_HW_STRUCT_PIN_GPIO{uint8_t  control,led,button,wsBus,adc,btn,tch,pwm,dac,servo,debug1,debug2,debug3;};	//--Номера пинов платы;  
struct RT_HW_STRUCT_PIN_DEV {uint8_t  oneWBus,dht22,srTrig;};	//--Тестовые пины устройств->1-Wire(ds1820),DHT22,HC-SR04.echo,HC-SR04.trig;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						4.Обобщенная структура системных устройств
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ 
struct RT_HW_STRUCT_DEVICE{
RT_HW_STRUCT_BOARD      board;	//--Параметры контроллера (архитектура и пр.);
RT_HW_STRUCT_DEPTH		depth;	//--Разрешения устройств и дрейфы ADC;
RT_HW_STRUCT_PWM 		pwm;	//--PWM  ->макс.кол-во каналов, биты занятости каналов, частота;
RT_HW_STRUCT_TIMER  	timer;  //--Timer->макс.кол-во таймеров,биты занятости таймеров;
RT_HW_STRUCT_PIN_SPI 	spi;	//--Тестовые пины SPI->cs0,cs1,cs2,cs3;
RT_HW_STRUCT_PIN_GPIO  	pin;	//--Номера пинов платы->control,led,button,adc,pwm,debug1,debug2,debug3;
RT_HW_STRUCT_PIN_DEV 	dev;	//--Данные для работы с устройствами 1-Wire,bus WS2812,HC-SR04.Echo,HC-SR04.Trig,DHT22;
};		 
//=================================================================================================
//struct RT_HW_CHATTER_V8_ID    {uint32_t time; uint8_t dir=0;   uint8_t ago=0;};				    //--Для защиты от дребезга пина DI;