//=================================================================================================
//						1.Структуры для диспетчера планирования задач
//=================================================================================================
struct RT_HW_STRUCT_SHAD  	{uint8_t  num,cnt,qnt;};	//--Регистры диспетчера (;
struct RT_HW_STRUCT_SHED  	{
RT_HW_STRUCT_SHAD quick, fast, slow, back, frdm;  //--параметры по типам задач: 
												  //  1) num=номер задачи как событие; 
												  //  2) cnt=текущий счетчик задач(рабочий параметр);
												  //  3) qnt=максимальное кол-во задач;
uint8_t  ready=0;                                 //--Флаг запуска ready; 
uint8_t  control=1,blink10=1,blink25=1,blink50=1,blink100=1,blink250=1,blink500=1,blinkSec=1; 
uint8_t  eventSec=1;
uint8_t  event=0,run=0; 
uint32_t cycle; 		//--Кол-во циклов loop()      в сек;
uint16_t smallCycle;    //--Кол-во циклов loop()/1000 в сек;
uint32_t cntSec=0;		//--Счетчик секунд с начала запуска программы;
uint32_t cntCycle=0;    //--Счетчик для расчета кол-во циклов loop();
uint32_t timeStart10=0, timeStart25=0;  //--Рабочие таймеры для периодов 10 и 25мс; 
uint8_t  workSec;
uint8_t  cnt50=0, cnt100=0, cnt250=0; 
uint8_t  initParam=0;
};  	
//=================================================================================================
//                  	2.Структура управления задачами
// Работает совместно с функциями directTask и при необходимости с SetTaskID
//=================================================================================================
struct RT_HW_STRUCT_SHED_TASK{                    //--Управление задачами полный
uint8_t  custom=0;      uint8_t  first=1;       uint8_t run=0;   char    mode='C';  
uint8_t  gen=0;		    uint8_t  agoGen=1;      uint8_t agoEN=1; uint8_t extEN=1;  
uint8_t  periodTask=20; uint8_t  periodLimit=2; uint8_t cntTask; uint8_t cntLimit;     
uint8_t  tick=0;        uint8_t  dir=0;         uint32_t timeBegin;
};
//=================================================================================================
//                  	2.Структура управления задачами
// Работает совместно с функциями directTask и при необходимости с SetTaskID
//=================================================================================================
struct RT_HW_STRUCT_CONTROL_TASK{                    //--Управление задачами полный
uint8_t  custom=0;  uint8_t  first=1; uint8_t run=0; char    mode='P';  
uint8_t  agoEN=1;   uint8_t  extEN=1; uint8_t dir=0; uint8_t timeOut=10;
uint8_t  workDelay=0;   
uint16_t period=100;         
uint32_t timeBegin; uint32_t timeBig;
};
//=================================================================================================
//                  	3.Структура для функции динамической задержки 
//=================================================================================================
struct RT_HW_STRUCT_DELAY{                    
uint32_t vTime;		    //--Переменная для начала отсчета задержки;
uint16_t vDelay;		//--Время задержки;
uint8_t  dir=0;			//--Этап функции;
uint8_t  point; 		//--Точка возрата из функции(используется внешними программами);
};
//=================================================================================================
//						4.Класс для блоков вывода на консоль FLProg
//    Пока используется,  но постепенно надо будет заменить на RT_HW_STRUCT_SHED_TASK  
//=================================================================================================
class RT_HW_CLASS_FLPROG_CHECK{
public:
uint8_t dir; uint8_t state:4,first:1,agoeN:1,exteN:1,extEN:1;
RT_HW_CLASS_FLPROG_CHECK(){dir=state=first=agoeN=0; exteN=extEN=1;} //--Конструктор;
private:
};  //---END 
//=================================================================================================






//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.Структура для блоков вывода на консоль FLProg;  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//struct RT_HW_STRUCT_FLPROG_CHECK{
//uint8_t dir=0;   	  char modeOutput='N'; uint8_t state=0;
//uint8_t agoeN=0; 	  uint8_t  exteN=1;    uint8_t first=0;
//uint32_t timeBegin=0; uint16_t period=100;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						2.Структура для блоков вывода на консоль FLProg;  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//struct RT_HW_STRUCT_FLPROG_SIMPLE{uint8_t dir=0; uint8_t state:4,first:1,agoeN:1,exteN:1;};
//struct RT_HW_STRUCT_FLPROG_CHECK_SIMPLE{uint8_t dir=0; uint8_t state:4,first:1,agoeN:1,exteN:1;};
//-------------------------------------------------------------------------------------------------
