//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.Структуры работы с UART
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
struct RT_HW_STRUCT_UART_RXTX{uint16_t begin=0;   uint16_t ready=0;};	
struct RT_HW_STRUCT_UART_USB {uint32_t timeBegin; uint16_t dir=0;};
struct RT_HW_STRUCT_UART     {
uint8_t  state=0;				//--Состояние: bit.0-
uint32_t speed=115200;			//--Скорость
#if defined(SERIAL_8N1)
	uint32_t config=SERIAL_8N1;
#else 
	uint32_t config=0x800001C;
#endif	
	uint8_t  rx=255; 
	uint8_t  tx=255;
	uint8_t  dir=0;
	uint8_t  status=0;
};	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						3.Структура работы с встроенным Bluetooth
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
struct RT_HW_STRUCT_BLUETOOTH{
uint8_t  state=0;
uint32_t speed=115200;
uint8_t  dir=0;
String name="ESP32S BTH EIS";
};
/*
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						4.Структуры работы с i2с
// status: =0-No init; =1 -Master; =2 -Slave;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct RT_HW_STRUCT_I2C {
	uint8_t  sda=255; 	//--пин SDA;
	uint8_t  scl=255;	//--пин SCL;  
	uint8_t  adr=255; 	//--Адрес: для Master всегда=0;
	uint8_t  busy=0; 	//--Состояние занятости шины: =10-для i2c0; =11-для i2c1; =12-для i2c2;	
	uint8_t  codeErr=0; //--Код ошибки;
	uint8_t  status=0; 	//--Настройка шины: =0 - не настроена; =1 Master; =2 Slave;
	uint32_t speed=400000UL; //--Скорость шины;
	uint32_t timeOut;   //--Регистр для тайм-аута при приеме байтов;
	uint32_t cntByte;   //--Счетчик принятых байт;
    uint8_t  ddr=0;
	uint8_t  idx;
    uint16_t buff;
    uint16_t cntScan=0;
	uint8_t  i2cDelay;	//--Задержка для программного i2c(STM32_M)	
};
struct RT_HW_STRUCT_I2C_FUNC {
uint8_t	 adr=255; 		//--Адрес;	
uint8_t  bus=0;			//--Номер шины;
uint8_t  stop=1;		//--Cтоповый бит;
uint8_t  idx;			//--Рабочий индекс;
uint32_t speed=400000UL; //--Скорость шины;	
};
*/



 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						5.Структуры работы с SPI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
struct RT_HW_STRUCT_SPI {
uint8_t  sck=255; 	//--номер пина SCK;
uint8_t  mosi=255; 	//--номер пина MOSI;
uint8_t  miso=255; 	//--номер пина MISO;	
uint8_t  ss=0; 	    //--номер пина SS/CS: для Slave ss, для Master сs;
uint8_t  busy=0;  	//--Состояние занятости шины: =10-для SPI0; =11-для SPI1; =12-для SPI2;};
uint8_t  status=0;	//--Настройка шины: =0 - не настроена; =1 Master; =2 Slave;
uint8_t  codeErr=0;	//--Код ошибки; 	
uint32_t speed=4000000UL;	//--Скорость шины;	
uint16_t buff;		//--Регистр для приема функцией transfer;
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						5.Структуры работы с SSPI
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
struct RT_HW_STRUCT_SPN {
RT_HW_PIN_DIR_ID idSCK, idMISO, idMOSI, idCS;
uint8_t  custom=0;
uint8_t  status=0;	//--Настройка шины: =0 - не настроена; =1 Master; =2 Slave;
uint8_t  codeErr=0;	//--Код ошибки; 	
uint8_t  speed=0;
uint8_t  time=0;
uint8_t	 permitRX=0, permitTX=0;
char     bitOrder='F';	//--Впереди старший бит;
uint8_t  idx;
};




//=================================================================================================
