//*************************************************************************************************
//							1.Контроллер типа DUE
//*************************************************************************************************
#if !defined(RT_HW_BOARD_SELECT) && defined(RT_HW_BOARD_SAM_DUE)						
#define      RT_HW_BOARD_SELECT 	             "BOARD SAM DUE"			//--Идентификатор выбора платы;
#define RT_HW_BOARD_MEMORY   "FLASH=512Kb; RAM=96Kb;"						//--Параметры памяти;
#define RT_HW_PERMIT_UART0													//--Разрешение работы с UART0;
#define RT_HW_PERMIT_UART1													//--Разрешение работы с UART1; 
#define RT_HW_PERMIT_UART2													//--Разрешение работы с UART2; 
#define RT_HW_PERMIT_UART3													//--Разрешение работы с UART3;  
#define RT_HW_PERMIT_I2C0													//--Разрешение работы с i2c0; 
#define RT_HW_PERMIT_SPI0													//--Разрешение работы с spi0;
#define RT_HW_PERMIT_SSPI													//--Разрешение работы с sspi; 
#define RT_HW_PERMIT_DAC													//--Разрешение работы с DAC;
//------Системные пины------------------------------------------------------------------------------
enum   {RT_HW_BOARD_CONTROL=42, RT_HW_BOARD_LED=13, RT_HW_BOARD_BUTTON=4, RT_HW_BOARD_WS=255};//--Пины контроль,led,кнопка;
//------Параметры контроллера общие----------------------------------------------------------------	
enum   {RT_HW_PIN_QNT_MAX=70,	RT_HW_FCPU=84, 	RT_HW_VCC=3300};
//-----Параметры UART------------------------------------------------------------------------------	
enum   {RT_HW_UART0_RX=0,  RT_HW_UART0_TX=1, 
		RT_HW_UART1_RX=19, RT_HW_UART1_TX=18, 
		RT_HW_UART2_RX=17, RT_HW_UART2_TX=16, 
		RT_HW_UART3_RX=15, RT_HW_UART3_TX=14};
//-----Параметры I2C------------------------------------------------------------------------------	
enum   {RT_HW_I2C0_SDA=18, RT_HW_I2C0_SCL=19, RT_HW_I2C0_MODE_FM=RT_HW_I2C_MODE_FM}; 
#define RT_HW_PERMIT_I2C0	
//-----Параметры SPI------------------------------------------------------------------------------	
enum   {RT_HW_SPI0_SCK=52, RT_HW_SPI0_MISO=50,  RT_HW_SPI0_MOSI=51, RT_HW_SPI0_SS=53};
//-----Системные параметры-------------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_SYS_PAR[] 	={12,			   	RT_HW_PGM_END};  //--SYS->depth;
const uint8_t PROGMEM RT_HW_PGM_SYS_ADC[] 	={12,3,5,			RT_HW_PGM_END};  //--ADC->depth,drift,null;
const uint8_t PROGMEM RT_HW_PGM_SYS_TCH[] 	={  				RT_HW_PGM_END};  //--TCH->depth,drift,null; 
const uint8_t PROGMEM RT_HW_PGM_SYS_PWM[] 	={12,10,			RT_HW_PGM_END};  //--PWM->depth,freq; 
const uint8_t PROGMEM RT_HW_PGM_SYS_DAC[] 	={8,				RT_HW_PGM_END};  //--DAC->depth; 
//-----Системные пины и параметры коммуникаций------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_BRD[] 	={RT_HW_BOARD_CONTROL, RT_HW_BOARD_LED, RT_HW_BOARD_BUTTON, RT_HW_BOARD_WS, RT_HW_PGM_END};  //--Пины->control,led,button,WS2812; 
const uint8_t PROGMEM RT_HW_PGM_PIN_I2C[]	={RT_HW_I2C0_SDA,  RT_HW_I2C0_SCL,									RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_ICS[]	={	    															RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_SPI[]	={RT_HW_SPI0_SCK, RT_HW_SPI0_MISO,  RT_HW_SPI0_MOSI, RT_HW_SPI0_SS, RT_HW_PGM_END}; 
const uint8_t PROGMEM RT_HW_PGM_PIN_SPN[]	={ 4, 5, 6, 7, 														RT_HW_PGM_END}; // Soft SPI(sck,miso,mosi,cs[];  
const uint8_t PROGMEM RT_HW_PGM_PIN_UHS[]	={RT_HW_UART0_RX,  RT_HW_UART0_TX,	RT_HW_UART1_RX,  RT_HW_UART1_TX, 
											  RT_HW_UART2_RX,  RT_HW_UART2_TX,	RT_HW_UART3_RX,  RT_HW_UART3_TX,RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_USS[]	={									RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_CAN[]	={									RT_HW_PGM_END};		
const uint8_t PROGMEM RT_HW_PGM_PIN_BTH[]	={									RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_ETH[]	={									RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_WFI[]	={									RT_HW_PGM_END};	
//-----Доступные пины контроллера------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_ALL[]	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
										      16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,
										      32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,
										      48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,
										      64,65,66,67,68,69,70,71,							RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_DIN[]	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
										      16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,
										      32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,
										      48,49,50,51,52,53,								RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_ADC[]	={54,55,56,57,58,59,60,61,62,63,64,	RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_TCH[]	={													RT_HW_PGM_END};									
const uint8_t PROGMEM RT_HW_PGM_PIN_DOT[]	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
										      16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,
										      32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,
										      48,49,50,51,52,53, 								RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_PWM[]	={ 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,44,45,46,		RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_DAC[]	={67,												RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_INT[]	={ 2, 3,18,19,20,21,								RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_N5V[]	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
										      16,17,18,19,20,21,22,23,24,25,26,27,28,29,30,31,
										      32,33,34,35,36,37,38,39,40,41,42,43,44,45,46,47,
										      48,49,50,51,52,53,54,55,56,57,58,59,60,61,62,63,
										      64,65,66,67,68,69,70,71,							RT_HW_PGM_END};	
//-----Тестовые пины и адреса------------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_DBG[] 	={43,44,45,			RT_HW_PGM_END};	//--Пины debug1,debug2,debug3;	
const uint8_t PROGMEM RT_HW_PGM_PIN_OUT[]	={ 5, 6, 2,      RT_HW_PGM_END};	//--Пины PWM0,PWM1,Servo1,Servo2;							                  
const uint8_t PROGMEM RT_HW_PGM_PIN_INP[]	={54,55,12,         RT_HW_PGM_END};	//--Пины A0,A1,btn1,btn2,TCH0,TCH1;
const uint8_t PROGMEM RT_HW_PGM_PIN_DCT[]	={          		RT_HW_PGM_END};	//--Пины DAC0,DAC1;
const uint8_t PROGMEM RT_HW_PGM_PIN_DEV[]	={ 4, 7, 3,			RT_HW_PGM_END};	//--Пины DS1820,DHT22,HC-SR04.trig;
const uint8_t PROGMEM RT_HW_PGM_PIN_CSS[]	={46,47,48,49,		RT_HW_PGM_END};	//--Пины CS SPI:595,LCD,NRF,DEVl;	
const uint8_t PROGMEM RT_HW_PGM_PIN_LC6[]   ={23,24,25,26,27,28,29,							//--Пины LCD HD44780 for bus4: RS,RW,E,DB4-DB7[]
                                              31,32,33,34,35,36,37,38,39,40,41,RT_HW_PGM_END};//Пины LCD HD44780 for bus8: RS,RW,E,DB0-DB7[]
const uint8_t PROGMEM RT_HW_PGM_PIN_TFT[] 	={26,27,28,29,30,				RT_HW_PGM_END};	//--Пины(дополнительные) TFT дисплея(SPI)-CS,R/S,LED,RST,TOUCH;
const uint8_t PROGMEM RT_HW_PGM_PIN_URT[] 	={ 1, 2, 			RT_HW_PGM_END};	// UART: ModBus, Nextion 	
const uint8_t PROGMEM RT_HW_PGM_ADR_I2C[] 	={63,62,32,33,		RT_HW_PGM_END};	// lcd1,lcd2,mcp1,mcp2;
//-------------------------------------------------------------------------------------------------
#endif
//*************************************************************************************************
