//*************************************************************************************************
//							1.Контроллер типа ESP32S2 Dev module [esp32.variant]
//*************************************************************************************************
#if !defined(RT_HW_BOARD_SELECT)  && defined(RT_HW_BOARD_ESP32S2_DEV)
#define      RT_HW_BOARD_SELECT 			"BOARD ESP32S2 DEV"				//--Идентификатор выбора платы;
//-------------------------------------------------------------------------------------------------
#define RT_HW_BOARD_MEMORY  "FLASH=128Kb; RAM=320Kb; Ext_FLASH=4/16Mb;"		//--Параметры памяти;												
#define RT_HW_PERMIT_UART0													//--Разрешение работы с UART0; 
//#define RT_HW_PERMIT_UART1												//--Разрешение работы с UART1; 
#define RT_HW_PERMIT_I2C0													//--Разрешение работы с i2c0; 
//#define RT_HW_PERMIT_I2C1													//--Разрешение работы с i2c1; 
#define RT_HW_PERMIT_SPI0													//--Разрешение работы с spi0 (clk=18,miso=19,mosi=23,cs=5); 
//#define RT_HW_PERMIT_SPI1	//--!!! Проблемы с core ESP32??? - !!!			//--Разрешение работы с spi1 (clk=14,miso=12,mosi=13,ss=15); 
#define RT_HW_PERMIT_DAC													//--Разрешение работы с DAC;
#define RT_HW_PERMIT_WS														//--Разрешение работы с WS2812; 
//------Системные пины------------------------------------------------------------------------------
enum   {RT_HW_BOARD_CONTROL=13, RT_HW_BOARD_LED=18, RT_HW_BOARD_BUTTON=14, RT_HW_BOARD_WS=255};	//--Пины контроль,led,кнопка;
//------Параметры контроллера общие-------------------------------------------------------------------	
enum   {RT_HW_PIN_QNT_MAX=43,	RT_HW_FCPU=240, 	RT_HW_VCC=3300}; 
//-----Параметры UART------------------------------------------------------------------------------	
enum   {RT_HW_UART0_RX=33,   RT_HW_UART0_TX=38};
//-----Параметры I2C------------------------------------------------------------------------------	
enum   {RT_HW_I2C0_SDA=8,  RT_HW_I2C0_SCL=9};  //--В действительности будет sda=32, scl=33;	
//-----Параметры SPI------------------------------------------------------------------------------	
enum   {RT_HW_SPI0_SCK=36,  RT_HW_SPI0_MISO=37, RT_HW_SPI0_MOSI=35, RT_HW_SPI0_SS=34};
//-----Системные параметры-------------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_SYS_PAR[]  	={12,			   	RT_HW_PGM_END};  //--SYS->depth;
const uint8_t PROGMEM RT_HW_PGM_SYS_ADC[]  	={13,20,9,			RT_HW_PGM_END};  //--ADC->depth,drift,null;
const uint8_t PROGMEM RT_HW_PGM_SYS_TCH[]  	={8,  				RT_HW_PGM_END};  //--TCH->depth,drift,null; 
const uint8_t PROGMEM RT_HW_PGM_SYS_PWM[]  	={12,10,			RT_HW_PGM_END};  //--PWM->depth,freq; 
const uint8_t PROGMEM RT_HW_PGM_SYS_DAC[]  	={8,				RT_HW_PGM_END};  //--DAC->depth; 
//-----Системные пины и параметры коммуникаций------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_BRD[]	={RT_HW_BOARD_CONTROL, RT_HW_BOARD_LED, RT_HW_BOARD_BUTTON, RT_HW_BOARD_WS, RT_HW_PGM_END};  //--Пины->control,led,button,WS2812; 
const uint8_t PROGMEM RT_HW_PGM_PIN_I2C[] 	={RT_HW_I2C0_SDA, RT_HW_I2C0_SCL, RT_HW_PGM_END}; 
const uint8_t PROGMEM RT_HW_PGM_PIN_ICS[]	={	    												 			RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_SPI[] 	={RT_HW_SPI0_SCK, RT_HW_SPI0_MISO, RT_HW_SPI0_MOSI, RT_HW_SPI0_SS, 	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_SPN[]	={ 														 			RT_HW_PGM_END}; 
const uint8_t PROGMEM RT_HW_PGM_PIN_UHS[] 	={RT_HW_UART0_RX, RT_HW_UART0_TX,   RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_USS[] 	={				 					RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_CAN[] 	={				 		    		RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_BTH[] 	={				 		             RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_ETH[] 	={  								RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_WFI[] 	={192,  							RT_HW_PGM_END};
//-----Доступные пины контроллера------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_ALL[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										      20,21, 				  33,34,35,36,39,40,41,42,43,44,45,  	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_DIN[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										      20,21, 				  33,34,35,36,39,40,41,42,43,44,45,  	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_ADC[] 	={     1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,20, 	RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_TCH[] 	={     1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14, 	RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_DOT[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										      20,21, 				  33,34,35,36,39,40,41,42,43,44,45,  	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_PWM[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										      20,21, 				  33,34,35,36,39,40,41,42,43,44,45,  	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_DAC[] 	={17,18,													  	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_INT[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										      20,21, 				  33,34,35,36,39,40,41,42,43,44,45,  	RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_N5V[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										      20,21, 				  33,34,35,36,39,40,41,42,43,44,45,  	RT_HW_PGM_END};
//-----Тестовые пины и адреса------------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_DBG[]  	={13,  			    RT_HW_PGM_END};	//--Пины debug1,debug2,debug3;	
const uint8_t PROGMEM RT_HW_PGM_PIN_OUT[] 	={25,       		RT_HW_PGM_END};	//--Пины PWM0,PWM1,Servo1,Servo2;
const uint8_t PROGMEM RT_HW_PGM_PIN_INP[] 	={36, 39, 35,    	RT_HW_PGM_END};	//--Пины A0,A1,btn1,btn2,TCH0,TCH1;
const uint8_t PROGMEM RT_HW_PGM_PIN_DCT[] 	={25, 26,           RT_HW_PGM_END};	//--Пины DAC0,DAC1;
const uint8_t PROGMEM RT_HW_PGM_PIN_DEV[] 	={33,13,32, 		RT_HW_PGM_END};	//--Пины DS1820,DHT,HC-SR04.trig;
const uint8_t PROGMEM RT_HW_PGM_PIN_CSS[] 	={ 5,  4, 15, 2,	RT_HW_PGM_END};	//--Пины CS SPI:595,LCD,NRF,DEVl 	
const uint8_t PROGMEM RT_HW_PGM_PIN_LC6[]  	={					RT_HW_PGM_END};	//--Пины для подключения LCD по 4-х битной шине;
const uint8_t PROGMEM RT_HW_PGM_PIN_TFT[]  	={0,26,32,33,255,	RT_HW_PGM_END};	//--Пины(дополнительные[]  TFT дисплея(SPI[] -CS,R/S,LED,RST,TOUCH;
const uint8_t PROGMEM RT_HW_PGM_PIN_URT[] 	={99, 2, 			RT_HW_PGM_END};	//--UART: ModBus, Nextion 	
const uint8_t PROGMEM RT_HW_PGM_ADR_I2C[]  	={39,62,32,33,		RT_HW_PGM_END};	//--i2c: lcd1,lcd2,mcp1,mcp2;
//-------------------------------------------------------------------------------------------------
#endif

//*************************************************************************************************
//							2.Контроллер типа ESP32 LOLIN S2 PRO [esp32.variant]
//*************************************************************************************************
#if !defined(RT_HW_BOARD_SELECT)  && defined(RT_HW_BOARD_LOLIN_S2_PRO)
#define      RT_HW_BOARD_SELECT 			"BOARD LOLIN S2 PRO"				//--Идентификатор выбора платы;
//-------------------------------------------------------------------------------------------------
#define RT_HW_BOARD_MEMORY  "FLASH=128Kb; RAM=320Kb; Ext_FLASH=4/16Mb;"		//--Параметры памяти;												
#define RT_HW_PERMIT_UART0													//--Разрешение работы с UART0; 
//#define RT_HW_PERMIT_UART1												//--Разрешение работы с UART1; 
#define RT_HW_PERMIT_I2C0													//--Разрешение работы с i2c0; 
//#define RT_HW_PERMIT_I2C1													//--Разрешение работы с i2c1; 
#define RT_HW_PERMIT_SPI0													//--Разрешение работы с spi0 (clk=18,miso=19,mosi=23,cs=5); 
//#define RT_HW_PERMIT_SPI1	//--!!! Проблемы с core ESP32??? - !!!			//--Разрешение работы с spi1 (clk=14,miso=12,mosi=13,ss=15); 
#define RT_HW_PERMIT_DAC													//--Разрешение работы с DAC;
#define RT_HW_PERMIT_WS														//--Разрешение работы с WS2812; 
//------Системные пины------------------------------------------------------------------------------
enum   {RT_HW_BOARD_CONTROL=13, RT_HW_BOARD_LED=18, RT_HW_BOARD_BUTTON=14, RT_HW_BOARD_WS=255};	//--Пины контроль,led,кнопка;
//------Параметры контроллера общие-------------------------------------------------------------------	
enum   {RT_HW_PIN_QNT_MAX=43,	RT_HW_FCPU=240, 	RT_HW_VCC=3300}; 
//-----Параметры UART------------------------------------------------------------------------------	
enum   {RT_HW_UART0_RX=33,   RT_HW_UART0_TX=38};
enum   {RT_HW_UART1_RX=33,   RT_HW_UART1_TX=38};
//-----Параметры I2C------------------------------------------------------------------------------	
enum   {RT_HW_I2C0_SDA=8,  RT_HW_I2C0_SCL=9};  //--В действительности будет sda=32, scl=33;	
//-----Параметры SPI------------------------------------------------------------------------------	
enum   {RT_HW_SPI0_SCK=36,  RT_HW_SPI0_MISO=37, RT_HW_SPI0_MOSI=35, RT_HW_SPI0_SS=34};
//-----Системные параметры-------------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_SYS_PAR[]  	={12,			   	RT_HW_PGM_END};  //--SYS->depth;
const uint8_t PROGMEM RT_HW_PGM_SYS_ADC[]  	={13,20,9,			RT_HW_PGM_END};  //--ADC->depth,drift,null;
const uint8_t PROGMEM RT_HW_PGM_SYS_TCH[]  	={8,  				RT_HW_PGM_END};  //--TCH->depth,drift,null; 
const uint8_t PROGMEM RT_HW_PGM_SYS_PWM[]  	={12,10,			RT_HW_PGM_END};  //--PWM->depth,freq; 
const uint8_t PROGMEM RT_HW_PGM_SYS_DAC[]  	={8,				RT_HW_PGM_END};  //--DAC->depth; 
//-----Системные пины и параметры коммуникаций------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_BRD[]	={RT_HW_BOARD_CONTROL, RT_HW_BOARD_LED, RT_HW_BOARD_BUTTON, RT_HW_BOARD_WS, RT_HW_PGM_END};  //--Пины->control,led,button,WS2812; 
const uint8_t PROGMEM RT_HW_PGM_PIN_I2C[] 	={RT_HW_I2C0_SDA, RT_HW_I2C0_SCL, RT_HW_PGM_END}; 
const uint8_t PROGMEM RT_HW_PGM_PIN_ICS[]	={	    												 			RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_SPI[] 	={RT_HW_SPI0_SCK, RT_HW_SPI0_MISO, RT_HW_SPI0_MOSI, RT_HW_SPI0_SS, 	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_SPN[]	={ 														 			RT_HW_PGM_END}; 
const uint8_t PROGMEM RT_HW_PGM_PIN_UHS[] 	={RT_HW_UART0_RX, RT_HW_UART0_TX,
											  RT_HW_UART1_RX, RT_HW_UART1_TX,   RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_USS[] 	={				 					RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_CAN[] 	={				 		    		RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_BTH[] 	={				 		             RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_ETH[] 	={  								RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_WFI[] 	={192,  							RT_HW_PGM_END};
//-----Доступные пины контроллера------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_ALL[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										      20,21, 				  33,34,35,36,39,40,41,42,43,44,45,  	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_DIN[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										      20,21, 				  33,34,35,36,39,40,41,42,43,44,45,  	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_ADC[] 	={     1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14, 	RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_TCH[] 	={     1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14, 	RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_DOT[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										      20,21, 				  33,34,35,36,39,40,41,42,43,44,45,  	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_PWM[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										      20,21, 				  33,34,35,36,39,40,41,42,43,44,45,  	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_DAC[] 	={17,18,													  	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_INT[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										      20,21, 				  33,34,35,36,39,40,41,42,43,44,45,  	RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_N5V[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										      20,21, 				  33,34,35,36,39,40,41,42,43,44,45,  	RT_HW_PGM_END};
//-----Тестовые пины и адреса------------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_DBG[]  	={13,  			    RT_HW_PGM_END};	//--Пины debug1,debug2,debug3;	
const uint8_t PROGMEM RT_HW_PGM_PIN_OUT[] 	={25,       		RT_HW_PGM_END};	//--Пины PWM0,PWM1,Servo1,Servo2;
const uint8_t PROGMEM RT_HW_PGM_PIN_INP[] 	={36, 39, 35,    	RT_HW_PGM_END};	//--Пины A0,A1,btn1,btn2,TCH0,TCH1;
const uint8_t PROGMEM RT_HW_PGM_PIN_DCT[] 	={25, 26,           RT_HW_PGM_END};	//--Пины DAC0,DAC1;
const uint8_t PROGMEM RT_HW_PGM_PIN_DEV[] 	={33,13,32, 		RT_HW_PGM_END};	//--Пины DS1820,DHT,HC-SR04.trig;
const uint8_t PROGMEM RT_HW_PGM_PIN_CSS[] 	={ 5,  4, 15, 2,	RT_HW_PGM_END};	//--Пины CS SPI:595,LCD,NRF,DEVl 	
const uint8_t PROGMEM RT_HW_PGM_PIN_LC6[]  	={					RT_HW_PGM_END};	//--Пины для подключения LCD по 4-х битной шине;
const uint8_t PROGMEM RT_HW_PGM_PIN_TFT[]  	={0,26,32,33,255,	RT_HW_PGM_END};	//--Пины(дополнительные[]  TFT дисплея(SPI[] -CS,R/S,LED,RST,TOUCH;
const uint8_t PROGMEM RT_HW_PGM_PIN_URT[] 	={99, 2, 			RT_HW_PGM_END};	//--UART: ModBus, Nextion 	
const uint8_t PROGMEM RT_HW_PGM_ADR_I2C[]  	={39,62,32,33,		RT_HW_PGM_END};	//--i2c: lcd1,lcd2,mcp1,mcp2;
//-------------------------------------------------------------------------------------------------
#endif

//*************************************************************************************************
//							3.Контроллер типа ESP32 LOLIN S2 MINI [esp32.variant]
//*************************************************************************************************
#if !defined(RT_HW_BOARD_SELECT)  && defined(RT_HW_BOARD_LOLIN_S2_MINI)
#define      RT_HW_BOARD_SELECT 			"BOARD LOLIN S2 MINI"				//--Идентификатор выбора платы;
//-------------------------------------------------------------------------------------------------
#define RT_HW_BOARD_MEMORY  "FLASH=128Kb; RAM=320Kb; Ext_FLASH=4/16Mb;"		//--Параметры памяти;												
#define RT_HW_PERMIT_UART0													//--Разрешение работы с UART0; 
//#define RT_HW_PERMIT_UART1												//--Разрешение работы с UART1; 
#define RT_HW_PERMIT_I2C0													//--Разрешение работы с i2c0;  
#define RT_HW_PERMIT_SPI0													//--Разрешение работы с spi0; 
#define RT_HW_PERMIT_DAC													//--Разрешение работы с DAC;
#define RT_HW_PERMIT_WS														//--Разрешение работы с WS2812; 
//------Системные пины------------------------------------------------------------------------------
enum   {RT_HW_BOARD_CONTROL=13, RT_HW_BOARD_LED=15, RT_HW_BOARD_BUTTON=14, RT_HW_BOARD_WS=255};	//--Пины контроль,led,кнопка;
//------Параметры контроллера общие-------------------------------------------------------------------	
enum   {RT_HW_PIN_QNT_MAX=43,	RT_HW_FCPU=240, 	RT_HW_VCC=3300}; 
//-----Параметры UART------------------------------------------------------------------------------	
enum   {RT_HW_UART0_RX=37,   RT_HW_UART0_TX=37};
enum   {RT_HW_UART1_RX=33,   RT_HW_UART1_TX=38};
//-----Параметры I2C------------------------------------------------------------------------------	
enum   {RT_HW_I2C0_SDA=33,  RT_HW_I2C0_SCL=35}; 	
//-----Параметры SPI------------------------------------------------------------------------------	
enum   {RT_HW_SPI0_SCK=36,   RT_HW_SPI0_MISO=37,  RT_HW_SPI0_MOSI=35, RT_HW_SPI0_SS=34};
//-----Системные параметры-------------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_SYS_PAR[]  	={12,			   	RT_HW_PGM_END};  //--SYS->depth;
const uint8_t PROGMEM RT_HW_PGM_SYS_ADC[]  	={13,20,9,			RT_HW_PGM_END};  //--ADC->depth,drift,null;
const uint8_t PROGMEM RT_HW_PGM_SYS_TCH[]  	={8,  				RT_HW_PGM_END};  //--TCH->depth,drift,null; 
const uint8_t PROGMEM RT_HW_PGM_SYS_PWM[]  	={12,10,			RT_HW_PGM_END};  //--PWM->depth,freq; 
const uint8_t PROGMEM RT_HW_PGM_SYS_DAC[]  	={8,				RT_HW_PGM_END};  //--DAC->depth; 
//-----Системные пины и параметры коммуникаций------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_BRD[]	={RT_HW_BOARD_CONTROL, RT_HW_BOARD_LED, RT_HW_BOARD_BUTTON, RT_HW_BOARD_WS, RT_HW_PGM_END};  //--Пины->control,led,button,WS2812; 
const uint8_t PROGMEM RT_HW_PGM_PIN_I2C[] 	={RT_HW_I2C0_SDA, RT_HW_I2C0_SCL, RT_HW_PGM_END}; 
const uint8_t PROGMEM RT_HW_PGM_PIN_ICS[]	={	    												 			RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_SPI[] 	={RT_HW_SPI0_SCK, RT_HW_SPI0_MISO, RT_HW_SPI0_MOSI, RT_HW_SPI0_SS, 	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_SPN[]	={ 														 			RT_HW_PGM_END}; 
const uint8_t PROGMEM RT_HW_PGM_PIN_UHS[] 	={RT_HW_UART0_RX, RT_HW_UART0_TX,
											  RT_HW_UART1_RX, RT_HW_UART1_TX,   RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_USS[] 	={				 					RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_CAN[] 	={				 		    		RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_BTH[] 	={				 		             RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_ETH[] 	={  								RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_WFI[] 	={192,  							RT_HW_PGM_END};
//-----Доступные пины контроллера------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_ALL[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										      20,21, 				  33,34,35,36,39,40,41,42,43,44,45,  	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_DIN[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										      20,21, 				  33,34,35,36,39,40,41,42,43,44,45,  	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_ADC[] 	={     1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14, 	RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_TCH[] 	={     1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14, 	RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_DOT[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										      20,21, 				  33,34,35,36,39,40,41,42,43,44,45,  	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_PWM[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										      20,21, 				  33,34,35,36,39,40,41,42,43,44,45,  	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_DAC[] 	={17,18,													  	RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_INT[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										      20,21, 				  33,34,35,36,39,40,41,42,43,44,45,  	RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_N5V[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,16,17,18,19,
										      20,21, 				  33,34,35,36,39,40,41,42,43,44,45,  	RT_HW_PGM_END};
//-----Тестовые пины и адреса------------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_DBG[]  	={                  RT_HW_PGM_END};	//--Пины debug1,debug2,debug3;	
const uint8_t PROGMEM RT_HW_PGM_PIN_OUT[] 	={25,       		RT_HW_PGM_END};	//--Пины PWM0,PWM1,Servo1,Servo2;
const uint8_t PROGMEM RT_HW_PGM_PIN_INP[] 	={ 3, 5, 2, 4,   	RT_HW_PGM_END};	//--Пины A0,A1,btn1,btn2,TCH0,TCH1;
const uint8_t PROGMEM RT_HW_PGM_PIN_DCT[] 	={25, 26,           RT_HW_PGM_END};	//--Пины DAC0,DAC1;
const uint8_t PROGMEM RT_HW_PGM_PIN_DEV[] 	={33,13,32, 	    RT_HW_PGM_END};	//--Пины DS1820,DHT,HC-SR04.trig;
const uint8_t PROGMEM RT_HW_PGM_PIN_CSS[] 	={34,  4, 15, 2,	RT_HW_PGM_END};	//--Пины CS SPI:595,LCD,NRF,DEVl 	
const uint8_t PROGMEM RT_HW_PGM_PIN_LC6[]  	={					RT_HW_PGM_END};	//--Пины для подключения LCD по 4-х битной шине;
const uint8_t PROGMEM RT_HW_PGM_PIN_TFT[]  	={              	RT_HW_PGM_END};	//--Пины(дополнительные[]  TFT дисплея(SPI[] -CS,R/S,LED,RST,TOUCH;
const uint8_t PROGMEM RT_HW_PGM_PIN_URT[] 	={99, 0, 			RT_HW_PGM_END};	//--UART: ModBus, Nextion 	
const uint8_t PROGMEM RT_HW_PGM_ADR_I2C[]  	={39,62,32,33,		RT_HW_PGM_END};	//--i2c: lcd1,lcd2,mcp1,mcp2;
//-------------------------------------------------------------------------------------------------
#endif
//=================================================================================================