//*************************************************************************************************
//							 1.Контроллер типа Raspberry Pi Pico
//*************************************************************************************************
#if !defined(RT_HW_BOARD_SELECT) && (defined(RT_HW_BOARD_RP_PICO) || defined(RT_HW_BOARD_RP_PICO_ANON))	
#if    defined(RT_HW_BOARD_RP_PICO)
 #define      RT_HW_BOARD_SELECT 		    "Board Raspberry Pi Pico"	   //--Идентификатор выбора платы Raspberry Pi Pico;
#elif defined(RT_HW_BOARD_RP_PICO_ANON)
 #define      RT_HW_BOARD_SELECT 		    "Board Raspberry Pi Pico ANON" //--Идентификатор выбора платы ANON;
#else 
 #define      RT_HW_BOARD_SELECT 		    "Board Raspberry Pi Pico XXXX" //--Идентификатор выбора платы (заглушка); 
#endif
//-------------------------------------------------------------------------------------------------
#define RT_HW_BOARD_MEMORY   "FLASH=2000kB; RAM=264Kb;"					//--Параметры памяти;
#define RT_HW_PERMIT_UART0
#define RT_HW_PERMIT_UART1
#define RT_HW_PERMIT_UART2
#define RT_HW_PERMIT_I2C0	
#define RT_HW_PERMIT_I2C1	
#define RT_HW_PERMIT_SPI0
//#define RT_HW_PERMIT_SPI1
//=================================================================================================
//------Системные пины------------------------------------------------------------------------------
enum   {RT_HW_BOARD_CONTROL=28, RT_HW_BOARD_LED=25, RT_HW_BOARD_BUTTON=22, RT_HW_BOARD_WS=255};	//--Пины контроль,led,кнопка;
//------Параметры контроллера общие-------------------------------------------------------------------	
enum   {RT_HW_PIN_QNT_MAX=30, RT_HW_FCPU=125, 	  RT_HW_VCC=3300};
//-----Параметры UART------------------------------------------------------------------------------	
enum   {RT_HW_UART0_RX=1,  RT_HW_UART0_TX=0,
		RT_HW_UART1_RX=1,  RT_HW_UART1_TX=0,  
        RT_HW_UART2_RX=9,  RT_HW_UART2_TX=8};
//-----Параметры I2C------------------------------------------------------------------------------	
enum   {RT_HW_I2C0_SDA=20, RT_HW_I2C0_SCL=21, RT_HW_I2C0_MODE_FM=RT_HW_I2C_MODE_FM,
		RT_HW_I2C1_SDA=14, RT_HW_I2C1_SCL=15, RT_HW_I2C1_MODE_FM=RT_HW_I2C_MODE_FM,
}; 
//-----Параметры SPI------------------------------------------------------------------------------	
enum   {RT_HW_SPI0_SCK=2,  RT_HW_SPI0_MISO=4,  RT_HW_SPI0_MOSI=3,  RT_HW_SPI0_SS=5, 	//--cs 595,lcd,nrf,user->5,6,7,255
		RT_HW_SPI1_SCK=10, RT_HW_SPI1_MISO=12, RT_HW_SPI1_MOSI=11, RT_HW_SPI1_SS=13};
//-----Системные параметры-------------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_SYS_PAR[]   ={12,			   	RT_HW_PGM_END};  //--SYS->depth;
const uint8_t PROGMEM RT_HW_PGM_SYS_ADC[]	={12,4,0,			RT_HW_PGM_END};  //--ADC->depth,drift,null;
const uint8_t PROGMEM RT_HW_PGM_SYS_TCH[]  	={  				RT_HW_PGM_END};  //--TCH->depth,drift,null; 
const uint8_t PROGMEM RT_HW_PGM_SYS_PWM[]  	={12,10,			RT_HW_PGM_END};  //--PWM->depth,freq; 
const uint8_t PROGMEM RT_HW_PGM_SYS_DAC[]  	={  				RT_HW_PGM_END};  //--DAC->depth; 
//-----Системные пины и параметры коммуникаций------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_BRD[] 	={RT_HW_BOARD_CONTROL, RT_HW_BOARD_LED, RT_HW_BOARD_BUTTON, RT_HW_BOARD_WS, RT_HW_PGM_END};  //--Пины->control,led,button,WS2812; 
const uint8_t PROGMEM RT_HW_PGM_PIN_I2C[] 	={RT_HW_I2C0_SDA,   RT_HW_I2C0_SCL,	
											  RT_HW_I2C1_SDA,   RT_HW_I2C1_SCL,    			                  	  RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_ICS[]	={	    															  RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_SPI[] 	={RT_HW_SPI0_SCK,   RT_HW_SPI0_MISO, RT_HW_SPI0_MOSI, RT_HW_SPI0_SS,            
											  RT_HW_SPI1_SCK,   RT_HW_SPI1_MISO, RT_HW_SPI1_MOSI, RT_HW_SPI1_SS,  RT_HW_PGM_END}; 
const uint8_t PROGMEM RT_HW_PGM_PIN_SPN[]	={ 																  	  RT_HW_PGM_END}; 
const uint8_t PROGMEM RT_HW_PGM_PIN_UHS[] 	={RT_HW_UART0_RX,   RT_HW_UART0_TX,	 
                                              RT_HW_UART1_RX,   RT_HW_UART1_TX,
											  RT_HW_UART2_RX,   RT_HW_UART2_TX, 								  RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_USS[] 	={					RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_CAN[] 	={					RT_HW_PGM_END};		
const uint8_t PROGMEM RT_HW_PGM_PIN_BTH[] 	={					RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_ETH[] 	={					RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_WFI[] 	={					RT_HW_PGM_END};	
//-----Доступные пины контроллера------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_ALL[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
											  16,17,18,19,20,21,22,23,24,25,26,27,28,29,		RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_DIN[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
											  16,17,18,19,20,21,22,23,24,25,26,27,28,29,		RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_ADC[] 	={26,27,28,29,   									RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_TCH[] 	={													RT_HW_PGM_END};									
const uint8_t PROGMEM RT_HW_PGM_PIN_DOT[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
											  16,17,18,19,20,21,22,       25,26,27,28,29,	    RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_PWM[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
											  16,17,18,19,20,21,22,       25,26,27,28,29,		RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_DAC[] 	={													RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_INT[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
											  16,17,18,19,20,21,22,         26,27,28,29,		RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_N5V[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
											  16,17,18,19,20,21,22,      25,26,27,28,29,		RT_HW_PGM_END};	
//-----Тестовые пины и адреса------------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_DBG[]  	={16,					RT_HW_PGM_END};	//--Пины debug1,debug2,debug3;	
const uint8_t PROGMEM RT_HW_PGM_PIN_OUT[] 	={27,        			RT_HW_PGM_END};	//--Пины PWM0,PWM1,Servo1,Servo2;							                  
const uint8_t PROGMEM RT_HW_PGM_PIN_INP[] 	={26,27,22,         	RT_HW_PGM_END};	//--Пины A0,A1,btn1,btn2,TCH0,TCH1;
const uint8_t PROGMEM RT_HW_PGM_PIN_DCT[] 	={          			RT_HW_PGM_END};	//--Пины DAC0,DAC1;
const uint8_t PROGMEM RT_HW_PGM_PIN_DEV[] 	={17,255,18,	        RT_HW_PGM_END};	//--Пины DS1820,DHT22.HC-SR04.trig;
const uint8_t PROGMEM RT_HW_PGM_PIN_CSS[] 	={ 5, 6, 7,19,13,16,17,18,   RT_HW_PGM_END};	//--Пины CS SPI:595,LCD,NRF,DEV1; 	
const uint8_t PROGMEM RT_HW_PGM_PIN_LC6[]  	={  					RT_HW_PGM_END};	//--Пины для подключения LCD по 4-х битной шине;
const uint8_t PROGMEM RT_HW_PGM_PIN_TFT[]  	={   		     		RT_HW_PGM_END};	//--Пины(дополнительные[]  TFT дисплея(SPI[] -CS,R/S,LED,RST,TOUCH;
const uint8_t PROGMEM RT_HW_PGM_PIN_URT[]   ={ 1, 2, 				RT_HW_PGM_END};	//--UART: ModBus, Nextion 
const uint8_t PROGMEM RT_HW_PGM_ADR_I2C[]  	={39,62,32,33,			RT_HW_PGM_END};	//--i2c: lcd1,lcd2,mcp1,mcp2;
//-------------------------------------------------------------------------------------------------
#endif
//*************************************************************************************************
//							 2.Контроллер типа Raspberry Pi Pico ZERO (Adafruit KB2040)
//*************************************************************************************************
#if !defined(RT_HW_BOARD_SELECT) && defined(RT_HW_BOARD_RP_PICO_ZERO)	
#define      RT_HW_BOARD_SELECT 		    "Board Raspberry Pi Pico Zero"	//--Идентификатор выбора платы;
#define RT_HW_BOARD_MEMORY   "FLASH=2000kB; RAM=264Kb;"					//--Параметры памяти;
#define RT_HW_PERMIT_UART0
#define RT_HW_PERMIT_UART1
#define RT_HW_PERMIT_UART2
#define RT_HW_PERMIT_I2C0	
//#define RT_HW_PERMIT_I2C1	
#define RT_HW_PERMIT_SPI0
//#define RT_HW_PERMIT_SPI1
//=================================================================================================
//------Системные пины------------------------------------------------------------------------------
enum   {RT_HW_BOARD_CONTROL=28, RT_HW_BOARD_LED=25, RT_HW_BOARD_BUTTON=22, RT_HW_BOARD_WS=255};	//--Пины контроль,led,кнопка;
//------Параметры контроллера общие-------------------------------------------------------------------	
enum   {RT_HW_PIN_QNT_MAX=30, RT_HW_FCPU=125, 	  RT_HW_VCC=3300};
//-----Параметры UART------------------------------------------------------------------------------	
enum   {RT_HW_UART0_RX=1,  RT_HW_UART0_TX=0,
		RT_HW_UART1_RX=1,  RT_HW_UART1_TX=0,  
        RT_HW_UART2_RX=9,  RT_HW_UART2_TX=8};
//-----Параметры I2C------------------------------------------------------------------------------	
enum   {RT_HW_I2C0_SDA=12, RT_HW_I2C0_SCL=13, RT_HW_I2C0_MODE_FM=RT_HW_I2C_MODE_FM}; 
//-----Параметры SPI------------------------------------------------------------------------------	
enum   {RT_HW_SPI0_SCK=2,  RT_HW_SPI0_MISO=4,  RT_HW_SPI0_MOSI=3,  RT_HW_SPI0_SS=5};
//-----Системные параметры-------------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_SYS_PAR[]   ={12,			   	RT_HW_PGM_END};  //--SYS->depth;
const uint8_t PROGMEM RT_HW_PGM_SYS_ADC[]	={12,4,0,			RT_HW_PGM_END};  //--ADC->depth,drift,null;
const uint8_t PROGMEM RT_HW_PGM_SYS_TCH[]  	={  				RT_HW_PGM_END};  //--TCH->depth,drift,null; 
const uint8_t PROGMEM RT_HW_PGM_SYS_PWM[]  	={12,10,			RT_HW_PGM_END};  //--PWM->depth,freq; 
const uint8_t PROGMEM RT_HW_PGM_SYS_DAC[]  	={  				RT_HW_PGM_END};  //--DAC->depth; 
//-----Системные пины и параметры коммуникаций------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_BRD[] 	={RT_HW_BOARD_CONTROL, RT_HW_BOARD_LED, RT_HW_BOARD_BUTTON, RT_HW_BOARD_WS, RT_HW_PGM_END};  //--Пины->control,led,button,WS2812; 
const uint8_t PROGMEM RT_HW_PGM_PIN_I2C[] 	={RT_HW_I2C0_SDA,   RT_HW_I2C0_SCL,    			                  	  RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_ICS[]	={	    															  RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_SPI[] 	={RT_HW_SPI0_SCK,   RT_HW_SPI0_MISO, RT_HW_SPI0_MOSI, RT_HW_SPI0_SS,  RT_HW_PGM_END}; 
const uint8_t PROGMEM RT_HW_PGM_PIN_SPN[]	={ 																  	  RT_HW_PGM_END}; 
const uint8_t PROGMEM RT_HW_PGM_PIN_UHS[] 	={RT_HW_UART0_RX,   RT_HW_UART0_TX,	 
                                              RT_HW_UART1_RX,   RT_HW_UART1_TX,
											  RT_HW_UART2_RX,   RT_HW_UART2_TX, 								  RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_USS[] 	={					RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_CAN[] 	={					RT_HW_PGM_END};		
const uint8_t PROGMEM RT_HW_PGM_PIN_BTH[] 	={					RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_ETH[] 	={					RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_WFI[] 	={					RT_HW_PGM_END};	
//-----Доступные пины контроллера------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_ALL[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
											  16,17,18,19,20,21,22,23,24,25,26,27,28,29,		RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_DIN[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
											  16,17,18,19,20,21,22,23,24,25,26,27,28,29,		RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_ADC[] 	={26,27,28,29,   									RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_TCH[] 	={													RT_HW_PGM_END};									
const uint8_t PROGMEM RT_HW_PGM_PIN_DOT[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
											  16,17,18,19,20,21,22,       25,26,27,28,29,	    RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_PWM[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
											  16,17,18,19,20,21,22,       25,26,27,28,29,		RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_DAC[] 	={													RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_INT[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
											  16,17,18,19,20,21,22,         26,27,28,29,		RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_N5V[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
											  16,17,18,19,20,21,22,      25,26,27,28,29,		RT_HW_PGM_END};	
//-----Тестовые пины и адреса------------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_DBG[]  	={16,					RT_HW_PGM_END};	//--Пины debug1,debug2,debug3;	
const uint8_t PROGMEM RT_HW_PGM_PIN_OUT[] 	={29,        			RT_HW_PGM_END};	//--Пины PWM0,PWM1,Servo1,Servo2;							                  
const uint8_t PROGMEM RT_HW_PGM_PIN_INP[] 	={26,255,27,         	RT_HW_PGM_END};	//--Пины A0,A1,btn1,btn2,TCH0,TCH1;
const uint8_t PROGMEM RT_HW_PGM_PIN_DCT[] 	={          			RT_HW_PGM_END};	//--Пины DAC0,DAC1;
const uint8_t PROGMEM RT_HW_PGM_PIN_DEV[] 	={14,11,15,	        	RT_HW_PGM_END}; //--Пины DS1820,DHT22.HC-SR04.trig;
const uint8_t PROGMEM RT_HW_PGM_PIN_CSS[] 	={ 5, 6, 7,10,          RT_HW_PGM_END};	//--Пины CS SPI:595,LCD,NRF,user 	
const uint8_t PROGMEM RT_HW_PGM_PIN_LC6[]  	={  					RT_HW_PGM_END};	//--Пины для подключения LCD по 4-х битной шине;
const uint8_t PROGMEM RT_HW_PGM_PIN_TFT[]  	={   		     		RT_HW_PGM_END};	//--Пины(дополнительные[]  TFT дисплея(SPI[] -CS,R/S,LED,RST,TOUCH;
const uint8_t PROGMEM RT_HW_PGM_PIN_URT[]   ={ 1, 2, 				RT_HW_PGM_END};	//--UART: ModBus, Nextion 
const uint8_t PROGMEM RT_HW_PGM_ADR_I2C[]  	={39,62,32,33,			RT_HW_PGM_END};	//--i2c: lcd1,lcd2,mcp1,mcp2;
//-------------------------------------------------------------------------------------------------
#endif
//*************************************************************************************************
//							 Контроллеры типа Raspberry Pi Pico W
//*************************************************************************************************
#if !defined(RT_HW_BOARD_SELECT) && (definedRT_HW_BOARD_RP_PICO_W)	
#define RT_HW_BOARD_SELECT 		    "Board Raspberry Pi Pico W"	   //--Идентификатор выбора платы Raspberry Pi Pico W;
//-------------------------------------------------------------------------------------------------
#define RT_HW_BOARD_MEMORY   "FLASH=2000kB; RAM=264Kb;"			   //--Параметры памяти;
#define RT_HW_PERMIT_UART0
#define RT_HW_PERMIT_UART1
#define RT_HW_PERMIT_UART2
#define RT_HW_PERMIT_I2C0	
#define RT_HW_PERMIT_I2C1	
#define RT_HW_PERMIT_SPI0
//#define RT_HW_PERMIT_SPI1
//=================================================================================================
//------Системные пины------------------------------------------------------------------------------
enum   {RT_HW_BOARD_CONTROL=28, RT_HW_BOARD_LED=255, RT_HW_BOARD_BUTTON=22, RT_HW_BOARD_WS=255};	//--Пины контроль,led,кнопка;
//------Параметры контроллера общие-------------------------------------------------------------------	
enum   {RT_HW_PIN_QNT_MAX=30, RT_HW_FCPU=125, 	  RT_HW_VCC=3300};
//-----Параметры UART------------------------------------------------------------------------------	
enum   {RT_HW_UART0_RX=1,  RT_HW_UART0_TX=0,
		RT_HW_UART1_RX=1,  RT_HW_UART1_TX=0,  
        RT_HW_UART2_RX=9,  RT_HW_UART2_TX=8};
//-----Параметры I2C------------------------------------------------------------------------------	
enum   {RT_HW_I2C0_SDA=20, RT_HW_I2C0_SCL=21, RT_HW_I2C0_MODE_FM=RT_HW_I2C_MODE_FM,
		RT_HW_I2C1_SDA=14, RT_HW_I2C1_SCL=15, RT_HW_I2C1_MODE_FM=RT_HW_I2C_MODE_FM,
}; 
//-----Параметры SPI------------------------------------------------------------------------------	
enum   {RT_HW_SPI0_SCK=2,  RT_HW_SPI0_MISO=4,  RT_HW_SPI0_MOSI=3,  RT_HW_SPI0_SS=5, 	//--cs 595,lcd,nrf,user->5,6,7,255
		RT_HW_SPI1_SCK=10, RT_HW_SPI1_MISO=12, RT_HW_SPI1_MOSI=11, RT_HW_SPI1_SS=13};
//-----Системные параметры-------------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_SYS_PAR[]   ={12,			   	RT_HW_PGM_END};  //--SYS->depth;
const uint8_t PROGMEM RT_HW_PGM_SYS_ADC[]	={12,4,0,			RT_HW_PGM_END};  //--ADC->depth,drift,null;
const uint8_t PROGMEM RT_HW_PGM_SYS_TCH[]  	={  				RT_HW_PGM_END};  //--TCH->depth,drift,null; 
const uint8_t PROGMEM RT_HW_PGM_SYS_PWM[]  	={12,10,			RT_HW_PGM_END};  //--PWM->depth,freq; 
const uint8_t PROGMEM RT_HW_PGM_SYS_DAC[]  	={  				RT_HW_PGM_END};  //--DAC->depth; 
//-----Системные пины и параметры коммуникаций------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_BRD[] 	={RT_HW_BOARD_CONTROL, RT_HW_BOARD_LED, RT_HW_BOARD_BUTTON, RT_HW_BOARD_WS, RT_HW_PGM_END};  //--Пины->control,led,button,WS2812; 
const uint8_t PROGMEM RT_HW_PGM_PIN_I2C[] 	={RT_HW_I2C0_SDA,   RT_HW_I2C0_SCL,	
											  RT_HW_I2C1_SDA,   RT_HW_I2C1_SCL,    			                  	  RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_ICS[]	={	    															  RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_SPI[] 	={RT_HW_SPI0_SCK,   RT_HW_SPI0_MISO, RT_HW_SPI0_MOSI, RT_HW_SPI0_SS,            
											  RT_HW_SPI1_SCK,   RT_HW_SPI1_MISO, RT_HW_SPI1_MOSI, RT_HW_SPI1_SS,  RT_HW_PGM_END}; 
const uint8_t PROGMEM RT_HW_PGM_PIN_SPN[]	={ 																  	  RT_HW_PGM_END}; 
const uint8_t PROGMEM RT_HW_PGM_PIN_UHS[] 	={RT_HW_UART0_RX,   RT_HW_UART0_TX,	 
                                              RT_HW_UART1_RX,   RT_HW_UART1_TX,
											  RT_HW_UART2_RX,   RT_HW_UART2_TX, 								  RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_USS[] 	={					RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_CAN[] 	={					RT_HW_PGM_END};		
const uint8_t PROGMEM RT_HW_PGM_PIN_BTH[] 	={					RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_ETH[] 	={					RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_WFI[] 	={					RT_HW_PGM_END};	
//-----Доступные пины контроллера------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_ALL[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
											  16,17,18,19,20,21,22,23,24,25,26,27,28,29,		RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_DIN[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
											  16,17,18,19,20,21,22,23,24,25,26,27,28,29,		RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_ADC[] 	={26,27,28,29,   									RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_TCH[] 	={													RT_HW_PGM_END};									
const uint8_t PROGMEM RT_HW_PGM_PIN_DOT[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
											  16,17,18,19,20,21,22,       25,26,27,28,29,	    RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_PWM[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
											  16,17,18,19,20,21,22,       25,26,27,28,29,		RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_DAC[] 	={													RT_HW_PGM_END};
const uint8_t PROGMEM RT_HW_PGM_PIN_INT[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
											  16,17,18,19,20,21,22,         26,27,28,29,		RT_HW_PGM_END};	
const uint8_t PROGMEM RT_HW_PGM_PIN_N5V[] 	={ 0, 1, 2, 3, 4, 5, 6, 7, 8, 9,10,11,12,13,14,15,
											  16,17,18,19,20,21,22,      25,26,27,28,29,		RT_HW_PGM_END};	
//-----Тестовые пины и адреса------------------------------------------------------------------------
const uint8_t PROGMEM RT_HW_PGM_PIN_DBG[]  	={16,					RT_HW_PGM_END};	//--Пины debug1,debug2,debug3;	
const uint8_t PROGMEM RT_HW_PGM_PIN_OUT[] 	={27,        			RT_HW_PGM_END};	//--Пины PWM0,PWM1,Servo1,Servo2;							                  
const uint8_t PROGMEM RT_HW_PGM_PIN_INP[] 	={26,27,22,         	RT_HW_PGM_END};	//--Пины A0,A1,btn1,btn2,TCH0,TCH1;
const uint8_t PROGMEM RT_HW_PGM_PIN_DCT[] 	={          			RT_HW_PGM_END};	//--Пины DAC0,DAC1;
const uint8_t PROGMEM RT_HW_PGM_PIN_DEV[] 	={17,255,18,	    	RT_HW_PGM_END};	//--Пины DS1820,DHT22.HC-SR04.trig
const uint8_t PROGMEM RT_HW_PGM_PIN_CSS[] 	={ 5, 6, 7,19,13,16,17,18,RT_HW_PGM_END}; //--Пины CS SPI:595,LCD,NRF,DEV1; 	
const uint8_t PROGMEM RT_HW_PGM_PIN_LC6[]  	={  					RT_HW_PGM_END};	//--Пины для подключения LCD по 4-х битной шине;
const uint8_t PROGMEM RT_HW_PGM_PIN_TFT[]  	={   		     		RT_HW_PGM_END};	//--Пины(дополнительные[]  TFT дисплея(SPI[] -CS,R/S,LED,RST,TOUCH;
const uint8_t PROGMEM RT_HW_PGM_PIN_URT[]   ={ 1, 2, 				RT_HW_PGM_END};	//--UART: ModBus, Nextion; 
const uint8_t PROGMEM RT_HW_PGM_ADR_I2C[]  	={39,62,32,33,			RT_HW_PGM_END};	//--i2c: lcd1,lcd2,mcp1,mcp2;
//-------------------------------------------------------------------------------------------------
#endif