



//+++++++++++++++++++++++++++++++++ ФУНКЦИИ ВВОДА ++++++++++++++++++vNor===============================
bool pinDigitalRead(RT_HW_PIN_DIR_ID &id,uint8_t pin){if(id.dir==0){id.pin=pin;} return pinDigitalRead(id);}
bool pinDigitalRead(RT_HW_PIN_DIR_ID &id,uint8_t pin, char mode){if(id.dir==0){id.pin=pin; id.mode=mode;} return pinDigitalRead(id);}
bool pinDigitalRead(RT_HW_PIN_DIR_ID &id){ 
if(id.dir==0){
	if(id.pin==255){return 0;}
	if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,id.pin)){id.dir=50; return 0;} 	//--Проверка на допустимость пина;  
	else           {RT_HW_PIN_DIR_SET_ID(id,id.pin); 						//--Сохранение параметров пина;
	if     (id.mode=='U') {pinMode(id.pin, RT_HW_PIN_MODE_INPUT_PULLUP);}	//--Дискретный вход с подтяжкой к +Vcc;
	else if(id.mode=='D') {pinMode(id.pin, RT_HW_PIN_MODE_INPUT_PULLDOWN);}	//--Дискретный вход с подтяжкой к Gnd;
	else if(id.mode=='F') {pinMode(id.pin, RT_HW_PIN_MODE_INPUT);}			//--Дискретный вход - аналог INPUT; 
	else                  {pinMode(id.pin, RT_HW_PIN_MODE_INPUT);}			//--Дискретный вход - аналог INPUT; 
												 id.dir=1;}}
//-------------------------------------------------------------------------------------------------
if(id.dir==1) {return RT_HW_PIN_DIR_READ(id);} 
//-------------------------------------------------------------------------------------------------
return 0;};	//+++END pinDigitalRead();
//=================================================================================================
//							ADC-аналоговый ввод
// default: id.pin=255; 
//=================================================================================================
void pinAnalogRead(RT_HW_PIN_ADC_ID &id, uint8_t pin){if(id.dir==0){id.pin=pin;} pinAnalogRead(id);}
void pinAnalogRead(RT_HW_PIN_ADC_ID &id){
if(id.dir==0){
	if(!checkPinPGM(RT_HW_PGM_PIN_ADC_ID,id.pin)){id.dir=50; return;} 		//--Проверка на допустимость пина;  
    id.adcMax=maxBitDepth(device.depth.adc);								//--Расчет максимального значения;
	pinMode(id.pin, RT_HW_PIN_MODE_INPUT_ANALOG); 
	id.dir=1;}
if(id.dir==1){
	id.vPin=analogRead(id.pin);
#if defined(RT_HW_BOARD_ESP32C3_DEV)
	if(id.pin==0){id.adcPin=(uint32_t)id.adcPin*3300/1000;}		//--У данного контроллера на пине 0 установлен резисторный делитель;
#endif	
    if(id.vPin>id.adcVar){if((id.vPin-id.adcVar)>device.depth.adcDrift){id.adcVar=id.vPin;}}
    if(id.vPin<id.adcVar){if((id.adcVar-id.vPin)>device.depth.adcDrift){id.adcVar=id.vPin;}}
	if(id.adcVar>id.adcMax){id.adcVar=id.adcMax;}
	if(id.adcVar<device.depth.adcNull){id.adcVar=0;}
    id.vNorm=normADC(id.adcVar);}
};
//=================================================================================================
//							TCH-cенсорное ввод[ESP32]
//  По умолчанию id.pin=255; 
//=================================================================================================
void pinTouchRead(RT_HW_PIN_TCH_ID &id, uint8_t pin){{if(id.dir==0){id.pin=pin;} pinTouchRead(id);}}
void pinTouchRead(RT_HW_PIN_TCH_ID &id){		
#if defined(RT_HW_CORE_ESP32) && defined(RT_HW_PERMIT_TOUCH)
if(id.dir==0){
	if(!checkPinPGM(RT_HW_PGM_PIN_TCH_ID,id.pin)){id.dir=50; return;} 		//--Проверка на допустимость пина; 	
    id.dir=1;}
if(id.dir==1){id.vPin=touchRead(id.pin); id.vNorm=id.vNorm;}
#endif	
id.vNorm=0;
};	//+++END pinTouchRead();
//=================================================================================================
//							HALL-чтение с датчика Холла [ESP32]
//=================================================================================================
void pinReadHALL(RT_HW_PIN_HALL_ID &id){	
#if  defined(RT_HW_CORE_ESP32) && defined(RT_HW_PERMIT_HALL)
id.vPin=hallRead();
id.vNorm=map(id.vPin,-128,127,0,maxBitDepth(device.depth.sys));	//--Заглушка;
#endif
id.vNorm=0;	
};	//+++END pinReadHALL();
//=============================================================================

//+++++++++++++++++++++++++++++++++ ФУНКЦИИ ВЫВОДА +++++++++++++++++++++++++++++++++++++++++++++++++

//=================================================================================================
//							DO -дискретный вывод 
// default: id.pin=255; id.mode='N'[N-(normal)обычный вывод; O-(open)открытый коллектор];
//=================================================================================================
void pinDigitalWrite(RT_HW_PIN_DIR_ID &id, uint8_t pin, uint8_t var){if(id.dir==0){id.pin=pin;} pinDigitalWrite(id,var);};
void pinDigitalWrite(RT_HW_PIN_DIR_ID &id, uint8_t pin, char mode, uint8_t var){if(id.dir==0){id.pin=pin; id.mode=mode;} pinDigitalWrite(id,var);};
void pinDigitalWrite(RT_HW_PIN_DIR_ID &id, uint8_t var){
if(id.dir==0){	
	if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,id.pin)){id.dir=50; return;} 		//--Проверка на допустимость пина; 
	else           {RT_HW_PIN_DIR_SET_ID(id,id.pin); 								;
		            if(id.mode=='O'){pinMode(id.pin, RT_HW_PIN_MODE_OUTPUT_OPEN_DRAIN);} 
		            else            {pinMode(id.pin, RT_HW_PIN_MODE_OUTPUT);} id.dir=1;}}
if(id.dir==1) {RT_HW_PIN_DIR_WRITE(id,var);}		//--Быстрый дискретный вывод
};			//+++END pinDigitalWrite();	

//=================================================================================================
//							PWM -широтно-импульсный вывод 
// default: id.pin=255; id.mode='N'[N-(normal)обычный вывод; O-(open)открытый коллектор];
// default: id.freq=1000(ESP,STM,RPPICO); id.depth=12(ESP32); id.channel=2(ESP32);
//=================================================================================================
void pinPWMDebug1(RT_HW_PIN_PWM_ID &id){
 consoleTest(String(F("PWM pin")),id.pin,';'); consoleTest(String(F(" channel")),id.channel,';'); 
 consoleTest(String(F(" depth")),id.depth,';');  consoleTest(String(F(" freq")),id.freq,';');
 consoleCR();	
};
void pinPWMDebug2(RT_HW_PIN_PWM_ID &id){
 consoleTest(String(F("PWM var")),id.var,';'); consoleTest(String(F(" duration")),id.duration,';'); consoleTest(String(F(" duty")),id.duty,';');  
 consoleCR();	
};
//-------------------------------------------------------------------------------------------------
void pinPWM(RT_HW_PIN_PWM_ID &id, uint8_t pin, uint16_t var){if(id.dir==0){id.pin=pin;} pinPWM(id,var);};
void pinPWM(RT_HW_PIN_PWM_ID &id, uint8_t pin, char mode, uint16_t var){if(id.dir==0){id.pin=pin; id.mode=mode;} pinPWM(id,var);};
void pinPWM(RT_HW_PIN_PWM_ID &id, uint16_t var){
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_AVR) ||defined(RT_HW_CORE_SAMD) || defined(RT_HW_CORE_SAMD21) || defined(RT_HW_CORE_ESP8266)
if(id.dir==0){
	if(!checkPinPGM(RT_HW_PGM_PIN_PWM_ID,id.pin)){id.dir=50; return;} 		//--Проверка на допустимость пина; 
    pinMode(id.pin,RT_HW_PIN_MODE_OUTPUT); id.dir=1;}  //--Настройка пина на выход;
if(id.dir==1){id.var=normPWM(var); analogWrite(id.pin,id.var); return;}	//--Вывод;
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_RP_PICO)
if(id.dir==0){
	if(!checkPinPGM(RT_HW_PGM_PIN_PWM_ID,id.pin)){id.dir=50; return;} 		//--Проверка на допустимость пина;  
    pinMode(id.pin,RT_HW_PIN_MODE_OUTPUT); id.dir=1;}  //--Настройка пина на выход;
if(id.dir==1){id.var=normPWM(var); analogWrite(id.pin,id.var); return;}	//--Вывод;
#endif
//------------------------------------------------------------------------------------------------	
#if defined(RT_HW_CORE_ESP32) 
if(id.dir==0){
	if(!checkPinPGM(RT_HW_PGM_PIN_PWM_ID,id.pin)){id.dir=50; return;} 		//--Проверка на допустимость пина;   
	pinMode(id.pin,RT_HW_PIN_MODE_OUTPUT);   
	if(id.depth==255){id.depth=device.depth.pwm;} 	//--Установка разрешения по умолчанию (если параметр не настраивался);
	if(id.depth>16)  {id.depth=16;}				  	//--Ограничение разрядности;
#if defined(RT_HW_CORE_ESP32C3)
	if(id.depth>14)  {id.depth=14;}				  	//--Ограничение разрядности для ESP32C3;
#endif	
	if(id.channel==255){for(id.idx=0; id.idx<RT_HW_MAX_NUM_CHANNEL; id.idx++){	//--Выбор свободного канала;
		                 if(!bitRead(device.pwm.channel,id.idx)){bitSet(device.pwm.channel,id.idx); id.channel=id.idx; break;}}}
	ledcSetup(id.channel,id.freq,id.depth);			//--Настройка канала id.channel: частота и разрешение;
	ledcAttachPin(id.pin,id.channel);				//--Привязка пина к номеру канала;	
	//pinPWMDebug1(id);
	id.dir=1;}
if(id.dir==1){//ledcChangeFrequency(id.channel,id.freq,id.depth); 
	id.var=var;
	id.duration=id.var;
	id.duty=normDepth(id.duration,id.depth); 
	ledcWrite(id.channel,id.duty); 			
	//pinPWMDebug2(id);
	return;}	//--Вывод;
#endif
//------------------------------------------------------------------------------------------------	
#if defined(RT_HW_CORE_STM32_M_F1) || defined(RT_HW_CORE_STM32_M_F4)
if(id.dir==0){
	if(!checkPinPGM(RT_HW_PGM_PIN_PWM_ID,id.pin)){id.dir=50;   return;} 		//--Проверка на допустимость пина; 
    pinMode(id.pin,RT_HW_PIN_MODE_OUTPUT); id.dir=1;}  //--Настройка пина на выход;
if(id.dir==1){id.var=normPWM(var); analogWrite(id.pin,id.var); return;}	//--Вывод;
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_STM32_D) 
if(id.dir==0){
	if(!checkPinPGM(RT_HW_PGM_PIN_PWM_ID,id.pin)){id.dir=50;   return;} 		//--Проверка на допустимость пина; 
    pinMode(id.pin,RT_HW_PIN_MODE_OUTPUT); id.dir=1;}  //--Настройка пина на выход;
if(id.dir==1){id.var=normPWM(var); analogWrite(id.pin,id.var); return;}	//--Вывод;
#endif
//-------------------------------------------------------------------------------------------------
id.var=var;} //+++END	pinPWM();
//=================================================================================================
//							SERVO -управление серводвигателем 
// default: id.pin=255;(open)открытый коллектор];
// default: id.freq=1000(ESP,STM,RPPICO); id.depth=12(ESP32); id.channel=4(ESP32);
//=================================================================================================
void pinServoDebug1(RT_HW_PIN_SERVO_ID &id){
 consoleTest(String(F("Servo pin")),id.pin,';'); consoleTest(String(F(" channel")),id.channel,';'); 
 consoleTest(String(F(" depth")),id.depth,';');  consoleTest(String(F(" freq")),id.freq,';');
 consoleTest(String(F(" period")),id.period,';');consoleTest(String(F(" maxDepth")),id.maxDepth,';');
 consoleTest(String(F(" max Angle")),id.maxAngle,';'); consoleTest(String(F(" min,max Width")),id.minWidth,',');  consoleVar(id.maxWidth,';');
 consoleCR();	
};
void pinServoDebug2(RT_HW_PIN_SERVO_ID &id){
 consoleTest(String(F("Servo var")),id.var,';'); consoleTest(String(F(" duration")),id.duration,';'); consoleTest(String(F(" duty")),id.duty,';');  
 consoleCR();	
};
//-------------------------------------------------------------------------------------------------
void pinServoSet_MG90S    (RT_HW_PIN_SERVO_ID &id){id.freq=50; id.minWidth=650; id.maxWidth=2200; id.maxAngle=180;}
uint16_t pinServoNormSYS  (RT_HW_PIN_SERVO_ID &id, uint16_t var){return map(var,0,((1<<device.depth.sys)-1),id.minWidth,id.maxWidth);}
uint16_t pinServoNormAngle(RT_HW_PIN_SERVO_ID &id, uint16_t var){return map(var,0,id.maxAngle,id.minWidth,id.maxWidth);}
//-------------------------------------------------------------------------------------------------
void pinServo(RT_HW_PIN_SERVO_ID &id, uint16_t var){id.var=var; pinServo(id);}
void pinServo(RT_HW_PIN_SERVO_ID &id, uint8_t pin, uint16_t var){if(id.dir==0){id.pin=pin;} id.var=var; pinServo(id);}
void pinServo(RT_HW_PIN_SERVO_ID &id){
//------------------------------------------------------------------------------------------------	
#if defined(RT_HW_CORE_ESP32) 
if(id.dir==0){
	if(!checkPinPGM(RT_HW_PGM_PIN_PWM_ID,id.pin)){id.dir=50; return;} 		//--Проверка на допустимость пина; 
    pinMode(id.pin,RT_HW_PIN_MODE_OUTPUT);			//--Настройка пина на вывод;   
	if(id.depth==255){id.depth=device.depth.pwm;} 				//--Установка default for depth;
	if(id.depth>16)  {id.depth=16;}				  				//--Ограничение разрядности;
#if defined(RT_HW_CORE_ESP32C3)
	if(id.depth>14)  {id.depth=14;}				  	//--Ограничение разрядности для ESP32C3;
#endif
	if(id.channel==255){for(id.idx=0; id.idx<RT_HW_MAX_NUM_CHANNEL; id.idx++){	//--Выбор свободного канала;
		                 if(!bitRead(device.pwm.channel,id.idx)){bitSet(device.pwm.channel,id.idx); id.channel=id.idx; break;}}}
	if(id.freq<40){id.freq=40;} if(id.freq>100){id.freq=100;} 	//--Нормализация частоты;
	id.period=1000000UL/id.freq;								//--Расчет периода вывода импульсов;
	id.maxDepth=((1 << id.depth) - 1);							//--Расчет максимального значения для выбранной разрядности;
	ledcSetup(id.channel,id.freq,id.depth);						//--Настройка канала id.channel: частота и разрешение;
	ledcAttachPin(id.pin,id.channel);							//--Привязка пина к номеру канала;
	//pinServoDebug1(id);											//--DEBUG:Вывод на консоль параметров настройки;
	id.dir=1;}
if(id.dir==1){ 
	id.duration=id.var; 
	if(id.duration<id.minWidth){id.duration=id.minWidth;} 		//--Ограничение импульса снизу;
	if(id.duration>id.maxWidth){id.duration=id.maxWidth;}		//--Ограничение импульса сверху;
	id.duty=map(id.duration,0,id.period,0,id.maxDepth);			//--Расчет длительности с учетом разрядности depth;
	//pinServoDebug2(id);											//--DEBUG:Вывод на консоль параметров вывода;
	ledcWrite(id.channel,id.duty);
	return;}	
#endif
id.var=0;
};
void pinServo_MG90S(RT_HW_PIN_SERVO_ID &id){id.minWidth=650; id.maxWidth=2300;}
//=================================================================================================
//							DAC-аналоговый вывод
// default: id.pin=255;
//=================================================================================================
void pinDAC(RT_HW_PIN_DAC_ID &id, uint8_t pin, uint16_t var){id.pin=pin; id.var=var;  pinDAC(id);}
void pinDAC(RT_HW_PIN_DAC_ID &id, uint16_t var)             {id.var=var;  pinDAC(id);}
void pinDAC(RT_HW_PIN_DAC_ID &id){
//------------------------------------------------------------------------
if(id.dir==0){
	if(!checkPinPGM(RT_HW_PGM_PIN_DAC_ID,id.pin)){id.dir=50; return;} 		//--Проверка на допустимость пина;  
    id.dir=1;} 				//--Сохранение параметров пина;   
//-----------------------------------------------
if(id.dir==1) {
#if defined(RT_HW_PERMIT_DAC) && defined(RT_HW_CORE_ESP32) 	
	id.vPin=normDAC(id.var); dacWrite(id.pin,id.vPin);	return;
#endif
//-----------------------------------------------
#if defined(RT_HW_PERMIT_DAC) && (defined(RT_HW_CORE_STM32_M_F1) || defined(RT_HW_CORE_STM32_M_F4) || defined(RT_HW_CORE_STM32_D))	 
 	id.vPin=normDAC(id.var); analogWrite(id.pin,id.vPin); return;
#endif
//-----------------------------------------------
id.var=0;
}  //--END if (id.dir==1)
//=============================================================================
};




//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							ФУНКЦИИ ЗАПИСИ-ЧТЕНИЯ ПИНОВ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//bool changeProtectPinDI(RT_HW_CHANGE_PINDI_ID &id, uint8_t timeChange, uint8_t val){//==Защита от дребезга значения на пине DI;
//if(id.dir==0) {if(id.ago!=val) {id.time=RT_HW_MILLIS; id.dir++;}                       return id.ago;}
//if(id.dir==1) {if((getPastMs(id.time)< (timeChange)) && (id.ago==val))  	{id.dir=0; return id.ago;} 
//				if( getPastMs(id.time)>= timeChange)     {id.ago=val;		 id.dir=0; return id.ago;}}
//																					   return id.ago;};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
