
//=================================================================================================
//							Hастройка вектора запуcка задача полный
//struct RT_HW_STRUCT_SHED_TASK{                    //--Управление задачами полный
//uint8_t  dir=0, state=0, first=1, agoGen=255;   char mode='C';
//uint8_t  periodTask=20, periodLimit=2, cntTask, cntLimit;	
//uint8_t  agoeN=0, exteN=0, extEN=1;
//
// mode - режим запуска задачи [C,P,T,A,F,E,Q,N];
// С-по изменению, P-периодически, T-периодически при изменении, A-периодически или по изменениям,
// F-однократно, E-в каждом цикле(удобно связано с EN), Q-в каждом цикле при изменении;
// N-отключено.
//
//
// 
// periodLimit - минимальный период вызова [имеет значение только для режимов C,P,T,A];
// periodTask  - период вызова задач [имеет значение только для режимов P,T,A];
//=================================================================================================
void setTaskID  (RT_HW_STRUCT_SHED_TASK &id, char mode, uint16_t periodLimit, uint16_t periodTask, uint16_t tick=25){ //++++Универсальный вызов задач;
if(tick>250){tick=250;}
if( tick==0)               {id.tick=0;};
if((tick>0)  &&(tick<=10)) {id.tick=10;};
if((tick>10) &&(tick<=25)) {id.tick=25;}
if((tick>25) &&(tick<=50)) {id.tick=50;}
if((tick>50) &&(tick<=100)){id.tick=100;}
if((tick>100)&&(tick<=250)){id.tick=250;}
id.mode=mode;																				//--Режим управления задачей [C,P,T,A,E,S,F,N];
id.periodLimit=timeToTick(periodLimit,id.tick); if(id.periodLimit==0){id.periodLimit=1;}	//--Расчет минимального периода в тиках;
id.periodTask =timeToTick(periodTask, id.tick);	if(id.periodTask==0) {id.periodTask=1;}		//--Расчет основного    периода в тиках;
if(id.periodTask<id.periodLimit){id.periodTask=id.periodLimit;}
id.cntLimit=id.cntTask=0;
id.custom=1;
};	//++++END setTaskID(....)======================================================================
void setTaskID  (RT_HW_STRUCT_SHED_TASK &id, uint16_t periodTask, uint16_t tick=50){ 	//++++Периодический вызов задач;
if(periodTask>0){setTaskID (id,'P',tick,periodTask,tick);} else {setTaskID (id);}
};	//++++END setTaskID(..)========================================================================
void setTaskID  (RT_HW_STRUCT_SHED_TASK &id){ //++++Вызов задач по изменению переменной id.extEN 0->1 и однократныый вызов задач(при EN=1);
setTaskID (id,'F',50,100,50);
};	//++++END setTaskID()==========================================================================
//=================================================================================================
//										Управление вызовом задач
// Функция setTaskId устанавливает периоды обработки события 10,25,50,100,250,500 или 1000 ms.
// id - вектор запуска задач;
// gen - меандр  внешнего генератора с полупериодом равным tick, 
//       который был применен в функции настройки вектора запуска задач.
//=================================================================================================
/*
uint8_t directTask (RT_HW_STRUCT_SHED_TASK &id, uint8_t stanGen=1){
//-------------------------------------------------------------------------------------------------
id.run=0;
if(period(id.timeBegin,millis(),id.tick)){id.gen=!id.gen;}
//if((!shed.ready) || (stanGen)) {if(period(id.timeBegin,millis(),id.tick)){id.gen=!id.gen;}} //--Автономный генератор при не работающием диспетчере;
//else {if(id.tick==10) {id.gen=shed.blink10;}  if(id.tick==25) {id.gen=shed.blink25;}  if(id.tick==50){id.gen=shed.blink50;} 
//      if(id.tick==100){id.gen=shed.blink100;} if(id.tick==250){id.gen=shed.blink250;}}
if(id.mode=='N'){return 0;}
if(!id.extEN)  {id.first=1; return id.run;}
if(id.first==1){id.first=0; id.run=1; id.agoGen=id.gen; id.agoEN=id.extEN; return id.run;}  
if(id.mode=='F'){           return id.run;} 															   //--Выполняется однократно по first=1;
if(id.mode=='E'){id.run=1;  return id.run;} //--Выполняется в каждом цикле;
if(id.mode=='Q'){id.run=2;  return id.run;} //--Выполняется в каждом цикле при изменении во внешней функции;
//-------------------------------------------------------------------------------------------------
if(id.agoGen!=id.gen){id.agoGen=id.gen;
if(id.mode=='C'){if(++id.cntLimit>=id.periodLimit){id.cntLimit=0;				id.run=2;} return id.run;} //--По изменению во внешней функции;
if(id.mode=='P'){if(++id.cntTask >=id.periodTask) {id.cntTask=0; 				id.run=1;} return id.run;} //--Периодически;
if(id.mode=='T'){if(++id.cntTask >=id.periodTask) {id.cntTask=0; 				id.run=2;} return id.run;} //--Периодически и по изменению во внешней функции: 
if(id.mode=='A'){if(++id.cntLimit>=id.periodLimit){id.cntLimit=0;id.cntTask=0;  id.run=2;}          	   //--По изменению во внешней функции
                 if(++id.cntTask >=id.periodTask) {id.cntTask=0; id.cntLimit=0; id.run=1;} return id.run;} //                       или периодически; 
}
return id.run;
};	//++++END directTask 
*/


uint8_t directTask (RT_HW_STRUCT_SHED_TASK &id, uint8_t stanGen=1){
//-------------------------------------------------------------------------------------------------
id.run=0;
if(period(id.timeBegin,millis(),id.tick)){id.gen=!id.gen;}
//if((!shed.ready) || (stanGen)) {if(period(id.timeBegin,millis(),id.tick)){id.gen=!id.gen;}} //--Автономный генератор при не работающием диспетчере;
//else {if(id.tick==10) {id.gen=shed.blink10;}  if(id.tick==25) {id.gen=shed.blink25;}  if(id.tick==50){id.gen=shed.blink50;} 
//      if(id.tick==100){id.gen=shed.blink100;} if(id.tick==250){id.gen=shed.blink250;}}
if(id.mode=='N'){return 0;}
if(!id.extEN)  {id.first=1; return id.run;}
if(id.first==1){id.first=0; id.run=1; id.agoGen=id.gen; id.agoEN=id.extEN; return id.run;}  
if(id.mode=='F'){           return id.run;} 															   //--Выполняется однократно по first=1;
if(id.mode=='E'){id.run=1;  return id.run;} //--Выполняется в каждом цикле;
if(id.mode=='Q'){id.run=2;  return id.run;} //--Выполняется в каждом цикле при изменении во внешней функции;
//-------------------------------------------------------------------------------------------------
if(id.agoGen!=id.gen){id.agoGen=id.gen;
if(id.mode=='C'){if(++id.cntLimit>=id.periodLimit){id.cntLimit=0;				id.run=2;} return id.run;} //--По изменению во внешней функции;
if(id.mode=='P'){
	
	
	if(++id.cntTask >=id.periodTask) {id.cntTask=0; 				id.run=1;} return id.run;} //--Периодически;
if(id.mode=='T'){if(++id.cntTask >=id.periodTask) {id.cntTask=0; 				id.run=2;} return id.run;} //--Периодически и по изменению во внешней функции: 
if(id.mode=='A'){if(++id.cntLimit>=id.periodLimit){id.cntLimit=0;id.cntTask=0;  id.run=2;}          	   //--По изменению во внешней функции
                 if(++id.cntTask >=id.periodTask) {id.cntTask=0; id.cntLimit=0; id.run=1;} return id.run;} //                       или периодически; 
}
return id.run;
};	//++++END directTask 


uint8_t controlTask (RT_HW_STRUCT_CONTROL_TASK &id){
//-------------------------------------------------------------------------------------------------
id.run=0;
if(id.mode=='N'){return 0;}
if(!id.extEN)  {id.first=1; return id.run;}
if(id.first==1){id.first=0; id.run=1; id.agoEN=id.extEN; return id.run;}  
if(id.mode=='F'){           return id.run;} //--Выполняется однократно по first=1;
if(id.mode=='E'){id.run=1;  return id.run;} //--Выполняется в каждом цикле;
if(id.mode=='Q'){id.run=2;  return id.run;} //--Выполняется в каждом цикле при изменении во внешней функции;
//-------------------------------------------------------------------------------------------------
if(id.mode=='C'){if(timeDelay(id.timeBegin,id.workDelay,id.timeOut)){id.run=2;} return;}; 	//--По изменению во внешней функции;
//if(id.mode=='P'){if(period(id.timeBegin,millis(),id.period)){id.run=1; return;}} 			//--Периодически;
//if(id.mode=='T'){if(period(id.timeBegin,millis(),id.period)){id.run=2; return;}} 			//--Периодически по изменению во внешней функции; 
//if(id.mode=='A'){
//if(id.dir==0){} 	
	
	
	//if(++id.cntLimit>=id.periodLimit){id.cntLimit=0;id.cntTask=0;  id.run=2;}          	   //--По изменению во внешней функции
       //          if(++id.cntTask >=id.periodTask) {id.cntTask=0; id.cntLimit=0; id.run=1;} return id.run;} //                       или периодически; 

//return id.run;
};	//++++END directTask 

//=================================================================================================

//=================================================================================================
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 								Выбор режима работы без периода
//uint8_t dir=0; uint8_t state:4,first:1,agoeN:1,exteN:1,extEN:1;
//    Пока используется,  но постепенно надо будет заменить на RT_HW_STRUCT_SHED_TASK 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void FLProgCheckEvent(RT_HW_CLASS_FLPROG_CHECK &id, char modeOutput){
//-------------------------------------------------------------------------------------------------
id.state=0;
if(!id.extEN)  {id.first=0; return;}
if(id.first==0){id.first=1; id.state=1; id.agoeN=id.exteN; return;}  
//-------------------------------------------------------------------------------------------------
if(modeOutput=='C'){id.state=2; return;}
if(modeOutput=='E'){id.state=1; return;}
if(modeOutput=='S'){if(id.agoeN!=id.exteN){id.agoeN=id.exteN; if(id.agoeN){id.state=1;}} return;} 
if(modeOutput=='F'){return;} //--Выполняется по first=0;
if(modeOutput=='N'){return;} 
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
// 								Выбор режима работы с периодом
//    Пока используется,  но постепенно надо будет заменить на RT_HW_STRUCT_SHED_TASK 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
void FLProgCheckEvent(RT_HW_CLASS_FLPROG_CHECK &id,uint32_t &timeBegin, char modeOutput, uint16_t period){
//-------------------------------------------------------------------------------------------------
if(id.state==3){timeBegin=millis();}
id.state=0;
if(!id.extEN)  {id.first=0; return;}
if(id.first==0){id.first=1; id.state=1; id.agoeN=id.exteN; return;}  
//-------------------------------------------------------------------------------------------------
if(modeOutput=='C'){id.state=2; return;} 													//--По изменению во внешней функции;
if(modeOutput=='P'){if(periodMs(timeBegin,period)){id.state=1;} return;}				  	//--Периодически;
if(modeOutput=='T'){if(periodMs(timeBegin,period)){id.state=2;} return;}				  	//--Периодически и   по изменению во внешней функции; 
if(modeOutput=='A'){if(periodMs(timeBegin,period)){id.state=1;} else{id.state=2;}return;} 	//--Периодически или по изменению во внешней функции; 
if(modeOutput=='E'){id.state=1; return;}													//--В каждом цикле;
if(modeOutput=='S'){if(id.agoeN!=id.exteN){id.agoeN=id.exteN; if(id.agoeN){id.state=1;}} return;} //--По переднему фронту;
if(modeOutput=='F'){return;} 																//--Выполняется однократно по first=0;
if(modeOutput=='N'){return;} 																//--Не выполняется;
return;
};
//=================================================================================================