//=================================================================================================
//							КОНСОЛЬ: Базовые функции
//=================================================================================================
bool consoleBegin(uint8_t numUart=0){		//++++Настройка консоли================================
if(console.dir==3) {return console.ok;}					//--Пустой вход для консоли;
if(console.dir==0) {							//--Ожидание внешнего сигнала запуска;	
  console.numUart=numUart;
  console.ok=console.head=console.all=0; 		//--Сброс состояний;	
  uartBegin(numUart);							//--Инициализация UART;							  	
  console.dir++; }								//--Переход на следующий этап;
if(console.dir==1) {							//--Ожидание готовности консоли
 if(!uartSerial(console.numUart)) {return console.ok;} 	//--Ожидание готовности консоли
				 console.ok=console.head=1;		//--Установка состояния "Вывод заголовков";   
			   //consoleBLANK(10); consoleCR();	//--Очистка панели консоли(код очистки Arduino IDE найти не удалось);	   
				 console.dir++; return console.ok;}  		//--Переход на следущий этап; 				
if(console.dir==2) {							//--Сброс флага "Вывод заголовка" и переход на этап 3;
	console.head=0; console.all=1;				//--Сброс флага "Вывод заголовка", установка флага "All";
	console.dir++;} return console.ok;};							//--Переход на этап 3;
void consoleWrite(uint8_t v){				//++++Отправка байта(или символа) в консоль============ 
if(!console.ok){return;}
//----Для контроллеров Raspberry Pi Pico------------------------------------------------------------
#if defined(RT_HW_CORE_RP_PICO)
Serial.print(char(v)); return; //--Надо разобраться, почему проблемы с Serial.write(); 

#else
if(uartAvailableForWrite(console.numUart)>0){uartWrite(console.numUart,v); return;}
//-------------------------------------------------------------------------------------------------
uint32_t timeBegin=micros();
do{if(getPastMcs(timeBegin)>500) {return;} 
if(uartAvailableForWrite(console.numUart)>0){break;}
}while(1);
uartWrite(console.numUart,v);
#endif
};		
void consoleSuff (char suff){				//++++Вывод суффикса [G,L,E,S,V,~]=====================
if(suff=='~'){                   return;}
if(suff=='V'){consoleWrite(','); return;} 
if(suff=='S'){consoleWrite(';'); return;} 
if(suff=='G'){consoleWrite(' '); return;}
if(suff=='L'){consoleWrite('\n');return;} 				
if(suff=='E'){consoleWrite(';'); consoleWrite('\n'); return;} 
consoleWrite(suff);}
void consoleChar (char v=' ',char suff='~'){//++++Вывод символа с суффиксом [G,L,E,S,V,~]==========
	consoleWrite(v);  consoleSuff(suff);};	
void consoleCR(){							//++++Вывод перевода строки============================
	 consoleWrite('\n');};	
void consoleCR(uint8_t n){					//++++Вывод нескольких переводoв строки================
	for(idx.i=0; idx.i<n;  idx.i++){consoleWrite('\n');}};																
void consoleLine(char v='=',uint8_t sz=80){ //++++Вывод горизонтальной линии=======================
	for(idx.i=0; idx.i<sz; idx.i++){consoleWrite(uint8_t(v));} consoleWrite('\n');};			 	
void consoleBlank(char v,char suff,uint8_t sz){//++++Вывод sz заполнителей=v с суффиксом ==========			
	 char sign=v; if(sign=='G'){sign=' ';} for(idx.i=0; idx.i<sz; idx.i++){consoleWrite(uint8_t(sign));} consoleSuff(suff);};
void consoleBlank(uint8_t sz){				//++++Вывод sz пробелов================================
	for(idx.i=0; idx.i<sz; idx.i++){consoleWrite(uint8_t(' '));}};	
void consoleBlank(char v, uint8_t sz){		//++++Вывод sz заполнителей=v =========================
	char sign=v; if(sign=='G') {sign=' ';} for(idx.i=0; idx.i<sz; idx.i++){consoleWrite(sign);};};

//=================================================================================================
//							КОНСОЛЬ: Основная функция форматированного вывода String
//=================================================================================================	
void consoleFormat(String str, char suff='~',uint8_t sz=1){ 		//++++String [mode:P,A,C,B,*,H,U,I,0,1,2,3,Z,z,X]
//---------------------------Подготовительные операции---------------------------------------------
 uint8_t lenText=0; uint8_t lenBuff=0; char buff; uint8_t qnt; 
 char alig=mess.alig; char blank=mess.blank;
 if(mess.blank=='G') {mess.blank=' ';}			//--
 const char * data=str.c_str(); if(sz==0) {sz=160; mess.alig='N';}
//-----------------------Вычисление длины текстового буфера с учетом кодировки UTF-8'--------------
 for(uint8_t i=0; i<=160; i++){buff=data[i]; lenBuff=i;  
							   if((buff=='\0') || (buff==RT_HW_BREAK_CHAR) || (lenText>=sz)) {break;}
						       if(((uint8_t)buff)<0xC0) {lenText++;}} 
//-------------------------------------Вывод заполнителей перед текстом----------------------------
 qnt=getLenBegin(sz,lenText,mess.alig); if(qnt>100){qnt=100;} for(uint8_t i=0; i<qnt; i++){consoleWrite(mess.blank);} 
//------------------------------------Вывод текста длиной lenBuff----------------------------------
 qnt=lenBuff;                           if(qnt>100){qnt=100;} for(uint8_t i=0; i<qnt; i++){consoleWrite(data[i]);}	
//-------------------------------------Вывод заполнителей после текста-----------------------------
 qnt=getLenEnd(sz,lenText,mess.alig); 	if(qnt>100){qnt=100;} for(uint8_t i=0; i<qnt;  i++){consoleWrite(mess.blank);}
//---------------------------------------------Вывод суффикса--------------------------------------
 consoleSuff(suff);
//-------------------------------------------------------------------------------------------------
mess.alig=alig;  mess.blank=blank;}; //--Востановление параметров и выход
//=================================================================================================
//							КОНСОЛЬ: Форматированный вывод переменных
//=================================================================================================	
void consoleHead(String v,char bl='-',  uint8_t sz=80){ 			//++++Заголовок================
char alig=mess.alig; char blank=mess.blank; mess.alig='C';  mess.blank=bl;
consoleFormat(v,'L',sz);				    mess.alig=alig; mess.blank=blank;}	
void consoleVar(bool v,    char suff='~',uint8_t sz=0,char mode='0'){//--bool    [mode='0'-'9']	
char vMode=mess.signBit;                      mess.signBit=mode;
consoleFormat((String)boolToChar(v),suff,sz); mess.signBit=vMode;};	
void consoleVar(char v,    char suff='~',uint8_t sz=0,char mode='Z'){//--char    [mode:Z,U,L,H]
	 consoleFormat(charToString(v,mode),suff,sz);};	
void consoleVar(uint8_t v, char suff='~',uint8_t sz=0,char mode='Z'){//--uint8_t [mode:P,A,C,B,*,H,U,I,0,1,2,3,Z,z,X]
	 consoleFormat(varToString(v,mode),suff,sz);}	
void consoleVar(int8_t v,  char suff='~',uint8_t sz=0,char mode='Z'){//-- int8_t [mode:P,A,C,B,*,H,U,I,0,1,2,3,Z,z,X]
	 uint8_t a=uint8_t(v); consoleVar(a,suff,sz,mode);};
void consoleVar(int16_t v, char suff='~',uint8_t sz=0,char mode='Z'){//-- int16_t[mode:B,*,H,U,I,0,1,2,3,Z,z]
	consoleFormat(varToString(v,mode),suff,sz);}
void consoleVar(uint16_t v,char suff='~',uint8_t sz=0,char mode='Z'){//--uint16_t[mode:B,*,H,U,I,0,1,2,3,Z,z]
	int16_t a=int16_t(v); consoleVar(a,suff,sz,mode);};
void consoleVar(int32_t  v,char suff='~',uint8_t sz=0,char mode='Z'){//-- int32_t[mode:B,*,H,U,I,0,1,2,3,Z,z]
	 consoleFormat(varToString(v,mode),suff,sz);}	
void consoleVar(uint32_t v,char suff='~',uint8_t sz=0,char mode='Z'){//--uint32_t[mode:B,*,H,U,I,0,1,2,3,Z,z]
	 int32_t a=int32_t(v); consoleVar(a,suff,sz,mode);};
void consoleVar(float v,   char suff='~',uint8_t sz=0,char mode='2'){//--float   [mode:0,1,2,3,Z,z]
	 consoleFormat(varToString(v,mode),suff,sz);}		
void consoleVar(String v,  char suff='~',uint8_t sz=0,char mode='Z'){//--String  [mode:]
	consoleFormat(varToString(v,mode),suff,sz);} 		

//=================================================================================================
//							КОНСОЛЬ: Форматированный вывод массивов
//=================================================================================================
void consoleArrVar( int8_t *arr, char suff, uint8_t sz, char mode, uint8_t qnt){//-- int8_t [mode:P,A,C,B,*,H,U,I,0,1,2,3,Z,z,X]
 for(uint8_t i=0; i<qnt; i++){if(i>0){consoleChar(',');}    uint8_t a=arr[i];	consoleVar(a,'~',sz,mode);} consoleSuff(suff);};
void consoleArrVar(uint8_t  *arr, char suff, uint8_t sz, char mode, uint8_t qnt){
 for(uint8_t i=0; i<qnt; i++){if(i>0){consoleChar(',');}    uint8_t a=arr[i];	consoleVar(a,'~',sz,mode);} consoleSuff(suff);};	
void consoleArrVar(int16_t  *arr, char suff, uint8_t sz, char mode, uint8_t qnt){
 for(uint8_t i=0; i<qnt; i++){if(i>0){consoleChar(',');} 	consoleVar(arr[i],'~',sz,mode);} consoleSuff(suff);};
void consoleArrVar(uint16_t *arr, char suff, uint8_t sz, char mode, uint8_t qnt){
 for(uint8_t i=0; i<qnt; i++){if(i>0){consoleChar(',');} 	consoleVar(arr[i],'~',sz,mode);} consoleSuff(suff);}; 
void consoleArrVar(int32_t  *arr, char suff, uint8_t sz, char mode, uint8_t qnt){
 for(uint8_t i=0; i<qnt; i++){if(i>0){consoleChar(',');} 	consoleVar(arr[i],'~',sz,mode);} consoleSuff(suff);};
void consoleArrVar(uint32_t *arr, char suff, uint8_t sz, char mode, uint8_t qnt){
 for(uint8_t i=0; i<qnt; i++){if(i>0){consoleChar(',');} 	consoleVar(arr[i],'~',sz,mode);} consoleSuff(suff);}; 
void consoleArrVar(float    *arr, char suff, uint8_t sz, char mode, uint8_t qnt){
 for(uint8_t i=0; i<qnt; i++){if(i>0){consoleChar(',');} 	consoleVar(arr[i],'~',sz,mode);} consoleSuff(suff);};
void consoleArrVar( char    *arr, char suff, uint8_t sz, char mode, uint8_t qnt){
 for(uint8_t i=0; i<qnt; i++){if(i>0){consoleChar(',');}    char a=arr[i];	consoleVar(a,'~',sz,mode);} consoleSuff(suff);};
void consoleArrVar(String   *arr, char suff, uint8_t sz, char mode, uint8_t qnt){
 for(uint8_t i=0; i<qnt; i++){if(i>0){consoleChar(',');} 	consoleVar(arr[i],'~',sz,mode);} consoleSuff(suff);}; 

//=================================================================================================
//							Вывод значений из массивов заданного типа [kind]
//=================================================================================================
void consoleArrPGM(uint8_t kind, char mode){
char alig=mess.alig; char modePin=mess.modePin;
//-------------------------------------------------------------------
if(kind>RT_HW_PGM_QNT_ID) 	{return;}	//--Выход по несуществующему типу массива; 
uint8_t lenFull=getLenFullPGM(kind);
uint8_t lenVal =getLenPosPGM(kind);
if(lenVal==0)				{return;}	//--Выход если нет выводимых элементов;					
mess.alig='L'; consoleVar(getNameKindPin(kind),'[',3); 		//--Вывод
mess.alig='R'; consoleVar(lenVal,']',2,'U'); consoleChar(':',' ');	// 		заголовка;
//-------------------------------------------------------------------
uint8_t indexPin=0;	uint8_t indexLine=0; uint8_t  qntLine=16; //RT_HW_PIN_QNT_LINE;
#if defined(RT_HW_CORE_ESP32)
qntLine=30;
#endif
//-------------------------------------------------------------------
for(uint8_t i=0; i<lenFull; i++){
uint8_t pin=getFromArrPGM(kind,i);
if(pin!=255){
if(indexPin>=qntLine){consoleSuff('E'); indexLine++; indexPin=0;}
if((indexLine>0) && (indexPin==0)){consoleBlank(9);}
if(indexPin!=0) {consoleChar(',');}
	 if(mode=='A') {mess.modePin='T'; consoleVar(pin,'~',mess.lenPin,'P');}
else if(mode=='T') {mess.modePin='T'; consoleVar(pin,'~',mess.lenPin,'P');}
else if(mode=='D') {mess.modePin='D'; consoleVar(pin,'~',3,'P');}
else               {                  consoleVar(pin,'~',3,'U');}
indexPin++;	
}}
if(indexPin>0) {consoleSuff('E');}
//------------------------------------------------------------------
mess.alig=alig; mess.modePin=modePin;};
//===================================================================

//=================================================================================================
//			 КОНСОЛЬ: Тестовый вывод переменных (заголовок+переменная)
//=================================================================================================
//void consoleTest(String str, bool     v=0) {if(consoleBegin()){consoleVar(str,'='); uint8_t  d=v; consoleVar(d,'E');}}	
void consoleTest(String str, uint8_t  v, char suff='E', char mode='Z') {if(consoleBegin()){consoleVar(str,'='); uint8_t  d=v; consoleVar(d,suff,0,mode);}}
void consoleTest(String str, char     v, char suff='E', char mode='Z') {if(consoleBegin()){consoleVar(str,'='); char     d=v; consoleVar(d,suff,0,mode);}}
void consoleTest(String str, int16_t  v, char suff='E', char mode='Z') {if(consoleBegin()){consoleVar(str,'='); int16_t  d=v; consoleVar(d,suff,0,mode);}}
void consoleTest(String str, uint16_t v, char suff='E', char mode='Z') {if(consoleBegin()){consoleVar(str,'='); uint16_t d=v; consoleVar(d,suff,0,mode);}}
void consoleTest(String str, int32_t  v, char suff='E', char mode='Z') {if(consoleBegin()){consoleVar(str,'='); int32_t  d=v; consoleVar(d,suff,0,mode);}}
void consoleTest(String str, uint32_t v, char suff='E', char mode='Z') {if(consoleBegin()){consoleVar(str,'='); uint32_t d=v; consoleVar(d,suff,0,mode);}}
void consoleTest(String str, float    v, char suff='E') {if(consoleBegin()){consoleVar(str,'='); float    d=v; consoleVar(d,suff);}}
void consoleTest(String str, String   v, char suff='E') {if(consoleBegin()){consoleVar(str,'='); String   d=v; consoleVar(d,suff);}}
//=================================================================================================
//		   КОНСОЛЬ: Тестовый вывод переменных по изменению (заголовок+переменная)
//=================================================================================================
void consoleChange(String str, bool     &ago, bool     v, char suff='E') {if(consoleBegin()){if(ago!=v){ago=v; consoleVar(str,'=');consoleVar(v,suff);}}}	
void consoleChange(String str, uint8_t  &ago, uint8_t  v, char suff='E') {if(consoleBegin()){if(ago!=v){ago=v; consoleVar(str,'=');consoleVar(v,suff);}}}
void consoleChange(String str, int16_t  &ago, int16_t  v, char suff='E') {if(consoleBegin()){if(ago!=v){ago=v; consoleVar(str,'=');consoleVar(v,suff);}}}
void consoleChange(String str, int32_t  &ago, int32_t  v, char suff='E') {if(consoleBegin()){if(ago!=v){ago=v; consoleVar(str,'=');consoleVar(v,suff);}}}
void consoleChange(String str, uint32_t &ago, uint32_t v, char suff='E') {if(consoleBegin()){if(ago!=v){ago=v; consoleVar(str,'=');consoleVar(v,suff);}}}