//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						API консоль - сканирование шин I2c, заголовки
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//=================================================================================================
//							Вывод основных параметров платы 
//=================================================================================================
void  consoleBoardGeneral(){		
mess.alig='R'; mess.blank=' ';
consoleVar(String(__DATE__));   		   	consoleBlank(' ',61);consoleVar(String(__TIME__),'L');
consoleVar(String(F("Board->")));          	consoleVar(String(F(RT_HW_BOARD_NAME)),'/'); 
consoleVar((uint8_t)RT_HW_BOARD_CODE,';',0,'U'); 	consoleBlank(2);
consoleVar(String(F("Arch->")));           	consoleVar(String(F(RT_HW_ARCH_NAME)),'/');	consoleVar((uint8_t)RT_HW_ARCH_CODE,';',0,'U'); 
consoleVar(String(F("  Core->")));		   	consoleVar(String(F(RT_HW_CORE_NAME)),';'); 
#if defined(RT_HW_CORE_STM32)
consoleVar(String(F("[family STM32]")));  
#endif
#if defined(RT_HW_CORE_ESP32)
consoleVar(String(F("[family ESP32]")));  
#endif
consoleSuff('E');
consoleVar(String(F("Select board->")));	consoleVar(String(F(RT_HW_BOARD_SELECT)),'E');	
};		
//=================================================================================================
//							Вывод системных 
//control,led,button,wsBus,adc,btn,tch,pwm,dac,servo,debug1,debug2,debug3;
//=================================================================================================
void  consolePinsSystem(){		
mess.alig='R'; mess.blank=' ';
consoleVar(String(F("System->")));
if(device.pin.control!=255){consoleTest(String(F(" control")),device.pin.control,';','P');}
if(device.pin.led!=255)    {consoleTest(String(F(" LedBLT")), device.pin.led,    ';','P');}
if(device.pin.button!=255) {consoleTest(String(F(" ButBLT")), device.pin.button, ';','P');}
if(device.pin.wsBus!=255)  {consoleTest(String(F(" ws2812")), device.pin.wsBus,  ';','P');}
if(device.pin.debug1!=255) {consoleTest(String(F(" debug1")), device.pin.debug1, ';','P');}
if(device.pin.debug2!=255) {consoleTest(String(F(" debug2")), device.pin.debug2, ';','P');}
if(device.pin.debug3!=255) {consoleTest(String(F(" debug3")), device.pin.debug3, ';','P');}
consoleCR();
};	
//=================================================================================================
//							Вывод тестовых пинов
//=================================================================================================
void  consolePinsTest(){		
mess.alig='R'; mess.blank=' ';
//-------------------------------------------------------------------------------------------------
consoleVar(String(F("Board-->")));
if(device.pin.adc!=255)   {consoleTest(String(F(" ADC")),   device.pin.adc,  ';','P');}
if(device.pin.btn!=255)   {consoleTest(String(F(" Button")),device.pin.btn,  ';','P');}
if(device.pin.tch!=255)   {consoleTest(String(F(" Touch")), device.pin.tch,  ';','P');}
if(device.pin.pwm!=255)   {consoleTest(String(F(" PWM")),   device.pin.pwm,  ';','P');}
if(device.pin.dac!=255)   {consoleTest(String(F(" DAC")),   device.pin.dac,  ';','P');}
if(device.pin.servo!=255) {consoleTest(String(F(" Servo")), device.pin.servo,';','P');}
consoleCR();
//-------------------------------------------------------------------------------------------------
consoleVar(String(F("SPI.cs->")));
if(device.spi.cs0!=255) {consoleTest(String(F(" cs0(74HC595)")),    device.spi.cs0,';','P');}
if(device.spi.cs1!=255) {consoleTest(String(F(" cs1(Lcd 74HC595)")),device.spi.cs1,';','P');}
if(device.spi.cs2!=255) {consoleTest(String(F(" cs2(NRF2401)")),    device.spi.cs2,';','P');}
if(device.spi.cs3!=255) {consoleTest(String(F(" cs3(MAX6675)")), 	device.spi.cs3,';','P');}
consoleCR();
//-------------------------------------------------------------------------------------------------
consoleVar(String(F("Device->")));
if(device.dev.oneWBus!=255){consoleTest(String(F(" 1-Wire(DS1820)")),device.dev.oneWBus,';','P');}
if(device.dev.dht22!=255)  {consoleTest(String(F(" DHT22")),        device.dev.dht22,  ';','P');}
if(device.dev.srTrig!=255) {consoleTest(String(F(" HC-SR04.trig")), device.dev.srTrig, ';','P');}
consoleCR();
};				
//=================================================================================================
//							Вывод дополнительных параметров платы
//=================================================================================================
void  consoleBoardAdd(){
mess.alig='R'; mess.blank=' ';
//------Вывод наименование библиотеки--------------------------------------------------------------
consoleVar(String(F("RT_HW_BASE.h->")));   consoleVar(String(F(RT_HW_BASE_VER_NAME)),'E');
//------Вывод размера памяти-----------------------------------------------------------------------
#if defined(RT_HW_CORE_ANON)
consoleVar(String(F("Fcpu=xxx; Vcc=x.xx; Memory=xxx")),'E'); 			
#else
consoleVar(String(F("Fcpu="))); 	consoleVar(uint32_t(RT_HW_FCPU));	consoleVar(String(F("mHz")),';'); 
consoleVar(String(F(" Vcc="))); 	consoleVar(float(RT_HW_VCC/1000.0),';'); 
consoleVar(String(F(" Memory::"))); consoleVar(String(F(RT_HW_BOARD_MEMORY)),'E');
#endif
//-----Вывод системной разрядности и разрядности устройств на плате--------------------------------
mess.alig='R'; mess.blank=' ';
consoleVar(String(F("Depth->"))); consoleTest(String(F(" SYS,max")),device.depth.sys,';'); consoleVar(uint16_t(maxBitDepth(device.depth.sys)),';');
if(device.depth.adc!=255){consoleTest(String(F(" ADC,drift,null")),device.depth.adc,',');  consoleVar(device.depth.adc,','); consoleVar(device.depth.adcDrift,','); consoleVar(device.depth.adcNull,';');}
if(device.depth.tch!=255){consoleTest(String(F(" Touch")),device.depth.tch,';');}
if(device.depth.pwm!=255){consoleTest(String(F(" PWM")),device.depth.pwm,';');}
if(device.depth.dac!=255){consoleTest(String(F(" DAC")),device.depth.dac,';');}
consoleCR();
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ESP8266)	
//------Исключения при загрузке ESP8266------------------------------------------------------------
consoleVar(String(F("[Download requirement for pins->D3=1,D4=1,D8=0;]")),'E');
#endif
#if defined(RT_HW_CORE_ESP32_S2)
//------Исключения при загрузке ESP32--------------------------------------------------------------
consoleVar(String(F("[Download requirement for pins->pin.3=1,pin.12=1. Note: pins 0,5,14,15=PWM; pins.1=debug;]")),'E');
#endif
#if defined(RT_HW_CORE_ESP32_C3)
//------Исключения при загрузке ESP32-C3--------------------------------------------------------------
consoleVar(String(F("[Download requirement for pins->pin.3=1]")),'E');
#endif
};
//=================================================================================================
//							Вывод параметров диспетчера задач
//=================================================================================================
void  consoleShedulerParameters(){	
mess.alig='R'; mess.blank=' ';
consoleVar(String(F("Sheduler::qnt---->quick,fast,slow,back,frdm="))); consoleVar(shed.quick.qnt,','); consoleVar(shed.fast.qnt,','); consoleVar(shed.slow.qnt,','); consoleVar(shed.frdm.qnt,';');  
consoleVar(String(F("period->quick,fast,slow,back,frdm=10,25,250,100,loop()")));
consoleCR();
};
//=================================================================================================
//							Вывод доступных пинов [T,D,A];
//=================================================================================================
void  consolePinsAll(){
//-------------------------------------------------------------------------------------------------
mess.alig='R'; mess.blank=' '; mess.modePin='T'; mess.modeAdr='A'; mess.qntBit=8; mess.signBit='1'; 
//-------------------------------------------------------------------------------------------------
for(uint8_t i=RT_HW_PGM_PIN_ALL_ID;i<=RT_HW_PGM_PIN_N5V_ID;i++){consoleArrPGM(i,mess.modePin);}
if(getLenPosPGM(RT_HW_PGM_PIN_N5V_ID)==0) {consoleVar(String(F("All pins tolerant to 5V")),'E');}	
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ESP8266)	
mess.alig='R'; mess.modePin='D';
consoleHead(String(F("Name pins ESP8266")),'-',80);
consoleVar(String(F("[D0-D4]--------->16,5,4,0,2")),'E');
consoleVar(String(F("[D5-D8,--------->14,12,13,15")),'E');
consoleVar(String(F("[D9-D10,A0]----->3,1,17")),'E');
consoleVar(String(F("[RX,RX0,TX,TX0]->3,3,1,1,")),'E');
consoleVar(String(F("[TX1,RX2,TX2]--->2,3,15")),'E');
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_STM32)  //--STM32 одноядерный процессор, поэтому можно безконфликтно использовать временные переменные; 
{uint8_t arr[16]; char reg; bool ok;
consoleHead(String(F("Name pins STM32")),'-',80);
mess.modePin='A';
for(uint8_t m=0; m<12; m++){reg='A'+ m; ok=0; 
 for(uint8_t i=0;i<16; i++){arr[i]=getNumPinSTM32(reg,i); if(arr[i]<254){ok=1;}}	
  if(ok){consoleChar('P'); consoleVar(char(reg)); consoleVar(String(F("[16]  ")));
    for(uint8_t j=0;j<16;j++){      
		consoleVar(arr[j],' ',9,'P'); 
		if((j==7) && (mess.modePin=='A')){consoleSuff('L'); consoleBlank(8);}
		if(j==15){consoleSuff('L');} 
}}}} 
#endif
//-------------------------------------------------------------------------------------------------
};
//=================================================================================================
//							Вывод интерфейсов
//================================================================================================= 
void consoleInterface(){
//-------------------------------------------------------------------------------------------------
//							Интерфейс i2c
//-------------------------------------------------------------------------------------------------
for(idx.i=0; idx.i<=15; idx.i++){i2cHeadInterface(idx.i);}
//-------------------------------------------------------------------------------------------------
//						Сообщения по интерфейсу i2c
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_ESP8266)
consoleVar(String(F("[SDA,SCL any pin from D1-D10]")),'E');
#endif
#if defined(RT_HW_CORE_ESP32_S2)  
consoleVar(String(F("[SDA,SCL any pin <35]")),'E');
#endif
#if defined(RT_HW_CORE_STM32)
consoleVar(String(F("[i2c0: SDA,SCL pin PB7,PB6 or PB9,PB8]")),'E');   
#endif 
//-------------------------------------------------------------------------------------------------
//							Интерфейс SPI
//-------------------------------------------------------------------------------------------------	
for(idx.i=0; idx.i<=15; idx.i++){SPIheadInterface(idx.i);}
//-------------------------------------------------------------------------------------------------
//							Интерфейс SPN
//-------------------------------------------------------------------------------------------------	
SPNheadInterface();
//-------------------------------------------------------------------------------------------------
//							Интерфейс UART
//-------------------------------------------------------------------------------------------------
for(idx.i=0; idx.i<=15; idx.i++){uartHeadInterface(idx.i);}
//-------------------------------------------------------------------------------------------------
//						Сообщения по интерфейсу UART
//-------------------------------------------------------------------------------------------------
#ifdef RT_HW_CORE_ESP8266
consoleVar(String(F("[UART  possible options are (1,3),(2,3) or (15,13);")),'L');
consoleVar(String(F(" Set Serial.pins(uint8_t tx, uint8_t rx) or Serial.swap(uint8_t tx_pin)")),'L');
consoleVar(String(F(" toggle between use of GPIO13/GPIO15 or GPIO3/GPIO(1/2)as RX and TX;")),'E');
consoleVar(String(F(" UART1 allows only TX on 2 if UART is not (2,3);]")),'E');	 
#endif
//-------------------------------------------------------------------------------------------------
									
//-------------------------------------------------------------------------------------------------
//							Интерфейс CAN
//-------------------------------------------------------------------------------------------------
#ifdef RT_HW_PERMIT_CAN
mess.alig='R'; mess.blank=' '; mess.modePin='A';
{uint8_t arr[]={readArrPGM(RT_HW_PGM_PIN_CAN_ID,0), readArrPGM(RT_HW_PGM_PIN_CAN_ID,1)}; 
  if((arr[0]!=255) && (arr[1]!=255)) {consoleVar(String(F("CAN:   RX,TX="))); consoleArrVar(arr,'E',0,'P',2);}}	
#endif
//-------------------------------------------------------------------------------------------------
//							Интерфейс BlueTooth
//-------------------------------------------------------------------------------------------------
#ifdef RT_HW_PERMIT_BTH
mess.alig='R'; mess.blank=' ';
consoleVar(String(F("BlueTooth->в разработке:"))); 
for(idx.i=0; idx.i<3; idx.i++){consoleChar(char(getIntPGM(RT_HW_PGM_PIN_BTH_ID)),idx.i);} consoleSuff('E');
#endif
//-------------------------------------------------------------------------------------------------
//							Интерфейс Ethernet
//-------------------------------------------------------------------------------------------------
#ifdef RT_HW_PERMIT_ETH
mess.alig='R'; mess.blank=' ';
consoleText(String(F("Ethernet->(debug):"))); 
for(idx.i=0; idx.i<3; idx.i++){consoleVar(uint8_t(readArrPGM(RT_HW_PGM_PIN_ETH_ID,idx.i)),'.',3);} consoleSuff('E');
#endif
//-------------------------------------------------------------------------------------------------
//							Интерфейс Wi-Fi
//-------------------------------------------------------------------------------------------------
#ifdef RT_HW_PERMIT_WFI
mess.alig='R'; mess.blank=' ';
consoleVar(String(F("Wi-Fi(debug)->:"))); 
for(idx.i=0; idx.i<4; idx.i++){consoleChar(char(getIntPGM(RT_HW_PGM_PIN_WFI_ID)),idx.i);} consoleSuff('E'); 
#endif
//-------------------------------------------------------------------------------------------------
//							Интерфейс: завершение
//-------------------------------------------------------------------------------------------------
};

//=================================================================================================
//							Вывод массивов из PROGMEM 
//=================================================================================================
void  consoleFromPGM(){
mess.alig='R'; mess.blank=' '; mess.modePin='A'; mess.modeAdr='A'; mess.qntBit=8; mess.signBit='1'; 
//-------------------------------------------------------------------------------------------------
for(console.idx=0;                    console.idx<=RT_HW_PGM_SYS_DAC_ID; console.idx++){consoleArrPGM(console.idx,'N');};
consoleLine('-',60);
for(console.idx=RT_HW_PGM_PIN_BRD_ID; console.idx<=RT_HW_PGM_PIN_CAN_ID; console.idx++){consoleArrPGM(console.idx,'T');};
consoleLine('-',60);
for(console.idx=RT_HW_PGM_PIN_DBG_ID; console.idx<=RT_HW_PGM_PIN_TFT_ID; console.idx++){consoleArrPGM(console.idx,'T');};
//for(idx.i=RT_HW_PGM_PIN_BTH_ID; idx.i<=RT_HW_PGM_PIN_WFI_ID; idx.i++){consoleArrPGM(idx.i,'N');};	 
consoleLine('-',60);
//consoleArrPGM(RT_HW_PGM_PIN_URT_ID,'N');
//consoleArrPGM(RT_HW_PGM_ADR_I2C_ID,'N');
//-------------------------------------------------------------------------------------------------
};
//--------------------------------------------------------------------------------------------------
