
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							1.СОЗДАНИЕ ОБЪЕКТОВ С ДАННЫМИ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_PERMIT_SPI0)							//++++Данные для SPI0----------------------				  
RT_HW_STRUCT_SPI 	LinkSPI0;
#endif	//-----------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI1)							//++++Данные для SPI1----------------------		  
RT_HW_STRUCT_SPI 	LinkSPI1;
#endif	//-----------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI2)							//++++Данные для SPI2----------------------			  
RT_HW_STRUCT_SPI 	LinkSPI2;						
#endif	//----------------------------------------------------------------------------------------- 
//=================================================================================================
//							2.НАСТРОЙКА SPI
//=================================================================================================
void     SPIheadInterface(               uint8_t bus=0){//++++Вывод на консоль заголовка по интерфейсу SPI;	
if(!spiCheckBus(bus))			{return;}	//--Проверка наличия шины;
consoleBegin();	if(!console.ok)	{return;} 	//--Настройка консоли с параметрами по умолчанию и ожидание готовности;
mess.alig='R'; mess.blank=' '; mess.modePin='T'; mess.modeAdr='A'; mess.qntBit=8; mess.signBit='1'; 
uint8_t arr[4]; arr[0]=spiGetPinSCK(bus); arr[1]=spiGetPinMISO(bus); arr[2]=spiGetPinMOSI(bus); arr[3]=spiGetPinSS(bus); 
consoleVar(String(F("SPI")));                consoleVar(bus);
consoleVar(String(F(" bus=")));              consoleVar(bus,':');
consoleVar(String(F(" SCK,MISO,MOSI,SS="))); consoleArrVar(arr,';',0,'P',4);
     if(spiGetStatus(bus)==1){consoleVar(String(F("  Master")),';');}
else if(spiGetStatus(bus)==2){consoleVar(String(F("   Slave")),';');}
else			  {consoleVar(String(F(" No init")),';');}
consoleVar(String(F(" speed(kHz)="))); consoleVar(uint32_t(spiGetSpeed(bus)/1000),';');
consoleCR();
};	//=============================================================================================
void 	 SPIinitParam (                  uint8_t bus=0){//++++Первичная инициализация пинов SPI----
#if defined(RT_HW_PERMIT_SPI0)
if(bus==0) {LinkSPI0.busy=LinkSPI0.status=LinkSPI0.codeErr=0;	//--clear busy,status,codeErr;
			LinkSPI0.sck  =readArrPGM(RT_HW_PGM_PIN_SPI_ID,0);	//--set pin SCK; 
			LinkSPI0.miso =readArrPGM(RT_HW_PGM_PIN_SPI_ID,1);	//--set pin MISO;
			LinkSPI0.mosi =readArrPGM(RT_HW_PGM_PIN_SPI_ID,2);	//--set pin MOSI; 
			LinkSPI0.ss   =readArrPGM(RT_HW_PGM_PIN_SPI_ID,3);	//--set pin SS;
			LinkSPI0.speed=RT_HW_SPI_SPEED;}            	    //--set speed;
#endif
#if defined(RT_HW_PERMIT_SPI1)
if(bus==1) {LinkSPI1.busy=LinkSPI1.status=LinkSPI1.codeErr=0;	//--clear busy,status,codeErr;
			LinkSPI1.sck  =readArrPGM(RT_HW_PGM_PIN_SPI_ID,4);	//--set pin SCK; 
			LinkSPI1.miso =readArrPGM(RT_HW_PGM_PIN_SPI_ID,5);	//--set pin MISO;
			LinkSPI1.mosi =readArrPGM(RT_HW_PGM_PIN_SPI_ID,6);	//--set pin MOSI; 
			LinkSPI1.ss   =readArrPGM(RT_HW_PGM_PIN_SPI_ID,7);	//--set pin SS;
			LinkSPI1.speed=RT_HW_SPI_SPEED;}				//--set speed;			
#endif
#if defined(RT_HW_PERMIT_SPI2)
if(bus==2) {LinkSPI2.busy=LinkSPI2.status=LinkSPI2.codeErr=0;	//--clear busy,status,codeErr;
			LinkSPI2.sck  =readArrPGM(RT_HW_PGM_PIN_SPI_ID,8);	//--set pin SCK; 
			LinkSPI2.miso =readArrPGM(RT_HW_PGM_PIN_SPI_ID,9);	//--set pin MISO;
			LinkSPI2.mosi =readArrPGM(RT_HW_PGM_PIN_SPI_ID,10);	//--set pin MOSI; 
			LinkSPI2.ss   =readArrPGM(RT_HW_PGM_PIN_SPI_ID,11);	//--set pin SS;
			LinkSPI2.speed=RT_HW_SPI_SPEED;}				    //--set speed;
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
};	//++++END spiInitParam()-----------------------------------------------------------------------

uint8_t  SPIbeginSlave(uint8_t &codeErr, uint8_t bus=0){//++++Настройка шины как Slave;
if(spiBeginMaster(codeErr,bus)){spiSetCodeErr(codeErr,bus); return 1;} 
else                           {spiSetCodeErr(codeErr,bus); return 0;} 
};	//++++END SPIBegin()===========================================================================
uint8_t  SPIbegin     (uint8_t &codeErr, uint8_t pinSCK, uint8_t pinMISO, uint8_t pinMOSI, uint8_t bus=0){//++++Настройка шины как Master с перенастройкой пинов;
SPIsetPins(codeErr, pinSCK, pinMISO, pinMOSI, bus);	 
if(codeErr!=0){return 1;}
if(!spiBeginMaster(codeErr,bus)){return 0;}
return 1;
};	//++++END SPIBegin(pins)=======================================================================
uint8_t  SPIbegin     (uint8_t &codeErr, uint8_t bus=0){//++++Настройка шины как Master;
if(!spiBeginMaster(codeErr,bus)){return 0;}
return 1;
};	//++++END SPIBegin()===========================================================================
uint8_t  SPIbeginSlave(uint8_t &codeErr, uint8_t pinSCK, uint8_t pinMISO, uint8_t pinMOSI, uint8_t pinSS, uint8_t bus=0){//++++Настройка шины как Slave с перенастройкой пинов;
SPIsetPins(codeErr, pinSCK, pinMISO, pinMOSI, bus);	 
if(codeErr!=0){return 1;}
if(codeErr==0){if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinMOSI(bus))){codeErr=64; return 1;} else{spiSetPinSS(pinSS, bus);}}
if(!spiBeginSlave(codeErr,bus)){return 0;}
return 1;
};	//++++END SPIBeginSlave(pins)==================================================================
uint8_t  SPIbeginSlave(uint8_t &codeErr, uint8_t pinSS, uint8_t bus=0){//++++Настройка шины как Slave;
codeErr=0;
if(codeErr==0){if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinMOSI(bus))){codeErr=64; return 1;} else{spiSetPinSS(pinSS, bus);}}
if(!spiBeginSlave(codeErr,bus)){return 0;}
return 1;
};	//++++END SPIBeginSlave(pins)==================================================================
uint8_t  SPIinitDevice(uint8_t &codeErr,                                  uint8_t cs,      uint8_t bus=0){//++++Проверка bus, настройка cs, инициализация MASTER;
codeErr=0;
if(codeErr==0){if(!spiCheckBus(bus))						  {codeErr=65;}}	//--Check bus;
if(codeErr==0){if(!SPIbegin(codeErr,bus)){return 0;}                     }		//--Wait init SPIbus.begin();
if(codeErr==0){if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,cs)) 	  {codeErr=66;}}	//--Check cs;
if(codeErr==0){pinMode(cs,OUTPUT); digitalWrite(cs,1); pinMode(cs,OUTPUT); }	//--init CS; 
return  1;	
};	//++++spiInitDevice()----------------------------------------------------------------------------
//=================================================================================================
//						3.РАБОТА С ДОПОЛНИТЕЛЬНЫМИ ПАРАМЕТРАМИ
//=================================================================================================
uint8_t	 SPIcheckBus  (					 uint8_t bus=0){//++++Проверка номера шины------------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return 1;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return 1;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return 1;}
#endif	
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;};
void     SPIsetStatus (uint8_t var,      uint8_t bus=0){//++++Запись статуса------------------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.status=var; return;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.status=var; return;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.status=var; return;}
#endif
buff.vu8=var;  //--Для предотвращения warning C++;
buff.bf8=bus; //--Для предотвращения warning C++;
}
uint8_t  SPIgetStatus (uint8_t bus){				    //++++Чтение статуса------------------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.status;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.status;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.status;}
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;};
void 	 SPIsetSpeed  (uint32_t speed,   uint8_t bus=0){//++++Запись speed--------------------------
if(speed==0){speed=RT_HW_SPI_SPEED;}
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.speed=speed; return;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.speed=speed; return;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.speed=speed; return;}
#endif
buff.vu32=speed; //--Для предотвращения warning C++;
buff.bf8=bus;    //--Для предотвращения warning C++;
};	//++++END spiSetSpeed()------------------------------------------------------------------------
uint32_t SPIgetSpeed  (                  uint8_t bus=0){//++++Чтение speed--------------------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.speed;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.speed;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.speed;}
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return 400000UL;
};	//++++END spiGetSpeed()------------------------------------------------------------------------

//=================================================================================================
//						4.РАБОТА С НОМЕРАМИ ПИНАМИ
//(для sck,miso,mosi изменение допускается по разрешению бита слова состояния RT_HW_SPI_STATE_BLOCK_PINS=0)
//=================================================================================================
void	 SPIsetPins    (uint8_t &codeErr, uint8_t pinSCK, uint8_t pinMISO, uint8_t pinMOSI, uint8_t bus){ //++++Запись номеров пинов SCK,MISO,MOSI;
codeErr=0;
#if defined(RT_HW_I2C_BLOCK_USER_PINS)
buff.vi8=bus; 		//--for block warning C++;
buff.vu8=pinSCK; 	//--for block warning C++;
buff.bf8=pinMISO; 	//--for block warning C++;
buff.vu16=pinMISO; 	//--for block warning C++;
buff.vu16=pinMOSI; 	//--for block warning C++;
return;
#endif
if((pinSCK==pinMISO) || (pinSCK==pinMOSI) || (pinMISO==pinMOSI))            {codeErr=60;}
if(codeErr==0){if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinSCK (bus))) 	{codeErr=61;}}
if(codeErr==0){if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,spiGetPinMISO(bus)))	{codeErr=62;}}
if(codeErr==0){if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinMOSI(bus)))	{codeErr=63;}}
if(codeErr==0){spiSetPinSCK(pinSCK,bus); spiSetPinMISO(pinMISO,bus); spiSetPinMOSI(pinMOSI,bus);}
};	//++++END i2ccSetPins()=========================================================================
void 	 SPIsetPinSCK  (uint8_t sck,      uint8_t bus=0){//--Запись номера пина SCK-----------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.sck=sck; return;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.sck=sck; return;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.sck=sck; return;}
#endif
buff.vu8=sck; //--Для предотвращения warning C++;
buff.bf8=bus; //--Для предотвращения warning C++;
};
void 	 SPIsetPinMISO (uint8_t miso,     uint8_t bus=0){//--Запись номера пина MISO----------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.miso=miso; return;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.miso=miso; return;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.miso=miso; return;}
#endif
buff.vu8=miso; //--Для предотвращения warning C++;
buff.bf8=bus; //--Для предотвращения warning C++;
};
void 	 SPIsetPinMOSI (uint8_t mosi,     uint8_t bus=0){//--Запись номера пина MOSI----------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.mosi=mosi; return;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.mosi=mosi; return;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.mosi=mosi; return;}
#endif
buff.vu8=mosi; //--Для предотвращения warning C++;
buff.bf8=bus; //--Для предотвращения warning C++;
};
void 	 SPIsetPinSS   (uint8_t ss,       uint8_t bus=0){//--Запись номера пина SS------------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.ss=ss; return;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.ss=ss; return;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.ss=ss; return;}
#endif
buff.vu8=ss; //--Для предотвращения warning C++;
buff.bf8=bus; //--Для предотвращения warning C++;
};
uint8_t  SPIgetPinSCK  (                  uint8_t bus=0){//--Чтение номера пина SCK-----------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.sck;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.sck;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.sck;}
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;};
uint8_t  SPIgetPinMISO (                  uint8_t bus=0){//--Чтение номера пина MISO----------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.miso;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.miso;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.miso;}
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;};
uint8_t  SPIgetPinMOSI (                  uint8_t bus=0){//--Чтение номера пина MOSI----------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.mosi;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.mosi;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.mosi;}
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;};
uint8_t  SPIgetPinSS   (                  uint8_t bus=0){//--Чтение номера пина SS------------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.ss;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.ss;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.ss;}
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;};

//=================================================================================================
//						5.ФУНКЦИИ ОБМЕНА
//=================================================================================================
void     SPItransfer   (uint8_t bitOrder, uint8_t dataMode, uint8_t  tx,  uint8_t  &rx, uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id); 
if(speed==0){speed=SPIgetSpeed(bus);}
spiBeginTransaction(speed,LSBFIRST,dataMode,bus); 
if(bitOrder){tx=reverseV8(tx);} rx=spiTransfer(tx,bus); if(bitOrder){rx=reverseV8(rx);} 
spiEndTransaction(bus); 
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransfer v8()======================================================================
void 	 SPItransfer16 (uint8_t bitOrder, uint8_t dataMode, uint16_t tx,  uint16_t &rx, uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id);
if(speed==0){speed=SPIgetSpeed(bus);}
spiBeginTransaction(speed,LSBFIRST,dataMode,bus); 
if(bitOrder){tx=reverseV16(tx);}
rx=   (uint16_t)(spiTransfer( (uint8_t)( tx     &0xFF) ,bus)); 
rx=rx+(uint16_t)(spiTransfer(((uint8_t)((tx>>8) &0xFF)),bus)<<8); 
if(bitOrder){rx=reverseV16(rx);}
spiEndTransaction(bus);
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransfer16()======================================================================
void 	 SPItransfer24 (uint8_t bitOrder, uint8_t dataMode, uint32_t tx,  uint32_t &rx, uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id);
if(speed==0){speed=SPIgetSpeed(bus);}
spiBeginTransaction(speed,LSBFIRST,dataMode,bus); 
if(bitOrder){tx=reverseV24(tx);}
rx=     (uint32_t)spiTransfer( (uint8_t)( tx     &0xFF) ,bus); 
rx=rx+(((uint32_t)spiTransfer(((uint8_t)((tx>>8) &0xFF)),bus))<<8);
rx=rx+(((uint32_t)spiTransfer(((uint8_t)((tx>>16)&0xFF)),bus))<<16); 
if(bitOrder){rx=reverseV24(rx);}
spiEndTransaction(bus);
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransfer16()======================================================================
void 	 SPItransfer32 (uint8_t bitOrder, uint8_t dataMode, uint32_t tx,  uint32_t &rx, uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id);
if(speed==0){speed=SPIgetSpeed(bus);}
spiBeginTransaction(speed,LSBFIRST,dataMode,bus); 
if(bitOrder){tx=reverseV32(tx);}
rx=     (uint32_t)spiTransfer( (uint8_t)( tx     &0xFF) ,bus); 
rx=rx+(((uint32_t)spiTransfer(((uint8_t)((tx>>8) &0xFF)),bus))<<8);
rx=rx+(((uint32_t)spiTransfer(((uint8_t)((tx>>16)&0xFF)),bus))<<16); 
rx=rx+(((uint32_t)spiTransfer(((uint8_t)((tx>>24)&0xFF)),bus))<<24); 
if(bitOrder){rx=reverseV32(rx);}
spiEndTransaction(bus);
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransfer16()=====================================================================
void  	 SPItransferArr(uint8_t bitOrder, uint8_t dataMode, uint8_t  *tx, uint8_t  *rx, uint8_t qnt, uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id);
if(speed==0){speed=SPIgetSpeed(bus);}
spiBeginTransaction(speed,bitOrder,dataMode,bus);		
for(uint8_t i=0; i<qnt; i++){if(bitOrder){tx[i]=reverseV8(tx[i]);} rx[i]=spiTransfer(tx[i],bus); if(bitOrder){rx[i]=reverseV8(rx[i]);}} 
spiEndTransaction(bus);
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransferArr()=====================================================================

void     SPIwrite   (uint8_t bitOrder, uint8_t dataMode, uint8_t  tx, uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id); 
if(speed==0){speed=SPIgetSpeed(bus);}
spiBeginTransaction(speed,LSBFIRST,dataMode,bus); 
if(bitOrder){tx=reverseV8(tx);} spiTransfer(tx,bus);
spiEndTransaction(bus); 
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransfer v8()======================================================================
void 	 SPIwrite16 (uint8_t bitOrder, uint8_t dataMode, uint16_t tx, uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id);
if(speed==0){speed=SPIgetSpeed(bus);}
spiBeginTransaction(speed,LSBFIRST,dataMode,bus); 
if(bitOrder){tx=reverseV16(tx);}
spiTransfer((uint8_t)( tx     &0xFF),bus); 
spiTransfer((uint8_t)((tx>>8) &0xFF),bus); 
spiEndTransaction(bus);
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransfer16()======================================================================
void 	 SPIwrite24 (uint8_t bitOrder, uint8_t dataMode, uint32_t tx, uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id);
if(speed==0){speed=SPIgetSpeed(bus);}
spiBeginTransaction(speed,LSBFIRST,dataMode,bus); 
if(bitOrder){tx=reverseV24(tx);}
spiTransfer((uint8_t)( tx     &0xFF),bus); 
spiTransfer((uint8_t)((tx>>8) &0xFF),bus);
spiTransfer((uint8_t)((tx>>16)&0xFF),bus); 
spiEndTransaction(bus);
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransfer16()======================================================================
void 	 SPIwrite32 (uint8_t bitOrder, uint8_t dataMode, uint32_t tx, uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id);
if(speed==0){speed=SPIgetSpeed(bus);}
spiBeginTransaction(speed,LSBFIRST,dataMode,bus); 
if(bitOrder){tx=reverseV32(tx);}
spiTransfer((uint8_t)( tx     &0xFF),bus); 
spiTransfer((uint8_t)((tx>>8) &0xFF),bus);
spiTransfer((uint8_t)((tx>>16)&0xFF),bus); 
spiTransfer((uint8_t)((tx>>24)&0xFF),bus); 
spiEndTransaction(bus);
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransfer16()=====================================================================
void  	 SPIwriteArr(uint8_t bitOrder, uint8_t dataMode, uint8_t *tx, uint8_t qnt,uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id);
if(speed==0){speed=SPIgetSpeed(bus);}
spiBeginTransaction(speed,bitOrder,dataMode,bus);		
for(uint8_t i=0; i<qnt; i++){if(bitOrder){tx[i]=reverseV8(tx[i]);} spiTransfer(tx[i],bus);} 
spiEndTransaction(bus);
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransferArr()=====================================================================

void     SPIread   (uint8_t bitOrder, uint8_t dataMode, uint8_t  &rx, uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id); 
if(speed==0){speed=SPIgetSpeed(bus);}
spiBeginTransaction(speed,LSBFIRST,dataMode,bus); 
rx=spiTransfer(0,bus); 
if(bitOrder){rx=reverseV8(rx);} 
spiEndTransaction(bus); 
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransfer v8()======================================================================
void 	 SPIread16 (uint8_t bitOrder, uint8_t dataMode, uint16_t &rx, uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id);
if(speed==0){speed=SPIgetSpeed(bus);}
spiBeginTransaction(speed,LSBFIRST,dataMode,bus); 
rx=     (uint16_t)spiTransfer(0,bus); 
rx=rx+(((uint16_t)spiTransfer(0,bus))<<8); 
if(bitOrder){rx=reverseV16(rx);}
spiEndTransaction(bus);
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransfer16()======================================================================
void 	 SPIread24 (uint8_t bitOrder, uint8_t dataMode, uint32_t &rx, uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id);
if(speed==0){speed=SPIgetSpeed(bus);}
spiBeginTransaction(speed,LSBFIRST,dataMode,bus); 
rx=     (uint32_t)spiTransfer(0,bus); 
rx=rx+(((uint32_t)spiTransfer(0,bus))<<8);
rx=rx+(((uint32_t)spiTransfer(0,bus))<<16); 
if(bitOrder){rx=reverseV24(rx);}
spiEndTransaction(bus);
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransfer16()======================================================================
void 	 SPIread32 (uint8_t bitOrder, uint8_t dataMode, uint32_t &rx, uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id);
if(speed==0){speed=SPIgetSpeed(bus);}
spiBeginTransaction(speed,LSBFIRST,dataMode,bus); 
rx=     (uint32_t)spiTransfer(0,bus); 
rx=rx+(((uint32_t)spiTransfer(0,bus))<<8);
rx=rx+(((uint32_t)spiTransfer(0,bus))<<16); 
rx=rx+(((uint32_t)spiTransfer(0,bus))<<24); 
if(bitOrder){rx=reverseV32(rx);}
spiEndTransaction(bus);
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransfer16()=====================================================================
void  	 SPIreadArr(uint8_t bitOrder, uint8_t dataMode, uint8_t  *rx, uint8_t qnt,uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id);
if(speed==0){speed=SPIgetSpeed(bus);}
spiBeginTransaction(speed,bitOrder,dataMode,bus);		
for(uint8_t i=0; i<qnt; i++){rx[i]=spiTransfer(0,bus); 
if(bitOrder){rx[i]=reverseV8(rx[i]);}} 
spiEndTransaction(bus);
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransferArr()=====================================================================

//=================================================================================================
//						6.ФУНКЦИИ ЗАПИСИ В РЕГИСТРЫ ТИПА 74HC595
//=================================================================================================
void     SPIhc595  (uint8_t bitOrder, uint8_t  tx, uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id); 
if(speed==0){speed=SPIgetSpeed(bus);}
delayMicroseconds(1);
spiBeginTransaction(speed,LSBFIRST,0,bus); 
if(bitOrder){tx=reverseV8(tx);} 
spiTransfer(tx,bus);
spiEndTransaction(bus); 
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransfer v8()======================================================================
void 	 SPIhc595x2(uint8_t bitOrder, uint16_t tx, uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id);
if(speed==0){speed=SPIgetSpeed(bus);}
delayMicroseconds(1);
spiBeginTransaction(speed,LSBFIRST,0,bus); 
if(bitOrder){tx=reverseV16(tx);}
spiTransfer((uint8_t)( tx     &0xFF),bus); 
spiTransfer((uint8_t)((tx>>8) &0xFF),bus); 
spiEndTransaction(bus);
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransfer16()======================================================================
void 	 SPIhc595x3(uint8_t bitOrder, uint32_t tx, uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id);
if(speed==0){speed=SPIgetSpeed(bus);}
delayMicroseconds(1);
spiBeginTransaction(speed,LSBFIRST,0,bus); 
if(bitOrder){tx=reverseV24(tx);}
spiTransfer((uint8_t)( tx     &0xFF),bus); 
spiTransfer((uint8_t)((tx>>8) &0xFF),bus);
spiTransfer((uint8_t)((tx>>16)&0xFF),bus); 
spiEndTransaction(bus);
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransfer16()======================================================================
void 	 SPIhc595x4(uint8_t bitOrder, uint32_t tx, uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id);
if(speed==0){speed=SPIgetSpeed(bus);}
delayMicroseconds(1);
spiBeginTransaction(speed,LSBFIRST,0,bus); 
if(bitOrder){tx=reverseV32(tx);}
spiTransfer((uint8_t)( tx     &0xFF),bus); 
spiTransfer((uint8_t)((tx>>8) &0xFF),bus);
spiTransfer((uint8_t)((tx>>16)&0xFF),bus); 
spiTransfer((uint8_t)((tx>>24)&0xFF),bus); 
spiEndTransaction(bus);
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransfer16()=====================================================================
void  	 SPIhc595xN(uint8_t bitOrder, uint8_t *tx, uint8_t qnt,uint8_t cs, uint8_t bus, uint32_t speed=0){
RT_HW_PIN_DIR_ID id; RT_HW_PIN_DIR_SET_ID(id,cs); RT_HW_PIN_DIR_WRITE_HIGH(id); RT_HW_PIN_DIR_MODE_OUTPUT(id); RT_HW_PIN_DIR_WRITE_LOW(id);
if(speed==0){speed=SPIgetSpeed(bus);}
delayMicroseconds(1);
spiBeginTransaction(speed,bitOrder,0,bus);		
for(uint8_t i=0; i<qnt; i++){if(bitOrder){tx[i]=reverseV8(tx[i]);} spiTransfer(tx[i],bus);} 
spiEndTransaction(bus);
RT_HW_PIN_DIR_WRITE_HIGH(id);
};	//++++END SPItransferArr()=====================================================================

//=================================================================================================
//   					3.Функции работы с захватом и освобождением шины               
//=================================================================================================
uint8_t spiCheckBusy (uint8_t bus){	
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {if(LinkSPI0.busy==10){return 1;} return 0;} 
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {if(LinkSPI1.busy==11){return 1;} return 0;} 
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {if(LinkSPI2.busy==12){return 1;} return 0;} 
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;};
uint8_t spiSetBusy   (uint8_t bus){	
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {if(LinkSPI0.busy==0) {LinkSPI0.busy=10;} if(LinkSPI0.busy!=10){return 0;}; return 1;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {if(!LinkSPI1.busy==0){LinkSPI1.busy=11;} if(LinkSPI1.busy!=11){return 0;}; return 1;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {if(!LinkSPI2.busy==0){LinkSPI2.busy=12;} if(LinkSPI2.busy!=12){return 0;}; return 1;}
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;};
void    spiClearBusy (uint8_t bus){	
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.busy=0; return;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.busy=0; return;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinSPI2.busy=0; return;}
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return;};

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						3.Функции для установки номеров пинов 
//		(для sck,miso,mosi по разрешению бита слова состояния RT_HW_SPI_STATE_BLOCK_PINS=0)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//void	spiSetPins(uint8_t pinSCK, uint8_t pinMISO, uint8_t pinMOSI,  uint8_t bus){ //++++Запись в вектор данных номеров пинов SCK,MISO,MOSI;
//if(RT_HW_SPI_BLOCK_USER_PINS==0){spiSetPinSCK(pinSCK,bus); spiSetPinMISO(pinMISO,bus); spiSetPinMOSI(pinMOSI,bus);}
//};	//++++END i2ccSetPins()=========================================================================
void 	spiSetPinSCK( uint8_t sck, uint8_t bus){		//--Запись номера пина SCK
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.sck=sck; return;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.sck=sck; return;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.sck=sck; return;}
#endif
buff.vu8=sck; //--Для предотвращения warning C++;
buff.bf8=bus; //--Для предотвращения warning C++;
};
void 	spiSetPinMISO(uint8_t miso, uint8_t bus){		//--Запись номера пина MISO
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.miso=miso; return;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.miso=miso; return;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.miso=miso; return;}
#endif
buff.vu8=miso; //--Для предотвращения warning C++;
buff.bf8=bus; //--Для предотвращения warning C++;
};
void 	spiSetPinMOSI(uint8_t mosi, uint8_t bus){		//--Запись номера пина mosi
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.mosi=mosi; return;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.mosi=mosi; return;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.mosi=mosi; return;}
#endif
buff.vu8=mosi; //--Для предотвращения warning C++;
buff.bf8=bus; //--Для предотвращения warning C++;
};
void 	spiSetPinSS  (uint8_t ss, uint8_t bus){			//--Запись номера пина ss
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.ss=ss; return;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.ss=ss; return;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.ss=ss; return;}
#endif
buff.vu8=ss; //--Для предотвращения warning C++;
buff.bf8=bus; //--Для предотвращения warning C++;
};
uint8_t spiGetPinSCK (uint8_t bus){						//--Чтение номера пина sck
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.sck;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.sck;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.sck;}
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;};
uint8_t spiGetPinMISO(uint8_t bus){						//--Чтение номера пина miso
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.miso;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.miso;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.miso;}
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;};
uint8_t spiGetPinMOSI(uint8_t bus){						//--Чтение номера пина mosi
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.mosi;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.mosi;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.mosi;}
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;};
uint8_t spiGetPinSS  (uint8_t bus){						//--Чтение номера пина ss
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.ss;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.ss;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.ss;}
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;};
	
//=================================================================================================
//						4.Функции записи параметров транзакций
//=================================================================================================
void 	 spiSetSpeed(uint32_t speed, uint8_t bus){	//++++Запись speed-----------------------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.speed=speed; return;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.speed=speed; return;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.speed=speed; return;}
#endif
buff.vu32=speed; //--Для предотвращения warning C++;
buff.bf8=bus; //--Для предотвращения warning C++;
};	//++++END spiSetSpeed()------------------------------------------------------------------------
uint32_t spiGetSpeed(uint8_t bus){					//++++Чтение speed-----------------------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.speed;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.speed;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.speed;}
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return 4000000UL;
};	//++++END spiGetSpeed()------------------------------------------------------------------------
void 	 spiSetBuff (uint16_t var, uint8_t bus){	//++++Запись в буфер---------------------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.buff=var; return;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.buff=var; return;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.buff=var; return;}
#endif
buff.vu16=var; //--Для предотвращения warning C++;
buff.bf8=bus; //--Для предотвращения warning C++;
};	//++++END spiSetBuff()-------------------------------------------------------------------------
uint16_t spiGetBuff (uint8_t bus){					//++++Чтение из буфера-------------------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.buff;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.buff;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return inkSPI2.buff;}
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;
};	//++++END spiGetBuff()-------------------------------------------------------------------------
//=================================================================================================
//							
//=================================================================================================
void 	 spiBeginTransaction(uint32_t speed, uint8_t bitOrder, uint8_t dataMode, uint8_t bus=0);//++++Begin транзакции с параметрами speed,bitOrder,dataMode;
void 	 spiBeginTransaction(uint32_t speed, uint8_t bus=0);									//++++Begin транзакции с параметрами speed,  [bitOrder=MSBFIRST,dataMode=MODE0]
void     spiBeginTransaction(uint8_t bus=0);													//++++Begin транзакции [speed=default,bitOrder=MSBFIRST,dataMode=MODE0]
void 	 spiEndTransaction  (uint8_t bus=0);													//++++End   транзакции;	
//=================================================================================================
//							
//=================================================================================================					

	
/*
void     spiWriteCS   (uint8_t val,              uint8_t cs, uint8_t bus=0){	//--Запись байта с управлением с cs
//spiBeginTransaction(bus); 
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); RT_HW_PIN_DIR_MODE_OUTPUT(idPinCS);
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); spiWrite(val,bus); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); 
//spiEndTransaction(bus);
}
void     spiWriteArrCS(uint8_t *tx, uint8_t qnt, uint8_t cs, uint8_t bus=0){ //--Запись массива из qnt байт с cs
spiBeginTransaction(bus); 
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); RT_HW_PIN_DIR_MODE_OUTPUT(idPinCS);
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); 
for(uint8_t i=0; i<qnt; i++){spiWrite(tx[i],bus);}
RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); 
spiEndTransaction(bus);}
uint8_t  spiReadCS    (                          uint8_t cs, uint8_t bus=0){	//--Чтение байта с управлением транзакциями и cs
spiBeginTransaction(bus); 
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); RT_HW_PIN_DIR_MODE_OUTPUT(idPinCS);
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); uint8_t v=spiRead(bus); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); 
spiEndTransaction(bus); 
return v;}
void     spiReadArrCS (uint8_t *rx, uint8_t qnt, uint8_t cs, uint8_t bus=0){	//--Чтение qnt байт с управлением транзакциями и cs
spiBeginTransaction(bus); 
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); RT_HW_PIN_DIR_MODE_OUTPUT(idPinCS);
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); 
for(uint8_t i=0; i<qnt; i++){rx[i]=spiRead(bus);}
RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); 
spiEndTransaction(bus);}
uint8_t  spiTransferCS(uint8_t val,              uint8_t cs, uint8_t bus=0){	//--Запись/чтение с управлением транзакциями и cs
spiBeginTransaction(bus); 
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs);       RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); RT_HW_PIN_DIR_MODE_OUTPUT(idPinCS);
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); uint8_t v=spiTransfer(val,bus); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); 
spiEndTransaction(bus); 
return v;}
void     spiReadArrCS (uint8_t *rx, uint8_t *tx, uint8_t qnt, uint8_t cs,  uint8_t bus=0){ //--Чтение qnt байт в массив с управлением транзакциями и cs
spiBeginTransaction(bus); 
RT_HW_PIN_DIR_ID idPinCS; RT_HW_PIN_DIR_SET_ID(idPinCS,cs); RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); RT_HW_PIN_DIR_MODE_OUTPUT(idPinCS);
RT_HW_PIN_DIR_WRITE_LOW(idPinCS); 
for(uint8_t i=0; i<qnt; i++){rx[i]=spiTransfer(tx[i],bus);}
RT_HW_PIN_DIR_WRITE_HIGH(idPinCS); 
spiEndTransaction(bus);}
*/


//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						2.Функции проверки номера шины, управления регистром состояния
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t	 spiCheckBus(uint8_t bus){							//++++Проверка номера шины-------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return 1;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return 1;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return 1;}
#endif	
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;};
void     spiSetStatus(uint8_t var,uint8_t bus){				//++++Запись статуса-------------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.status=var; return;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.status=var; return;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.status=var; return;}
#endif
buff.vu8=var; //--Для предотвращения warning C++;
buff.bf8=bus; //--Для предотвращения warning C++;
}
void     spiSetCodeErr(uint8_t var,uint8_t bus){			//++++Запись кода ошибки---------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {LinkSPI0.codeErr=var; return;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {LinkSPI1.codeErr=var; return;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {LinkSPI2.codeErr=var; return;}
#endif
buff.vu8=var; //--Для предотвращения warning C++;
buff.bf8=bus; //--Для предотвращения warning C++;
} 
uint8_t  spiGetStatus(uint8_t bus){							//++++Чтение статуса-------------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.status;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.status;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.status;}
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;};
uint8_t  spiGetCodeErr(uint8_t bus){						//++++Чтение кода ошибки---------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return LinkSPI0.codeErr;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return LinkSPI1.codeErr;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return LinkSPI2.codeErr;}
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;};

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						5.Функции обмена
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t	  spiTransfer   (uint8_t  val, 							 uint8_t bus);	//++++Отправка/прием байта;
uint16_t  spiTransfer16 (uint16_t val, 							 uint8_t bus);	//++++Отправка/прием слова;
void      spiTransferArr(uint8_t  *tx, uint8_t *rx, uint8_t qnt, uint8_t bus);	//++++Обмен qnt байтами;
void      spiWrite      (uint8_t  val, 							 uint8_t bus); 	//++++Отправка байта;
void      spiWrite16    (uint16_t val, 							 uint8_t bus); 	//++++Отправка слова;
void      spiWriteArr   (uint8_t  *tx, 				uint8_t qnt, uint8_t bus);	//++++Отправка qnt байт;
uint8_t   spiRead       (uint8_t  bus);											//++++Прием байта;
uint16_t  spiRead16     (uint8_t  bus);											//++++Прием слова;
void      spiReadArr    (uint8_t *rx, uint8_t qnt,             uint8_t bus=0);	//+++Чтение в массив qnt байт;
//=================================================================================================
//							10.1. Инициализация шины SPI как Master
//=================================================================================================
uint8_t   spiBeginMaster(uint8_t &codeErr, uint8_t bus);
//=================================================================================================
//							10.2. Инициализация шины SPI как Slave
//=================================================================================================
uint8_t   spiBeginSlave(uint8_t &codeErr, uint8_t bus=0);	//--Инициализация шины SPI как Slave;

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
