//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						             RT_HW_BASE.h
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#ifndef   RT_HW_BASE_h
#define   RT_HW_BASE_h
//=================================================================================================
#define   RT_HW_BASE_VER 		 111								//--Library version number [digital];
#define   RT_HW_BASE_VER_NAME 	"1.1.1e 29.03.2023"					//--Library version number [text];
//=================================================================================================
//				1., ,  PROGMEM [Macros,enum, arrays in PROGMEM]
//=================================================================================================
#include "BASE_001_Common define/COM_101_define.hpp"			//--Common macros;
#include "BASE_001_Common define/COM_102_enum.hpp"				//--Common enum;
#include "BASE_001_Common define/COM_103_array_PROGMEM.hpp"		//--Common arrays in PROGMEM;
//=================================================================================================
//				2.   [Data structures used]
//=================================================================================================
#include "BASE_002_Struct data/Struct_201_System.hpp"			//--System structures;
#include "BASE_002_Struct data/Struct_202_Sheduler.hpp"			//--Task manager structures;
#include "BASE_002_Struct data/Struct_203_Mess.hpp"				//--Console structures;
#include "BASE_002_Struct data/Struct_205_Generator.hpp"		//--Generator structures;
#include "BASE_002_Struct data/Struct_210_Pins.hpp"				//--Pins structures;
//=================================================================================================
//				3.   [Board selections macros]
//		[AVR,SAM,ESP8266,ESP32,ESP32x,STM32_M_F1,STM32_M_F4,STM32_D, SEEED]
//=================================================================================================
#include "BASE_003_Select/Select_301_Board_AVR.hpp"				//--Select a board AVR;
#include "BASE_003_Select/Select_302_Board_SAM.hpp"				//--Select a board SAM;
#include "BASE_003_Select/Select_303_Board_SAMD21.hpp"			//--Select a board SAMD21;
#include "BASE_003_Select/Select_304_Board_ESP8266.hpp"			//--Select a board ESP8266;
#include "BASE_003_Select/Select_305_Board_ESP32_M5.hpp"		//--Select a board ESP32_M5Stack;
#include "BASE_003_Select/Select_305_Board_ESP32_PICO.hpp"		//--Select a board ESP32 PICO;
#include "BASE_003_Select/Select_305_Board_ESP32C3.hpp"			//--Select a board ESP32C3;
#include "BASE_003_Select/Select_305_Board_ESP32S.hpp"			//--Select a board ESP32S;
#include "BASE_003_Select/Select_305_Board_ESP32S2.hpp"			//--Select a board ESP32S2;
#include "BASE_003_Select/Select_305_Board_ESP32S3.hpp"			//--Select a board ESP32S3;
#include "BASE_003_Select/Select_306_Board_RP_PICO.hpp"			//--Select a board Raspberry Pi Pico;
#include "BASE_003_Select/Select_310_Board_STM32F1.hpp"			//--Select a board STM32F1;
#include "BASE_003_Select/Select_311_Board_STM32F4.hpp"			//--Select a board STM32F4;
#include "BASE_003_Select/Select_312_Board_STM32H7.hpp"			//--Select a board STM32H7;
#include "BASE_003_Select/Select_390_Board_ANON.hpp"			//--Select a board for the ore ANON;
//=================================================================================================
//				4.  [descriptions Core] 
//		[AVR,SAM,ESP8266,ESP32,ESP32x,STM32_M_F1,STM32_M_F4,STM32_D, SEEED, ANON]
//=================================================================================================
#include "BASE_004_Core/CORE_401_AVR.hpp"						//--CORE AVR;
#include "BASE_004_Core/CORE_402_SAM.hpp"						//--CORE SAM;
#include "BASE_004_Core/CORE_403_SAMD21.hpp"					//--CORE Seeed(SAMD21);
#include "BASE_004_Core/CORE_404_ESP8266.hpp"					//--CORE ESP8266;
#include "BASE_004_Core/CORE_405_ESP32.hpp"						//--CORE ESP32;
#include "BASE_004_Core/CORE_406_RP_PICO.hpp"					//--CORE Raspberry Pi Pico;
#include "BASE_004_Core/CORE_410_STM32F1_M.hpp"					//--CORE STM32_M_F1;
#include "BASE_004_Core/CORE_411_STM32F4_M.hpp"					//--CORE STM32_M_F4;
#include "BASE_004_Core/CORE_412_STM32_D.hpp"					//--CORE STM32_D;
#include "BASE_004_Core/CORE_490_ANON.hpp"						//--CORE ANON;
#include "BASE_004_Core/CORE_491_ADD_DEFINE.hpp"				//--CORE Add define;
//=================================================================================================
//				5.    [descriptions Board]
//		[AVR,SAM,ESP8266,ESP32,ESP32x,STM32_M_F1,STM32_M_F4,STM32_D, SEEED, ANON]
//=========================================================	========================================
#include  "BASE_005_Board/Board_501_AVR.hpp"	    			//--Board AVR;
#include  "BASE_005_Board/Board_502_SAM.hpp"					//--Board SAM;
#include  "BASE_005_Board/Board_503_SAMD21.hpp"					//--Board Seeeduino;
#include  "BASE_005_Board/Board_504_ESP8266.hpp"				//--Board ESP8266;
#include  "BASE_005_Board/Board_505_ESP32_M5.hpp"				//--Board_M5Stack;
#include  "BASE_005_Board/Board_505_ESP32_PICO.hpp"				//--Board ESP32-STAMP-PICO;
#include  "BASE_005_Board/Board_505_ESP32C3.hpp"				//--Board ESP32_C3;
#include  "BASE_005_Board/Board_505_ESP32S.hpp"					//--Board ESP32;
#include  "BASE_005_Board/Board_505_ESP32S2.hpp"				//--Board ESP32S2;
//#include  "BASE_005_Board/Board_505_ESP32S3.hpp"				//--Board ESP32S3;
//#include  "BASE_005_Board/Board_505_ESP32_ANON.hpp"			//--Board ESP32_ANON;
#include  "BASE_005_Board/Board_506_RP_PICO.hpp"				//--Board Raspberry Pi Pico;
#include  "BASE_005_Board/Board_510_STM32F103X.hpp"			    //--Board STM32F103X;
#include  "BASE_005_Board/Board_511_STM32F4x1X.hpp"		        //--Board STM32F4x1X;
#include  "BASE_005_Board/Board_512_STM32F4x7X.hpp"			    //--Board STM32F4x7X;
#include  "BASE_005_Board/Board_513_STM32H743X.hpp"			    //--Board STM32F743X;
#include  "BASE_005_Board/Board_590_ANON.hpp"					//--Board ANON (always last  of the list);
//=================================================================================================
//				6.   core STM32master[Defined pins for core STM32master]
//=================================================================================================
#include "BASE_021_API Pins/API_005_DefinedPinsSTM32M.hpp"			//--For STM32master defined pins;
//=================================================================================================
//						7.  (  Core  Board)
//=================================================================================================
#include "BASE_002_Struct data/Struct_220_Link.hpp"			//--Extender structures;
//=================================================================================================
//						8.  
//=================================================================================================
#include "RT_HW_ONEWIRE.h"	//--   1-Wire (      RT_HW_BASE.h)
//=================================================================================================
//									 RT_HW_BASE.h
//=================================================================================================
class RT_HW_BASE{
public:
//-------------------------------------------------------------------------------------------------
String debugStr="*";
RT_HW_STRUCT_INDEX		idx;								//-- ;
RT_HW_STRUCT_BUFF		buff;								//-- ;
RT_HW_STRUCT_SHED		shed;								//-- ;
RT_HW_STRUCT_DEVICE 	device;								//--  ;
RT_HW_STRUCT_CONSOLE	console;							//-- ;
RT_HW_STRUCT_MESS		mess;								//--   ;
//-------------------------------------API ---------------------------------------------------
#include "BASE_020_API System/API_010_FuncMain.hpp"			//--API   ;
#include "BASE_020_API System/API_011_FuncArrayPGM.hpp"		//--API       PROGMEM;
#include "BASE_020_API System/API_012_FuncString.hpp"		//--API     ;
#include "BASE_020_API System/API_013_FuncVarToMess.hpp"	//--API      ;
#include "BASE_020_API System/API_014_FuncCounter.hpp"		//--API  ,;
#include "BASE_020_API System/API_015_FuncGenerator.hpp"	//--API  ;
#include "BASE_020_API System/API_020_FuncOther.hpp"		//--API  ;
//-------------------------------------API   -----------------------------------------
#include "BASE_021_API Pins/API_010_FuncPinSTM32.hpp"		//--API        STM32;
#include "BASE_021_API Pins/API_020_PinsFunc.hpp"			//--API   ;
//-------------------------------------API   ,----------------------------
#include "BASE_030_API Timer/API_030_TimeFunc.hpp"			//--API TtimeFunc;
#include "BASE_030_API Timer/API_031_Sheduler.hpp"			//--API Sheduler;
#include "BASE_030_API Timer/API_032_DirectTask.hpp"		//--API_DirectTask;
//-------------------------------------API   ---------------------------------------
#include "BASE_050_API Console/API_051_ConsoleFunc.hpp"		//--API Console base function; 
#include "BASE_050_API Console/API_052_ConsoleHead.hpp"		//--API Console output head;
#include "BASE_050_API Console/API_053_ConsoleLink.hpp"		//--API Console output head;
//-------------------------------------API --------------------------------------------
#include "BASE_100_API Link/API_101_UART.hpp"				//--API UART;
#include "BASE_100_API Link/API_102_I2C.hpp"				//--API i2c;
#include "BASE_100_API Link/API_103_SPI.hpp"				//--API SPI;
#include "BASE_100_API Link/API_104_SPN.hpp"				//--API SPN;
//-------------------------------------------------------------------------------------------------
RT_HW_BASE();												//--;
private:
};  //---END CLASS RT_HW_BASE.h====================================================================
extern RT_HW_BASE 				RT_HW_Base; 				//--    RT_HW_Base;
//=================================================================================================

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						     RT_HW_FILTER.h
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#include "BASE_300_API Filters/API_010_FilterMedian3.hpp"		//--API  median 3- ;
#include "BASE_300_API Filters/API_011_FilterMedian.hpp"		//--API  median N- ;
#include "BASE_300_API Filters/API_012_FilterRingAverage.hpp"	//--API      ;
#include "BASE_300_API Filters/API_013_FilterCritical.hpp"		//--API   ;
//-------------------------------------------------------------------------------------------------
#endif //---RT_HW_BASE_h===========================================================================
//-------------------------------------------------------------------------------------------------