                                                                           #include "RT_HW_BASE.h"
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//									КОНСТРУКТОР
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
RT_HW_BASE:: RT_HW_BASE(){
//=================================================================================================
//							1.Настройка общих параметров
//=================================================================================================
device.board.codeArch= RT_HW_ARCH_CODE;		//--Код архитектуры контроллера;
device.board.codeBoard=RT_HW_BOARD_CODE;	//--Код контроллера;
//=================================================================================================
//							2.Настройка диспетчера задач
//=================================================================================================
shed.quick.qnt=5; 							//--Кол-во срочных   задач (период  10мс);
shed.fast.qnt=4;							//--Кол-во быстрых   задач (период  25мс);
shed.slow.qnt=4; 							//--Кол-во медленных задач (период 250мс);
shed.back.qnt=5;   							//--Кол-во фоновых   задач (период 100мс);
shed.frdm.qnt=50; 							//--Кол-во свободных задач (период loop()-когда нет вызванных задач);
//=================================================================================================
//							3.Настройка устройств ввода/вывода
//=================================================================================================
//-------------------------------------------------------------------------------------------------
//			3.1.Настройка рабочих регистров
//-------------------------------------------------------------------------------------------------
device.depth.sys	 = readArrPGM(RT_HW_PGM_SYS_PAR_ID, 0);	//--Cистемное разрешение (8,10,12,16); 
device.depth.adc	 = readArrPGM(RT_HW_PGM_SYS_ADC_ID, 0); //--Разрешение ADC;
device.depth.adcDrift= readArrPGM(RT_HW_PGM_SYS_ADC_ID,	1); //--Допустимый дрейф показаний ADC;
device.depth.adcNull = readArrPGM(RT_HW_PGM_SYS_ADC_ID, 2); //--Допустимый дрейф нуля ADC;
device.depth.tch	 = readArrPGM(RT_HW_PGM_SYS_TCH_ID, 0);	//--Разрешение TCH (ESP32);
device.depth.pwm	 = readArrPGM(RT_HW_PGM_SYS_PWM_ID, 0);	//--Разрешение PWM; 
device.depth.dac	 = readArrPGM(RT_HW_PGM_SYS_DAC_ID, 0); //--Разрешение DAC;	
//-------------------------------------------------------------------------------------------------
//			3.2.Настройка рабочих регистров для работы с пинами
//control,led,button,wsBus,adc,btn,tch,pwm,dac,servo,debug1,debug2,debug3;
//-------------------------------------------------------------------------------------------------
//--PIN_BRD->control,LedBLT,ButtonBLT,WS2812---------------
device.pin.control	= readArrPGM(RT_HW_PGM_PIN_BRD_ID,  0);	//--Пин контрольного светодиода; 
device.pin.led	 	= readArrPGM(RT_HW_PGM_PIN_BRD_ID,  1);	//--Пин светодиода на плате;
device.pin.button	= readArrPGM(RT_HW_PGM_PIN_BRD_ID,  2); //--Пин кнопки на плате; 	 
device.pin.wsBus	= readArrPGM(RT_HW_PGM_PIN_BRD_ID,  3); //--Пин для шины адресных светодиодов типа WS2812; 
//--PIN_DBG->debug1,debug2,debug3--------------------------
device.pin.debug1	= readArrPGM(RT_HW_PGM_PIN_DBG_ID,  0); //--Пин для отладки 1;
device.pin.debug2	= readArrPGM(RT_HW_PGM_PIN_DBG_ID,  1); //--Пин для отладки 2;
device.pin.debug3	= readArrPGM(RT_HW_PGM_PIN_DBG_ID,  2); //--Пин для отладки 3;
//--PIN_OUT->PWM0,PWM1,Servo1,Servo2-----------------------
device.pin.pwm	  	= readArrPGM(RT_HW_PGM_PIN_OUT_ID,  0); //--Пин тестовый PWM;
device.pin.servo	= readArrPGM(RT_HW_PGM_PIN_OUT_ID,  2); //--Пин тестовый Servo;
//--PIN_INP->ADC0,ADC1,btn1,btn2,TCH0,TCH1-----------------
device.pin.adc	   	= readArrPGM(RT_HW_PGM_PIN_INP_ID,  0); //--Пин тестовый ADC;
device.pin.btn	   	= readArrPGM(RT_HW_PGM_PIN_INP_ID,  2); //--Пин тестовый Button;
device.pin.tch	   	= readArrPGM(RT_HW_PGM_PIN_INP_ID,  4); //--Пин тестовый Touch;
//--PIN_DCT->DAC0,DAC1-------------------------------------
device.pin.dac	  	= readArrPGM(RT_HW_PGM_PIN_DCT_ID,  0); //--Пин тестовый DAC;
//--PIN_DEV->DS1820,DHT22,HC-SR04.trig---------------------
device.dev.oneWBus	= readArrPGM(RT_HW_PGM_PIN_DEV_ID,  0); //--Пин для шины 1-Wire(DS1820);
device.dev.dht22   	= readArrPGM(RT_HW_PGM_PIN_DEV_ID,  1); //--Пин для DHT22;
device.dev.srTrig 	= readArrPGM(RT_HW_PGM_PIN_DEV_ID,  2); //--Пин для HC-SR04.Trig;
//--PIN_CSS->cs0(74HC595),cs1(Lcd.SPI),cs2(NRF2401),cs3(DEVl)
device.spi.cs0   	= readArrPGM(RT_HW_PGM_PIN_CSS_ID,  0); //--Пин для шины SPI.cs0;
device.spi.cs1    	= readArrPGM(RT_HW_PGM_PIN_CSS_ID,  1); //--Пин для шины SPI.cs1;
device.spi.cs2    	= readArrPGM(RT_HW_PGM_PIN_CSS_ID,  2); //--Пин для шины SPI.cs2;
device.spi.cs3    	= readArrPGM(RT_HW_PGM_PIN_CSS_ID,  3); //--Пин для шины SPI.cs3;
//-------------------------------------------------------------------------------------------------
//  		3.2. Настройка длины поля при выводе пинов 
//-------------------------------------------------------------------------------------------------
mess.lenPin=2;
#if   defined(RT_HW_CORE_STM32)
mess.lenPin=4;
#endif
#if   defined(RT_HW_CORE_ESP8266)
mess.lenPin=3;
#endif	
//-------------------------------------------------------------------------------------------------
//			3.3.Настройка разрядности ADC
//-------------------------------------------------------------------------------------------------
            //RT_HW_PERMIT_SET_RESOLUTION_ADC	
#if defined(RT_HW_ADC_PERMIT_SET_RESOLUTION) 
	analogReadResolution(device.depth.adc); 
#endif 
//-------------------------------------------------------------------------------------------------
//			3.4.Настройка разрядности PWM
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PWM_PERMIT_SET_RESOLUTION)
	analogWriteResolution(device.depth.pwm); 
#endif  
//-------------------------------------------------------------------------------------------------
//			3.6.Настройка кол-во таймеров (используется в ESP32)
//-------------------------------------------------------------------------------------------------
//#if !defined(RT_HW_BLOCK_SET_RESOLUTION_PWM)
//analogWriteResolution(device.depth.pwm); 
//#endif  

//-------------------------------------------------------------------------------------------------
//			3.5.Разрешение использование выводов JTDI,JTDO,JRST(PA15,PB3,PB4) для STM32F1-103C
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_JTAG_PERMIT_ENABLE_PIN)	
	afio_cfg_debug_ports(AFIO_DEBUG_SW_ONLY);	
#endif
//-------------------------------------------------------------------------------------------------
//			3.6.M5Stack-Core-ESP32:: Настройка DAC чтобы избежать звуков зуммера при включении
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_BOARD_M5Stack_Core_ESP32) 
dacWrite(25,0);		//--Чтобы избежать звуков зуммера при включении;
#endif 
 //=================================================================================================
//								4.Настройка UART,i2c,SPI
//=================================================================================================
for(uint8_t i=0; i<10; i++){uartInitParam(i);} 
for(uint8_t i=0; i< 3; i++){i2cInitParam(i);} 
for(uint8_t i=0; i< 3; i++){SPIinitParam(i);} 
//=================================================================================================
};	//--End RT_HW_BASE()	

//=================================================================================================
//							 СОЗДАНИЕ ВНЕШНИХ ОБЪЕКТОВ
//=================================================================================================
RT_HW_BASE RT_HW_Base;									//==Создание внешнего объекта	RT_HW_Base;
//-------------------------------------------------------------------------------------------------	