#include "RT_HW_BASE.h"
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//							2.СОЗДАНИЕ ДОПОЛНИТЕЛЬНЫХ ОБЪЕКТОВ I2C ПОД ТИП MCU
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_PERMIT_I2C0) 
#define RT_HW_CREATED_WIRE0
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C1)  && defined(RT_HW_CORE_ESP8266)		//--1.1.2.Объект для i2c1 & CORE ESP8266 	
#if !defined(NO_GLOBAL_INSTANCES) && !defined(NO_GLOBAL_TWOWIRE)
#define RT_HW_CREATED_WIRE1
TwoWire rtWire1;
#endif
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C1)  && defined(RT_HW_CORE_ESP32) 		//--1.1.3.Объект для i2c1 & CORE ESP32	
#define RT_HW_CREATED_WIRE1
TwoWire rtWire1(1);
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C1)  && defined(RT_HW_CORE_STM32_M)		//--1.1.4.Объект для i2c1 & CORE STM32-M 	
#define RT_HW_CREATED_WIRE1
TwoWire rtWire1(2,I2C_FAST_MODE);
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C1)  && defined(RT_HW_CORE_STM32_D)		//--1.1.5.Объект для i2c1 & CORE STM32-D
#define RT_HW_CREATED_WIRE1
TwoWire rtWire1(RT_HW_I2C1_SDA, RT_HW_I2C1_SCL);
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C2)  && defined(RT_HW_CORE_STM32_M)		//--1.2.2.Объект для i2c2 & CORE STM32-M  	
#define RT_HW_CREATED_WIRE2
TwoWire rtWire2(3,I2C_FAST_MODE);
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2C2)  && defined(RT_HW_CORE_STM32_D)		//--1.2.3.Объект для i2c2 & CORE STM32-D 
#define RT_HW_CREATED_WIRE2
TwoWire rtWire2(RT_HW_I2C2_SDA, RT_HW_I2C2_SCL);
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2CS)  && defined(RT_HW_CORE_STM32_M)		//--1.8.2.Объект для i2cS & CORE STM32-M 
#define RT_HW_CREATED_WIRES
SoftWire rtWireS(RT_HW_I2CS_SCL, RT_HW_I2CS_SDA, SOFT_FAST);		//--Объект WireS;
#endif
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_I2CS1) && defined(RT_HW_CORE_STM32_M)		//--1.9.2.Объект для i2cS1& CORE STM32-M 
#define RT_HW_CREATED_WIRES1
SoftWire rtWireS1(RT_HW_I2CS1_SCL, RT_HW_I2CS1_SDA, SOFT_FAST);	//--Объект WireS1;
#endif
//=================================================================================================
//						 Установка скорости шины i2c;
//=================================================================================================
void     RT_HW_BASE:: i2cSetClock (uint32_t speed,uint8_t bus){	//++++Установка скорости(аппаратная)-----------
if(speed==0){speed=RT_HW_I2C_SPEED;}
#if defined(RT_HW_CREATED_WIRE0) 
if(bus==0){Wire.setClock(speed); return;}
#endif	
#if defined(RT_HW_CREATED_WIRE1)
if(bus==1){rtWire1.setClock(speed); return;};
#endif
#if defined(RT_HW_CREATED_WIRE2)
if(bus==2){rtWire2.setClock(speed); return;}
#endif	
//-------------------------------------
#if defined(RT_HW_CREATED_WIRES)
if(bus==0){if(speed<= 10000){rtWireS.i2c_delay=100; return;}
		   if(speed<= 50000){rtWireS.i2c_delay=40;  return;}
		   if(speed<=100000){rtWireS.i2c_delay=19;  return;}
		   if(speed<=200000){rtWireS.i2c_delay=10;  return;}		   
		                     rtWireS.i2c_delay=0;   return;}
#endif	
#if defined(RT_HW_CREATED_WIRES1)
if(bus==1){if(speed<= 10000){rtWireS1.i2c_delay=100; return;}
		   if(speed<= 50000){rtWireS1.i2c_delay=40;  return;}
		   if(speed<=100000){rtWireS1.i2c_delay=19;  return;}
		   if(speed<=200000){rtWireS1.i2c_delay=10;  return;}		   
		                     rtWireS1.i2c_delay=0;   return;}
#endif	
buff.vu8=bus;
buff.vu32=speed;
};
//=================================================================================================
//									Функции обмена
// Коды codeErr: 0-ok,1-слишком много данных; 2-Nack на передачу адреса; 3-Nack на передачу данных; 4-другая ошибка i2c; 
// 5-недопустимый контроллер; 6-недопустимая шина; 7-не допустимый адрес(>=254),8-шина не настроена как master,8 другие причины; 
//=================================================================================================
void     RT_HW_BASE:: i2cBeginTransmission(uint8_t adr, uint8_t bus){ //++++Начало аппаратной транзакции--------
if(i2cGetStatus(bus)!=1) 				{return;};	//--Выход, если шина не Master;
#if defined(RT_HW_CREATED_WIRE0)
if(bus==0){Wire.beginTransmission(adr);  return;};
#endif	
#if defined(RT_HW_CREATED_WIRE1)
if(bus==1){rtWire1.beginTransmission(adr); return;};
#endif	
#if defined(RT_HW_CREATED_WIRE2)
if(bus==2){rtWire2.beginTransmission(adr); return;};
#endif	
//-------------------------------------
#if defined(RT_HW_CREATED_WIRES)
if(bus==0){rtWireS.beginTransmission(adr); return;};
#endif
#if defined(RT_HW_CREATED_WIRES1)
if(bus==1){rtWireS1.beginTransmission(adr); return;};
#endif		
buff.vu8=adr; //--Для предотвращения warning C++;
buff.bf8=bus; //--Для предотвращения warning C++;
};
uint8_t  RT_HW_BASE:: i2cEndTransmission (  uint8_t bus){		//++++Завершение аппаратной транзакции---------
if(i2cGetStatus(bus)!=1) 				{return 5;};	//--Выход, если шина не Master;
#if defined(RT_HW_CREATED_WIRE0)
if(bus==0){return Wire.endTransmission();};
#endif	
#if defined(RT_HW_CREATED_WIRE1)
if(bus==1){return rtWire1.endTransmission();};
#endif	
#if defined(RT_HW_CREATED_WIRE2)
if(bus==2){return rtWire2.endTransmission();};
#endif
//-------------------------------------
#if defined(RT_HW_CREATED_WIRES)
if(bus==0){return rtWireS.endTransmission();};
#endif
#if defined(RT_HW_CREATED_WIRES1)
if(bus==1){return rtWireS1.endTransmission();};
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return 6;}
uint8_t  RT_HW_BASE:: i2cFlush    (         uint8_t bus){		//++++Flush()----------------------------------
#if !defined(RT_HW_I2C_BLOCK_FLUSH)
#if defined(RT_HW_CREATED_WIRE0)
if(bus==0){Wire.flush(); return 1;}
#endif	
#if defined(RT_HW_CREATED_WIRE1)
if(bus==1){rtWire1.flush(); return 1;}
#endif	
#if defined(RT_HW_CREATED_WIRE2)
if(bus==2){rtWire2.flush(); return 1;}
#endif	
//-------------------------------------
#if defined(RT_HW_CREATED_WIRES)
if(bus==0){rtWireS.flush(); return 1;}
#endif
#if defined(RT_HW_CREATED_WIRES1)
if(bus==1){rtWireS1.flush(); return 1;}
#endif	
//-------------------------------------
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;
};
uint8_t  RT_HW_BASE:: i2cAvailable(         uint8_t bus){		//++++Проверка кол-ва принятых байт в буфере i2c
#if defined(RT_HW_CREATED_WIRE0)
if(bus==0){return Wire.available();};
#endif	
#if defined(RT_HW_CREATED_WIRE1)
if(bus==1){return rtWire1.available();};
#endif	
#if defined(RT_HW_CREATED_WIRE2)
if(bus==2){return rtWire2.available();};
#endif
#if defined(RT_HW_CREATED_WIRES)
if(bus==0){return rtWireS.available();};
#endif
#if defined(RT_HW_CREATED_WIRES1)
if(bus==1){return rtWireS1.available();};
#endif			
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;}
uint8_t  RT_HW_BASE:: i2cRead (             uint8_t bus){		//++++Чтение байта из буфера i2c---------------
#if defined(RT_HW_CREATED_WIRE0)
if(bus==0){return Wire.read();};
#endif	
#if defined(RT_HW_CREATED_WIRE1)
if(bus==1){return rtWire1.read();};
#endif	
#if defined(RT_HW_PERMIT_I2C2)
if(bus==2){return rtWire2.read();};
#endif
//-------------------------------------
#if defined(RT_HW_CREATED_WIRES)
if(bus==0){return rtWireS.read();};
#endif
#if defined(RT_HW_CREATED_WIRES1)
if(bus==1){return rtWireS1.read();};
#endif				
buff.bf8=bus; //--Для предотвращения warning C++;
return 0;};
void     RT_HW_BASE:: i2cWrite(uint8_t var, uint8_t bus){		//++++Запись байта-----------------------------
#if defined(RT_HW_CREATED_WIRE0)
if(bus==0){Wire.write(var); return;};
#endif	
#if defined(RT_HW_CREATED_WIRE1)
if(bus==1){rtWire1.write(var); return;};
#endif	
#if defined(RT_HW_CREATED_WIRE2)
if(bus==2){rtWire2.write(var); return;};
#endif
//-------------------------------------
#if defined(RT_HW_CREATED_WIRES)
if(bus==0){rtWireS.write(var); return;};
#endif
#if defined(RT_HW_CREATED_WIRES1)
if(bus==1){rtWireS1.write(var); return;};
#endif		
buff.vu8=var; //--Для предотвращения warning C++;
buff.bf8=bus; //--Для предотвращения warning C++;
};
void     RT_HW_BASE:: i2cWrite(const uint8_t *arr, uint8_t qnt, uint8_t bus){	//++++Запись qnt байт----------	
 if(qnt>32){qnt=32;} for(uint8_t i=0; i<qnt; i++){i2cWrite(arr[i],bus);}};	
void     RT_HW_BASE:: i2cWrite(const char    *arr, uint8_t qnt, uint8_t bus){	//++++Запись qnt символов------
 if(qnt>32){qnt=32;} for(uint8_t i=0; i<qnt; i++){i2cWrite(arr[i],bus);}};	
uint8_t  RT_HW_BASE:: i2cRequestFrom(uint8_t qnt,  uint8_t adr, uint8_t bus, uint8_t sendStop){ //++++Чтение qnt байт в буфер i2c
buff.vu8=sendStop; //--Для исключения предупреждений от компилятора;
#if defined(RT_HW_CREATED_WIRE0)
if(bus==0){
#if defined(RT_HW_CORE_STM32_M_F4)
return Wire.requestFrom(adr,qnt);
#else
return Wire.requestFrom(adr,qnt,(uint8_t)sendStop);
#endif
};
#endif	
#if defined(RT_HW_CREATED_WIRE1)
if(bus==1){
#if defined(RT_HW_CORE_STM32_M_F4)
return rtWire1.requestFrom(adr,qnt);
#else
return rtWire1.requestFrom(adr,qnt,(uint8_t)sendStop);
#endif
};
#endif	
#if defined(RT_HW_CREATED_WIRE2)
if(bus==2){
#if defined(RT_HW_CORE_STM32_M_F4)
return rtWire2.requestFrom(adr,qnt);
#else
return rtWire2.requestFrom(adr,qnt,(uint8_t)sendStop);
#endif
};
#endif	
//-------------------------------------
#if defined(RT_HW_PERMIT_I2CS)
if(bus==0){
#if defined(RT_HW_CORE_STM32_M_F4)
return rtWireS.requestFrom(adr,qnt);
#else
return rtWireS.requestFrom(adr,qnt,(uint8_t)sendStop);
#endif
};
#endif
#if defined(RT_HW_PERMIT_I2CS1)
if(bus==1){
#if defined(RT_HW_CORE_STM32_M_F4)
return rtWireS1.requestFrom(adr,qnt);
#else
return rtWireS1.requestFrom(adr,qnt,(uint8_t)sendStop);
#endif
};
#endif		
//-------------------------------------
buff.vu16=bus; //--Для предотвращения warning C++;
buff.bf8=qnt; //--Для предотвращения warning C++;
buff.vi8=adr; //--Для предотвращения warning C++;
return 0;}
//=================================================================================================
//						        НАСТРОЙКА ШИНЫ i2c.Master
//=================================================================================================
uint8_t  RT_HW_BASE:: i2cBeginMaster(uint8_t &codeErr, uint8_t bus){
//-------------------------------------------------------------------------------------------------
codeErr=0;											//--Очистка кода ошибки;
if(i2cCheckBus(bus)==0)	{codeErr=65; return 1;}	//--Выход, если недопустиый номер шины;
if(i2cGetStatus(bus)==1){            return 1;} //--Выход, если шина уже Master;
if(i2cSetBusy(bus)==0)	{            return 0;}	//--Захват шины или выход если шина занята;
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_CREATED_WIRE0)
if(bus==0){									
#if defined(RT_HW_CORE_AVR) || defined(RT_HW_CORE_SAM) || defined(RT_HW_CORE_SAMD) || defined(RT_HW_CORE_STM32_M)
Wire.begin();							//--Инициализация как Master;
Wire.setClock(i2cGetSpeed(bus));;		//--Установка частоты шины;
i2cSetStatus(1,bus); 					//--Установка статуса Master и успешный выход;
i2cClearBusy(bus); return 1;	//++++Освобождение шины и выход------------------------------------
#endif
#if defined(RT_HW_CORE_ESP8266)
Wire.begin(i2cGetPinSDA(bus),i2cGetPinSCL(bus));//--Установка номеров пинов SDA,SCL и инициализация как Master;
Wire.setClock(i2cGetSpeed(bus));;		//--Установка частоты шины;	
Wire.setClockStretchLimit(260);			//--Ограничение лимита по времени;
i2cSetStatus(1,bus);					//--Установка статуса Master и успешный выход;
i2cClearBusy(bus); return 1;	//++++Освобождение шины и выход------------------------------------
#endif	
#if defined(RT_HW_CORE_ESP32)			 													
Wire.setPins(i2cGetPinSDA(bus),i2cGetPinSCL(bus));//--Настройка пинов SDA,SCL;
Wire.begin();							//--Инициализация как Master;
Wire.setClock(i2cGetSpeed(bus));;		//--Установка частоты шины;		
Wire.setTimeOut(50); 					//--По умолчанию  тайм-аут на транзакцию =50ms;	
i2cSetStatus(1,bus);					//--Установка статуса Master и успешный выход;
i2cClearBusy(bus); return 1;	//++++Освобождение шины и выход------------------------------------
#endif		//-------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_STM32_D) || defined(RT_HW_CORE_RP_PICO) || defined(RT_HW_CORE_SEEED) 
//consoleTest(String(F("init i2c")),(String)RT_HW_BOARD_SELECT);
Wire.setSDA(i2cGetPinSDA(bus));			//--Установка номера пина SDA;	
Wire.setSCL(i2cGetPinSCL(bus));			//--Установка номера пина SCL;		
Wire.begin();							//--Инициализация как Master;
Wire.setClock(i2cGetSpeed(bus));;		//--Установка частоты шины;	
i2cSetStatus(1,bus);					//--Установка статуса Master и успешный выход;
i2cClearBusy(bus); return 1;	//++++Освобождение шины и выход------------------------------------
#endif
#if defined(RT_HW_CORE_ANON)
Wire.begin();							//--Инициализация как Master;
i2cSetStatus(1,bus);					//--Установка статуса Master и успешный выход;
i2cClearBusy(bus); return 1;	//++++Освобождение шины и выход------------------------------------
#endif
i2cSetStatus(5,bus); codeErr=5; 		//--Выход с установкой неопределенного статуса;
i2cClearBusy(bus); return 1;}	//++++Освобождение шины и выход------------------------------------
#endif	//--END #if defined(RT_HW_CREATED_WIRE0)
//=================================================================================================
#if defined(RT_HW_CREATED_WIRE1)
if(bus==1){									
#if defined(RT_HW_CORE_SAM) || defined(RT_HW_CORE_STM32_M)
rtWire1.begin();							//--Инициализация как Master;
rtWire1.setClock(i2cGetSpeed(bus));;		//--Установка частоты шины;	
i2cSetStatus(1,bus);					//--Установка статуса Master и успешный выход;
i2cClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_ESP32)			 													
rtWire1.setPins(i2cGetPinSDA(bus),i2cGetPinSCL(bus));//--Настройка пинов SDA,SCL;
rtWire1.begin();							//--Инициализация как Master;
rtWire1.setClock(i2cGetSpeed(bus));;		//--Установка частоты шины;			
rtWire1.setTimeOut(50); 					//--По умолчанию  тайм-аут на транзакцию =50ms;	
i2cSetStatus(1,bus);					//--Установка статуса Master и успешный выход;
i2cClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_STM32_D) || defined(RT_HW_CORE_RP_PICO) || defined(RT_HW_CORE_SEEED) 
rtWire1.setSDA(i2cGetPinSDA(bus));		//--Установка номера пина SDA;	
rtWire1.setSCL(i2cGetPinSCL(bus));		//--Установка номера пина SCL;			
rtWire1.begin();							//--Инициализация как Master;
rtWire1.setClock(i2cGetSpeed(bus));;		//--Установка частоты шины;	
i2cSetStatus(1,bus);					//--Установка статуса Master и успешный выход;
i2cClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
LinkI2C1.status=5; codeErr=5;			//--Выход с установкой неопределенного статуса; 
i2cClearBusy(bus); return 1;}	//++++Освобождение шины и выход-------------------------------------	
#endif	//--END #if defined(RT_HW_CREATED_WIRE1)
#if defined(RT_HW_CREATED_WIRE2)
if(bus==2){									
#if defined(RT_HW_CORE_STM32_M)
rtWire2.begin();							//--Инициализация как Master;
LinkI2C2.status=1;						//--Установка статуса Master и успешный выход;
i2cClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif		//-------------------------------------------------------------------------------------
#if defined(RT_HW_CORE_STM32_D) || defined(RT_HW_CORE_RP_PICO) || defined(RT_HW_CORE_SEEED) 
rtWire2.setSDA(i2cGetPinSDA(bus));		//--Установка номера пина SDA;	
rtWire2.setSCL(i2cGetPinSCL(bus));		//--Установка номера пина SCL;			
rtWire2.begin();							//--Инициализация как Master;
rtWire2.setClock(i2cGetSpeed(bus));;		//--Установка частоты шины;	
i2cSetStatus(1,bus);					//--Установка статуса Master и успешный выход;
i2cClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
LinkI2C2.status=5; codeErr=5;			//--Выход с установкой неопределенного статуса;
i2cClearBusy(bus); return 1;}	//++++Освобождение шины и выход-------------------------------------
//====END if(bus==2)---------------------------------------------------
#endif	//--END #if defined(RT_HW_CREATED_WIRE2)
#if defined(RT_HW_CREATED_WIRES)
if(bus==0){									
#if defined(RT_HW_CORE_STM32_M)
rtWireS.begin();							//--Инициализация как Master;
rtWireS.setClock(i2cGetSpeed(bus));		//--Установка частоты шины;	
i2cSetStatus(1,bus);					//--Установка статуса Master и успешный выход;
i2cClearBusy(bus); 
return 1;	//++++Освобождение шины и выход------------------------------------
#endif
LinkI2CS.status=5; codeErr=5;			//--Выход с установкой неопределенного статуса;
i2cClearBusy(bus); return 1;}	//++++Освобождение шины и выход------------------------------------
//====END if(I2S bus=0)----------------------------------------------------------------------------
#endif	//--END #if defined(RT_HW_CREATED_WIRES)
#if defined(RT_HW_PERMIT_I2CS1)
if(bus==1){									
#if defined(RT_HW_CORE_STM32_M)
rtWireS1.begin();							//--Инициализация как Master;
rtWireS1.setClock(i2cGetSpeed(bus));;		//--Установка частоты шины;	
i2cSetStatus(1,bus);					//--Установка статуса Master и успешный выход;
i2cClearBusy(bus); return 1;	//++++Освобождение шины и выход------------------------------------
#endif		//-------------------------------------------------------------------------------------
i2cSetStatus(5,bus); codeErr=5;			//--Выход с установкой неопределенного статуса;
i2cClearBusy(bus); return 1;}	//++++Освобождение шины и выход------------------------------------
//====END if(I2S1 bus=1)---------------------------------------------------------------------------
#endif	//--END #if defined(RT_HW_CREATED_WIRES1)
codeErr=7;								//--Выход с установкой ошибки "Нет шины"
i2cClearBusy(bus); return 1;}; 

//=================================================================================================
//								Настройка шины как Slave
//=================================================================================================
//void    RT_HW_BASE:: i2cBeginSlave(uint8_t bus){
//if(i2cGetStatus(bus)==1) {return;};
//};
//--END i2cBegin()
//=================================================================================================

