#include "RT_HW_BASE.h"
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						1.СОЗДАНИЕ ДОПОЛНИТЕЛЬНЫХ ОБЪЕКТОВ SPI ПОД ТИП MCU
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#if defined(RT_HW_PERMIT_SPI1) && defined(RT_HW_CORE_ESP32)			//--Создание объекта для SPI1 для ESP32
SPIClass rtSPI1(HSPI);
#endif //------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI1) && defined(RT_HW_CORE_STM32_M)		//--Создание объекта для SPI1 для STM32(M)	
SPIClass rtSPI1(1);
#endif //------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI1) && defined(RT_HW_CORE_STM32_D)		//--Создание объекта для SPI1 для STM32(D)	
SPIClass rtSPI1(1);
#endif //------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI2) && defined(RT_HW_CORE_STM32_M)		//--Создание объекта для SPI2 для STM32(M)	
SPIClass rtSPI2(2);
#endif //------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI2) && defined(RT_HW_CORE_STM32_D)		//--Создание объекта для SPI2 для STM32(D)	
SPIClass rtSPI2(1);
#endif //------------------------------------------------------------------------------------------

//=================================================================================================
void    RT_HW_BASE:: spiBeginTransaction(uint32_t speed, uint8_t bitOrder, uint8_t dataMode, uint8_t bus){//++++Begin транзакции с параметрами speed,bitOrder,dataMode;
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {if(bitOrder){SPI.beginTransaction (SPISettings(speed,MSBFIRST,dataMode));}	
else                    {SPI.beginTransaction (SPISettings(speed,LSBFIRST,dataMode));}
return;}						 
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==0) {if(bitOrder){rtSPI1.beginTransaction (SPISettings(speed,MSBFIRST,dataMode));}	
else                    {rtSPI1.beginTransaction (SPISettings(speed,LSBFIRST,dataMode));}
return;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==0) {if(bitOrder){rtSPI2.beginTransaction (SPISettings(speed,MSBFIRST,dataMode));}	
else                    {rtSPI2.beginTransaction (SPISettings(speed,LSBFIRST,dataMode));}
return;}
#endif
buff.vu32=speed; //--Для предотвращения warning C++;
buff.vu16=bitOrder; //--Для предотвращения warning C++;
buff.vu8=dataMode; //--Для предотвращения warning C++;
buff.bf8=bus; //--Для предотвращения warning C++;
};	//++++END spiBeginTransaction(speed,bitOrder,dataMode,bus)=====================================
void    RT_HW_BASE:: spiBeginTransaction(uint32_t speed, uint8_t bus){									  //++++Begin транзакции с параметрами speed,  [bitOrder=MSBFIRST,dataMode=MODE0]
spiBeginTransaction(speed,1,0,bus);
};	//++++end spiBeginTransaction(uint32_t speed, uint8_t bus)======================================
void    RT_HW_BASE:: spiBeginTransaction(uint8_t bus){										              //++++Begin транзакции [speed=default,bitOrder=MSBFIRST,dataMode=MODE0]
spiBeginTransaction(spiGetSpeed(bus),1,0,bus);
};	//++++end spiBeginTransaction(uint8_t bus)======================================
void    RT_HW_BASE:: spiEndTransaction  (uint8_t bus){													  //++++End   транзакции;
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {SPI.endTransaction(); return;}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {rtSPI1.endTransaction(); return;}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {rtSPI2.endTransaction(); return;}
#endif
buff.bf8=bus; //--Для предотвращения warning C++;
};	//++++++END i2cGetBusState()	

//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//						5.Функции обмена
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t  RT_HW_BASE:: spiTransfer   (uint8_t  var, 							 uint8_t bus){	//++++Отправка/прием байта;
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return SPI.transfer(var);}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return rtSPI1.transfer(var);}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return rtSPI2.transfer(var);}
#endif
buff.vu8=var;  //--Для предотвращения warning C++;
buff.bf8=bus;  //--Для предотвращения warning C++;
return 0;};
uint16_t RT_HW_BASE:: spiTransfer16 (uint16_t var, 							 uint8_t bus){	//++++Отправка/прием слова;
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return SPI.transfer16(var);}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return rtSPI1.transfer16(var);}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return rtSPI2.transfer16(var);}
#endif
buff.vu16=var; //--Для предотвращения warning C++;
buff.bf8=bus;  //--Для предотвращения warning C++;
return 0;};
void     RT_HW_BASE:: spiTransferArr(uint8_t  *tx, uint8_t *rx, uint8_t qnt, uint8_t bus){	//--Обмен qnt байтами;
for(uint8_t i=0; i<qnt; i++){rx[i]=spiTransfer(tx[i],bus);}} 
void     RT_HW_BASE:: spiWrite      (uint8_t  var, 							 uint8_t bus){ 	//--Отправка байта;
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {SPI.transfer(var);}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {rtSPI1.transfer(var);}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {rtSPI2.transfer(var);}
#endif
buff.vu8=var;  //--Для предотвращения warning C++;
buff.bf8=bus;  //--Для предотвращения warning C++;
};
void     RT_HW_BASE:: spiWrite16    (uint16_t var, 							 uint8_t bus){ 	//--Отправка слова;
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {SPI.transfer16(var);}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {rtSPI1.transfer16(var);}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {rtSPI2.transfer16(var);}
#endif
buff.vu16=var;  //--Для предотвращения warning C++;
buff.bf8=bus;  //--Для предотвращения warning C++;
};
void     RT_HW_BASE:: spiWriteArr   (uint8_t  *tx, 				uint8_t qnt, uint8_t bus){	//--Отправка qnt байт;
for(uint8_t i=0; i<qnt; i++){spiWrite(tx[i],bus);}} 
uint8_t  RT_HW_BASE:: spiRead       (uint8_t  bus){											//--Прием байта;
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return SPI.transfer(0);}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return rtSPI1.transfer(0);}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return rtSPI2.transfer(0);}
#endif
buff.bf8=bus;  //--Для предотвращения warning C++;
return 0;};
uint16_t RT_HW_BASE:: spiRead16     (uint8_t  bus){											//--Прием слова;
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0) {return SPI.transfer16(0);}
#endif
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1) {return rtSPI1.transfer16(0);}
#endif
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2) {return rtSPI2.transfer16(0);}
#endif
buff.bf8=bus;  //--Для предотвращения warning C++;
return 0;};
void     RT_HW_BASE:: spiReadArr    (			   uint8_t *rx, uint8_t qnt, uint8_t bus){	//--Прием qnt байт;
for(uint8_t i=0; i<qnt; i++){rx[i]=spiRead(bus);}} 	
//=================================================================================================
//							10.1. Инициализация шины SPI как Master
//=================================================================================================
uint8_t  RT_HW_BASE:: spiBeginMaster(uint8_t &codeErr, uint8_t bus){
//-------------------------------------------------------------------------------------------------
//consoleTest(String(F("1.init SPI")),bus);

codeErr=0;											//--Очистка кода ошибки;
if(!spiCheckBus(bus))	 {codeErr=65; return 1;}	//--Выход, если недопустиый номер шины;
if( spiGetStatus(bus)==1){            return 1;} 	//--Выход, если шина уже Master;
if(!spiSetBusy(bus))	 {            return 0;}	//--Захват шины или выход еcли шина занята
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0){	//=========================CHECK bus=0=================================================				
#if defined(RT_HW_CORE_AVR) || defined(RT_HW_CORE_SAM) || defined(RT_HW_CORE_SAMD) || defined(RT_HW_CORE_SEED)
if(codeErr==0){SPI.begin();	spiSetStatus(1,bus);}			//--init SPI & Set status=Master;
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_ESP8266) 
if(!SPI.pins((int8_t)spiGetPinSCK(bus),(int8_t)spiGetPinMISO(bus),(int8_t)spiGetPinMOSI(bus),0)){codeErr=61;};								
if(codeErr==0){SPI.begin();	spiSetStatus(1,bus);}			//--init SPI & Set status=Master;
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_ESP32) 
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinSCK (bus))) 	{codeErr=61;}
if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,spiGetPinMISO(bus)))	{codeErr=62;}
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinMOSI(bus)))	{codeErr=63;}
if(codeErr==0){SPI.begin(spiGetPinSCK(bus),spiGetPinMISO(bus),spiGetPinMOSI(bus)); 	spiSetStatus(1,bus);}//--Set status=Master;
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_STM32_M) 
if(codeErr==0){SPI.begin();	spiSetStatus(1,bus);}			//--init SPI & Set status=Master;
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_STM32_D) 
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinSCK (bus))) 	{codeErr=61;}
if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,spiGetPinMISO(bus)))	{codeErr=62;}
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinMOSI(bus)))	{codeErr=63;}
if(codeErr==0){SPI.setSCLK(spiGetPinSCK(bus)); SPI.setMISO(spiGetPinMISO(bus)); SPI.setMOSI(spiGetPinMOSI(bus));
               SPI.begin();	spiSetStatus(1,bus);}			//--init SPI & Set status=Master;	
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif	
          //RT_HW_CORE_RP_PICO

//
//consoleTest(String(F("2.init SPI")),bus);
#if defined(RT_HW_CORE_RP_PICO) 
if(!SPI.setSCK(spiGetPinSCK (bus))) 						{codeErr=61;};							
if(!SPI.setRX (spiGetPinMISO(bus))) 						{codeErr=62;};	
if(!SPI.setTX (spiGetPinMOSI(bus))) 						{codeErr=63;};	
if(codeErr==0){SPI.begin();	spiSetStatus(1,bus);}			//--init SPI & Set status=Master;

//consoleTest(String(F("2.init SPI codeErr")),codeErr);


spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_ANON)
spiSetStatus(0,bus);               							 codeErr=67;
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
}	//++++END init bus=0;	
#endif	//++++#if defined(RT_HW_PERMIT_SPI0)=======================================================	
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1){	//=========================CHECK bus=1=================================================	
#if defined(RT_HW_CORE_ESP32) 
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinSCK (bus))) 	{codeErr=61;}
if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,spiGetPinMISO(bus)))	{codeErr=62;}
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinMOSI(bus)))	{codeErr=63;}
if(codeErr==0){SPI1.begin(spiGetPinSCK(bus),spiGetPinMISO(bus),spiGetPinMOSI(bus)); spiSetStatus(1,bus);}//--Set status=Master;
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_STM32_M) 
if(codeErr==0){rtSPI1.begin();	spiSetStatus(1,bus);}			//--init SPI & Set status=Master;
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_STM32_D) 
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinSCK (bus))) 	{codeErr=61;}
if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,spiGetPinMISO(bus)))	{codeErr=62;}
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinMOSI(bus)))	{codeErr=63;}
if(codeErr==0){SPI1.setSCLK(spiGetPinSCK (bus)); SPI1.setMISO(spiGetPinMISO(bus)); SPI1.setMOSI(spiGetPinMOSI(bus));
               SPI1.begin();	spiSetStatus(1,bus);}			//--init SPI & Set status=Master;
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_RP_PICO) 
if(!SPI1.setSCK(spiGetPinSCK (bus))) 						{codeErr=61;};							
if(!SPI1.setRX (spiGetPinMISO(bus))) 						{codeErr=62;};	
if(!SPI1.setTX (spiGetPinMOSI(bus))) 						{codeErr=63;};	
if(codeErr==0){rtSPI1.begin();	spiSetStatus(1,bus);}			//--init SPI & Set status=Master;
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_ANON)
spiSetStatus(0,bus);                 						 codeErr=67;  //--errot init ANON.bus=1;		
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
}	//++++END init bus=1;		
#endif	//++++#if defined(RT_HW_PERMIT_SPI1)=======================================================	
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2){	//=========================CHECK bus=2=================================================				
#if defined(RT_HW_CORE_STM32_D) 
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinSCK (bus))) 	{codeErr=61;}
if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,spiGetPinMISO(bus)))	{codeErr=62;}
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinMOSI(bus)))	{codeErr=63;}
if(codeErr==0){rtSPI2.setSCLK(spiGetPinSCK (bus)); SPI2.setMISO(spiGetPinMISO(bus)); SPI2.setMOSI(spiGetPinMOSI(bus));
               rtSPI2.begin();	spiSetStatus(1,bus);}			//--init SPI & Set status=Master;
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_ANON)
spiSetStatus(0,bus); 										 codeErr=67;  //--errot init ANON.bus=2; 
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
}	//++++END init bus=2;
#endif	//++++#if defined(RT_HW_PERMIT_SPI2)=======================================================		
//=================================================================================================  	
spiClearBusy(bus); codeErr=6; return 1;}	//++++Освобождение шины и выход------------------------
//++++++END spiBeginMaster()=======================================================================
//=================================================================================================
//							10.2. Инициализация шины SPI как Slave
//=================================================================================================
uint8_t  RT_HW_BASE:: spiBeginSlave(uint8_t &codeErr, uint8_t bus){	//--Инициализация шины SPI как Slave;
//-------------------------------------------------------------------------------------------------
codeErr=0;											//--Очистка кода ошибки;
if(!spiCheckBus(bus))	 {codeErr=65; return 1;}	//--Выход, если недопустиый номер шины;
if( spiGetStatus(bus)==2){            return 1;} 	//--Выход, если шина уже Slave;
if(!spiSetBusy(bus))	 {            return 0;}	//--Захват шины или выход еcли шина занята
//-------------------------------------------------------------------------------------------------
#if defined(RT_HW_PERMIT_SPI0)	
if(bus==0){	//=========================CHECK bus=0=================================================				
#if defined(RT_HW_CORE_AVR) || defined(RT_HW_CORE_SAM)
if(codeErr==0){pinMode(SPIgetPinSS(bus),INPUT); SPI.begin(); spiSetStatus(2,bus);}			//--init SPI & Set status=Slave;
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_ESP8266) 
//if(!SPI.pins((int8_t)spiGetPinSCK(bus),(int8_t)spiGetPinMISO(bus),(int8_t)spiGetPinMOSI(bus),(int8_t)spiGetPinSS(bus))){codeErr=61;};								
//if(codeErr==0){SPI.begin();	spiSetStatus(2,bus);}			//--init SPI & Set status=Master;
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_ESP32) 
/*
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinSCK (bus))) 	{codeErr=61;}
if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,spiGetPinMISO(bus)))	{codeErr=62;}
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinMOSI(bus)))	{codeErr=63;}
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinSS(bus)))	    {codeErr=64;}
if(codeErr==0){SPI.begin(spiGetPinSCK(bus),spiGetPinMISO(bus),spiGetPinMOSI(bus)); 	spiSetStatus(1,bus);}//--Set status=Master;
*/
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_STM32_M) 
//if(codeErr==0){SPI.begin();	spiSetStatus(1,bus);}			//--init SPI & Set status=Master;
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_STM32_D) 
/*
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinSCK (bus))) 	{codeErr=61;}
if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,spiGetPinMISO(bus)))	{codeErr=62;}
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinMOSI(bus)))	{codeErr=63;}
if(codeErr==0){SPI.setSCLK(spiGetPinSCK(bus)); SPI.setMISO(spiGetPinMISO(bus)); SPI.setMOSI(spiGetPinMOSI(bus));
               SPI.begin();	spiSetStatus(1,bus);}			//--init SPI & Set status=Master;	
*/
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif	
#if defined(RT_HW_CORE_RP_PICO) 
/*
if(!SPI.setSCK(spiGetPinSCK (bus))) 						{codeErr=61;};							
if(!SPI.setRX (spiGetPinMISO(bus))) 						{codeErr=62;};	
if(!SPI.setTX (spiGetPinMOSI(bus))) 						{codeErr=63;};	
if(codeErr==0){SPI.begin();	spiSetStatus(1,bus);}			//--init SPI & Set status=Master;
*/
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_ANON)
spiSetStatus(0,bus);               							 codeErr=67;
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
}	//++++END init bus=0;	
#endif	//++++#if defined(RT_HW_PERMIT_SPI0)=======================================================	
#if defined(RT_HW_PERMIT_SPI1)	
if(bus==1){	//=========================CHECK bus=1=================================================	
#if defined(RT_HW_CORE_ESP32) 
/*
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinSCK (bus))) 	{codeErr=61;}
if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,spiGetPinMISO(bus)))	{codeErr=62;}
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinMOSI(bus)))	{codeErr=63;}
if(codeErr==0){rtSPI1.begin(spiGetPinSCK(bus),spiGetPinMISO(bus),spiGetPinMOSI(bus)); spiSetStatus(1,bus);}//--Set status=Master;
*/
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_STM32_M) 
//if(codeErr==0){rtSPI1.begin();	spiSetStatus(1,bus);}			//--init SPI & Set status=Master;
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_STM32_D) 
/*
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinSCK (bus))) 	{codeErr=61;}
if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,spiGetPinMISO(bus)))	{codeErr=62;}
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinMOSI(bus)))	{codeErr=63;}
if(codeErr==0){rtSPI1.setSCLK(spiGetPinSCK (bus)); rtSPI1.setMISO(spiGetPinMISO(bus)); rtSPI1.setMOSI(spiGetPinMOSI(bus));
               rtSPI1.begin();	spiSetStatus(1,bus);}			//--init SPI & Set status=Master;
*/
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_RP_PICO) 
/*
if(!SPI1.setSCK(spiGetPinSCK (bus))) 						{codeErr=61;};							
if(!SPI1.setRX (spiGetPinMISO(bus))) 						{codeErr=62;};	
if(!SPI1.setTX (spiGetPinMOSI(bus))) 						{codeErr=63;};	
if(codeErr==0){SPI1.begin();	spiSetStatus(1,bus);}			//--init SPI & Set status=Master;
*/
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_ANON)
spiSetStatus(0,bus);                 						 codeErr=67;  //--errot init ANON.bus=1;		
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
}	//++++END init bus=1;		
#endif	//++++#if defined(RT_HW_PERMIT_SPI1)=======================================================	
#if defined(RT_HW_PERMIT_SPI2)	
if(bus==2){	//=========================CHECK bus=2=================================================				
#if defined(RT_HW_CORE_STM32_D) 
/*
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinSCK (bus))) 	{codeErr=61;}
if(!checkPinPGM(RT_HW_PGM_PIN_DIN_ID,spiGetPinMISO(bus)))	{codeErr=62;}
if(!checkPinPGM(RT_HW_PGM_PIN_DOT_ID,spiGetPinMOSI(bus)))	{codeErr=63;}
if(codeErr==0){rtSPI2.setSCLK(spiGetPinSCK (bus)); rtSPI2.setMISO(spiGetPinMISO(bus)); rtSPI2.setMOSI(spiGetPinMOSI(bus));
               rtSPI2.begin();	spiSetStatus(1,bus);}			//--init SPI & Set status=Master;
*/
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
#if defined(RT_HW_CORE_ANON)
spiSetStatus(0,bus); 										 codeErr=67;  //--errot init ANON.bus=2; 
spiClearBusy(bus); return 1;	//++++Освобождение шины и выход-------------------------------------
#endif
}	//++++END init bus=2;
#endif	//++++#if defined(RT_HW_PERMIT_SPI2)=======================================================		
//=================================================================================================  	
spiClearBusy(bus); codeErr=6; return 1;}	//++++Освобождение шины и выход------------------------
//++++++END spiBeginSlave()========================================================================
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++




//=================================================================================================

