//=================================================================================================
//#define RT_HW_LCD44780_DIR_CHECK   		3			//--Номер этапа, на котором проверяется изменение переменных; 
#define RT_HW_LCD44780_MAX_DEVICE		15			//--Максимальное кол-во допустимых устройств;
#define RT_HW_LCD44780_MAX_COLS  		40			//--Максимальное кол-во колонок
#define RT_HW_LCD44780_MAX_ROWS  		4			//--Максимальное кол-во строк
//#define RT_HW_LCD44780_TIME_BUSY			250			//--Время для захвата дисплея;
//#define RT_HW_LCD44780_TIME_DATA			0			//--Время для захвата дисплея;
#define RT_HW_LCD44780_TIME_CURSOR		37			//--Время установки курсора(mcs);
#define RT_HW_LCD44780_PERIOD_TICK  	20			//--Период системного времени в ms, не более 255;
#define RT_HW_LCD44780_PERIOD_BLINK_ON 	15			//--Длительность включения  при мерцании в тиках(50ms) ;
#define RT_HW_LCD44780_PERIOD_BLINK_OFF	10			//--Длительность выключения при мерцании в тиках(50ms) ;
#define RT_HW_LCD44780_CNT_TICK_SEC  	20			//--Количество тиков в одной секунде;
#define RT_HW_LCD44780_QNT_BLOCK		3			//--Количество тиков для возобновления вывода после EN=0;
#define RT_HW_LCD44780_WATCH_DOG_BUSY    20			//--Размер watchDog в тиках;
#define RT_HW_LCD44780_BLANK		    ' '			//--Символ заполнения;
#define RT_HW_LCD44780_BREAK_CHAR		'~'			//--Символ "Запрещающего" символа;
#define RT_HW_LCD44780_CODE_BLANK		's'			//--Символ указатель, что заполнитель "пробел";
#define RT_HW_LCD44780_UPPER  			1			//--0 -нижний регистр, 1 -верхний регистр (при выводе HEX-значений);
//-------------------------------------------------------------------------------------------------
#define RT_HW_LCD44780_FIND_MAX_OK		8			//
#define RT_HW_LCD44780_FIND_PERIOD		20			//
#define RT_HW_LCD44780_FIND_PERIOD_MAX	2000		//
//-------------------------------------------------------------------------------------------------
#define RT_HW_LCD44780_BIT_RS		0				//--Бит управление RS;
#define RT_HW_LCD44780_BIT_RW		1				//--Бит управление RW(E2),
#define RT_HW_LCD44780_BIT_E		2				//--Бит управления строба записи E(E1);
#define RT_HW_LCD44780_BIT_ON		3				//--Бит управления подсветкой;
#define RT_HW_LCD44780_BIT_D4		4				//--Бит D4;
#define RT_HW_LCD44780_BIT_D5		5				//--Бит D5;
#define RT_HW_LCD44780_BIT_D6		6				//--Бит D6;
#define RT_HW_LCD44780_BIT_D7		7				//--Бит D7;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++	
const char  RT_HW_LCD44780_HEAD[] PROGMEM="~";
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                 LCD Bit Sequence Table
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++																
static const unsigned char  RT_HW_LCD44780_TABLE_ORDER_BIT_LCD[] PROGMEM={ 
//RS RW E LED D4 D5 D6 D7
  0, 1, 2, 3, 4, 5, 6, 7,	//--RS, RW,  E,LED, D4, D5, D6, D7;
  6, 5, 4, 7, 0, 1, 2, 3	//--D4, D5, D6, D7,  E, RW, RS,LED;
};  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                 Control code table for 4-bit data bus
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
static const unsigned char  RT_HW_LCD44780_INIT_BUS4[] PROGMEM= 
{0,'N',250,				//--pause 25ms 250х100=25мс; 
 0,'N',250,				//--pause 25ms 250х100=25мс; 
 0b00000011,'T',45,		//--code 0x3,'T',pause 25ms 45мкс; 
 0b00000011,'T',45,
 0b00000011,'T',45,
 0b00000010,'T',20,
 0b00100000,'I',20,
 0b00000001,'I',20,
 0b00000100,'I',20,
 0b00101000,'I',20,
 0b00010000,'I',20,
 0b00001100,'I',20,
 0b00000110,'I',20,
 0b00000001,'I',20};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                 Control code table for 8-bit data bus
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
static const unsigned char  RT_HW_LCD44780_INIT_BUS8[] PROGMEM= 
{0,'N',250,				//--pause 25ms; 
 0,'N',250,				//--pause 25ms; 
 0b00110000,'I',45,		//--init;
 0b00110000,'I', 1,
 0b00110000,'I', 1,
 0b00111000,'I', 1,		//--bus 8-bits, two line;
 0b00001110,'I', 1,		//--DCB:   D=1 display ON,С=1 cursor underline ON,B=1 blinking square cursor ON;
 0b00000001,'I',20,		//--clear display;
 0b00000110,'I', 1,		//--I/D S: I/D=1 address increment ON; S=0 screen shift OFF.
 0b00001100,'I', 1		//--DCB:   D=1 display ON,С=1 cursor underline ON,B=1 blinking square cursor ON;
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                     CYRILLIC CODE TABLE LCD
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
static const unsigned char  RT_HW_LCD44780_CONVERT_RUS[] PROGMEM= 
{0x41,0xA0,0x42,0xA1,0xE0,0x45,0xA3,0xA4,   // АБВГДЕЖЗ
 0xA5,0xA6,0x4B,0xA7,0x4D,0x48,0x4F,0xA8,   // ИЙКЛМНОП
 0x50,0x43,0x54,0xA9,0xAA,0x58,0xE1,0xAB,   // РСТУФХЦЧ
 0xAC,0xE2,0xAD,0xAE,0xAD,0xAF,0xB0,0xB1,   // ШЩЪЫЬЭЮЯ
 0x61,0xB2,0xB3,0xB4,0xE3,0x65,0xB6,0xB7,   // абвгдежз
 0xB8,0xB9,0xBA,0xBB,0xBC,0xBD,0x6F,0xBE,   // ийклмноп
 0x70,0x63,0xBF,0x79,0xE4,0x78,0xE5,0xC0,   // рстуфхцч
 0xC1,0xE6,0xC2,0xC3,0xC4,0xC5,0xC6,0xC7,	// шщъыьэюя
 0xA2,0xB5,0xFF,0xFF};					    // Ёё
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//=================================================================================================
//								FONTS RUS
//=================================================================================================
#if defined(RT_HW_LCD44780_EXT_GEN_RUS)
static const RT_HW_LCD44780_FONT_UNICODE  RT_HW_LCD44780_FONT[] PROGMEM = {	
{{0b11111, 0b10000, 0b10000, 0b11110, 0b10001, 0b10001, 0b11110, 0b00000}, 0xD091},	//Б
{{0b11111, 0b10000, 0b10000, 0b10000, 0b10000, 0b10000, 0b10000, 0b00000}, 0xD093},	//Г
{{0b00110, 0b01010, 0b01010, 0b01010, 0b01010, 0b01010, 0b11111, 0b10001}, 0xD094},	//Д
{{0b10101, 0b10101, 0b10101, 0b01110, 0b10101, 0b10101, 0b10101, 0b00000}, 0xD096},	//Ж
{{0b01110, 0b10001, 0b00001, 0b00110, 0b00001, 0b10001, 0b01110, 0b00000}, 0xD097},	//З
{{0b10001, 0b10001, 0b10001, 0b10011, 0b10101, 0b11001, 0b10001, 0b00000}, 0xD098},	//И
{{0b10101, 0b10001, 0b10001, 0b10011, 0b10101, 0b11001, 0b10001, 0b00000}, 0xD099},	//Й
{{0b00111, 0b01001, 0b01001, 0b01001, 0b01001, 0b01001, 0b10001, 0b00000}, 0xD09B},	//Л
{{0b11111, 0b10001, 0b10001, 0b10001, 0b10001, 0b10001, 0b10001, 0b00000}, 0xD09F},	//П
{{0b10001, 0b10001, 0b10001, 0b01111, 0b00001, 0b10001, 0b01110, 0b00000}, 1059},	//У
{{0b00100, 0b01110, 0b10101, 0b10101, 0b10101, 0b01110, 0b00100, 0b00000}, 1060},	//Ф
{{0b10010, 0b10010, 0b10010, 0b10010, 0b10010, 0b10010, 0b11111, 0b00001}, 1062},	//Ц
{{0b10001, 0b10001, 0b10001, 0b01111, 0b00001, 0b00001, 0b00001, 0b00000}, 1063},	//Ч
{{0b10001, 0b10001, 0b10001, 0b10101, 0b10101, 0b10101, 0b11111, 0b00000}, 1064},	//Ш
{{0b10001, 0b10001, 0b10001, 0b10101, 0b10101, 0b10101, 0b11111, 0b00001}, 1065},	//Щ
{{0b11000, 0b01000, 0b01000, 0b01110, 0b01001, 0b01001, 0b01110, 0b00000}, 1066},	//Ъ
{{0b10001, 0b10001, 0b10001, 0b11101, 0b10011, 0b10011, 0b11101, 0b00000}, 1067},	//Ы
{{0b10000, 0b10000, 0b10000, 0b11110, 0b10001, 0b10001, 0b11110, 0b00000}, 1068},	//Ь
{{0b01110, 0b10001, 0b00001, 0b00111, 0b00001, 0b10001, 0b01110, 0b00000}, 1069},	//Э
{{0b10010, 0b10101, 0b10101, 0b11101, 0b10101, 0b10101, 0b10010, 0b00000}, 1070},	//Ю
{{0b01111, 0b10001, 0b10001, 0b01111, 0b00101, 0b01001, 0b10001, 0b00000}, 1071},	//Я
{{0b00011, 0b01100, 0b10000, 0b11110, 0b10001, 0b10001, 0b01110, 0b00000}, 1073},	//б
{{0b00000, 0b00000, 0b11110, 0b10001, 0b11110, 0b10001, 0b11110, 0b00000}, 1074},	//в
{{0b00000, 0b00000, 0b11110, 0b10000, 0b10000, 0b10000, 0b10000, 0b00000}, 1075},	//г
{{0b00000, 0b00000, 0b00110, 0b01010, 0b01010, 0b01010, 0b11111, 0b10001}, 1076},	//д
{{0b01010, 0b00000, 0b01110, 0b10001, 0b11111, 0b10000, 0b01111, 0b00000}, 1105},	//ё
{{0b00000, 0b00000, 0b10101, 0b10101, 0b01110, 0b10101, 0b10101, 0b00000}, 1078},	//ж
{{0b00000, 0b00000, 0b01110, 0b10001, 0b00110, 0b10001, 0b01110, 0b00000}, 1079},	//з
{{0b00000, 0b00000, 0b10001, 0b10011, 0b10101, 0b11001, 0b10001, 0b00000}, 1080},	//и
{{0b01010, 0b00100, 0b10001, 0b10011, 0b10101, 0b11001, 0b10001, 0b00000}, 1081},	//й
{{0b00000, 0b00000, 0b10010, 0b10100, 0b11000, 0b10100, 0b10010, 0b00000}, 1082},	//к
{{0b00000, 0b00000, 0b00111, 0b01001, 0b01001, 0b01001, 0b10001, 0b00000}, 1083},	//л
{{0b00000, 0b00000, 0b10001, 0b11011, 0b10101, 0b10001, 0b10001, 0b00000}, 1084},	//м
{{0b00000, 0b00000, 0b10001, 0b10001, 0b11111, 0b10001, 0b10001, 0b00000}, 1085},	//н
{{0b00000, 0b00000, 0b11111, 0b10001, 0b10001, 0b10001, 0b10001, 0b00000}, 1087},	//п
{{0b00000, 0b00000, 0b11111, 0b00100, 0b00100, 0b00100, 0b00100, 0b00000}, 1090},	//т
{{0b00000, 0b00000, 0b00100, 0b01110, 0b10101, 0b01110, 0b00100, 0b00000}, 1092},	//ф
{{0b00000, 0b00000, 0b10010, 0b10010, 0b10010, 0b10010, 0b11111, 0b00001}, 1094},	//ц
{{0b00000, 0b00000, 0b10001, 0b10001, 0b01111, 0b00001, 0b00001, 0b00000}, 1095},	//ч
{{0b00000, 0b00000, 0b10101, 0b10101, 0b10101, 0b10101, 0b11111, 0b00000}, 1096},	//ш
{{0b00000, 0b00000, 0b10101, 0b10101, 0b10101, 0b10101, 0b11111, 0b00001}, 1097},	//щ
{{0b00000, 0b00000, 0b11000, 0b01000, 0b01110, 0b01001, 0b01110, 0b00000}, 1098},	//ъ
{{0b00000, 0b00000, 0b10001, 0b10001, 0b11101, 0b10011, 0b11101, 0b00000}, 1099},	//ы
{{0b00000, 0b00000, 0b10000, 0b10000, 0b11110, 0b10001, 0b11110, 0b00000}, 1100},	//ь
{{0b00000, 0b00000, 0b01110, 0b10001, 0b00111, 0b10001, 0b01110, 0b00000}, 1101},	//э
{{0b00000, 0b00000, 0b10010, 0b10101, 0b11101, 0b10101, 0b10010, 0b00000}, 1102},	//ю
{{0b00000, 0b00000, 0b01111, 0b10001, 0b01111, 0b00101, 0b01001, 0b00000}, 1103},	//я
{{0b00001, 0b11111, 0b10000, 0b10000, 0b10000, 0b10000, 0b10000, 0b00000}, 0x490},	//укр. Г
{{0b00000, 0b00010, 0b11110, 0b10000, 0b10000, 0b10000, 0b10000, 0b00000}, 0x491},	//укр. г
{{0b01111, 0b10000, 0b10000, 0b11110, 0b10000, 0b10000, 0b01111, 0b00000}, 0x404},	//укр. Е
{{0b00000, 0b00000, 0b01110, 0b10000, 0b11100, 0b10000, 0b01110, 0b00000}, 0x454},	//укр. е
{{0b01010, 0b00000, 0b01110, 0b00100, 0b00100, 0b00100, 0b01110, 0b00000}, 0x407},	//укр. I
{{0b00000, 0b01010, 0b00000, 0b01100, 0b00100, 0b00100, 0b01110, 0b00000}, 0x457}	//укр. i
};
#endif
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++




