//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                    СТРУКТУРА RT_HW_LCD44780_DEVICE_ID;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct   RT_HW_LCD44780_DEVICE_ID{		  
//-----------------Основные параметры управления---------------------------------------------------
uint8_t  num=0; 				//--Номер устройства (от 1 до RT_HW_LCD44780_MAX_DEVICE).По этому номеру внешние блоки привязываются к устройству;
uint8_t  dir=0;					//--Этапы основной программы управления устройствами;
uint8_t  ddr=0;					//--Этапы для вторичных функций;
uint8_t  custom=0;				//--Флаг настройки, устанавливается функцией setDeviceID();
uint8_t  codeErr=0;				//--Код ошибки при настройке(50-100) и обмена с шиной(1-9);
uint8_t  genState=2;			//--Состояние генератора:=0-LOW тактового генератора; =1-HIGH тактового генератора; =2-сброс внешних блоков,тактовый генератор=LOW;
uint8_t  extReset,agoReset;		//--Внешний перезапуск 	Lcd 			[0->1];
uint8_t  extClear,agoClear;		//--Внешняя очистка 	Lcd				[0->1]; 
uint8_t  extLight, agoLight;	//--Внешнее управление подсветкой Lcd	[=1];
uint8_t  extEN=1, agoEN=0;		//--Разрешение работы Lcd  				[=1];
//-----------------Параметры корректируемые до вызова функции setID()------------------------------
char     mi='I';				//--Интерфейс (I,S,4,8);
uint8_t  modeData:2,			//--Соединение с дисплеем: =0-cоединение D4-D7; =1-cоединение D0-D7;
		 modeFind:2,			//  Алгоритм поиска устройства: =0 -без поиска;  =1 -как на шине i2c;  =2 -как на шине SPI;
         modeRW=1,				//--Блокировка использования пина RW (шины bus4,bus8); 
		 modeOrder:1;			//--Последовательность битов
								//  Для i2c.PCF8574: =0-[    RS,RW,E,Light,     D4-D7]; =1-[D4-D7,E,RW,E,Light]; 
                                //  Для i2c.MCP23017:   [PA: RS,RW,E,light; PB: D0-D7];
								//  Для SPI.hc595:      [    RS,RW,E,Light,     D4-D7];
								//  Для SPI.hc595x2:    [PA: RS,RW,E,light; PB: D0-D7];
uint8_t  cols=16; 				//--Кол-во колонок дисплея;
uint8_t  rows=2;				//--Кол-во строк   дисплея;
uint8_t  sizeLcd=3;				//--Размер дисплея;				
uint16_t periodReboot=0;		//--Период внутреннего перезапуска в мин. Если =0, перезапуск не выполняется;
uint16_t cntReboot;				//--Счетчик периода внутреннего перезапуска в мин(max 60);
uint16_t runReboot=0;			//--Флаг запуска перезагрузки;
uint8_t  bus=0;					//--Номер шины (i2c,SPI); 
uint8_t  adr=255;				//--Адрес i2c
uint8_t  sck=255;				//--SPI.sck(SoftWare);
uint8_t  miso=255;				//--SPI.mosi(SoftWare);
uint8_t  mosi=255;				//--SPI.mosi(SoftWare);
uint8_t  cs=255;				//--SPI.cs
RT_HW_STRUCT_SPN spn;			//--SPN - программный  

uint8_t  pin[11];				//--RS,RW(E2),E1,D0-D7; 
uint8_t  sendTime=10;
uint32_t speed=400000;			//--Скорость шины по умочанию;
uint8_t  timeSpeed;				//--Задержка)обратно пропорционально скорости) для SPN,BUS4,BUS8; 
uint8_t  busy;					//--Флаг занятости дисплея;
uint8_t  blockMISO=1;			//--Блокировка контроля связи с LCD через MISO;
//------------------------------------------------------------------------------------------------- 
uint8_t	 chip:2,				//--Кол-во чипов в устройстве; 
		 agoChip:2;				//--Номер текущего чипа;		  
//-----------------Основные параметры управления---------------------------------------------------
uint8_t  periodBlink=10;		//--Период мерцания полями (в тиках);
//-----------------Параметры тактирующего генератора (для связи с внешними блоками)----------------
uint32_t timeBeginGen=0;		//--Рабочий регистр для генератора;
uint8_t  periodGen=RT_HW_LCD44780_PERIOD_TICK; //--Период тактирующего генератора в ms;
uint16_t periodWatchDog=1000;	//--Период сторожевого таймера в ms;
uint32_t genTime;				//--Рабочий регистр тактирующего генератора;
uint16_t genCalcMin;			//--Счетчик для вычисление минутных событий;
//---------------------------Флаги-----------------------------------------------------------------
uint8_t  cmnd:1,				//--0/1-в дисплей передаются данные/команда (RS=0/1);  
		 event:1, 				//--События 50мс;
		 runReset:1,			//--Флаг запуска сброса;	
		 tick:1,				//--Меандр 50мс;
		 mnt:1;					//--Меандр 1 мин;
//-----------------------Рабочие регистры----------------------------------------------------------
uint8_t  cntWatchDogBusy;		//--Счетчик watch dog для флага busy (в тиках);
uint32_t timeDelay;				//--Рабочие регистры для работы со временем;
uint16_t buff16;				//--Рабочий регистры для функции;
uint8_t  idx;					//--Рабочий регистр для организации циклов;
uint8_t  index;					//--Рабочий регистр;
uint8_t  stepInit; 				//--Этапы для функций инициализации устройства; 
uint8_t  codeBlack=0xFF;		//--Код для отображения черного квадрата (может меняться в зависимости от кодировки);
//----------------Дополнительные переменные управления измерением-----------------------------------
uint8_t  initDevice=0;			//--Состояние настройки устройства;
uint8_t  readyDevice=0;			//--Состoяние готовности устройства к выводу данных;
uint8_t  qntTickSec=100;		//--Кол-во тиков в сек;
uint8_t  qntWatchDog=10;        //--Кол-во тиков в сторожевом таймере;
uint8_t  cntTickSec=0;			//--Счетчик для отсчета сек по тикам;
uint8_t  cntSecMin=0;			//--Счетчик для отсчета минут по секундам;
uint8_t  eventTick,    eventSec,    eventMin;    //--События тиковое,секундное,минутное;
uint8_t  meanderTick:1,meanderSec:1,meanderMin:1;//--Меандры тиковый,секундный,минутный;
uint8_t  cntErr;				//--Счетчик повторных ошибок;
uint8_t  cntFind;
//----------------Параметры для функци timeDelay()--------------------------------------------------
uint32_t startDelay;		    //--Рабочий регистр;
uint8_t  workDelay=0;			//--Рабочий регистр; 
uint8_t  pointDelay;			//--Точка возврата из функции;
uint16_t sizeDelay;				//--Задержка для функции();
//---------------------------------------
uint8_t   arrSend[4], buffSend, bitE;
//--------------------------------------- 
 uint8_t  arrData[RT_HW_LCD44780_MAX_COLS+1];	//--Массив с данными;
 uint8_t  arrDataCur;			//--Текущее прочитанное значение;
 uint8_t  arrPackMax=8;			//--Ограничение отправляемых значений за одну транзакцию; 
 uint8_t  arrLen;				//--Размер записываемого массива;
 uint8_t  arrSize;				//--Кол-во записанных в массив данных; 
 uint8_t  arrPackCnt=0;			//--Счетчик размера пакета за одну транзакцию;
 uint8_t  arrState;				//--Состояние при чтении: =0 -все прочитано; =1-есть данные; 
								//  =2-есть данные и передан пакет=arrReadPackMax; =3-чтение за пределами записываемого массива;  
uint8_t   arrIdx;				//--Индекс текущего значения массива;
uint8_t   arrDir;				//--Номер этапа для функций работы с массивом;
uint8_t   arrSendOk;			//--Результат успешной отправки всего массива;			
//-----------------------------------
};
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//				Структура для блоков вывода на LCD
//--------------------------------------------------------------------------------------
// modeVar: тип данных: B(uint8_t),W(int16_t),L(int32_t),F(float),S(String),C(char),R(бит),T(текст из PROGMEM),G(мерцание),
// formatVar: формат данных: U-целое без знака[B,W,L]; I-целое со знаком[B,W,L], 0,1,2,3-кол-во знаков после точки[0,1,2,3], H-HEX[B,W,L],
//                           #-битовое представленияю,впереди старший бит[B,W,L],#-битовое представленияю,впереди иладший бит[B,W,L],
//                           N-отсутствует;
//							 C-в формате char[B],T-формат времени XX[B]; 
// modeTask:  тип вызова задачи -C(по изменению,P(периодически),T(периодически при изменениях),A(по изменениям или периодически),
//                               S(по входу EN 0->1),F(однократно),N(вызов отключен);
// alig: выравнивание в поле:L(влево),C(по центру),R(вправо),N(без выравнивания);
// suff: суффикс(char), выводимый после данных.Если '~' - суффикс не выводится;
// periodLimit: ограничение(ms/tick) по времени вызова задачи[для C,P,T,A];
// periodTask:  период(ms/tick) вызова задач
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct RT_HW_LCD44780_PARAM_ID{			
uint8_t  num=0;  			//--Номер устройства; 
uint8_t  dir=0;  			//--Номер этапа блока вывода параметра на lcd;
uint8_t  ddr=0;				//--Номер этапа программы управления;
//--------------------------------------------------------------------------------------
uint8_t  custom=0;			//--Флаг успешной настройки ID;
char     modeVar='N';		//--Тип данных [B,W,L,F,S,C,R,T,G];
char     modeTask='A';		//--Тип вывода[C,P,T,A,E];
char     formatVar='N';		//--Формат типа переменной (U,I,0,1,2,3,#,*,H,C,T);
char     alig='L';			//--Выравнивание в поле:L(влево),C(по центру),R(вправо),N(без выравнивания);					
char     suff='~';			//--Суффикс('~' - суффикс не выводится);
uint8_t  run=0,cmdRun;		//--Команда:=0-ожидание;=1-вывод данных;=2-вывод по изменению;=3 очистка поля для мерцания; 
uint8_t	 extEN=1, agoEN=0;	//--Состояние входа EN(текущее и предыдущее значения);
uint8_t  cntEN=0;			//--Счетчик задержки вывода после перехода EN 0->1;
uint8_t  extGen=0,agoGen=0;	//--Текущее и предыдущее состояние главного тиктирующего генератора;
//----Параметры времени в тиках--------------------------------------------------------
uint8_t  periodGen=50;				//--Период тика;
uint8_t  periodLimit=2, cntLimit=0;	//--Период и счетчик минимального периода вывода(в тиках);
uint16_t periodTask=1,  cntTask=0;	//--Период и счетчик периодического вывода(в тиках) [режимы P,T,A];  
uint8_t  periodBlink=10,cntBlink=0;	//--Период и счетчик мерцания поля (в тиках);
//--------------------------------------------------------------------------------------
int32_t  agoVar=0;				//--Буфер предыдущего значения числовых переменных;
//--------------------------------------------------------------------------------------
uint8_t  col,row,len;   		//--Номера колонки,строки,размер поля;
uint16_t msLen:6, msLenVar:6,	//--Общая длина поля,длина переменной;
         msLenSuff:1,			//--Длина суффикcа;
         curChip:2,agoBit:1; 	//--Номер текущего чипа Lcd;
uint16_t msLenBegin:6,msLenEnd:6,//-Длина Begin и End заголовков;
         first:1,flicker:1,		//--Флаг первого запуска, флаг мерцания;
	     modeBlink:1,blink:1;	//--
uint8_t  msLenHead=255;			//--Рабочая длина заголовка(может меняться от размера переменной);
uint8_t  idx,xSrc;				//--Рабочий индекс для организации циклов;
uint8_t  vCursor;				//--Код позиции курсора;
uint8_t  buff;					//--Буфер для выводимого кода;
//--------------------------------------------------------------------------------------
uint8_t  agoState=0;
};
//=================================================================================================
