//=================================================================================================
// 									СЕРВИСНЫЕ ФУНКЦИИ
//=================================================================================================
uint8_t timeToTick(uint16_t time, uint8_t tick){				//+++Конвертирование время в тики==
 if((tick*255)>=time){return time/tick;} else{return 255;}}; 
uint8_t getGenState(uint8_t num){if(!checkNum(num)){return 4;} else {return ptr[num]->genState;}};
//=================================================================================================
//						Функци отправки данных/инструкций в LCD
// 1.code: =T отправка тетрады; =I отправка инструкция(байт); =D отправка данных (байт);
// 2.time: время задержки после отправки команды (default=0). Обычно >0 при отправке инструкций;  
//================================================================================================= 
uint8_t deviceSend       (uint8_t num, uint8_t numChip, uint8_t var, char code, uint16_t time=0){  //++++Отправка одного байта
if(!checkNum(num)) {return 1;} //--Проверка на наличие активного ID(для защиты от фатальных сбоев);
if(ptr[num]->mi=='I') {if(!deviceSendi2c    (num,numChip,var,code)){return 0;}}
if(ptr[num]->mi=='i') {if(!deviceSendi2c    (num,numChip,var,code)){return 0;}}
if(ptr[num]->mi=='S') {if(!deviceSendHC595  (num,numChip,var,code)){return 0;}; ptr[num]->codeErr=0;}  
if(ptr[num]->mi=='N') {ptr[num]->codeErr=deviceSendSPN (num,numChip,var,code);}
if(ptr[num]->mi=='4') {ptr[num]->codeErr=deviceSendBus4(num,numChip,var,code);}
if(ptr[num]->mi=='8') {ptr[num]->codeErr=deviceSendBus8(num,numChip,var,code);}
//-------------------------------------------------------------------------------------------------
if(time>0){delayMicroseconds(time);}
return 1;
};	//++++END deviceSend()=========================================================================
void    deviceSendPrepare(uint8_t num, uint8_t numChip, uint8_t var, char code){	//++++Подготовка массива для отправки
if(code=='D'){ptr[num]->cmnd=1;} else{ptr[num]->cmnd=0;}//--Запись флага cmnd;
if(numChip==1){ptr[num]->bitE=RT_HW_LCD44780_BIT_E;} 	//--Выбор номера бита E для Lcd c одним chip;
else 		  {ptr[num]->bitE=RT_HW_LCD44780_BIT_RW;}	//--Выбор номера бита E для Lcd c двумя chips;
ptr[num]->buffSend=(var & 0xf0); 						//--Подготовка битов 7-4 для записи в Lcd;	
//-------------------------------------------------------------------------------------------------
if(code!='T'){
bitWrite(ptr[num]->buffSend,RT_HW_LCD44780_BIT_RS, ptr[num]->cmnd);	//--Установка бита команды (RS Lcd);
bitWrite(ptr[num]->buffSend,RT_HW_LCD44780_BIT_ON, ptr[num]->extLight);//--Установка пина подсветки;	
bitSet  (ptr[num]->buffSend,ptr[num]->bitE); ptr[num]->arrSend[0] = ptr[num]->buffSend; 					//--Запись байта с установленным битом E для соответствующего чипа;
bitClear(ptr[num]->buffSend,ptr[num]->bitE); ptr[num]->arrSend[1] = ptr[num]->buffSend;}	 				//--Запись байта с сброшенным    битом E для соответствующего чипа;
//-------------------------------------------------------------------------------------------------
ptr[num]->buffSend=var<<4;											//--Подготовка битов 3-0 для записи в Lcd;	
bitWrite(ptr[num]->buffSend,RT_HW_LCD44780_BIT_RS, ptr[num]->cmnd);	//--Установка бита команды (RS Lcd);
bitWrite(ptr[num]->buffSend,RT_HW_LCD44780_BIT_ON, ptr[num]->extLight);//--Установка пина подсветки;	
bitSet  (ptr[num]->buffSend,ptr[num]->bitE); ptr[num]->arrSend[2] = ptr[num]->buffSend; 					//--Запись байта с установленным битом E для соответствующего чипа;
bitClear(ptr[num]->buffSend,ptr[num]->bitE); ptr[num]->arrSend[3] = ptr[num]->buffSend; 					//--Запись байта с сброшенным    битом E для соответствующего чипа;	
};	//++++END deviceTypeOne()=======================================================================
void    deviceTypeOne    (uint8_t num, uint8_t numChip, uint8_t var, char code, uint8_t *arr){//++++Подготовка массива для отправки
static uint8_t buff, bitE; 								//--Временные переменные;
//-------------------------------------------------------------------------------------------------
if(code=='D'){ptr[num]->cmnd=1;} else{ptr[num]->cmnd=0;}//--Запись флага cmnd;
if(numChip==1){bitE=RT_HW_LCD44780_BIT_E;} 				//--Выбор номера бита E для Lcd c одним chip;
else 		  {bitE=RT_HW_LCD44780_BIT_RW;}				//--Выбор номера бита E для Lcd c двумя chips;
buff=(var & 0xf0); 										//--Подготовка битов 7-4 для записи в Lcd;	
//-------------------------------------------------------------------------------------------------
if(code!='T'){
bitWrite(buff,RT_HW_LCD44780_BIT_RS, ptr[num]->cmnd);	//--Установка бита команды (RS Lcd);
bitWrite(buff,RT_HW_LCD44780_BIT_ON, ptr[num]->extLight);//--Установка пина подсветки;	
bitSet  (buff,bitE); arr[0] = buff; 					//--Запись байта с установленным битом E для соответствующего чипа;
bitClear(buff,bitE); arr[1] = buff;}	 				//--Запись байта с сброшенным    битом E для соответствующего чипа;
//-------------------------------------------------------------------------------------------------
buff=var<<4;											//--Подготовка битов 3-0 для записи в Lcd;	
bitWrite(buff,RT_HW_LCD44780_BIT_RS, ptr[num]->cmnd);	//--Установка бита команды (RS Lcd);
bitWrite(buff,RT_HW_LCD44780_BIT_ON, ptr[num]->extLight);//--Установка пина подсветки;	
bitSet  (buff,bitE); arr[2] = buff; 					//--Запись байта с установленным битом E для соответствующего чипа;
bitClear(buff,bitE); arr[3] = buff; 					//--Запись байта с сброшенным    битом E для соответствующего чипа;	
};	//++++END deviceTypeOne()=======================================================================
uint8_t deviceSendi2c    (uint8_t num, uint8_t numChip, uint8_t var, char code){	//++++Функция отправки байта/инструкции в i2c
deviceSendPrepare(num,numChip,var,code); 
if(code!='T'){if(!RT_HW_Base.i2cSendBytes(ptr[num]->codeErr,&ptr[num]->arrSend[0], 4, ptr[num]->adr, ptr[num]->bus, ptr[num]->speed)){return 0;};} //	ptr[num]->codeErr=RT_HW_Base.i2cGetCodeErr(ptr[num]->bus);}
else         {if(!RT_HW_Base.i2cSendBytes(ptr[num]->codeErr,&ptr[num]->arrSend[2], 2, ptr[num]->adr, ptr[num]->bus, ptr[num]->speed)){return 0;};} //	ptr[num]->codeErr=RT_HW_Base.i2cGetCodeErr(ptr[num]->bus);}
return 1;
};	//++++END deviceSendI2()=======================================================================
uint8_t deviceSendHC595  (uint8_t num, uint8_t numChip, uint8_t var, char code){	//++++Функция отправки байта/инструкции в SPI
deviceSendPrepare(num,numChip,var,code); 
//SPIhc595  (uint8_t bitOrder, uint8_t  tx, uint8_t cs, uint8_t bus, uint32_t speed=0)
if(code!='T'){RT_HW_Base.SPIhc595(1,ptr[num]->arrSend[0],ptr[num]->cs,ptr[num]->bus,ptr[num]->speed);
			  RT_HW_Base.SPIhc595(1,ptr[num]->arrSend[1],ptr[num]->cs,ptr[num]->bus,ptr[num]->speed);
			 } 
			  RT_HW_Base.SPIhc595(1,ptr[num]->arrSend[2],ptr[num]->cs,ptr[num]->bus,ptr[num]->speed);
			  RT_HW_Base.SPIhc595(1,ptr[num]->arrSend[3],ptr[num]->cs,ptr[num]->bus,ptr[num]->speed);
return 1;
};	//++++END deviceSendSPI()======================================================================
uint8_t deviceSendSPN    (uint8_t num, uint8_t numChip, uint8_t val, char code){	//++++Функция отправки байта/инструкции в SPN без контроля mis0;
static uint8_t  arr[4]; 
deviceTypeOne(num,numChip,val,code,arr);//--Получение данных в массив arr;
if(code!='T'){writeSPN(num,arr[0]);  writeSPN(num,arr[1]);} 
			  writeSPN(num,arr[2]);  writeSPN(num,arr[3]);				
return 0;
};	//++++END deviceSendSPN()=====================================================================
uint8_t deviceSendBus4   (uint8_t num, uint8_t numChip, uint8_t val, char code){	//++++Функция отправки байта/инструкции в BUS4
RT_HW_PIN_DIR_ID idPin; 
uint8_t pinEN; 
if(numChip==1){pinEN=ptr[num]->pin[2];} else {pinEN=ptr[num]->pin[1];} if(pinEN==255){return 0;} 
uint8_t cmnd=0; if(code=='D') {cmnd=1;} 
						  RT_HW_PIN_DIR_SET_ID(idPin,ptr[num]->pin[0]);    RT_HW_PIN_DIR_WRITE(idPin,cmnd); //--Запись на пин RS;
if(ptr[num]->pin[1]!=255){RT_HW_PIN_DIR_SET_ID(idPin,ptr[num]->pin[1]);    RT_HW_PIN_DIR_WRITE_LOW(idPin);} //--Сброс пина RW;
					      RT_HW_PIN_DIR_SET_ID(idPin,ptr[num]->pin[2]);    RT_HW_PIN_DIR_WRITE_LOW(idPin);  //--Сброс пина E;
if(code!='T'){
for(uint8_t i=0; i<4;i++){RT_HW_PIN_DIR_SET_ID(idPin, ptr[num]->pin[7+i]); RT_HW_PIN_DIR_WRITE(idPin,bitRead(val,(4+i)));}		
                          RT_HW_PIN_DIR_SET_ID(idPin, pinEN);              RT_HW_PIN_DIR_WRITE_HIGH(idPin);  RT_HW_PIN_DIR_WRITE_LOW(idPin);}	//--Строб записи пином pinEN;
for(uint8_t i=0; i<4;i++){RT_HW_PIN_DIR_SET_ID(idPin, ptr[num]->pin[7+i]); RT_HW_PIN_DIR_WRITE(idPin,bitRead(val,(i)));}
                          RT_HW_PIN_DIR_SET_ID(idPin, pinEN);              RT_HW_PIN_DIR_WRITE_HIGH(idPin);  RT_HW_PIN_DIR_WRITE_LOW(idPin);	 //--Строб записи пином pinEN;												
//-------------------------------------------------------------------------------------------------
return 0;
};	//++++END deviceSendSPI()====================================================================== 
uint8_t deviceSendBus8   (uint8_t num, uint8_t numChip, uint8_t val, char code){	//++++Функция отправки байта/инструкции в BUS8
RT_HW_PIN_DIR_ID idPin; 
uint8_t pinEN; 
if(numChip==1){pinEN=ptr[num]->pin[2];}   else{pinEN=ptr[num]->pin[1];} if(pinEN==255){return 0;} 
uint8_t cmnd=0; if(code=='D') {cmnd=1;} 
						  RT_HW_PIN_DIR_SET_ID(idPin,ptr[num]->pin[0]);   RT_HW_PIN_DIR_WRITE(idPin,cmnd); //--Запись на пин RS;
if(ptr[num]->pin[1]!=255){RT_HW_PIN_DIR_SET_ID(idPin,ptr[num]->pin[1]);   RT_HW_PIN_DIR_WRITE_LOW(idPin);} //--Сброс пина RW;
					      RT_HW_PIN_DIR_SET_ID(idPin,ptr[num]->pin[2]);   RT_HW_PIN_DIR_WRITE_LOW(idPin);  //--Сброс пина E;
for(uint8_t i=0;i<8;i++) {RT_HW_PIN_DIR_SET_ID(idPin,ptr[num]->pin[3+i]); RT_HW_PIN_DIR_WRITE(idPin,bitRead(val,i));}//--Запись на пины D0-D7;
                          RT_HW_PIN_DIR_SET_ID(idPin,pinEN);              RT_HW_PIN_DIR_WRITE_HIGH(idPin);  RT_HW_PIN_DIR_WRITE_LOW(idPin);	//--Строб записи пином pinEN;
//-------------------------------------------------------------------------------------------------
return 0;
};	//++++END deviceSendBUS8()======================================================================
//=================================================================================================
//				  ИНИЦИАЛИЗАЦИЯ ШИН СВЯЗИ(i2c,SPI,BUS4,BUS8) И ЧИПАМИ HD44780
//=================================================================================================
uint8_t initBUS	    (RT_HW_LCD44780_DEVICE_ID &z){	//++++Инициализация шины по её типа =z.mode====
if(z.mi=='I')	{return initBUS_i2c(z);} //--i2c.PCF8574;
if(z.mi=='i')	{return initBUS_i2c(z);} //--i2c.PCF8575;
if(z.mi=='S')	{return initBUS_SPI(z);} //--SPI;
if(z.mi=='N')	{return initBUS_SPN(z);} //--SPN;
if(z.mi=='4')	{return initBUS_Bus(z);} //--Bus4;
if(z.mi=='8')	{return initBUS_Bus(z);} //--Bus8;
z.codeErr=90; //--Код ошибки по несуществующему интерфейсу;
return 1;
};	//++++END initBUS()============================================================================
uint8_t initBUS_i2c (RT_HW_LCD44780_DEVICE_ID &z){	//++++Инициализация i2c ->adr,bus==============
if(!RT_HW_Base.i2cInitDevice(z.codeErr,z.adr,z.bus)){return 0;}
return 1;
};	//++++END initBUS_i2c()========================================================================
uint8_t initBUS_SPI (RT_HW_LCD44780_DEVICE_ID &z){	//++++Инициализация SPI ->cs,bus===============
return RT_HW_Base.SPIinitDevice(z.codeErr,z.cs,z.bus);
};	//++++END initSPI()============================================================================
uint8_t initBUS_SPN (RT_HW_LCD44780_DEVICE_ID &z){	//++++Инициализация SPN ->scl,mosi,cs==========
RT_HW_Base.SPNinitBus(z.spn, z.codeErr, z.sck, z.miso, z.mosi, z.cs, z.speed);	
if(z.spn.status==1){z.codeErr=0;} else {z.codeErr=70;}
return 1;
};	//++++END initSPI()============================================================================
uint8_t initBUS_Bus (RT_HW_LCD44780_DEVICE_ID &z){	//++++Инициализация BUS4 или BUS8 ->RS,RW,E,D0-D8
//-------------------------------------------------------------------------------------------------
//for(uint8_t i=0; i<11; i++){RT_HW_Base.consoleVar(z.pin[i],' ','U');} RT_HW_Base.consoleCR();

if(RT_HW_Base.checkPinPGM(RT_HW_PGM_PIN_DOT_ID,z.pin[0])) {digitalWrite(z.pin[0],0); pinMode(z.pin[0],OUTPUT);} else{return (60);}	//--Выход, если недоступный пин RS;
if(RT_HW_Base.checkPinPGM(RT_HW_PGM_PIN_DOT_ID,z.pin[1])) {digitalWrite(z.pin[1],0); pinMode(z.pin[1],OUTPUT);}						//--Выход, если недоступный пин RW;
if(RT_HW_Base.checkPinPGM(RT_HW_PGM_PIN_DOT_ID,z.pin[2])) {digitalWrite(z.pin[2],0); pinMode(z.pin[2],OUTPUT);} else{return (62);}	//--Выход, если недоступный пин RS;
//-------------------------------------------------------------------------------------------------
if(z.mi=='4') {
for(uint8_t i=0; i<4; i++){														//--Перебор используемых пинов;
if(!RT_HW_Base.checkPinPGM(RT_HW_PGM_PIN_DOT_ID,z.pin[i+7])) {return (66+i);}	//--Выход, если недоступный пин; 
digitalWrite(z.pin[i+7],0); pinMode(z.pin[i+7],OUTPUT);}						//--Настройка пина на выход с установленным 0;
} 
else{
//-------------------------------------------------------------------------------------------------
for(uint8_t i=0; i<8; i++){												//--Перебор используемых пинов;
if(!RT_HW_Base.checkPinPGM(RT_HW_PGM_PIN_DOT_ID,z.pin[i+3])) {return (70+i);}	//--Выход, если недоступный пин; 
digitalWrite(z.pin[i+3],0); pinMode(z.pin[i+3],OUTPUT);}						//--Настройка пина на выход с установленным 0;
//-------------------------------------------------------------------------------------------------
}	
//-------------------------------------------------------------------------------------------------
return 0;
};	//++++END initBUS()============================================================================
uint8_t initHD44780 (RT_HW_LCD44780_DEVICE_ID &z){	//++++Инициализация связи с чипами HD44780=====
if(z.stepInit==0) {	//==Выбор проверки связи устройства(для i2c,SPI)-------------------------------
 z.cntErr=0; z.cntFind=0; 
 z.stepInit=10;
 if(z.mi=='I'){z.stepInit=2;}  			//--Поиск на шине i2c.8;	
 if(z.mi=='i'){z.stepInit=2;}  			//--Поиск на шине i2c.16;	
}	//---------------------------------------------------------------------------------------------
if(z.stepInit==2) {	//==Настройка i2c--------------------------------------------------------------
 if(!RT_HW_Base.i2cFindAdr(z.codeErr,z.adr,z.bus,z.speed))        {return 0;}; //--Проверка наличия адреса на i2c;	    
 z.sizeDelay=50;      z.pointDelay=2;
 if(!z.codeErr){z.cntErr=0;  if(++z.cntFind>6) {z.stepInit=10;} else{z.stepInit=70;}} //--10-ти кратное повторение при обнаружения устройства; 
 else          {z.cntFind=0;                                         z.stepInit=65;}  //--По ошибке переход на динамическую задержку; 
return 0;
}	//---------------------------------------------------------------------------------------------
if(z.stepInit==10){	//==Выбор типа шины (4 или 8 бит)----------------------------------------------
 z.index=0; 
 z.stepInit=20;						//--Шаг для инициализации 4-х  битной шины;
 if(z.mi=='i'){z.stepInit=30;}		//--Шаг для инициализации 8-ми битной шины; 
 if(z.mi=='8'){z.stepInit=30;}		//--Шаг для инициализации 8-ми битной шины;  
}	//---------------------------------------------------------------------------------------------
if(z.stepInit==20){	//==4-x  битная шина данных, Lcd для 1-го чипа--------------------------------- 
 if(!deviceSend(z.num, 1,													//--Вывод в 1-й чип; 					
       pgm_read_byte(RT_HW_LCD44780_INIT_BUS4+(z.index*3)),					//--Выводимое значение;
 (char)pgm_read_byte(RT_HW_LCD44780_INIT_BUS4+(z.index*3+1)),				//--Тип посылки(I-инструкция,D-данные,T-тетрада) 
	   pgm_read_byte(RT_HW_LCD44780_INIT_BUS4+(z.index*3+2))*100)){return 0;}//-Время задержки;		
 if(++z.index<=13) {return 0;} 												//--Последовательная передача 13 значений; 
 if(z.chip==2){z.index=0; z.stepInit=22; return 0;}							//--Продолжение, если LCD c двумя чипами;
 else		  {z.index=0; z.stepInit=0;  return 1;} 						//--Выход для Lcd с 1-м чипом;
}	//---------------------------------------------------------------------------------------------
if(z.stepInit==22){	//==4-x  битная шина данных, Lcd для 2-го чипа--------------------------------- 
 if(!deviceSend(z.num, 2,													//--Вывод во 2-й чип; 					
	   pgm_read_byte(RT_HW_LCD44780_INIT_BUS4+(z.index*3)),					//--Выводимое значение;
 (char)pgm_read_byte(RT_HW_LCD44780_INIT_BUS4+(z.index*3+1)),				//--Код ('I','D','T') 
	   pgm_read_byte(RT_HW_LCD44780_INIT_BUS4+(z.index*3+2))*100)){return 0;}//--Время задержки;		
  if(++z.index<=13)       {return 0;} 										//--Последовательная передача 13 значений;
z.index=0; z.stepInit=0;   return 1;											//--Выход для Lcd с 2-мя чипами;
}	//---------------------------------------------------------------------------------------------
if(z.stepInit==30){	//==8-ми битная шина данных, Lcd для 1-го чипа--------------------------------- 
 if(!deviceSend(z.num, 1,													//--Вывод в  1-й чип; 	
	   pgm_read_byte(RT_HW_LCD44780_INIT_BUS8+(z.index*3)),					//--Выводимое значение;
 (char)pgm_read_byte(RT_HW_LCD44780_INIT_BUS8+(z.index*3+1)),				//--Тип посылки(I-инструкция,D-данные,T-тетрада);
	   pgm_read_byte(RT_HW_LCD44780_INIT_BUS8+(z.index*3+2))*100)){return 0;}//-Время задержки;	
 if(++z.index<13){return 0;} 												//--Последовательная передача 13 значений; 	
 if(z.chip==2){z.index=0; z.stepInit=22; return 0;}							//--Продолжение, если LCD c двумя чипами;
 else		  {z.index=0; z.stepInit=0;  return 1;} 						//--Выход для Lcd с 2-мя чипами;
}	//---------------------------------------------------------------------------------------------
if(z.stepInit==32){	//==8-ми битная шина данных, Lcd для 2-го чипа---------------------------------
if(!deviceSend(z.num, 2,													//--Вывод во 2-й чип; 					
	   pgm_read_byte(RT_HW_LCD44780_INIT_BUS8+(z.index*3)),					//--Выводимое значение;
 (char)pgm_read_byte(RT_HW_LCD44780_INIT_BUS8+(z.index*3+1)),				//--Тип посылки(I-инструкция,D-данные,T-тетрада);
	   pgm_read_byte(RT_HW_LCD44780_INIT_BUS8+(z.index*3+2))*100)){return 0;}//-Время задержки;	
 if(++z.index<=13)       {return 0;} 										//--Последовательная передача 13 значений;
 z.index=0; z.stepInit=0; return 1;										//--Выход для Lcd с 2-мя чипами;	
} //-----------------------------------------------------------------------------------------------
if(z.stepInit==65){if(++z.cntErr>6){z.cntErr=6;} z.sizeDelay=z.cntErr*z.cntErr*z.sizeDelay;   z.stepInit=70;} //--Динамическая задержка;
if(z.stepInit==70){if(!RT_HW_Base.timeDelay(z.startDelay,z.workDelay,z.sizeDelay)){return 0;} z.stepInit=z.pointDelay; return 0;} //--Фиксированная задержка;
return 0;};	//++++END initLcd()====================================================================
//=================================================================================================
//									УПРАВЛЕНИЕ ДИСПЛЕЕМ
//=================================================================================================
void clearDeviceID       (RT_HW_LCD44780_DEVICE_ID &z){	//+++Очистка вектора управления lcd (для функции iniDeviceID)
z.meanderTick =z.meanderSec =z.meanderMin =1;	
z.cntTickSec=z.cntSecMin=z.cntReboot=z.cntWatchDogBusy=0; //--Очистка счетчиков;
z.codeErr=0;
z.busy=1; 							//--Подготовка регистров;
z.runReboot=z.readyDevice=0;
//z.modeData=z.modeOrder=z.modeRW=z.modeFind=0;	
//-------------------------------------------------------------------------------------------------
z.agoEN=0; z.extEN=1;				//--Флаг  для параметра EN;
z.extLight=1;						//--Флаги для параметра Light;
z.agoClear=0; z.extClear=0;			//--Флаги для параметра Clear;
z.agoReset=z.extReset=z.runReset=0;	//--Флаги для параметра Reboot;	
z.codeErr=0; 						//--Очистка кода ошибок;
z.runReset=0;						//--Очистка параметров перезапуска Lcd; 
z.buff16=z.index=z.stepInit=0; 		//--Подготовка регистров;
z.cntErr=z.cntFind=0;
for(z.arrIdx=0;z.arrIdx < RT_HW_LCD44780_MAX_COLS; z.arrIdx++){z.arrData[z.arrIdx]=RT_HW_LCD44780_CODE_BLANK;} //--Очистка массива;
};	//++++END clearDeviceID()======================================================================
void initDeviceID        (RT_HW_LCD44780_DEVICE_ID &z){	//+++Инициализация вектора управления lcd (базовая функция)
if(z.custom!=0){return;}; z.custom=1;		//--Выход, если ID уже настроен;					
//----Выбор свободного номера (1-15) указателя-----------------------------------------------------
if(hive.qnt>15)						  {z.codeErr=50; return;}	//--Выход по превышению макс. уже настроенных устройств;
if(hive.qnt>RT_HW_LCD44780_MAX_DEVICE){z.codeErr=51; return;}	//--Выход по превышению макс. разрешенных устройств;
z.num=RT_HW_Base.setFistFreeDevice(hive.set,RT_HW_LCD44780_MAX_DEVICE); //--Получение номера устройства;
if(z.num==0) 					      {z.codeErr=52; return;}	//--Выход, если все номера оказались заняты;							
hive.qnt++;														//--Увеличение кол-ва занятых устройств;
setPointID(&z);													//--Установка адреса указателя
clearDeviceID(z);												//--Очистка регистров;
z.modeData=z.modeOrder=z.modeRW=z.modeFind=0;	
//-------------------------------------------------------------------------------------------------
if(z.mi=='I'){z.modeFind=1;                if(z.speed==0){z.speed=RT_HW_I2C_SPEED;}}	//--i2c.PCF8574---->RS,RW,E,Light,D4-D7;
if(z.mi=='i'){z.modeFind=1; z.modeData=1;  if(z.speed==0){z.speed=RT_HW_I2C_SPEED;}}	//--i2c.PCF8575--->PA: RS,RW,E,light;  PB:D0-D7;
if(z.mi=='S'){z.modeFind=2;                if(z.speed==0){z.speed=RT_HW_SPI_SPEED;}} 	//--SPI.74HC595--->RS,RW,E,Light,D4-D7;	[Hard SPI]
if((z.mi=='N')||(z.mi=='4')||(z.mi=='8')){												//--SPN,BUS4,BUS8;
	if((z.speed==0) || (z.speed>100)) {z.timeSpeed=0;} else {z.timeSpeed=(100-z.speed)/10;}}
//--------------------------------------------------------------------------------------------------
if((z.cols==40) && (z.rows==4)){z.chip=2; z.modeRW=0;}  //----Установка кол-во чипов для LCD 40x4 и сброс блок.пина RW;
else                           {z.chip=1;}				    //    или установка кол-ва чипов для других дисплеев;											
//--------------------------------------------------------------------------------------------------
z.periodWatchDog=100;						//--Период сторожевого таймера(ms);
clearDeviceID(z);							//--Очистка регистров;
};	//++++END initDeviceID()=======================================================================
void initDeviceI2CPCF8574(RT_HW_LCD44780_DEVICE_ID &z,uint8_t cols, uint8_t rows, uint8_t adr, uint8_t bus=0, uint32_t speed=0){
z.adr=adr; z.bus=bus; z.mi='I'; z.cols=cols; z.rows=rows; z.speed=speed; initDeviceID(z);}	
void initDeviceI2CPCF8575(RT_HW_LCD44780_DEVICE_ID &z,uint8_t cols, uint8_t rows, uint8_t adr, uint8_t bus=0, uint32_t speed=0){
z.adr=adr; z.bus=bus; z.mi='i'; z.cols=cols; z.rows=rows; z.speed=speed; initDeviceID(z);}	
void initDeviceSPIHC595  (RT_HW_LCD44780_DEVICE_ID &z,uint8_t cols, uint8_t rows, uint8_t cs,  uint8_t bus=0, uint32_t speed=0){
z.cs=cs;   z.bus=bus; z.mi='S'; z.cols=cols; z.rows=rows; z.speed=speed; initDeviceID(z);
};	//++++END initDeviceSPI()=======================================================================	
void initDeviceSPNHC595  (RT_HW_LCD44780_DEVICE_ID &z,uint8_t cols, uint8_t rows, uint8_t sck, uint8_t mosi,  uint8_t cs, uint32_t speed=100){
z.sck=sck; z.miso=255;  z.mosi=mosi; z.cs=cs; z.mi='N'; z.cols=cols; z.rows=rows; z.speed=speed; initDeviceID(z);
};	//++++END initDeviceSPN()=======================================================================	
void initDeviceDATA4     (RT_HW_LCD44780_DEVICE_ID &z,uint8_t cols, uint8_t rows, uint8_t pRS, uint8_t pE2, uint8_t pE1,  
                                                                      uint8_t pD4, uint8_t pD5, uint8_t pD6, uint8_t pD7){
z.mi='4'; z.cols=cols; z.rows=rows; z.pin[0]=pRS; z.pin[1]=pE2; z.pin[2]=pE1;
                                                        z.pin[7]=pD4; z.pin[8]=pD5; z.pin[9]=pD6; z.pin[10]=pD7;
initDeviceID(z);
};	//++++END initDeviceDATA8()=======================================================================	
void initDeviceDATA8     (RT_HW_LCD44780_DEVICE_ID &z,uint8_t cols, uint8_t rows, uint8_t pRS, uint8_t pE2, uint8_t pE1, 
                  uint8_t pD0, uint8_t pD1, uint8_t pD2, uint8_t pD3, uint8_t pD4, uint8_t pD5, uint8_t pD6, uint8_t pD7){
z.mi='8'; z.cols=cols; z.rows=rows; z.pin[0]=pRS; z.pin[1]=pE2; z.pin[2]=pE1;
z.pin[3]=pD0; z.pin[4]=pD1; z.pin[5]=pD2; z.pin[6]=pD3; z.pin[7]=pD4; z.pin[8]=pD5; z.pin[9]=pD6; z.pin[10]=pD7;
initDeviceID(z);
};	//++++END initDeviceDATA8()=======================================================================
//-------------------------------------------------------------------------------------------------
void generatorDevice    (RT_HW_LCD44780_DEVICE_ID &z){ //++++Тактирующий генератор управлениz lcd====
z.eventTick=z.eventSec=z.eventMin=0; 					//--Очистка флагов;
if(z.num==0){z.genState=4; return;}						//--Выход если устройству не присвоен номер;
if(RT_HW_Base.periodMs(z.timeBeginGen, z.periodGen)){	//++++Периодический генератор--------------
  if(z.genState==1){z.genState=0;} else{if(z.genState==0){z.genState=1;}}  
  z.eventTick=1; z.meanderTick=!z.meanderTick;
  z.buff16=1000/z.periodGen;  
  if(++z.cntTickSec>=z.buff16){z.cntTickSec=0; z.eventSec=1; }; //--Генерация тикового   меандра, секундного события;
  if(z.eventSec){z.meanderSec=!z.meanderSec; if(++z.cntSecMin>=60){z.cntSecMin=0; z.eventMin=1;}}; //--Генерация секундного меандра, минутного  события; 
  if(z.eventMin){z.meanderMin=!z.meanderMin; if((z.periodReboot>0)&&(++z.cntReboot>=z.periodReboot)){z.cntReboot=0; z.runReboot=1;}}
//-------------Сторожевой таймер-------------------------------------------------------------------------------------------------------------
  if(z.busy){z.buff16=z.periodWatchDog/z.periodGen; if(++z.cntWatchDogBusy>z.buff16){z.cntWatchDogBusy=0; z.busy=0;}} else {z.cntWatchDogBusy=0;}}
};	//++++END generatorDevice()====================================================================

void directDevice       (RT_HW_LCD44780_DEVICE_ID &z){ //++++Управление дисплеем=====================
generatorDevice(z); //++++Тактирующий генератор----------------------------------------------------
if(z.dir==0) {	//++++Ожидание настройки параметров------------------------------------------------	
if(z.custom!=1){ return;} 
z.dir=1;
}	//---------------------------------------------------------------------------------------------
if(z.dir==1) {	//++++Инициализация коммутационной шины--------------------------------------------
initBUS(z);
if(z.codeErr==90){z.dir=2; return;} ;	
if(z.codeErr!=0) {z.dir=70; z.sizeDelay=1000; z.pointDelay=1;}   //--Возврат через фиксированную задержку 1000ms;
else 			 {z.dir=70; z.sizeDelay=400;   z.pointDelay=10;} //--Переход через фиксированную задержку   40ms; 
return;
}	//---------------------------------------------------------------------------------------------
if(z.dir==2) {	//++++Заглушка, если шину невозможно настроить;------------------------------------
return;
}	//---------------------------------------------------------------------------------------------						
if(z.dir==10){	//++++Подготовка к запуску и ожидание EN-------------------------------------------												
z.genState=2;									//--Остановка(сброс) тактирующих генераторов внешних блоков;			
if(!z.extEN) {return;}							//--Ожидание разрешения работы;
clearDeviceID(z);								//--Очистка параметров;
z.dir=12; return;
}	//---------------------------------------------------------------------------------------------				
if(z.dir==12){	//++++Инициализация дисплея--------------------------------------------------------
if(!initHD44780(z)){return;}					//--Настройка Lcd;
if(z.codeErr){z.genState=2; z.dir=10; return;}	//--Выход, если оборвалась связь;
z.busy=0; 	  z.genState=0; z.dir=20;			//--Успешный переход;
}	//---------------------------------------------------------------------------------------------
if(z.dir==20){	//++++Основной цикл управления-----------------------------------------------------
if(z.codeErr){z.genState=2;  z.dir=10;  return;}	//--Перезапуск при обрыве связи (i2c);
if(!z.extEN)  {z.genState=2; directClear(z); z.dir=10; return;}	//--Перезапуск при блокирование дисплея;
if(z.agoReset!=z.extReset){z.agoReset=z.extReset; if(z.agoReset){z.genState=2; z.dir=10; return;}} //--Перезапуск по кнопке сброс(событие)
if(z.runReset){z.genState=2; 				 z.dir=10; return;} //--Перезапуск от счетчика перезапуска(мин) генератора (при периоде перезапуска>0); 
return;
}	//-------------------------------------------------------------------------------------------------
if(z.dir==70){if(!RT_HW_Base.timeDelay(z.startDelay,z.workDelay,z.sizeDelay)){return;} z.dir=z.pointDelay; return;} //--Фиксированная задержка;
};	//++++END directDevice()=======================================================================
//=================================================================================================
//									УПРАВЛЕНИЕ ВЫВОДОМ
//=================================================================================================
uint8_t checkNum (uint8_t num){					//==Проверка доступности номера устройтсва---------
 if((num!=0) && (num<=hive.qnt)){return 1;} else{return 0;}} 		
uint8_t getBusy  (uint8_t num){					//==Проверка зaнятости устойства и если свободно, захват его;
 if(ptr[num]->busy){return 0;} ptr[num]->busy=1; return 1;}  		
void    clearBusy(uint8_t num){					//==Освобождение устройство со сбросом сторожевого таймера;
 ptr[num]->busy=0; ptr[num]->cntWatchDogBusy=0;}		       		
void    arrInit  (uint8_t num,uint8_t len=40){ 	//==Сброс и установка параметров управления массивом;
 if(len>RT_HW_LCD44780_MAX_COLS){ptr[num]->arrLen=RT_HW_LCD44780_MAX_COLS;} else{ptr[num]->arrLen=len;} //--Размер записываемого массива;
 for(ptr[num]->arrIdx=0; (ptr[num]->arrIdx) < (ptr[num]->arrLen); ptr[num]->arrIdx++){ptr[num]->arrData[ptr[num]->arrIdx]='*';} //--Заполнение массива;
 ptr[num]->arrSize=0;		//--Размер записанного массива;
 ptr[num]->arrPackCnt=0;	//--Счетчик кол-ва отправляемых значений за одну транзакцию;
 ptr[num]->arrState=0;		//--Состояние при чтении: =0 -все прочитано; =1-есть данные; =2-есть данные и передан пакет=arrReadPackMax;  
 ptr[num]->arrIdx=0;		//--Индекс текущего значения массива; 
};	//++++END arrReset()===========================================================================
void    arrClear (uint8_t num){ 				//==Сброс параметров перед началом записи  в массив;
 for(ptr[num]->arrIdx=0; (ptr[num]->arrIdx) < (ptr[num]->arrLen); ptr[num]->arrIdx++){ptr[num]->arrData[ptr[num]->arrIdx]=' ';} //--Заполнение массива;
     ptr[num]->arrIdx=0;  ptr[num]->arrDir=0;													//--Очистка индекса и номера этапа; 
};	//++++END arrClear()===========================================================================
void    arrWrite (uint8_t num, uint8_t v8){		//==Запись в массив следующего значения------------   
 if(ptr[num]->arrIdx>=RT_HW_LCD44780_MAX_COLS){return;}  	//--Выход, если массив заполнен;
 ptr[num]->arrData[ptr[num]->arrIdx]=v8; 					//--Запись текущего значения;
 ptr[num]->arrIdx++;										//--Увеличение индекса;
 ptr[num]->arrSize++;										//--Увеличение размера записываемого массива;
};	//++++END arrWrite()===========================================================================
void    arrReset (uint8_t num){					//==Сброс индекса,arrDir и счетчика пакетов--------
    ptr[num]->arrIdx=0; ptr[num]->arrPackCnt=0; ptr[num]->arrDir=0;}
void    arrRead  (uint8_t num){					//==Чтение массива---------------------------------
//if((ptr[num]->arrIdx)>ptr[num]->arrLen){ptr[num]->arrDataCur='#';                                 ptr[num]->arrState=3; return;}  //--Выход по чтению за пределами записанных данных;
ptr[num]->arrDataCur=ptr[num]->arrData[ptr[num]->arrIdx];										                                  //--Чтение очередного значения;
if((ptr[num]->arrIdx)>=ptr[num]->arrSize){                                                        ptr[num]->arrState=0; return;}  //--Выход по чтению всех данных;
ptr[num]->arrPackCnt++; if((ptr[num]->arrPackCnt)>(ptr[num]->arrPackMax)){ptr[num]->arrPackCnt=0; ptr[num]->arrState=2; return;}  //--Выход по передаче пакета;
ptr[num]->arrIdx++;																	              ptr[num]->arrState=1; return;   //--Выход для продолжения чтения;
}	//++++END arrRead()============================================================================
uint8_t arrData  (uint8_t num){					//==Получение последнего прочитанного значения-----
	return ptr[num]->arrDataCur;}			//==Чтение последнего прочитанного значения;																						
uint8_t arrState (uint8_t num){					//==Чтение слова состояния-------------------------
	return ptr[num]->arrState;}																									
uint8_t arrSend  (uint8_t num, uint8_t curChip, uint8_t vCursor){	//==Отправка массива по указанном курсору;	
 if(ptr[num]->arrDir==0){if(!deviceSend(num,curChip,vCursor,'I',RT_HW_LCD44780_TIME_CURSOR)){return 0;}  //--Вывод курсора; 
                                                                ptr[num]->arrSendOk=0; ptr[num]->arrDir++;}
 if(ptr[num]->arrDir==1){do{arrRead(num); if(arrState(num)>=3) {ptr[num]->arrSendOk=1; break;} 	//--Прочитаны все данные
                                          if(arrState(num)==0) {ptr[num]->arrSendOk=1; break;} 	//--Прочитаны все данные;
                                          if(arrState(num)==2) {ptr[num]->arrSendOk=0; break;} 	//--Очередной пакет отправлен;
                                          if(arrState(num)==1) {deviceSend(num,curChip,arrData(num),'D');}//--Отправка данных;
					       }while(1); 
						 
                         return ptr[num]->arrSendOk;}
return 1;};	//++++END arrSend()============================================================================	
//=================================================================================================
//						              		УТИЛИТЫ
//=================================================================================================
void setPointID     (RT_HW_LCD44780_DEVICE_ID *z){	//++++Установка указателя (временная функция - надо будет переделать)
if(z->num<=RT_HW_LCD44780_MAX_DEVICE)  {ptr[z->num]=z;}}
void directClear    (RT_HW_LCD44780_DEVICE_ID &z){	//++++Быстрая очистка дисплея==================
              deviceSend(z.num,1,0b00000001,'I'); delayMicroseconds(40);
if(z.chip==2){deviceSend(z.num,2,0b00000001,'I'); delayMicroseconds(40);}
};	//++++END setPointID()=========================================================================
uint8_t getCols(uint8_t code){return code/10;};					//++++Получение кол-во колонок из формата 204;
uint8_t getRows(uint8_t code){return (code-((code/10)*10));};	//++++Получение кол-во строк   из формата 204;
//=================================================================================================
void 	writeSPN  (uint8_t num, uint8_t  tx){				 
RT_HW_PIN_DIR_ID idSCK;  RT_HW_PIN_DIR_SET_ID(idSCK, ptr[num]->sck);
RT_HW_PIN_DIR_ID idMOSI; RT_HW_PIN_DIR_SET_ID(idMOSI,ptr[num]->mosi);
RT_HW_PIN_DIR_ID idCS;   RT_HW_PIN_DIR_SET_ID(idCS,  ptr[num]->cs);
static uint8_t idx;
RT_HW_PIN_DIR_WRITE_LOW(idSCK);	RT_HW_PIN_DIR_WRITE_LOW(idCS);	//--Установка SCK в LOW, установка пина CS в LOW; 											
RT_HW_DELAY(ptr[num]->timeSpeed);
//-------------------------------------------------------------------------------------------------
for(idx=0; idx<=7;idx++){											//--Побитовый ввод/вывод;
RT_HW_PIN_DIR_WRITE(idMOSI,(tx & (uint8_t)1<<(7-idx)));//--Побитовая запись переменной;
RT_HW_PIN_DIR_WRITE_LOW(idSCK);  RT_HW_DELAY(ptr[num]->timeSpeed);		//--Строб  SCK
RT_HW_PIN_DIR_WRITE_HIGH(idSCK); RT_HW_DELAY(ptr[num]->timeSpeed); 	//            с задержкой;
}																			//--END for();
//-------------------------------------------------------------------------------------------------
RT_HW_PIN_DIR_WRITE_HIGH(idCS); RT_HW_PIN_DIR_WRITE_LOW(idMOSI);		//--Установка CS,MOSI в исходное состояние;	
RT_HW_DELAY(ptr[num]->timeSpeed);
};	//++++END SPNtransfer()======================================================================= 

/*
//if(ptr[num]->mi=='H') {if(!deviceSendHC595  (num,numChip,var,code)){return 0;}; ptr[num]->codeErr=RT_HW_Base.SPIgetCodeErr(ptr[num]->bus);}
//if(ptr[num]->mi=='h') {if(!deviceSendHC595x2(num,numChip,var,code)){return 0;}; ptr[num]->codeErr=RT_HW_Base.SPIgetCodeErr(ptr[num]->bus);}

uint8_t deviceSendHC595x2(uint8_t num, uint8_t numChip, uint8_t var, char code){	//++++Функция отправки байта/инструкции в SPI
deviceSendPrepare(num,numChip,var,code); 
if(code!='T'){   RT_HW_Base.SPIhc595Check16(ptr[num]->arrSend[0],ptr[num]->cs,ptr[num]->bus,ptr[num]->speed);                   if(RT_HW_Base.SPIgetCodeErr(ptr[num]->bus)){return 1;}; 
				 RT_HW_Base.SPIhc595Check16(ptr[num]->arrSend[1],ptr[num]->cs,ptr[num]->bus,ptr[num]->speed);                   if(RT_HW_Base.SPIgetCodeErr(ptr[num]->bus)){return 1;}; 
			 } 
				 RT_HW_Base.SPIhc595Check16(ptr[num]->arrSend[2],ptr[num]->cs,ptr[num]->bus,ptr[num]->speed);                   if(RT_HW_Base.SPIgetCodeErr(ptr[num]->bus)){return 1;};
				 RT_HW_Base.SPIhc595Check16(ptr[num]->arrSend[3],ptr[num]->cs,ptr[num]->bus,ptr[num]->speed);                   if(RT_HW_Base.SPIgetCodeErr(ptr[num]->bus)){return 1;};  
return 1;
};	//++++END deviceSendSPI()======================================================================
*/