/*** FLProg ************** Библиотека RT_HW_LCD44780 ver2.1 для Arduino ***************
  Вывод на несколько LCD типа LCD44780 переменных String, char, int16_t, float в указанное место указанного дисплея.
  Если задана длина (len) выводимого сообщения, то вывод осуществляется в пределах указанной длины или до конца  строки.
  Если len=0, то вывод осуществляется до конца строк. 
  Сообщение может быть отформатировано(alig) в пределах заданной длины  влево ('L'), по центру ('C'), право ('R').
    При этом к сообщению добавляются пробелы или оно обрезается. Если alig='N' (или другой отличный символ 
	кроме 'L','C','R'), то форматирование не осуществляется. При этом надо иметь ввиду что более короткое сообщение
	не затрет предыдущее более длинное сообщение. Поэтому рекомендуется явно задавать вид форматирования или использовать
    форматирование по умолчанию, которое в библиотеке ='L' (влево).
  Имеется функция вывода мерцающего символа по указанному адресу.	
	
  Библиотеки  разрабатываются с учетом особенностей использования в системе визуального программирования FLProg.
  ecoins@mail.ru 29.09.2019г.
  Обновление 03.07.21 Добавлен режим 40 колонок х 4 строки; 
**************************************************************************************************/
#ifndef RT_HW_LCD44780_h
#define RT_HW_LCD44780_h
#define RT_HW_LCD44780_VER 		 18							//--Library version number;
#include "RT_HW_BASE.h"										//--Connecting the base library;
#include "EXT_010_LCD44780/LCD44780_01_defined.hpp"			//--defined,enum,const in PROGMEM;
#include "EXT_010_LCD44780/LCD44780_02_struct.hpp"			//--Data structures;
struct RT_HW_LCD44780_FONT{uint8_t font[8];uint16_t code;}; //--Структура для растрового изображение символа;
struct RT_HW_LCD44780_HIVE{uint16_t set=0; uint8_t qnt=0;};	//--Флаги занятости устройства;
const char RT_HW_LCD44780_headEmpty[] PROGMEM="~";			//--Пустой заголовок;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                     CONTROL CLASS LCD
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class RT_HW_LCD44780{
public:
//-------1.0.Object creation and constructor-------------------------------------------------------
RT_HW_LCD44780_HIVE 		hive;							//--General data for the work of the library;
RT_HW_LCD44780_DEVICE_ID *ptr[RT_HW_LCD44780_MAX_DEVICE+1];	//--Массив указателей на объекты данных RT_HW_LCD44780_DEVICE_ID;				
RT_HW_LCD44780_DEVICE_ID zN;								//--Data to copy to non-initialized pointers;
RT_HW_LCD44780(); 											//--Constructor;
#include "EXT_010_LCD44780/LCD44780_10_funcDevice_h.hpp"	//--API finctions direct LCD;
#include "EXT_010_LCD44780/LCD44780_20_funcLcd_h.hpp"		//--API finctions writre to LCD;	
};//==============  End of class ==================================================================
extern RT_HW_LCD44780 RT_HW_lcd44780; 						//--Creating an LCD type object
#endif
//=================================================================================================
