//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                     ПЕРЕМЕННЫЕ, ПАРАМЕТРЫ, ОБЪЕКТЫ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//============================Системные переменные=====================================================
uint32_t vSpeedMCU=0; uint16_t vSpeedSmallMCU=0; uint32_t vTimeMCU=0;  //--Переменные для скорости процессора (speedMCU=SpeedMCU/1000);
uint16_t vSystemOk, vSensorsOk;
//==============================Пины===================================================================
  uint8_t spnPinSCK =RT_HW_Base.readArrPGM(RT_HW_PGM_PIN_SPN_ID,0); //--сохранение пина SPN.sck;  
  uint8_t spnPinMISO=RT_HW_Base.readArrPGM(RT_HW_PGM_PIN_SPN_ID,1); //--сохранение пина SPN.miso;
  uint8_t spnPinMOSI=RT_HW_Base.readArrPGM(RT_HW_PGM_PIN_SPN_ID,2); //--сохранение пина SPN.mosi;  
  uint8_t spnPinCS  =RT_HW_Base.readArrPGM(RT_HW_PGM_PIN_SPN_ID,3); //--сохранение пина SPN.cs;  
  RT_HW_PIN_DIR_ID idPinControl,idPinLed,idPinBTN;                      //--Объекты для основных пинов;
  RT_HW_PIN_DIR_ID idPinADC; uint16_t vADC,vADCdrift; uint8_t vADCPrc;  //--Объекты и переменные для ADC;
  RT_HW_PIN_DIR_ID idPinPWM; uint16_t vPWM;                             //--Объекты и переменные для PWM;
  RT_HW_PIN_DIR_ID idPinDebug1,idPinDebug2,idPinDebug3;                 //--Объекты для пинов отладки; 
  RT_HW_PIN_DIR_ID idPinCS0,idPinCS1,idPinCS2,idPinCS3;                 //--Объекты для CS SPI;
  RT_HW_CHANGE_PINDI_ID  idChBTN; uint8_t vBTN; uint8_t vBTNch;         //--Объекты и переменные для обработки кнопки с защитой от дребезга;
//==============================NEXTION================================================================
//==============================Фильтры================================================================
  RT_HW_FILTER_RING_AVERAGE<uint32_t,10> filterSpeed; uint32_t vSpeedMCUF;  //--Параметры для фильтров скорости MCU;
  RT_HW_FILTER_RING_AVERAGE<uint16_t,5>  filterADC;   uint16_t vADCF;       //--Параметры для для фильтра ADC;(скользящего среднего 5-го плоядка)
  RT_HW_FILTER_MEDIAN_3    <uint16_t>    ftrSR04;     uint16_t vSR04LenF;   //--Параметры для фильтра HC-SR04(медианный 3-го порядка);
//==============================Генераторы=============================================================
//==============================Счетчики===============================================================

//==============================Генераторы+счетчики====================================================
  RT_HW_GENERATOR_EVENT_ID idGenChar;  uint8_t  cntChar=0;          char     vChar='X';  //--Для генератора символов; 
  RT_HW_GENERATOR_EVENT_ID idGenRUN8;   RT_HW_COUNTER_ID idCntRUN8;  uint8_t   genRUN8=0;   //--Для генератора бегущей "1" 0-8; 
  RT_HW_GENERATOR_EVENT_ID idGenRUN16;  RT_HW_COUNTER_ID idCntRUN16; uint16_t  genRUN16=0;  //--Для генератора бегущей "1" 0-16; 
  RT_HW_GENERATOR_EVENT_ID idGenRUN24;  RT_HW_COUNTER_ID idCntRUN24; uint32_t  genRUN24=0;  //--Для генератора бегущей "1" 0-24;   
  RT_HW_GENERATOR_EVENT_ID idGenRUN32;  RT_HW_COUNTER_ID idCntRUN32; uint32_t  genRUN32=0;  //--Для генератора бегущей "1" 0-32;   
  RT_HW_GENERATOR_EVENT_ID idGenDAC;    RT_HW_COUNTER_ID idCntDAC;   int16_t   genDAC=0;    //--Для генераторо 0-4095 DAC;

  RT_HW_GENERATOR_EVENT_ID idGenA;  RT_HW_COUNTER_ID idCntA;  uint8_t  genA=0;  //--Для генератора бегущей "1"; 
  RT_HW_GENERATOR_EVENT_ID idGenB;  RT_HW_COUNTER_ID idCntB;  uint8_t  genB=0;  //--Для генератора бегущей "1"; 
//==============================Сенсоры=========================================================================================================
//------Сенсоры i2c----------------------------------------------------------------------------------------------------------------------------- 
  RT_HW_BH1750  dvBH1750;  RT_HW_STRUCT_SHED_TASK shBH1750;                                 uint16_t vBH1750Lux;            uint8_t vBH1750ok=0;   
  RT_HW_AHTXX   dvAHTXX;   RT_HW_STRUCT_SHED_TASK shAHTXX;                                  float vAHTXXTemp,  vAHTXXHum;   uint8_t vAHTXXok;    
  RT_HW_SHT3X   dvSHT3X;   RT_HW_STRUCT_SHED_TASK shSHT3X;                                  float vSHT3XTemp, vSHT3XHum;    uint8_t vSHT3Xok=0;
  RT_HW_BMP180  dvBMP180;  RT_HW_STRUCT_SHED_TASK shBMP180Temp,shBMP180Press;               float vBMP180Temp,vBMP180Press; uint8_t vBMP180ok=0;
//------Комбинированный сенсор AHT+BMP280(i2c)-------------------------------------------------------------------------------------------------- 
  RT_HW_AHTXX   dvCMAHT;   RT_HW_STRUCT_SHED_TASK shCMAHT; float vCMTemp,vCMHum,vCMPress;  uint8_t vCMok; 
  RT_HW_BME280  dvCMBMP;  RT_HW_STRUCT_SHED_TASK shCMBMP;    
//------Сенсоры через пины----------------------------------------------------------------------------------------------------------------------
  RT_HW_STRUCT_DS1820_ID  dvDS1820;  RT_HW_ONEWIRE dvNW; RT_HW_STRUCT_SHED_TASK shDS1820;   float vDS1820Temp;              uint8_t vDS1820ok; 
//------Сенсоры SPI,SPN-------------------------------------------------------------------------------------------------------------------------
  RT_HW_STRUCT_MAX6675_ID dvMAX6675;                     RT_HW_STRUCT_SHED_TASK shMAX6675;  float vMAX6675Temp;             uint8_t vMAX6675ok;
//==============================Сенсор HC-SR04==================================================================================================
  RT_HW_STRUCT_SR04_ID    dvSR04;                        RT_HW_STRUCT_SHED_TASK shSR04;   uint16_t vSR04Len;                uint8_t vSR04ok;
  RT_HW_IRAM_ATTR void RT_HW_IRQ_SR04_handler_dvSR04(){ //++++Обработчик прерываний HC-SR04------------
  if(dvSR04.state==2) {if( RT_HW_PIN_DIR_READ(dvSR04.ddPin)){dvSR04.timeBegin=micros(); dvSR04.state=3;}}
  if(dvSR04.state==3) {if(!RT_HW_PIN_DIR_READ(dvSR04.ddPin)){dvSR04.timeEnd  =micros(); dvSR04.state=4;}}}
//=============================Расширители======================================================================================================
  RT_HW_SPIhc595   dvSPIhc595;    RT_HW_STRUCT_SHED_TASK shSPIhc595;
  RT_HW_SPIhc165   dvSPIhc165;    RT_HW_STRUCT_SHED_TASK shSPIhc165;   uint8_t vSPIhc165; 
  RT_HW_MCP4725    dvMCP4725;     RT_HW_STRUCT_SHED_TASK shMCP4725; 
//=============================Задатчики для Nextion и ModBus===================================================================================
uint8_t vNXSL1=24, vNXSL2=67, vNXBTN=0x55;  //--Задатчики для Nextion; 
uint8_t vMBSL1=34, vMBSL2=74, vMBBTN=0xAA;  //--Задатчики для ModBus;
//============================Объекты и переменные Lcd.1========================================================================================
RT_HW_LCD44780_DEVICE_ID z1; uint8_t n1; 
RT_HW_LCD44780_PARAM_ID  z1Blink, z1BTN, z1SnsOk, z1speed, z1Char, z1PWM;
RT_HW_LCD44780_PARAM_ID  z1ADC,   z1Press;                      const char z1hADC[]   PROGMEM="a=";   const char z1hPress[] PROGMEM="P=";
RT_HW_LCD44780_PARAM_ID  z1Temp,  z1Hum;                        const char z1hTemp[]  PROGMEM="T=";   const char z1hHum[]   PROGMEM="H=";
//============================Объекты и переменные Lcd.2========================================================================================
RT_HW_LCD44780_DEVICE_ID z2; uint8_t n2; 
RT_HW_LCD44780_PARAM_ID  z2Blink, z2BTN,    z2Speed, z2Str, z2Bar;     String z2vAgoStr, z2vStr="Test";
RT_HW_LCD44780_PARAM_ID  z2DsOk,  z2DsTemp, z2MaxOk, z2MaxTemp; const char z2hDs[]    PROGMEM="DT=";  const char z2hMax[]   PROGMEM="MT=";
RT_HW_LCD44780_PARAM_ID  z2HsrOk, z2HsrLen, z2BhOk,  z2BhLux;   const char z2hHsr[]   PROGMEM="HCL="; const char z2hBh[]    PROGMEM="BLx=";
RT_HW_LCD44780_PARAM_ID  z2NXSL1, z2NXSL2,  z2NXBTN;            const char z2hNXSL1[] PROGMEM="s1=";  const char z2hNXSL2[] PROGMEM="s2=";
RT_HW_LCD44780_PARAM_ID  z2MBSL1, z2MBSL2,  z2MBBTN;            const char z2hMBSL1[] PROGMEM="S1=";  const char z2hMBSL2[] PROGMEM="S2=";





//============================Вспомогательные Переменные========================================================================================
uint8_t  agoDDR=255;  uint8_t  agoSTEP=255;  uint8_t  agoRUN=255;   //--Переменные для отладки;
//==============================================================================================================================================
