//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                                     СЕНСОРЫ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

//=================================================================================================
//                                      AHTXX.i2c
//=================================================================================================
void snsAHTXX(){
if(shAHTXX.custom==0){RT_HW_Base.setTaskID(shAHTXX,2400);}  //--Настройка периодического опроса с периодом 2400ms;
if(dvAHTXX.custom==0){dvAHTXX.setParam(0x38,0,0);}          //--Настройка параметров сенсора(адрес,номер шины,скорость);
dvAHTXX.run=RT_HW_Base.directTask(shAHTXX);                 //--Чтение события запуска измерения от планировщика directTask();
dvAHTXX.direct();                                           //--Управление сенсором;
if(dvAHTXX.fresh){dvAHTXX.fresh=0; vAHTXXTemp=dvAHTXX.vTemp; vAHTXXHum=dvAHTXX.vHum; vAHTXXok=dvAHTXX.ok;} //--Обновление измеренных данных;
};
//=================================================================================================
//                                      SHT3X.i2c
//=================================================================================================
void snsSHT3X(){
if(shSHT3X.custom==0){RT_HW_Base.setTaskID(shSHT3X,2200);}  //--Настройка периодического опроса с периодом 2200ms;
if(dvSHT3X.custom==0){dvSHT3X.setParam(0x44,0,0);}          //--Настройка параметров сенсора(адрес,номер шины,скорость);
dvSHT3X.run=RT_HW_Base.directTask(shSHT3X);                 //--Чтение события запуска измерения от планировщика directTask();
dvSHT3X.direct();                                           //--Управление сенсором;
if(dvSHT3X.fresh){dvSHT3X.fresh=0; vSHT3XTemp=dvSHT3X.vTemp; vSHT3XHum=dvSHT3X.vHum; vSHT3Xok=dvSHT3X.ok;} //--Обновление измеренных данных;
};
//=================================================================================================
//                                     BH1750
//=================================================================================================
void snsBH1750(){
if(shBH1750.custom==0){RT_HW_Base.setTaskID(shBH1750,2200);}  //--Настройка периодического вызова с периодом 2200ms;
if(dvBH1750.custom==0){dvBH1750.setParam(0x23,0,0);}          //--Настройка параметров сенсора(адрес,номер шины,скорость);
dvBH1750.run=RT_HW_Base.directTask(shBH1750);                 //--Чтение события запуска измерения от планировщика directTask();
dvBH1750.direct();                                             //--Управление сенсором;
if(dvBH1750.fresh){dvBH1750.fresh=0; vBH1750Lux=dvBH1750.vLux; vBH1750ok=dvBH1750.ok;} //--Обновление измеренных данных;
};
//=================================================================================================
//                                      BMP180.i2c
//=================================================================================================
void snsBMP180(){
if(shBMP180Temp.custom==0) {RT_HW_Base.setTaskID(shBMP180Temp, 1800);} //--Настройка периодического опроса температуры с периодом 1800ms;
if(shBMP180Press.custom==0){RT_HW_Base.setTaskID(shBMP180Press,2600);} //--Настройка периодического опроса давления    с периодом 2600ms;
if(dvBMP180.custom==0){dvBMP180.setParam(0x77,0,0);}                   //--Настройка параметров сенсора по умолчанию(адрес,номер шины,скорость);
dvBMP180.runTemp= RT_HW_Base.directTask(shBMP180Temp);      //--Чтение события запуска измерения температуры от планировщика directTask();               
dvBMP180.runPress=RT_HW_Base.directTask(shBMP180Press);     //--Чтение события запуска измерения давления от планировщика directTask();   
dvBMP180.direct();                                          //--Управление сенсором;
if(dvBMP180.fresh){dvBMP180.fresh=0; vBMP180Temp=dvBMP180.vTemp; vBMP180Press=dvBMP180.vPress; vBMP180ok=dvBMP180.ok;} //--Обновление измеренных данных;
};
//=================================================================================================
//                       CMBTHP.i2c (комбинированный сенсор AHTXX(T,H)+BMP280(P)
//  RT_HW_AHTXX   dvCMAHT;   RT_HW_STRUCT_SHED_TASK shCMAHT; float vCMTemp,vCMHum,vCMPress;  uint8_t vCMok; 
//  RT_HW_BME280  dvCMBMP;  RT_HW_STRUCT_SHED_TASK shCMBMP;      
//=================================================================================================
void snsCMTHP(){
if(shCMBMP.custom==0) {RT_HW_Base.setTaskID(shCMBMP, 2600); } //--Настройка периодического опроса температуры с периодом 2600ms;
if(dvCMBMP.custom==0){dvCMBMP.setParam('I',0x77,0,0); dvCMBMP.permitHum=0; dvCMBMP.permitTemp=0;} //--Настройка параметров сенсора(i2c('I'),adr,busspeed,блокировка Hum,Temp);
//------------------
if(shCMAHT.custom==0){RT_HW_Base.setTaskID(shCMAHT,2200);}   //--Настройка периодического опроса с периодом 2200ms;
if(dvCMAHT.custom==0){dvCMAHT.setParam(0x38,0,0);}          //--Настройка параметров сенсора(адрес,номер шины,скорость);
//-----------------
dvCMBMP.runPress=RT_HW_Base.directTask(shCMBMP);            //--Чтение события запуска измерения давления    от планировщика directTask();   
dvCMBMP.direct();   
dvCMAHT.run=RT_HW_Base.directTask(shCMAHT);                 //--Чтение события запуска измерения от планировщика directTask();
dvCMAHT.direct();                                           //--Управление сенсором;
//------------------
if(dvCMAHT.fresh || dvCMBMP.fresh){ 
  dvCMAHT.fresh=dvCMBMP.fresh=0; if(dvCMAHT.ok && dvCMBMP.ok){vCMok=1;} else{vCMok=0;} 
 vCMTemp=dvCMAHT.vTemp; vCMHum=dvCMAHT.vHum; vCMPress=dvCMBMP.vPress;} //--Обновление измеренных данных;
};
//=================================================================================================
//                                      DS1820.pin через 1-Wire
//=================================================================================================
void snsDS1820(){
if(dvDS1820.custom==0){RT_HW_ds1820.setParam(dvDS1820,RT_HW_Base.device.dev.oneWBus);} //--Настройка параметров сенсора;
if(shDS1820.custom==0){RT_HW_Base.setTaskID(shDS1820,2200);} //--Настройка периодического вызова с периодом 2200ms;
dvDS1820.run=RT_HW_Base.directTask(shDS1820);                 //--Чтение события запуска измерения от планировщика directTask()
RT_HW_ds1820.direct(dvNW,dvDS1820);                         //--Управление сенсором; 
if(dvDS1820.fresh){dvDS1820.fresh=0; vDS1820Temp=dvDS1820.vTemp; vDS1820ok=dvDS1820.ok;} //--Обновление измеренных данных;
};
//=================================================================================================
//                                     MXX6675.SPI
//=================================================================================================
void snsMAX6675(){
if(dvMAX6675.custom==0){RT_HW_max6675.setParamSPI(dvMAX6675, RT_HW_Base.device.spi.cs3,0);};  
if(shMAX6675.custom==0){RT_HW_Base.setTaskID(shMAX6675,1200);} //--Настройка периодического вызова с периодом 1200ms;                        
dvMAX6675.run=RT_HW_Base.directTask(shMAX6675);                //--Чтение события запуска измерения от планировщика directTask()                      
RT_HW_max6675.direct(dvMAX6675);                                            
if(dvMAX6675.fresh){dvMAX6675.fresh=0; vMAX6675Temp=dvMAX6675.vTemp; vMAX6675ok=dvMAX6675.ok;}
};
//=================================================================================================
//                                      HC-SR04.pinTrig(Echo соединен с Trig через R=470 Ом)
//=================================================================================================
void snsSR04(){
if(dvSR04.custom==0){dvSR04.custom=1; dvSR04.extPinTrig=RT_HW_Base.device.dev.srTrig;; dvSR04.maxLen=400;} //--Настройка параметров сенсора;
if(shSR04.custom==0){RT_HW_Base.setTaskID(shSR04,75,25);}        //--Настройка периодического вызова с периодом 75ms;
dvSR04.run=RT_HW_Base.directTask(shSR04);                       //--Чтение события запуска измерения от планировщика directTask();
RT_HW_sr04.direct(dvSR04);                                     //--Управление сенсором;
if(dvSR04.state==1) {dvSR04.state++;  attachInterrupt(dvSR04.numIRQ, RT_HW_IRQ_SR04_handler_dvSR04,CHANGE);}
if(dvSR04.fresh){dvSR04.fresh=0; dvSR04.LenMcs=ftrSR04.filtered(dvSR04.echoMcs); 
                 dvSR04.Len=round(dvSR04.LenMcs * dvSR04.speedSoundAir/10.0) ;  if(dvSR04.Len>dvSR04.maxLen){dvSR04.Len=dvSR04.maxLen;}
                 vSR04Len=dvSR04.Len;  vSR04ok=dvSR04.ok;} //--Обновление измеренных данных;
};
//=================================================================================================
