//===================================================================================================
//    ТЕСТ (ДЛЯ РАЗЛИЧНЫХ ПЛАТ) ПЛАТЫ,LCD i2c.16x2, i2c.20x4, SPI.20x4, сенсоры, расширители
// (для настройки IDE для работы с многими платами читать в тесте TEST_Board_v02 вкладкe Readme.hpp)
//===================================================================================================
#include "RT_HW_BASE.h"   
#include "RT_HW_NEXT.h"
#include "RT_HW_LCD44780.h"
#include "RT_HW_SENSORS.h" 
#include "RT_HW_EXTENDERS.h" 
//---------------------------------------------------------------------------------------------------
#include "Next_Aobj.hpp"     //--Объектов,переменных,констант для дисплея Nextion;
#include "Next_Bfunc.hpp"    //--Функции для дисплея Nextion;
//---------------------------------------------------------------------------------------------------
#include "Aobj.hpp"     //--Объектов,переменных,констант;
#include "Bfunc.hpp"    //--Функции;
#include "Csns.hpp"     //--Сенсоры;
#include "Dext.hpp"     //--Расширители ввода-вывода;
#include "Lcd1.hpp"     //--Дисплей 1(16x2,i2c);
#include "Lcd2.hpp"     //--Дисплей 2(20x4,i2c);
//----------------------------------------------------------------------------------------------------
void setup(){}
//---------------------------------------------------------------------------------------------------
void loop(){
RT_HW_Base.sheduler();
if(RT_HW_Base.shed.eventSec){vSpeedMCU=RT_HW_Base.shed.cycle; vSpeedMCUF=filterSpeed.filtered(vSpeedMCU); vSpeedSmallMCU=round(((float)vSpeedMCUF)/1000);} //--Получение быстродействия MCU;
RT_HW_Base.consoleBegin(); consoleHead();                                                          //--Инициализация консоли и вывод заголовков;
RT_HW_Base.pinDigitalWrite(idPinControl,RT_HW_Base.device.pin.control,RT_HW_Base.shed.control);    //--Вывод loop() на контрольный пин;
RT_HW_Base.pinDigitalWrite(idPinLed,    RT_HW_Base.device.pin.led,    RT_HW_Base.shed.blink500);   //--Вывод меандра 500ms на Led;  
//=====================ПИНЫ========================================================================
if(RT_HW_Base.shed.fast.num==2){vAnalog();}       //--Чтение ADC,запись PWM [Быстрая задача, период 100ms, так как ADC на AVR не быстрый); 
if(RT_HW_Base.shed.frdm.num==4){getButton();}     //--Чтение кнопки с защитой от дребезга;
if(RT_HW_Base.shed.frdm.num==6){generatorVar();}  //--Генератор тестовых значений;
//=====================ДИСПЛЕИ NEXTION=========================================================
if(RT_HW_Base.shed.frdm.num==10){
  nxtDirect(2);                               //--Настройка Nextion на UART=2;
  nxtSendINxx(nxtSend1,0,vSystemOk);          //--Вывод "Системные флаги";
  nxtSendINxx(nxtSend2,2,vSpeedMCUF);         //--Вывод "Быстродействие отфильтованное";
  nxtSendINxx(nxtSend3,3,vSpeedSmallMCU);     //--Вывод "Быстродействие отфильтрованное/1000 с округлением в большую сторону";
  nxtSendINxx(nxtSend4,4,vTimeMCU);           //--Вывод "Время наработки";
  nxtSendINxx(nxtSend5,8,vSensorsOk);         //--Вывод "Флаги ok сенсоров и расширителей";
  nxtSendINxx(nxtSend6,10,genRUN8);           //--Вывод "Бегущая "1" на 8-светодиодов";
  nxtSendINxx(nxtSend7,11,genRUN8);           //--Вывод "Счетчик cnt"; 
  nxtSendINxx(nxtSend8,12,vADCF);             //--Вывод "ADC отфильтрованное";
  nxtSendINxx(nxtSend9,13,genDAC);            //--Вывод "Счетчик 0-4095,Trian";
  nxtSendINxxFloat(nxtSend10,30,vCMTemp);     //--Вывод "AHTxx.Temp";    
  nxtSendINxxFloat(nxtSend11,31,vCMHum);      //--Вывод "AHTxx.Hum";   
  nxtSendINxxFloat(nxtSend12,32,vDS1820Temp); //--Вывод "DS1820.Temp";    
  nxtSendINxx     (nxtSend13,33,vSR04Len);    //--Вывод "HC-SR04.Len";  
  nxtSendINxxFloat(nxtSend14,34,vMAX6675Temp);//--Вывод "MAX6675.Temp";    
  nxtSendINxx     (nxtSend15,35,vBH1750Lux);  //--Вывод "BH1750.Len";  
  nxtSendINxxFloat(nxtSend16,36,vCMPress);    //--Вывод "BMP280.Press";    
  nxtSendINxxFloat(nxtSend17,37,vSHT3XTemp);  //--Вывод "SHTxx.Temp";     
  nxtSendINxxFloat(nxtSend18,38,vSHT3XHum);   //--Вывод "SHT3x.Hum"; 
}
//=====================ДИСПЛЕИ LCD HD44780=========================================================
if(RT_HW_Base.shed.frdm.num==40){Lcd1();}               //--Управление дисплеем 1(16x2,i2c,0x27);
if(RT_HW_Base.shed.frdm.num==44){Lcd2();}               //--Управление дисплеем 2(20x4,i2c,0x3E);
//=====================СЕНСОРЫ i2c=================================================================
//if(RT_HW_Base.shed.frdm.num==10){snsAHTXX();}         //--Управление сенсором AHTXX;
if(RT_HW_Base.shed.frdm.num==10){snsCMTHP();}           //--Управление сенсором AHTXX(T,H) и BMP280(P);
if(RT_HW_Base.shed.frdm.num==12){snsSHT3X();}           //--Управление сенсором SHT3X;
if(RT_HW_Base.shed.frdm.num==20){snsBH1750();}          //--Управление сенсором BH1750;  
//=====================СЕНСОРЫ SPI,SPN=============================================================
if(RT_HW_Base.shed.frdm.num==22){snsMAX6675();}         //--Управление сенсором MAX6675.SPI;  
//=====================СЕНСОРЫ через пины==========================================================  
if(RT_HW_Base.shed.frdm.num==28){snsDS1820();}          //--Управление сенсором DS1820 (по шине 1-Wire);  
if(RT_HW_Base.shed.frdm.num==30){snsSR04();}            //--Управление сенсором HC-SR04 (по прерываниям);  
//=====================РАСШИРИТЕЛИ i2c=============================================================
if(RT_HW_Base.shed.frdm.num==32){extMCP4725(genDAC);} //--Вывод DAC MCP4725;
//=====================РАСШИРИТЕЛИ SPI,SPN=========================================================
if(RT_HW_Base.shed.frdm.num==36){extSPIhc595(genRUN8);} //--74HC595,бегущая "1";
if(RT_HW_Base.shed.frdm.num==38){extSPIhc165();}        //--74HC595,бегущая "1";
//=================================================================================================            
//-------------------------------------------------------------------------------------------------  
}; //++++END loop()================================================================================
//--------------------------------------------------------------------------
