/*
//=================================================================================================
//					Прием транзакций из Nextion 
// Транзакции принмаются в фоновом режиме.
// Формат транзакций для данных(uint8_t):head=0x3A; func-функции приема-0x6,0x16,0x26,0x36,0x46 в массив prt. 
// Формат транзакции для номера страницы: 0x66 page 0xFF 0xFF 0xFF
//=================================================================================================
void getFromNxt(RT_HW_STRUCT_NEXT_DEVICE &z){
//-------------------------------------------------------------------------------------------------
//				Очистка параметов 
//-------------------------------------------------------------------------------------------------
if(z.step==0) {z.index=z.codeErr=z.step=0;	 
               for(uint8_t i=0; i<RT_HW_NEXT_BUFF_REG_SIZE; i++){z.buff[i]=0;}	//--Clearing buff;
			   z.step++; return;}												//--goto next step;
//-------------------------------------------------------------------------------------------------
//				Ожидание заголовка принимаемой транзакции
//-------------------------------------------------------------------------------------------------
if(z.step==1) {if(!RT_HW_Base.uartAvailable(z.uart)){return;}//-waiting first code head;
			   uint8_t vRX=RT_HW_Base.uartRead(z.uart);
			   z.codeErr=0;
			   z.index=0;									//--clear index;
               if(!((vRX==0x3A) || (vRX=0x66))) {return;}	//--check first code head(0x3A) || code page(0x66);
			   z.buff[z.index]=0x3A; z.index++;				//--store first code head;
			   z.head=0x3A;  
               z.timeGet=millis(); z.step++;}
//-------------------------------------------------------------------------------------------------
//				Обработка заголовка принимаемой транзакции (func,qnt,qntByte)
//-------------------------------------------------------------------------------------------------
if(z.step==2) {do{
			      if(RT_HW_Base.uartAvailable(z.uart))
				  {
			       z.buff[z.index]=RT_HW_Base.uartRead(z.uart); z.timeGet=millis();	
				   if(z.index==1) {z.func=z.buff[z.index]; 
				                   if((z.func!=0x06)&&(z.func!=0x16)&&(z.func!=0x26)&&(z.func!=0x46)&&(z.func!=0x56)) 
								                                   {z.codeErr=51; z.step=0;  return;}} //--check code func;	
				   if(z.index==2) {z.adr=z.buff[z.index];}
				   if(z.index==3) {z.qnt=z.buff[z.index];}
				   if(z.index==4) {z.qntByte=z.buff[z.index];
								   if(z.func==0x06){if(z.qntByte!=z.qnt) 	{z.codeErr=60;} else {if((z.adr+z.qnt)> z.lenArrByte) {z.codeErr=61;}}}
                                   if(z.func==0x16){if(z.qntByte!=(z.qnt*2)){z.codeErr=62;} else {if((z.adr+z.qnt)> z.lenArrWord) {z.codeErr=63;}}}	
	                               if(z.func==0x26){if(z.qntByte!=(z.qnt*4)){z.codeErr=64;} else {if((z.adr+z.qnt)> z.lenArrLong) {z.codeErr=65;}}}
								   if(z.func==0x46){if(z.qntByte!=z.qnt)    {z.codeErr=66;}}
								   if(z.func==0x56){if(z.qntByte!=z.qnt)    {z.codeErr=67;}}
	                               if(z.codeErr!=0){z.step=0; return;}
	                               if(z.qntByte>32){z.step=0; return;}}
                                   z.index++;
								   if(z.index>4){z.step++; break;}}
				  if(RT_HW_Base.getPastMs(z.timeGet)>z.timeOutGetByte)      {z.codeErr=70; z.step=0; return;}
				 } while(1);
			  }
//-------------------------------------------------------------------------------------------------
//				Обработка данных транзакций + crc + end
//-------------------------------------------------------------------------------------------------
if(z.step==3) {do{	
               if(RT_HW_Base.uartAvailable(z.uart)){
		          z.buff[z.index]=RT_HW_Base.uartRead(z.uart); z.timeGet=millis();
				  if(z.index==z.qntByte+5) {z.crc=z.buff[z.index];}
		          z.index++;
		          if(z.index>(z.qntByte+5)){z.step++; break;}}
		          if(RT_HW_Base.getPastMs(z.timeGet)>z.timeOutGetByte) 		{z.codeErr=71; z.step=0; return;}	//--check time-out transaction;	
				 } while(1);
				 // RT_HW_Base.consoleCR();
				 
				 }   
//-------------------------------------------------------------------------------------------------
//				Обработка целостности транзакций
//-------------------------------------------------------------------------------------------------
if(z.step==4) {z.crcCalc=0; z.readyRead=1; z.cntGetPackAll++;
			   for(uint8_t i=0;i<=(z.qntByte+4); i++){z.crcCalc=z.crcCalc+z.buff[i];}			   
			   z.crcCalc=z.crcCalc&0xFF;
               z.crcCalc=0xFF-z.crcCalc;	
			   z.crcCalc++;
               if(z.crcCalc!=z.crc)  {z.codeErr=85; z.step=0; return;} 
			   if(z.func==0x56) {z.vPage=z.buff[5]; 
								 z.vYear=z.buff[6];  z.vMonth=z.buff[7];  z.vDay=z.buff[8]; 
							     z.vHour=z.buff[9];  z.vMin  =z.buff[10]; z.vSec=z.buff[11];
								 z.vRsv1=z.buff[12]; z.vRsv2 =z.buff[13];}	
			   for(uint8_t i=0; i<z.qnt;i++){
			       if(z.func==0x06) {uint8_t  bf= z.buff[i+5]; 					     	   setValArr(z.num,'B',(z.adr+i),bf);}
	               if(z.func==0x16) {uint16_t bf=(z.buff[i*2+1+5]<<8)+z.buff[i*2+5]; i+=1; setValArr(z.num,'W',(z.adr+i),bf);}
                   if(z.func==0x26) {uint32_t bf=(z.buff[i*4+1+5]<<8)+z.buff[i*4+5]; i+=3; setValArr(z.num,'L',(z.adr+i),bf);}
				   //if(z.func==0x46) {uint8_t  bf=(z.buff[i+5]                              setValArr(z.num,'L',(z.adr+i),bf);}
				   
				   }				   
               z.cntGetPackOk++; z.codeErr=0; z.step=0; return;}
//-------------------------------------------------------------------------------------------------    	
};

*/
