//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                                     ОБЪЕКТЫ И ПЕРЕМЕННЫЕ
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-------------------------------Параметры быстродействия проекта----------------------------------
uint8_t  vInit=0;                                                         //--Флаг инициализации параметров;
uint32_t vSpeedMCU=0; uint16_t vSpeedSmall=0; uint32_t vSpeedFltr;        //--Быстродействие проекта в циклах loop() (speedMCU=SpeedMCU/1000);
RT_HW_FILTER_RING_AVERAGE<uint32_t,10> filterSpeed; uint32_t vSpeedMCUF;  //--Параметры фильтра(скользящий среднего значения 10-го порядка);
//-------------------------------Контрольный пин,Led плате,PWM-------------------------------------
RT_HW_PIN_DIR_ID   idPinControl; uint8_t pinControl;                      //--Объект и переменная для пина "Контроль";
RT_HW_PIN_DIR_ID   idPinLed;     uint8_t pinLed;                          //--Объект и переменная для пина "Led на плате";                    
RT_HW_PIN_PWM_ID   idPinPWM;     uint8_t pinPWM;    uint32_t vPWM;        //--Объект и переменная для пина PWM;
//-------------------------------Кнопка с защитой от дребезга--------------------------------------
RT_HW_PIN_DIR_ID   idPinButton;  uint8_t pinButton; uint8_t vButton;      //--Объект и переменные для пина "Button на плате";  
RT_HW_CHAT_V8_ID   idChatButton;                    uint8_t vChatBut;     //--Объекты и переменные для обработки кнопки с защитой от дребезга;
//-------------------------------ADC с фильрацией--------------------------------------------------
RT_HW_PIN_ADC_ID   idPinADC;     uint8_t pinADC; uint16_t vADC,agoADC,vADCF,vADCPrc; //--Объект и переменная для ADС;
RT_HW_FILTER_RING_AVERAGE<uint32_t,5>  filterADC;                         //--Параметры фильтра ADC(скользящий среднего значения 5-го порядка);
//-------------------------------Сенсоры через пины------------------------------------------------
RT_HW_DHT22             dvDHT22;  uint8_t pinDHT22;  RT_HW_STRUCT_SHED_TASK shDHT22; float vDHT22Temp, vDHT22Hum; uint8_t vDHT22ok;  
RT_HW_STRUCT_DS1820_ID  dvDS1820; uint8_t pinDS1820; RT_HW_ONEWIRE dvNW; RT_HW_STRUCT_SHED_TASK shDS1820; float vDS1820Temp; uint8_t vDS1820ok; 
//-------------------------------Сенсоры HC-SR04 через пин Trig с прерываниями----------------------
RT_HW_STRUCT_SR04_ID    dvSR04;   uint8_t pinSR04;   RT_HW_STRUCT_SHED_TASK shSR04; uint16_t vSR04Len;  uint8_t vSR04ok;
RT_HW_FILTER_MEDIAN_3    <uint16_t>    ftrSR04;     uint16_t vSR04LenF;   //--Параметры для фильтра HC-SR04(медианный 3-го порядка);
RT_HW_IRAM_ATTR void RT_HW_IRQ_SR04_handler_dvSR04(){ //++++Обработчик прерываний HC-SR04------------
  if(dvSR04.state==2) {if( RT_HW_PIN_DIR_READ(dvSR04.ddPin)){dvSR04.timeBegin=micros(); dvSR04.state=3;}}
  if(dvSR04.state==3) {if(!RT_HW_PIN_DIR_READ(dvSR04.ddPin)){dvSR04.timeEnd  =micros(); dvSR04.state=4;}}}
//-------------------------------Адреса устройств i2c----------------------------------------------
uint8_t adrLcd1;                                                          //--Адрес Lcd1;
//-------------------------------Комбинированный сенсор AHT+BMP280(i2c)---------------------------- 
RT_HW_AHTXX   devCMAHT;   RT_HW_STRUCT_SHED_TASK shedCMAHT; float vCMTemp,vCMHum,vCMPress; uint8_t vCMTHPok; 
RT_HW_BME280  devCMBMP;   RT_HW_STRUCT_SHED_TASK shedCMBMP;   
//-------------------------------Сенсоры SPI,SPN---------------------------------------------------
RT_HW_STRUCT_MAX6675_ID spiDevMAX6675;  RT_HW_STRUCT_SHED_TASK spiShedMAX6675; uint8_t spiPinMAX6675cs; float spiMAX6675temp;  uint8_t spiMAX6675ok;  //--Сенсор MAX6675(SPI);
RT_HW_STRUCT_MAX6675_ID spnDevMAX6675;  RT_HW_STRUCT_SHED_TASK spnShedMAX6675; uint8_t spnPinMAX6675sck,spnPinMAX6675miso,spnPinMAX6675mosi,spnPinMAX6675cs;                                                                                                     float spnMAX6675temp;  uint8_t spnMAX6675ok;  //--Сенсор MAX6675(SPN);
//-------------------------------Расширители-------------------------------------------------------
RT_HW_SPIhc595   spiDev74HC595;         RT_HW_STRUCT_SHED_TASK spiShed74HC595; uint8_t spiPin74HC595cs; //--Расширитель 74HC4595;
//==============================Генераторы+счетчики=============================================================================================
RT_HW_GENERATOR_EVENT_ID idGenRUN8;   RT_HW_COUNTER_ID idCntRUN8;  uint8_t   genRUN8=0;   //--Для генератора бегущей "1" 0-8;   
RT_HW_GENERATOR_EVENT_ID idGenDAC;    RT_HW_COUNTER_ID idCntDAC;   int16_t   genDAC=0;    //--Для генераторо 0-4095 DAC;
RT_HW_GENERATOR_EVENT_ID idGenA;      RT_HW_COUNTER_ID idCntA;     uint8_t   genA=0;      //--Для генератора бегущей "1"; 
RT_HW_GENERATOR_EVENT_ID idGenB;      RT_HW_COUNTER_ID idCntB;     uint8_t   genB=0;      //--Для генератора бегущей "1"; 
//============================Объекты и переменные Lcd.1=============================================
// Внутри вкладки LCD1.hpp
//===================================================================================================
