//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//    ТЕСТ MAX6675 через SPI, MAX6675 чере SPN(три пина)) ПЛАТЫ,LCD i2c.16x2
//    Показания с сенсоров выводятся на LCD. 
//    Дополнительно на LCD выводятся значения ADC,Кнопка,быстродействие проекта. На пин PWM выводится значение с ADC.      
// Для настройки IDE для работы поддерживаемыми платами в тесте TEST_Board_v01, вкладка Readme.hpp  имеется инструкция.
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#include "RT_HW_BASE.h"         //--Подключение базовой библиотеки (не обязательна, так как дублируется в других библиотеках ниже);
#include "RT_HW_LCD44780.h"     //--Подключение библиотеки поддержки LCD дисплеев типа HD44780;
#include "RT_HW_SENSORS.h"      //--Подключение библиотеки поддержки сенсоров;
#include "RT_HW_EXTENDERS.h"    //--Подключение библиотеки поддержки расширителей;
//=============================Подключение внутренних функций========================================
#include "Aobj.hpp"       //--Объекты и переменные;
#include "Bfunc.hpp"      //--Базовые функции;
#include "Csns.hpp"       //--Функции опроса сенсоров;
#include "Dext.hpp"       //--Функции работы с расширителями;
#include "Lcd1.hpp"       //--Функции вывода на дисплей Lcd1;        
//=============================SETUP()===============================================================
void setup(){}
//=============================LOOP()================================================================
void loop(){
//-----------------------------Системные функции-----------------------------------------------------
initProject();                                                                                     //--Настройка параметров;
RT_HW_Base.sheduler();                                                                             //--Работа дисплея;
if(RT_HW_Base.shed.eventSec){vSpeedMCU=RT_HW_Base.shed.cycle; vSpeedMCUF=filterSpeed.filtered(vSpeedMCU); //--Расчет быстродействия с фильтрацией; 
                             vSpeedSmall=round(((float)vSpeedMCUF)/1000);}                         //--Получение быстродействия/1000;
RT_HW_Base.consoleBegin();                                                                         //--Инициализация консоли;
if(RT_HW_Base.console.head){consoleHead();}                             //--Однократный вывод на консоль заголовка проекта;
RT_HW_Base.pinDigitalWrite(idPinControl,RT_HW_Base.device.pin.control,RT_HW_Base.shed.control);    //--Вывод loop() на контрольный пин;
RT_HW_Base.pinDigitalWrite(idPinLed,    RT_HW_Base.device.pin.led,    RT_HW_Base.shed.blink500);   //--Вывод меандра 500ms на Led; 
//=====================ПИНЫ========================================================================
if(RT_HW_Base.shed.fast.num==2) {fncADC();}       //--Чтение ADC [Быстрая задача, период 100ms, так как ADC на AVR не быстрый]; 
if(RT_HW_Base.shed.fast.num==2) {fncPWM();}       //--Запись PWM [Быстрая задача, период 100ms, так как ADC на AVR не быстрый]; 
if(RT_HW_Base.shed.frdm.num==3) {fncGen();}       //--Генераторы тестовые;
if(RT_HW_Base.shed.frdm.num==4) {fncButton();}    //--Чтение кнопки с защитой от дребезга;
//=====================СЕНСОРЫ SPI,SPN=============================================================
if(RT_HW_Base.shed.frdm.num==10){sns_spiMAX6675();}  //--Управление сенсором MAX6675.SPI;  
if(RT_HW_Base.shed.frdm.num==12){sns_spnMAX6675();}  //--Управление сенсором MAX6675.SPN;
//=====================РАСШИРИТЕЛИ SPI,SPN=========================================================
if(RT_HW_Base.shed.frdm.num==14){ext_spi74HC595(genRUN8);}  //--Вывод на 74HC595 "бегущей 1";
//=====================ДИСПЛЕИ LCD HD44780=========================================================
if(RT_HW_Base.shed.frdm.num==20){Lcd1();}         //--Управление дисплеем 1(16x2,i2c,0x27);
//-------------------------------------------------------------------------------------------------
} //--END loop()===================================================================================
