//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//            					СЕНСОР AHTXX
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-------------------------------------------------------------------------------------------------
#ifndef RT_HW_AHTXX_h
#define RT_HW_AHTXX_h
#define RT_HW_AHTXX_VER 		        10		//--Номер версии библиотеки;
#include "RT_HW_BASE.h"					        //--Подключение базовой библиотеки;
//=================================================================================================
//                            КЛАСС СЕНСОРА AHTXX
//=================================================================================================
class RT_HW_AHTXX{
public:
//-----------------Основные параметры управления---------------------------------------------------
uint8_t  custom=0;				//--Состояние настройки ID;  
//----------------Перенастраиваемые параметры пользователем----------------------------------------
uint8_t  bus=0;					//--Номер шины;
uint8_t  adr=0x38;				//--Адрес i2c по умолчанию;
uint32_t speed=RT_HW_I2C_SPEED;		//--Скорость шины;
//----------------Основные переменные управления измерением-----------------------------------------
uint8_t  run=0, cmdRun=0;       //--Флаги для запуска измерений;
uint8_t  ddr=0;					//--Этапы основной программы управления устройствами;
uint8_t  step;					//--Управление этапами управления в функциях измерения;
//----------------Выходные параметры-----------------------------------------------------------------
uint8_t  fresh=1;				//--Флаг "свежих" данных;
uint8_t  ok=0;					//--Флаг "Устройство в норме;
uint8_t  codeErr, err;			//--Код ошибки при обмене;
//----------------Дополнительные переменные управления измерением-----------------------------------
uint8_t  initDevice, action;	//--Рабочие флаги;
uint8_t  cntErr;				//--Счетчик повторных ошибок;
uint8_t  cntFind;				//--Счетчик поиска устройств;
//----------------Параметры для функци timeDelay()[и также используются функцией i2cFindAdr()]------
uint32_t startDelay;		    //--Рабочий регистр;
uint8_t  workDelay=0;			//--Рабочий регистр; 
uint8_t  pointDelay;			//--Точка возврата из функции;
uint16_t sizeDelay;				//--Задержка для функции();
//----------------Буферные рабочие переменные (поддержка релевантности)------------------------------
uint32_t temp;					//--Рабочий регистр;
uint8_t  cmd;					//--Рабочий регистр;
uint8_t  idx,idx1;				//--Индексы;
uint8_t  bf[8];              	//--Буфер для временного хранения данных;
float    vTemp, vHum;			//--Измеренные значения;
//=================================================================================================
void setParam(uint8_t vAdr=0x38, uint8_t vBus=0, uint32_t vSpeed=0){ //++++НАСТРОЙКА параметров
if(custom==0){	//++++Однократная настройка параметров---------------------------------------------
adr=vAdr;  bus=vBus; speed=vSpeed;	custom=1;}	//--Настройка адреса устройства,номера шины,скорости шины;
};	//+++++END setParam()==========================================================================

void direct(){									  //++++УПРАВЛЕНИЕ измерением====================== 
//-------------------------------------------------------------------------------------------------
if(run){cmdRun=1;} 
//-------------------------------------------------------------------------------------------------
if(ddr==0) {	//++++Начальная настройка----------------------------------------------------------	
workDelay=err=codeErr=cntErr=cntFind=initDevice=0; 	//--Инициализация рабочих параметров;
fresh=1; ok=0; vTemp=-0.11; vHum=57.7;				//--Инициализация выходных параметров; 
            ddr=90; sizeDelay=200; pointDelay=10;	//--Переход на продолжение через 200ms;
}	//---------------------------------------------------------------------------------------------
if(ddr==10){	//++++Ожидание команды cmdRun(запуск измерения)------------------------------------
if(!cmdRun){return;} step=0;			//-- 
if(initDevice) {ddr=30;} else {ddr=20;}	//--Переход на измерение или на инициализацию;	
}	//---------------------------------------------------------------------------------------------
if(ddr==20){	//++++Инициализация устройства-----------------------------------------------------
init(); 	  												//--Инициализация устройства; 		  
if(err)   {ddr=90; sizeDelay=2000; pointDelay=0;}			//--При ошибке переход ddr=0 через задержку 2000ms;
if(action){return;}   										//--Ожидание завершения измерения;
initDevice=1; step=0; ddr=30;								//--Переход на измерение;
}	//---------------------------------------------------------------------------------------------
if(ddr==30){	//++++Измерение и получение результатов--------------------------------------------
meter();	 	  											//--Пошаговое измерение; 
if(err)   {ddr=90; sizeDelay=500; pointDelay=0;} 			//--Переход на начало через задержку 1000ms;														
if(action){return;}  										//--Ожидание завершения измерения;
cmdRun=0;  ddr=90; sizeDelay=500; pointDelay=10; 			//--Переход на ожидание run через задержку 500ms;;
}	//--------------------------------------------------------------------------------------------- 
if(ddr==90){	//++++Фиксированная задержка-------------------------------------------------------
if(!RT_HW_Base.timeDelay(startDelay,workDelay,sizeDelay)){return;} else {ddr=pointDelay;  return;}
}	//---------------------------------------------------------------------------------------------
};	//+++++END direct()============================================================================

void init(){									  //++++ИНИЦИАЛИЗАЦИЯ устройства===================
if(step==0) {	//++++Подготовка внутренних параметров функции-------------------------------------           
workDelay=err=codeErr=0; action=1; 					//--Очистка параметров;
  cntErr=0; step=90; sizeDelay=50; pointDelay=10;	//--Переход на продолжение через задержку 50мс;     
}	//---------------------------------------------------------------------------------------------
if(step==10){	//++++Инициализация шины-----------------------------------------------------------
if(!RT_HW_Base.i2cInitDevice(codeErr,adr,bus)){return;} //--Инициализация шины;
if(codeErr){err=1; codeErr=80;         return;}			//--Выход по ошибке инициализации шины; 
else       {step=15;      cntFind=0; cntErr=0;}			//--Безусловный переход на продолжение;
}	//---------------------------------------------------------------------------------------------
if(step==15){	//++++Поиск устройства на шине i2c-------------------------------------------------
if(!RT_HW_Base.i2cFindAdr(codeErr,adr,bus,speed)){return;};		//--Поиск устройства на на шине i2c;      	
if(codeErr){step=85;                pointDelay=15; cntFind=0;}//--При ошибке переход на динамическую задержку; 
else       {step=90; sizeDelay=50;  pointDelay=15; cntErr=0;  //--Переход на повторение поиска с задержкой 50ms;
            if(++cntFind>=3){step=20;  return;}              }//--Переход на продолжение в следующем цикле после 3-кратного обнаружения;
}	//--------------------------------------------------------------------------------------------
if(step==20){	//++++Команда программного сброса [0xBA]-------------------------------------------	
if(!RT_HW_Base.i2cSendByte(codeErr,0xBA,adr,bus,speed)){return;}//--Отправка кода программного сброса[0xBA]; 	  
if(codeErr){step=85;               pointDelay=20;}		//--При ошибке повтор через динамическую задержку; 
else       {step=90; sizeDelay=40; pointDelay=30; cntErr=0;}//-При ok переход через фиксированную задержку 40ms;
}	//---------------------------------------------------------------------------------------------
if(step==30){	//++++Команда    инициализации    [0xBE]-------------------------------------------		
if(!RT_HW_Base.i2cSendByte(codeErr,0xBE,adr,bus,speed)){return;}//--Отправка кода инициализации[0xBE];	
if(codeErr){step=85;               pointDelay=30;}			//--При ошибке повтор через динамическую задержку; 
else       {step=90; sizeDelay=20; pointDelay=35; cntErr=0;}//-При ok переход через фиксированную задержку 20ms;
}	//---------------------------------------------------------------------------------------------
if(step==35){	//++++Запрос состояния устройства [0x71]-------------------------------------------	
if(!RT_HW_Base.i2cSendByte(codeErr,0x71,adr,bus,speed)){return;}//--Отправка кода запроса состояния[0x71];
if(codeErr){step=85;               pointDelay=35;}		//--При ошибке повтор через динамическую задержку; 
else       {step=90; sizeDelay=20; pointDelay=40; cntErr=0;}//-При ok переход через фиксированную задержку 20ms;
}	//---------------------------------------------------------------------------------------------
if(step==40){	//++++Чтение слова состояния и проверка бита(3)калибровки,timeDelay>=40ms----------   
if(!RT_HW_Base.i2cGetByte(codeErr,cmd,adr,bus,speed)){return;}  //--Чтение слова состояния; 
if(codeErr){step=85;               pointDelay=30;}		//--При ошибке повтор  через динамическую задержку; 
else       {cntErr=0; if(!bitRead(cmd,3)){				//--Проверка калибровки;
            step=60;               pointDelay=20;codeErr=80;}//-При отсутствии калибровки повтор через динамическую задержку;
            else{codeErr=0; action=0; step=0; return;}} //----Если калибровка в норме, выход по успешному завершению;
}	//---------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
if(step==85){	//++++Динамическая задержка--------------------------------------------------------
if(++cntErr>6){cntErr=6; codeErr=82; err=1;} sizeDelay=cntErr*cntErr*RT_HW_DEVICE_DELAY; step=90;
}	//---------------------------------------------------------------------------------------------
if(step==90){	//++++Фиксированная задержка-------------------------------------------------------
if(!RT_HW_Base.timeDelay(startDelay,workDelay,sizeDelay)){return;} step=pointDelay;
}	//---------------------------------------------------------------------------------------------
};	//====END init()===============================================================================

void meter(){									  //++++ИЗМЕРЕНИЕ параметров======================= 
if(step==0) {	//++++Подготовка внутренних параметров функции-------------------------------------
workDelay=err=codeErr=0; action=1; 						//--Очистка параметров;
     cntErr=0; step=10;									//--Переход на продолжение; 
}	//---------------------------------------------------------------------------------------------
if(step==10){	//++++Подготовка команды запуска измерения [0xAС,0x33,00]--------------------------
bf[0]=0xAC; bf[1]=0x33; bf[2]=0x00;	 					//--Подготовка параметров команды;
			 step=11;									//--Переход;
}	//---------------------------------------------------------------------------------------------
if(step==11){	//++++Команда запуска измерения [0xAС,0x33,00],timeDelay>=40ms---------------------
if(!RT_HW_Base.i2cSendBytes(codeErr,bf,3,adr,bus,speed)){return;}//-Отправка команды;	  
if(codeErr){step=85;                pointDelay=11;}		//--При ошибке повтор через динамическую  задержку;
else       {step=90; sizeDelay=150; pointDelay=15;cntErr=0;}//-При ok переход через фиксированную задержку 150ms;
}	//---------------------------------------------------------------------------------------------
if(step==15){	//++++Запрос состояния устройства[0x71]--------------------------------------------
if(!RT_HW_Base.i2cSendByte(codeErr,0x71,adr,bus,speed)){return;}//--Запрос состояния устройства;	 
if(codeErr){step=85; 		       pointDelay=15;}	//--При ошибке повтор через динамическую  задержку;
else       {step=90; sizeDelay=20; pointDelay=20; cntErr=0;}//-При ok переход через фиксированную задержку 20ms;
}	//---------------------------------------------------------------------------------------------
if(step==20){	//++++Чтение результатов измерения-------------------------------------------------    
if(!RT_HW_Base.i2cGetBytes(codeErr,bf,7,adr,bus,speed)){return;}//--Запрос 7-ми байтов;	 
if(codeErr){step=85;                pointDelay=20;}		//--При ошибке повтор через динамическую  задержку;
else       {step=90; sizeDelay=50;  pointDelay=20; cntErr=0; 
 if(!codeErr){if(!bitRead(bf[0],3))    {codeErr=54;}} 	//--Если нет калибровки,переход на обработку по фатальной ошибке;
 if(!codeErr){if( bitRead(bf[0],7))    {codeErr=53;}} 	//--Если не завершено,      повтор через динам.timeDelay();
 if(!codeErr){if(crc8(&bf[0],6)!=bf[6]){codeErr=55;}} 	//--Если ошибка CRC, переход назад через динам.timeDelay();
 if(!codeErr){ step=25;}} 							  	//--Если ok, переход на обработку результатов;				  
}	//---------------------------------------------------------------------------------------------
if(step==25){	//++++Обработка результатов измерения----------------------------------------------
temp=bf[1]; temp<<=8; temp|=bf[2]; temp<<=4; temp|=bf[3]>>4;   vHum =(float)(temp*100)/(float)0x100000;
temp=bf[3]&0x0F; temp<<=8; temp|=bf[4]; temp<<=8; temp|=bf[5]; vTemp=(float)(temp*200)/(float)0x100000 - 50;		 			   			 
fresh=ok=1; action=0; step=0;	return;						//--Выход по успешному завершению;	
}	//---------------------------------------------------------------------------------------------
//=================================================================================================
if(step==85){	//++++Динамическая задержка с выходом при многократной ошибке----------------------
if(++cntErr>3){cntErr=3; codeErr=84; err=1;} sizeDelay=cntErr*cntErr*RT_HW_DEVICE_DELAY; step=90;
}	//---------------------------------------------------------------------------------------------
if(step==90){	//++++Фиксированная задержка-------------------------------------------------------
if(!RT_HW_Base.timeDelay(startDelay,workDelay,sizeDelay)){return;} step=pointDelay;
}	//---------------------------------------------------------------------------------------------											 
};	//====void meter()-----------------------------------------------------------------------------	

uint8_t crc8(uint8_t *pData, uint8_t len){		  //++++РАСЧЕТ CRC=================================
//----Calcuration CRC8 polynomial: CRC[7: 0] = X8 + X5 + X4 + 1  -  0x1 0011 0001 - 0x131
cmd=0xFF;
for(idx1=0;  idx1<len; idx1++){cmd ^= pData[idx1];
 for(idx=8;  idx>0;    idx--) {if(cmd&0x80){cmd<<=1; cmd^= 0x31;} else{cmd<<=1;}}}
return cmd;} //====uint8_t crc8()------------------------------------------------------------------
};	//++++END class RT_HW_AHTXX====================================================================
#endif
//=================================================================================================