//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//            					СЕНСОР BMP180
//++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-------------------------------------------------------------------------------------------------
#ifndef RT_HW_BMP180_h
#define RT_HW_BMP180_h
#define RT_HW_BMP180_VER 		 10		//--Номер версии библиотеки;
#include "RT_HW_BASE.h"					//--Подключение базовой библиотеки;
//=================================================================================================
//                            КЛАСС СЕНСОРА BMP180
//=================================================================================================
class RT_HW_BMP180{
public:
//-----------------Основные параметры управления---------------------------------------------------
uint8_t  custom=0;				//--Состояние настройки ID;  
//----------------Перенастраиваемые параметры пользователем----------------------------------------
uint8_t  bus=0;					//--Номер шины;
uint8_t  adr=0x77;				//--Адрес i2c по умолчанию;
uint32_t speed=RT_HW_I2C_SPEED;	//--Скорость шины;
//----------------Основные переменные управления измерением----------------------------------------
uint8_t  runTemp=0, cmdRunTemp=0;  //--Флаг для внешнего запуска измерений;
uint8_t  runPress=0,cmdRunPress=0; //--Флаг для внешнего запуска измерений;
uint8_t  ddr=0;					//--Этапы основной программы управления устройствами;
uint8_t  step;					//--Управление этапами управления в функциях измерения;
//----------------Выходные параметры---------------------------------------------------------------
uint8_t  fresh=1;				//--Флаг "свежих" данных;
uint8_t  ok=0;					//--Флаг "Устройство в норме;
uint8_t  codeErr,err;			//--Код ошибки при обмене;
//----------------Дополнительные переменные управления измерением----------------------------------
uint8_t  initDevice=0, action;	//--Рабочие флаги;
uint8_t  cntErr;				//--Счетчик повторных ошибок;
uint8_t  cntFind;				//--Счетчик поиска устройств;
//uint8_t  cnt;
//----------------Параметры для функци timeDelay()[и также используются функцией i2cFindAdr()]-----
uint32_t startDelay;		    //--Рабочий регистр;
uint8_t  workDelay=0;			//--Рабочий регистр; 
uint8_t  pointDelay;			//--Точка возврата из функции;
uint16_t sizeDelay;				//--Задержка для функции();
//----------------Буферные рабочие переменные (поддержка релевантности)----------------------------
uint32_t temp;					//--Рабочий регистр;
uint8_t  cmd;					//--Рабочий регистр;
uint8_t  idx,idx1;				//--Индексы;
uint8_t  bf[10];              	//--Буфер для временного хранения данных;
//-------------------------------------------------------------------------------------------------
uint8_t  permitTemp=1;  		//--Разрешение на проведение измерения температуры;
uint8_t  permitPress=1; 		//--Разрешение на проведение измерения давления;
//-------------------------------------------------------------------------------------------------
uint8_t  OverPress=1;			//--Скорость вывода давления:0,1,2,3;
uint8_t  delayPress;			//--Регистр для задержки при измерении давления;
//-------------------------------------------------------------------------------------------------
int16_t  AC1,AC2,AC3,VB1,VB2,MB,MC,MD;	//--Корректирующие коэффициенты из сенсора;
uint16_t AC4,AC5,AC6; 			
float    c3,c4,b1;				
float    c5,c6,mc,md,x0,x1,x2,y0,y1,y2,p0,p1,p2;
float    tu,a;
float    pu,s,x,y,zu;
//-------------------------------------------------------------------------------------------------
float    vTemp, vPress;			//--Измеренные значения;
//=================================================================================================
void setParam(uint8_t vAdr=0x77, uint8_t vBus=0, uint32_t vSpeed=0){ //++++НАСТРОЙКА параметров=======================
if(custom==0){	//++++Однократная настройка параметров---------------------------------------------
adr=vAdr;  bus=vBus; speed=vSpeed;	custom=1;}	//--Настройка адреса устройства,номера шины,скорости шины;
};	//+++++END setParam()==========================================================================

void direct(){									  //++++УПРАВЛЕНИЕ измерением====================== 
//-------------------------------------------------------------------------------------------------
if(runTemp) {cmdRunTemp=1;}			//--Фиксация внешней команды на запуск измерения температуры; 
if(runPress){cmdRunPress=1;}		//--Фиксация внешней команды на запуск измерения давления;  
//-------------------------------------------------------------------------------------------------
if(ddr==0) {	//++++Начальная настройка----------------------------------------------------------	
workDelay=err=codeErr=cntErr=cntFind=initDevice=0; 	//--Инициализация рабочих параметров;
fresh=1; ok=0; vTemp=-0.11; vPress=695.2;			//--Инициализация выходных параметров; 
            ddr=90; sizeDelay=200;  pointDelay=10;	//--Переход на продолжение через 200ms;
}	//----------------------------------------------------------------------------------------------
if(ddr==10){	//++++Выбор перехода[cmdRunXXXб,iniDevice] на инициализацию или на измерение-------
if((!cmdRunTemp)&&(!cmdRunPress)){return;} step=0;	//--Ожидание команд cmdRunTemp,cmdRunPres;
if(initDevice==0){step=0; ddr=20;} else {ddr=30;}	//--Выбор переход на init() или на meterTemp();	
}	//---------------------------------------------------------------------------------------------
if(ddr==20){	//++++Инициализация устройства-----------------------------------------------------
init(); 	  										//--Пошаговая инициализация; 		  
if(err)    {ddr=90; sizeDelay=2000;pointDelay=0; cmdRunTemp=cmdRunPress=0;} //--Переход с задержкой на начало(ddr=0);
if(!action){ddr=30; initDevice=1; }   				//--Ожидание завершения инициализации;
if(ddr==20){return;}								//--Выход при продолжении работы meterTemp();
}	//---------------------------------------------------------------------------------------------
if(ddr==30){	//++++Проверка на запуск измерения температуры-------------------------------------
if(cmdRunTemp){cmdRunTemp=0;if(permitTemp){ddr=35; step=0;}};//-Проверка на запуск измерения температуры;
if(ddr==30){ddr=40;}								//--Если нет запуска по температуре, переход проверку cmdRunPress; 
}	//----------------------------------------------------------------------------------------------
if(ddr==35){	//++++Измерение температуры---------------------------------------------------------
meterTemp();	 	  								//--Пошаговое измерение температуры; 
if(err)    {ddr=90; sizeDelay=500;pointDelay=0;} 	//--Переход с задержкой при ошибке  meterTemp();
if(!action){ddr=90; sizeDelay=50; pointDelay=40;} 	//--Переход при успешном завершении meterTemp();
if(ddr==35){return;}								//--Выход   при продолжении работы  meterTemp();
}	//---------------------------------------------------------------------------------------------
if(ddr==40){	//++++Проверка на запуск измерения давления----------------------------------------
if(cmdRunPress){cmdRunPress=0;if(permitPress){ddr=45;step=0;}};//-Проверка на запуск измерения давления;
if(ddr==40){ddr=60;}								//--Если нет запуска, переход на завершение; 
}	//---------------------------------------------------------------------------------------------
if(ddr==45){	//++++Измерение давления-----------------------------------------------------------
meterPress();	 	  								//--Пошаговое измерение давления; 
if(err)    {ddr=90;  sizeDelay=500;pointDelay=0;} 	//--Переход с задержкой при ошибке  meterPress();
if(!action){ddr=90;  sizeDelay=50; pointDelay=60;} 	//--Переход при успешном завершении meterPress();
if(ddr==45){return;}								//--Выход   при продолжении работы  meterPress();
}	//---------------------------------------------------------------------------------------------
if(ddr==60){	//++++Завершение измерения---------------------------------------------------------
			ddr=90; sizeDelay=500; pointDelay=10;	//--Переход на начало с задержкой 500ms;
}	//---------------------------------------------------------------------------------------------
if(ddr==90){	//++++Задержка по времени с возвратом в заданную точку-----------------------------	
if(!RT_HW_Base.timeDelay(startDelay,workDelay,sizeDelay)){return;} else {ddr=pointDelay;  return;}
}	//---------------------------------------------------------------------------------------------
};	//+++++END direct()============================================================================

void init(){									  //++++ПОЛУЧЕНИЕ настроечных параметров===========
if(step==0) {	//++++Подготовка внутренних параметров функции-------------------------------------           
workDelay=err=codeErr=0; action=1; 					//--Очистка параметров;
   cntErr=0; step=90; sizeDelay=50; pointDelay=10;	//--Переход на продолжение через задержку 50мс;     
}	//---------------------------------------------------------------------------------------------
if(step==10){	//++++Инициализация шины-----------------------------------------------------------
if(!RT_HW_Base.i2cInitDevice(codeErr,adr,bus)){return;}     //--Инициализация шины;
if(codeErr){err=1; codeErr=80;         return;}		//--Выход по ошибке инициализации шины; 
else       {step=15;      cntFind=0; cntErr=0;}		//--Безусловный переход на продолжение;
}	//---------------------------------------------------------------------------------------------
if(step==15){	//++++Поиск устройства на шине i2c-------------------------------------------------
if(!RT_HW_Base.i2cFindAdr(codeErr,adr,bus,speed)){return;};	//--Поиск устройства на на шине i2c;     
//codeErr=RT_HW_Base.i2cGetCodeErr(bus);				//--Получение кода ошибки;  	
if(codeErr){step=85;                pointDelay=15; cntFind=0;}//--При ошибке переход на динамическую задержку; 
else       {step=90; sizeDelay=50;  pointDelay=15; cntErr=0;  //--Переход на повторение поиска с задержкой 50ms;
            if(++cntFind>=3){step=20;  return;}              }//--Переход на продолжение в следующем цикле после 3-кратного обнаружения;
}	//--------------------------------------------------------------------------------------------
if(step==20){	//++++Чтение AC1,AC2,AC3-----------------------------------------------------------
if(!RT_HW_Base.i2cReadRegs(codeErr,0xAA,bf, 6,adr,bus,speed)){return;}	//--Чтение 6 байт; 
//codeErr=RT_HW_Base.i2cGetCodeErr(bus); 				//--Получение кода ошибки;  
if(codeErr){step=85;               pointDelay=20;}	//--При ошибке повтор через динамическую задержку; 
else       {AC1=((int16_t)(bf[0]<<8)) | bf[1];		//--При ok, считывание параметров; 
            AC2=((int16_t)(bf[2]<<8)) | bf[3];		//--При ok, считывание параметров;
            AC3=((int16_t)(bf[4]<<8)) | bf[6];  	//--При ok, считывание параметров;
            step=90; sizeDelay=20; pointDelay=25;   cntErr=0;}	//--Переход через фиксированную задержку 20ms; 
}	//---------------------------------------------------------------------------------------------
if(step==25){	//++++Чтение AC4,AC5,AC6-----------------------------------------------------------
if(!RT_HW_Base.i2cReadRegs(codeErr,0xB0,bf, 6,adr,bus,speed)){return;}	//--Чтение 6 байт;   
//codeErr=RT_HW_Base.i2cGetCodeErr(bus);  			//--Получение кода ошибки; 
if(codeErr){step=85;               pointDelay=25;}	//--При ошибке повтор через динамическую задержку; 
else	   {AC4=((uint16_t)(bf[0]<<8)) | bf[1];//--При ok, считывание параметров; 
            AC5=((uint16_t)(bf[2]<<8)) | bf[3];//--При ok, считывание параметров; 
            AC6=((uint16_t)(bf[4]<<8)) | bf[5];//--При ok, считывание параметров; 
            step=90; sizeDelay=20;  pointDelay=30;   cntErr=0;} //--Переход через фиксированную задержку 20ms;
}	//---------------------------------------------------------------------------------------------
if(step==30) {	//++++Чтение VB1,VB2,MB,MC,MD------------------------------------------------------
if(!RT_HW_Base.i2cReadRegs(codeErr,0xB6,bf,10,adr,bus,speed)){return;} 	//--Чтение 10 байт; 
//codeErr=RT_HW_Base.i2cGetCodeErr(bus);   				//--Получение кода ошибки; 
if(codeErr){step=85;               pointDelay=25;}	//--При ошибке повтор через динамическую задержку; 
else       {VB1=((int16_t)(bf[0]<<8)) | bf[1];//--При ok, считывание параметров; 
			VB2=((int16_t)(bf[2]<<8)) | bf[3];//--При ok, считывание параметров;
			MB= ((int16_t)(bf[4]<<8)) | bf[5];//--При ok, считывание параметров; 
			MC= ((int16_t)(bf[6]<<8)) | bf[7];//--При ok, считывание параметров;
			MD= ((int16_t)(bf[8]<<8)) | bf[9];//--При ok, считывание параметров;			   
            step=35;  cntErr=0;                      return;} //--Переход на вычисление при следующем входе;
}	//---------------------------------------------------------------------------------------------			   
if(step==35){	//++++Вычисление-------------------------------------------------------------------
 c3 = 160.0 * pow(2,-15) * AC3;       c4 = pow(10,-3) * pow(2,-15) * AC4;
 b1 = pow(160,2) * pow(2,-30) * VB1;  c5 = (pow(2,-15) / 160) * AC5;
 step=36;  return;
}	//---------------------------------------------------------------------------------------------	
if(step==36){	//++++Вычисление-------------------------------------------------------------------
 c6 = AC6; mc = (pow(2,11) / pow(160,2)) * MC;  md = MD / 160.0;
 x0 = AC1; x1 = 160.0 * pow(2,-13) * AC2;       x2 = pow(160,2) * pow(2,-25) * VB2;
 step=37;  return;
}	//---------------------------------------------------------------------------------------------	
if(step==37){	//++++Вычисление-------------------------------------------------------------------
 y0 = c4 * pow(2,15);           y1 = c4 * c3;                   y2 = c4 * b1;
 p0 = (3791.0 - 8.0) / 1600.0;  p1 = 1.0 - 7357.0 * pow(2,-20); p2 = 3038.0 * 100.0 * pow(2,-36);			   
 step=40; 
}	//---------------------------------------------------------------------------------------------		   
if(step==40){	//++++Успешное завершение----------------------------------------------------------
codeErr=0; action=0; step=0;return;}
//-------------------------------------------------------------------------------------------------
if(step==85){	//++++Динамическая задержка с выходом при многократной ошибке----------------------
if(++cntErr>6){cntErr=6; codeErr=82; err=1;} sizeDelay=cntErr*cntErr*RT_HW_DEVICE_DELAY; step=90; return;
}	//---------------------------------------------------------------------------------------------
if(step==90){	//++++Фиксированная задержка-------------------------------------------------------
if(!RT_HW_Base.timeDelay(startDelay,workDelay,sizeDelay)){return;} step=pointDelay;
}	//---------------------------------------------------------------------------------------------
};	//++++END init()===============================================================================			   

void meterTemp(){								  //++++ИЗМЕРЕНИЕ ТЕМПЕРАТУРЫ======================
if(step==0) {	//++++Подготовка внутренних параметров функции-------------------------------------           
workDelay=err=codeErr=0; action=1; 						//--Очистка параметров;
   cntErr=0; step=10;									//--Переход на продолжение;   
}	//---------------------------------------------------------------------------------------------
if(step==10){	//++++Подготовка команды запуска измерения температуры-----------------------------
bf[0]=0xF4; bf[1]=0x2E;  //--REG_CONTROL=0xF4; CMND_TEMP=0x2E;						   	
             step=11;								//--Переход на продолжение;
}	//---------------------------------------------------------------------------------------------
if(step==11){	//++++Отправка команды запуска измерения температуры-------------------------------
if(!RT_HW_Base.i2cSendBytes(codeErr,bf,2,adr,bus,speed)){return;}	//--Отправка команды;  
//codeErr=RT_HW_Base.i2cGetCodeErr(bus); 						//--Получение кода ошибки;
if(codeErr){step=85;               pointDelay=11;}			//--При ошибке повтор через динамическую задержку; 
else       {step=90; sizeDelay=25; pointDelay=20;cntErr=0;}	//--При ok    переход через фиксированную задержку 25ms;
}	//---------------------------------------------------------------------------------------------
if(step==20){	//++++Чтение 2-х байт с регистра REG_RESULT=0xF6-----------------------------------
if(!RT_HW_Base.i2cReadRegs(codeErr,0xF6,bf,2,adr,bus,speed)){return;} 
//codeErr=RT_HW_Base.i2cGetCodeErr(bus); 						//--Получение кода ошибки;
if(codeErr){step=85; 		       pointDelay=20;}			//--При ошибке повтор через динамическую  задержку;
else       {step=30;	cntErr=0; 					 return;}	//--При ok    переход через фиксированную задержку 20ms;
}	//-----------------------------------------------------------------------------	
if(step==30){	//++++Обработка 2-х байт с регистра REG_RESULT=0xF6;
//bf[0]=RT_HW_Base.i2cRead(bus); bf[1]=RT_HW_Base.i2cRead(bus);								//--Сохранение 2-x байт масссиве;		
tu = (bf[0] * 256.0) + bf[1];
//example from http://wmrx00.sourceforge.net/Arduino/BMP085-Calcs.pdf  tu = 0x69EC;
a = c5 * (tu - c6);
vTemp = a + (mc / (a + md));
fresh=ok=1; action=0; return;
}				  														   
//-------------------------------------------------------------------------------------------------
if(step==85){	//++++Динамическая задержка с выходом при многократной ошибке----------------------
if(++cntErr>3){cntErr=3; codeErr=84; err=1;} sizeDelay=cntErr*cntErr*RT_HW_DEVICE_DELAY; step=90;
}	//---------------------------------------------------------------------------------------------
if(step==90){	//++++Фиксированная задержка-------------------------------------------------------
if(!RT_HW_Base.timeDelay(startDelay,workDelay,sizeDelay)){return;} step=pointDelay;
}	//---------------------------------------------------------------------------------------------
}	//++++END meterTemp()==========================================================================

void meterPress(){								  //++++ИЗМЕРЕНИЕ ДАВЛЕНИЯ=========================
if(step==0) {	//++++Подготовка внутренних параметров функции-------------------------------------           
workDelay=err=codeErr=0; action=1; 					//--Очистка параметров;
   cntErr=0; step=10;								//--Переход на продолжение;   
}	//---------------------------------------------------------------------------------------------
if(step==10){	//++++Подготовка команды запуска измерения давления--------------------------------
bf[0]=0xF4;			  						//--REG_CONTROL=0xF4
                 bf[1]=0x34; sizeDelay=5; 	//--CMND_PRESS_0=0x34						   
if(OverPress==1){bf[1]=0x74; sizeDelay=8;}	//--CMND_PRESS_1=0x74
if(OverPress==2){bf[1]=0xB4; sizeDelay=14;}	//--CMND_PRESS_2=0xB4
if(OverPress==3){bf[1]=0xF4; sizeDelay=26;}	//--CMND_PRESS_3=0xF4
			 step=11;								//--Переход на продолжение;
}	//---------------------------------------------------------------------------------------------
if(step==11){	//++++Отправка команды запуска измерения давления----------------------------------
if(!RT_HW_Base.i2cSendBytes(codeErr,bf,2,adr,bus,speed)){return;}	//--Отправка команды;        
//codeErr=RT_HW_Base.i2cGetCodeErr(bus); 				//--Получение кода ошибки;  	
if(codeErr){step=85;               pointDelay=11;}			//--При ошибке повтор через динамическую задержку; 
else       {step=90; sizeDelay=150;pointDelay=20;    cntErr=0;}	//--При ok    переход через фиксированную задержку 150ms;
}	//---------------------------------------------------------------------------------------------
if(step==20){	//++++Чтение 3-х байт с регистра REG_RESULT=0xF6;
if(!RT_HW_Base.i2cReadRegs(codeErr,0xF6,bf,3,adr,bus,speed)){return;} codeErr=RT_HW_Base.i2cGetCodeErr(bus);
if(codeErr){step=85; 		       pointDelay=20;}			//--При ошибке повтор через динамическую  задержку;
else       {step=30; cntErr=0;                       return;}	//--При ok    переход на продолжение в следующем цикле;
}	//-----------------------------------------------------------------------------	
if(step==30){	//++++Обработка 3-х байт с регистра REG_RESULT=0xF6;
pu = (bf[0] * 256.0) + bf[1] + (bf[2]/256.0);
//example from http://wmrx00.sourceforge.net/Arduino/BMP085-Calcs.pdf, pu = 0x982FC0;	
//pu = (0x98 * 256.0) + 0x2F + (0xC0/256.0);		
s = vTemp - 25.0;
x = (x2 * pow(s,2)) + (x1 * s) + x0;
y = (y2 * pow(s,2)) + (y1 * s) + y0;
zu= (pu - x) / y;
vPress = (p2 * pow(zu,2)) + (p1 * zu) + p0;
fresh=ok=1; action=0; step=0; return;
}				  														   
//-------------------------------------------------------------------------------------------------
if(step==85){	//++++Динамическая задержка с выходом при многократной ошибке----------------------
if(++cntErr>3){cntErr=3; codeErr=84; err=1;} sizeDelay=cntErr*cntErr*RT_HW_DEVICE_DELAY; step=90;
}	//---------------------------------------------------------------------------------------------
if(step==90){	//++++Фиксированная задержка-------------------------------------------------------
if(!RT_HW_Base.timeDelay(startDelay,workDelay,sizeDelay)){return;} step=pointDelay;
}	//---------------------------------------------------------------------------------------------
};	//++++END meterPress()=========================================================================
};	//++++END class RT_HW_BMP180===================================================================
#endif
//=================================================================================================
