//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//      БИБЛИОТЕКА RT_HW_MCP23x17   
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  ecoins (ecoins@mail.ru) 
//  2022-22-18: Begin version
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-------------------------------------------------------------------------------------------------
#ifndef RT_HW_MCP23x17_h
#define RT_HW_MCP23x17_h
#define RT_HW_MCP23017_VER 		 10		//--Номер версии библиотеки;
#include "RT_HW_BASE.h"					//--Подключение базовой библиотеки;
//-------------------------------------------------------------------------------------------------
#define RT_HW_MCP23x17_DELAY_ERR  50 	//--Базовая задержка при повторов после ошибки;
#define RT_HW_MCP23x17_SIZE_BUFF   6	//--Размер буфера обмена с устройствами;
#define RT_HW_MCP23x17_IODIRA	0x00	//--регистр направления пинов A: =0x00(default) - все на выход, 0xff - все на вход
#define RT_HW_MCP23x17_IODIRB	0x01	//--регистр направления пинов B: =0x00(default) - все на выход, 0xff - все на вход
#define RT_HW_MCP23x17_IPOLA	0x02	//--регистр инверсии    пинов A: =0x00(default) - все прямые,   0xff - все инверсные
#define RT_HW_MCP23x17_IPOLB	0x03	//--регистр инверсии    выводов регистра B: =0x00(default) - все прямые,   0xff - все инверсные
#define RT_HW_MCP23x17_GPPUA	0x0C	//--регистр подтяжки входов регистра A резисторами 100кОм: =0x00(default) - не подтянуты,   0xff - все подтянуты
#define RT_HW_MCP23x17_GPPUB	0x0D	//--регистр подтяжки входов регистра A резисторами 100кОм: =0x00(default) - не подтянуты,   0xff - все подтянуты
#define RT_HW_MCP23x17_GPIOA	0x12	//--регистр выводов  на пины A
#define RT_HW_MCP23x17_GPIOB	0x13	//--регистр выводов  на пины B
#define RT_HW_MCP23x17_IOCON    0x0A	//--регистр конфигурации  
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                     КЛАСС УПРАВЛЕНИЯ MCP23x17
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class RT_HW_MCP23x17{
public:
//-------------------------------------------------------------------------------------------------
uint8_t custom=0;
//----------------Перенастраиваемые параметры пользователем----------------------------------------
uint8_t  bus=0;					//--Номер шины;
uint8_t  adr=0x20;				//--Адрес i2c по умолчанию;
uint32_t speed=RT_HW_I2C_SPEED;	//--Скорость шины;
char     mi='I';				//--Тип шины(I-i2c,S-SPI,s-SPN;
uint8_t  timeLimit=5;			//--Ограничение периода опроса;
//----------------Основные переменные управления измерением-----------------------------------------
uint8_t  runIn,  cmdRunIn=0;    //--Флаги для запуска измерений;
uint8_t  runOut, cmdRunOut=0;   //--Флаги для запуска измерений;
uint8_t  invIn=1, invOut=0;		//--Инверcия входов/выходов;
uint8_t  ddr=0;					//--Этапы основной программы управления устройствами;
uint8_t  step;					//--Управление этапами управления в функциях измерения;
//----------------Выходные параметры-----------------------------------------------------------------
uint8_t  fresh=1;				//--Флаг "свежих" данных;
uint8_t  ok=0;					//--Флаг "Устройство в норме;
uint8_t  codeErr, err;			//--Код ошибки при обмене;
//----------------Дополнительные переменные управления измерением-----------------------------------
uint8_t  initDevice, action;	//--Рабочие флаги;
uint8_t  cntErr;				//--Счетчик повторных ошибок;
uint8_t  cntFind;				//--Счетчик поиска устройств;
uint8_t  arr[5]; 				//--Рабочий буфер для отправки/приема команд;
//----------------Параметры для функции timeDelay()[и также используются функцией i2cFindAdr()]------
uint32_t startDelay;		    //--Рабочий регистр;
uint8_t  workDelay=0;			//--Рабочий регистр; 
uint8_t  pointDelay;			//--Точка возврата из функции;
uint16_t sizeDelay;				//--Задержка для функции();
//-------------------------------------------------------------------------------------------------
uint8_t  cnfgA=0xFF;			//--Побитовая конфигурация регистров А (0-вывод, 1-ввод);
uint8_t  cnfgB=0xFF;			//--Побитовая конфигурация регистров B (0-вывод, 1-ввод);
uint8_t  cnfgIPOLA=0x00;		//--Побитовая конфигурация инверсии входов регистра A(0-без инверсии,1-инверсия);
uint8_t  cnfgIPOLB=0x00;		//--Побитовая конфигурация инверсии входов регистра B(0-без инверсии,1-инверсия);
uint8_t  cnfgGPPUA=0xFF;		//--Побитовая конфигурация подтяжки входов регистра A(0-без подтяжки,1-внутренний резистор 100ком к Vcc);
uint8_t  cnfgGPPUB=0xFF;		//--Побитовая конфигурация подтяжки входов регистра A(0-без подтяжки,1-внутренний резистор 100ком к Vcc);
uint8_t  inA=0,   inB=0; 		//--Буферы для чтения   из регистров A,B;
uint8_t  agoA=255,agoB=255; 	//--Буфер  для чтения   из регистра  B;
uint8_t  outA,outB; 			//--Буферы для записи   в  регистры  A,B;
uint8_t  extA,extB; 			//--Внешние значения для записи в регистры вывода A,B;
//-------------------------------------------------------------------------------------------------
uint8_t normOut(uint8_t var){if(invOut){return (~var);} else {return var;}}; //--Нормализация для записи  в устройство;
uint8_t normIn (uint8_t var){if(invIn) {return (~var);} else {return var;}}; //--Нормализация при чтении из устройства;
//=================================================================================================
void	direct(){	//++++Управление устройством===================================================
if(runIn) {cmdRunIn=runIn;}
if(runOut){cmdRunOut=runOut;}
if(ddr==0) {	//++++Начальная настройка----------------------------------------------------------
workDelay=err=codeErr=cntErr=cntFind=initDevice=0; 	//--Инициализация рабочих параметров;
//fresh=1;
if(invIn){inA=inB=0xFF; cnfgIPOLA=cnfgIPOLB=0xFF;} else {inA=inB=0;}
ok=0;     inA=inB=0;	cmdRunIn=cmdRunOut=1;  		//--Инициализация выходных параметров; 
          ddr=90; sizeDelay=50; pointDelay=10;		//--Переход на продолжение через 50ms;
}	//---------------------------------------------------------------------------------------------
if(ddr==10){	//++++Проверка инициализации устройства--------------------------------------------
if(!initDevice){ddr=20;} else{ddr=30;};				//--Переход на инициализацию или на проверку команд;
}	//---------------------------------------------------------------------------------------------
if(ddr==20){	//++++Инициализация устройства-----------------------------------------------------	
init();												//--Инициализацию шины и устройства;
if(err)   {ddr=90; sizeDelay=2000; pointDelay=0;}	//--При ошибке переход ddr=0 через задержку 2000ms;
if(action){return;}   								//--Ожидание завершения;
initDevice=1; step=0; ddr=30;						//--Переход на проверку флагов ввода/вывода;		
}	//---------------------------------------------------------------------------------------------
if(ddr==30){	//++++Проверка флагов запуска ВВОДА И ВЫВОДА---------------------------------------
if(cmdRunIn || cmdRunOut){ddr=40;} else {return;}	//--Переход, если один из флагов взведен или выход;
}	//---------------------------------------------------------------------------------------------
if(ddr==40){	//++++Проверка флага запуска ВВОДА-------------------------------------------------
if(cmdRunIn==0){ddr=50;} else {cmdRunIn=0; ddr=41; step=0;}		//--Переход на ввод или на продолжение---------
}	//---------------------------------------------------------------------------------------------
if(ddr==41){	//++++Чтение из устройства---------------------------------------------------------
getData();											//--Чтение из устройства-----------------------			    
if(err)   {ddr=90; sizeDelay=100; pointDelay=0;}	//--При ошибке переход ddr=0 через задержку 100ms;
if(action){return;}   								//--Ожидание завершения чтения;
           ddr=50; 						//--Переход на продолжение в следующем цикле;
}	//--------------------------------------------------------------------------------------------- 
if(ddr==50){	//++++Проверка флага запуска ВЫВОДА------------------------------------------------
if(cmdRunOut==0){ddr=60;} else { ddr=51; step=0;} 	//--Переход на вывод или на продолжение;
}	//---------------------------------------------------------------------------------------------
if(ddr==51){	//++++Запись в устройство----------------------------------------------------------
if(cmdRunOut==1){if(cnfgA!=0xFF){               outA=extA; ddr=52;}  
                 if(cnfgB!=0xFF){               outB=extB; ddr=52;}}
if(cmdRunOut >1){if(cnfgA!=0xFF){if(outA!=extA){outA=extA; ddr=52;}} 
                 if(cnfgB!=0xFF){if(outB!=extB){outB=extB; ddr=52;}}}
cmdRunOut=0;
if(ddr==51){ddr=60;}												//--Пропуск записи
}	//---------------------------------------------------------------------------------------------
if(ddr==52){	//++++Запись в устройство----------------------------------------------------------
sendData();											//--Запись в устройство------------------------ 
if(err)    {ddr=90; sizeDelay=100; pointDelay=0;}	//--При ошибке переход ddr=0 через задержку 100ms;
if(action) {return;}   								//--Ожидание завершения записи;
            ddr=60;   								//--Переход на продолжение;
}	//---------------------------------------------------------------------------------------------
if(ddr==60){	//++++Успешное завершение----------------------------------------------------------
if(timeLimit==0){ddr=10; return;}
else            {ddr=90; sizeDelay=timeLimit; pointDelay=10;}	//--Переход на начало после задержки;
}	//--------------------------------------------------------------------------------------------- 
if(ddr==90){	//++++Фиксированная задержка-------------------------------------------------------
if(!RT_HW_Base.timeDelay(startDelay,workDelay,sizeDelay)){return;} ddr=pointDelay;
}	//---------------------------------------------------------------------------------------------
};	//++++END direct()=============================================================================
//=================================================================================================
void	getData(){	//++++Чтение из устройства=====================================================
if(step==0) {	//++++Подготовка внутренних параметров функции------------------------------------- 
action=1; err=0; cntErr=0; step=10;
}	//---------------------------------------------------------------------------------------------
if(step==10) {											
//---------------------------НЕТ ввода-------------------------------------------------------------
if((cnfgA==0) && (cnfgB==0)){action=0;            return;}  //--Нет ввода,Успешный выход; 
//---------------------------Только РA-ввод--------------------------------------------------------
if((cnfgA!=0) && (cnfgB==0)){
 if(!busReadRegs(RT_HW_MCP23x17_GPIOA,1))        {return;}	//--Ожидание завершения чтения:
 if(codeErr==0){inA=normIn(arr[0]); fresh=1;
				if(agoA!=inA){agoA=inA; fresh=2;}
				action=0;             			return;}	//--Успешный выход при чтении PA;
 else		   {step=85;                   pointDelay=10;}}	//--При ошибке повтор через динамическую задержку;
//---------------------------Только РB-ввод--------------------------------------------------------
if((cnfgA==0) && (cnfgB!=0)){
 if(!busReadRegs(RT_HW_MCP23x17_GPIOB,1))        {return;}	//--Ожидание завершения чтения:
 if(codeErr==0){inB=normIn(arr[0]); fresh=1;
				if(agoB!=inB){agoB=inB; fresh=2;}
				action=0;           			 return;}	//--Успешный выход при чтении PB;
 else		   {step=85;                   pointDelay=10;}}	//--При ошибке повтор через динамическую задержку;
//---------------------------РA и PB ввод-----------------------------------------------------------
if((cnfgA!=0) && (cnfgB!=0)){
 if(!busReadRegs(RT_HW_MCP23x17_GPIOA,2))        {return;}			//--Ожидание завершения чтения:
 if(codeErr==0){inA=normIn(arr[0]); inB=normIn(arr[1]); fresh=1;
				if(agoA!=inA){agoA=inA; fresh=2;}
				if(agoB!=inB){agoB=inB; fresh=2;}				
                action=0; return;}	//--Успешный выход при чтении PB;
 else		   {step=85;                   pointDelay=10;}}	//--При ошибке повтор через динамическую задержку;
}	//---------------------------------------------------------------------------------------------
if(step==85){	//++++Динамическая задержка--------------------------------------------------------
if(++cntErr>6){cntErr=6; codeErr=82; err=1;} sizeDelay=cntErr*cntErr*RT_HW_DEVICE_DELAY; step=90;
}	//---------------------------------------------------------------------------------------------
if(step==90){	//++++Фиксированная задержка-------------------------------------------------------
if(!RT_HW_Base.timeDelay(startDelay,workDelay,sizeDelay)){return;} step=pointDelay;
}	//---------------------------------------------------------------------------------------------
};	//====END getDatat()===========================================================================
//=================================================================================================
void	sendData(){	//++++Запись в устройство======================================================
if(step==0) {	//++++Подготовка внутренних параметров функции------------------------------------- 
action=1; err=0; cntErr=0; step=10;
}	//---------------------------------------------------------------------------------------------
if(step==10){   //++++Вывод========================================================================
//---------------------------НЕТ вывода------------------------------------------------------------
if((cnfgA==0xFF) && (cnfgB==0xFF)) {action=0; return;}  	//--Успешный выход;   
//---------------------------Только РA-вывод-------------------------------------------------------			
if((cnfgA!=0xFF) && (cnfgB==0xFF)) {
arr[0]=RT_HW_MCP23x17_GPIOA; arr[1]=normOut(outA); 			//--Подготовка данных для вывода;
if(!busSendBytes(2)){return;}								//--Отправка регистра и одного байта;
 if(codeErr==0){action=0;     				   return;}		//--Успешный выход при записи PA;
 else		   {step=85;                   pointDelay=10;}}	//--При ошибке повтор через динамическую задержку;			   
//---------------------------Только РB-вывод-------------------------------------------------------
if((cnfgA==0xFF) && (cnfgB!=0xFF)) {
arr[0]=RT_HW_MCP23x17_GPIOB; arr[1]=normOut(outB);  		//--Подготовка данных для вывода; 
if(!busSendBytes(2)){return;}								//--Отправка регистра и одного байта;
 if(codeErr==0){action=0;     				   return;}		//--Успешный выход при записи PB;
 else		   {step=85;                   pointDelay=10;}}	//--При ошибке повтор через динамическую задержку;			   	 	
//---------------------------PA и РB-вывод---------------------------------------------------------
if((cnfgA!=0xFF) && (cnfgB!=0xFF)) {
arr[0]=RT_HW_MCP23x17_GPIOA; arr[1]=normOut(outA); arr[2]=normOut(outB);//--Подготовка данных для вывода;
if(!busSendBytes(3)){return;}								//--Отправка регистра и одного байта;
 if(codeErr==0){action=0;     				  return;}		//--Успешный выход при записи PA и РВ;
 else		   {step=85;                   pointDelay=10;}}	//--При ошибке повтор через динамическую задержку;  
}//-------------------------------------------------------------------------------------------------
if(step==85){	//++++Динамическая задержка--------------------------------------------------------
if(++cntErr>6){cntErr=6; codeErr=82; err=1;} sizeDelay=cntErr*cntErr*RT_HW_DEVICE_DELAY; step=90;
}	//---------------------------------------------------------------------------------------------
if(step==90){	//++++Фиксированная задержка-------------------------------------------------------
if(!RT_HW_Base.timeDelay(startDelay,workDelay,sizeDelay)){return;} step=pointDelay;
}	//---------------------------------------------------------------------------------------------
};	//====END sendDatat()==========================================================================
//=================================================================================================
//							ИНИЦИАЛИЗАЦИЯ УСТРОЙСТВА
//--Направление бита регистра: =1-ввод, =0-вывод;
//--Режимы входов:=0 инвер.+подтяжка к Vcc; =1 инвер.;=2 - подтяжка к Vcc; =3-как есть;
//=================================================================================================
void init(){		//++++Инициализация устройства=================================================
if(step==0) {	//++++Подготовка внутренних параметров функции-------------------------------------           
workDelay=err=codeErr=0; action=1; 					//--Очистка параметров;
  cntErr=0; step=90; sizeDelay=50; pointDelay=10;	//--Переход на продолжение через задержку 50мс;     
}	//---------------------------------------------------------------------------------------------
if(step==10){	//++++Инициализация шины-----------------------------------------------------------
if(!busInitDevice()){return;}   								//--Инициализация шины;
if(codeErr){err=1; codeErr=80;         return;}					//--Выход по ошибке инициализации шины; 
else       {step=15;      cntFind=0; cntErr=0;}					//--Безусловный переход на продолжение;
}	//---------------------------------------------------------------------------------------------
if(step==15){	//++++Поиск устройства на шине i2c-------------------------------------------------
if(!busFindAdr()){return;};	  								  	//--Поиск устройства на  шине i2c;     	
if(codeErr){step=85;                pointDelay=15; cntFind=0;}	//--При ошибке переход на динамическую задержку; 
else       {step=90; sizeDelay=50;  pointDelay=15; cntErr=0;  	//--Переход на повторение поиска с задержкой 50ms;
            if(++cntFind>=3){step=20;  return;}              }	//--Переход на продолжение в следующем цикле после 3-кратного обнаружения;
}	//--------------------------------------------------------------------------------------------
if(step==20){	//++++Подготовка транзакции-------------------------------------------------------- 
arr[0]=RT_HW_MCP23x17_IODIRA; arr[1]=cnfgA; arr[2]=cnfgB; arr[3]=cnfgIPOLA; arr[4]=cnfgIPOLB; step=21;
};	//---------------------------------------------------------------------------------------------
if(step==21){	//++++Команда   настройки----------------------------------------------------------	
if(!busSendBytes(5)){return;}									//--Отправка команды;	  
if(codeErr){step=85;               pointDelay=15;}				//--При ошибке повтор через динамическую задержку; 
else       {step=90; sizeDelay=20; pointDelay=30; cntErr=0;}	//-При ok переход через фиксированную задержку 20ms;
}	//---------------------------------------------------------------------------------------------
if(step==30){	//++++Подготовка транзакции-------------------------------------------------------- 
arr[0]=RT_HW_MCP23x17_GPPUA; arr[1]=cnfgGPPUA; arr[2]=cnfgGPPUB; step=31;
}	//---------------------------------------------------------------------------------------------
if(step==31){	//++++Команда   настройки----------------------------------------------------------	
if(!busSendBytes(3)){return;} 									//--Отправка кода запроса состояния[0x71];  
if(codeErr){step=85;               pointDelay=15;}				//--При ошибке повтор через динамическую задержку; 
else       {step=90; sizeDelay=20; pointDelay=40; cntErr=0;}	//--При ok переход через фиксированную задержку 20ms;
}	//---------------------------------------------------------------------------------------------
if(step==40){	//++++Успешное завершение----------------------------------------------------------
action=0; step=0; return; 
}	//---------------------------------------------------------------------------------------------
//-------------------------------------------------------------------------------------------------
if(step==85){	//++++Динамическая задержка--------------------------------------------------------
if(++cntErr>6){cntErr=6; codeErr=82; err=1;} sizeDelay=cntErr*cntErr*RT_HW_DEVICE_DELAY; step=90;
}	//---------------------------------------------------------------------------------------------
if(step==90){	//++++Фиксированная задержка-------------------------------------------------------
if(!RT_HW_Base.timeDelay(startDelay,workDelay,sizeDelay)){return;} step=pointDelay;
}	//---------------------------------------------------------------------------------------------
};	//====END init()===============================================================================
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
uint8_t busInitDevice(){//++++Инициализация шины с контролеи адреса(i2c),cs(SPI),пинов(SPN)=======
if(mi=='I'){if(!RT_HW_Base.i2cInitDevice(codeErr,adr,bus)){return 0;} return 1;}//--i2c;
if(mi=='N'){            return 1;}												//--SPI;
if(mi=='n'){            return 1;}												//--SPN;
            codeErr=50; return 1;												//--ANON;						
};	//++++END busInitDevice()======================================================================	
uint8_t busFindAdr(){	//++++Поиск устройства=====================================================	
if(mi=='I'){if(!RT_HW_Base.i2cFindAdr(codeErr,adr,bus)){return 0;} return 1;}//--i2c;
if(mi=='N'){            return 1;}												//--SPI;
if(mi=='n'){            return 1;}												//--SPN;
            codeErr=50; return 1;												//--ANON;						
};	//++++END busFindAdr()=========================================================================	
uint8_t busSendBytes(uint8_t qnt){				//++++Запись qnt байт==============================
if(mi=='I'){if(!RT_HW_Base.i2cSendBytes(codeErr,arr,qnt,adr,bus,speed))   {return 0;} return 1;}//--i2c;
if(mi=='S'){codeErr=10; return 1;}																//--SPI;
if(mi=='s'){codeErr=20; return 1;}																//--SPN;
            codeErr=50; return 1;																//--ANON;						
};	//++++END busSendBytes()=======================================================================	
uint8_t busReadRegs(uint8_t reg, uint8_t qnt){	//++++Чтение с регистра(reg) qnt байт==============   
if(mi=='I'){if(!RT_HW_Base.i2cReadRegs(codeErr,reg,arr,qnt,adr,bus,speed)){return 0;} return 1;}//--i2c;  
if(mi=='N'){codeErr=11; return 1;}																//--SPI;
if(mi=='n'){codeErr=21; return 1;}																//--SPN;
            codeErr=51; return 1;																//--ANON;
};	//++++END busReadRegs()========================================================================	
//=================================================================================================
};		//++++END CLASS RT_HW_MCP23x17()
#endif
//=================================================================================================


//=================================================================================================
//=================================================================================================
//							Инициализация шин и поиск устройства для I2c
//=================================================================================================
/*
void mcp23x17_initBus(){
if(step==0) {err=0; action=1;
sizeDelay=0; //--Используется как служебный регистр в функции поиска i2cFindAdr()
	 if(mi=='I'){step=1;}
else if(mi=='S'){step=5;}
else if(mi=='s'){step=10;}
else {codeErr=10; err=1; return;}
sizeDelay=0; //--Используется как служебный регистр в функции поиска i2cFindAdr()
}
//-------------------------------------------------------------------------------------------------
if(step==1) {
	
	codeErr=RT_HW_Base.i2cInitMaster(bus); if(codeErr){err=1; return;}	//--Настройка шины i2c;
               sizeDelay=0; step++;}		//--sizeDelay используется как служебный регистр;



if(step==2) {if(!RT_HW_Base.i2cFindAdr(timeDelay,sizeDelay,adr,bus)){return;}; step=80;} //--Поиск устройства на шине i2c;
//-------------------------------------------------------------------------------------------------
if(step==5) {codeErr=10; err=1; return;}			//--Настройка шины SPI;
//-------------------------------------------------------------------------------------------------
if(step==10){codeErr=12; err=1; return;}			//--Настройка шины SPI;
//-------------------------------------------------------------------------------------------------
if(step==80){err=0;   action=0; return;}			//--Успешное заверешение;
//----------------------------------------------------------
}
*/


/*	
//=================================================================================================
// 						Настройка устройства
//--Направление бита регистра: =1-ввод, =0-вывод;
//--Режимы входов:=0 инвер.+подтяжка к Vcc; =1 инвер.;=2 - подтяжка к Vcc; =3-как есть;
//=================================================================================================	
void	initDevice(){
if(step==0) {	//++++Подготовка внутренних параметров функции------------------------------------- 
action=1;err=0; cntErr=0; step=10;
}	//---------------------------------------------------------------------------------------------
if(step==10){	//++++Подготовка транзакции-------------------------------------------------------- 
arr[0]=RT_HW_MCP23x17_IODIRA; arr[1]=cnfgA; arr[2]=cnfgB; arr[3]=cnfgIPOLA; arr[4]=cnfgIPOLB; 
step=11;
};	//---------------------------------------------------------------------------------------------
if(step==11){
if(!busSendBytes(5)){return;}
if(codeErr==0){step=20;  cntErr=0;}						//--При ok переход на продолжение;  
else          {step=85;               pointDelay=10;}	//--При ошибке повтор через динамическую задержку
}	//---------------------------------------------------------------------------------------------
if(step==20){	//++++Подготовка транзакции-------------------------------------------------------- 
arr[0]=RT_HW_MCP23x17_GPPUA; arr[1]=cnfgGPPUA; arr[2]=cnfgGPPUB; //--Подготовка транзакции;
step=21;
}	//---------------------------------------------------------------------------------------------
if(step==21){
if(!busSendBytes(3)){return;}
if(codeErr==0){step=30;  cntErr=0;}						//--При ok переход на продолжение; 
else          {step=85;               pointDelay=10;}	//--При ошибке повтор через динамическую задержку; 
}	//---------------------------------------------------------------------------------------------			
if(step==30){	//++++Успешный выход---------------------------------------------------------------
action=0; return;
}	//---------------------------------------------------------------------------------------------
if(step==85){	//++++Динамическая задержка--------------------------------------------------------
if(++cntErr>3){cntErr=3; codeErr=82; err=1;} sizeDelay=cntErr*cntErr*RT_HW_DEVICE_DELAY; step=90;
}	//---------------------------------------------------------------------------------------------
if(step==90){	//++++Фиксированная задержка-------------------------------------------------------
if(!RT_HW_Base.timeDelay(startDelay,workDelay,sizeDelay)){return;} step=pointDelay;
}	//---------------------------------------------------------------------------------------------
};	//====END init()===============================================================================
*/	