//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//     			 БИБЛИОТЕКА RT_HW_MCP4725(DAC) 
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//  ecoins (ecoins@mail.ru) 
//  2022-22-18: Begin version
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//-------------------------------------------------------------------------------------------------
#ifndef RT_HW_MCP4725_h
#define RT_HW_MCP4725_h
#define RT_HW_MCP4725_VER 		    10	//--Номер версии библиотеки;
#include "RT_HW_BASE.h"					//--Подключение базовой библиотеки;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//                     КЛАСС УПРАВЛЕНИЯ MCP4725 (DAC)
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class RT_HW_MCP4725{
public:
//-------------------------------------------------------------------------------------------------
uint8_t  custom=0;				//--Флаг настройки параметров;
uint8_t  ddr=0;					//--Управление этапами управления в функции direct();
uint8_t  bus=0;					//--Номер шины;
uint8_t  adr=0x60;				//--Адрес i2c по умолчанию;
uint32_t speed;					//--Для i2c-speed; SPI-speed(clock); SSPI-spped(time);
uint8_t  codeErr;				//--Код ошибки при обмене;
uint8_t  cntErr,cntFind;		//--Счетчики;
uint8_t  initDevice=0;			//--Флаг иниицализации устройства;
//----------------Параметры для функци timeDelay()--------------------------------------------------
uint32_t startDelay;		    //--Рабочий регистр;
uint8_t  workDelay=0;			//--Рабочий регистр; 
uint8_t  pointDelay;			//--Точка возврата из функции;
uint16_t sizeDelay;				//--Задержка для функции();		    
//-------------------------------------------------------------------------------------------------
uint8_t  bf[4];
uint8_t  cmdRun=0;       		//--Флаг для внешнего запуска измерений;
uint8_t  fresh,ok,action,err,vEEPROM=0;	//--Флаги;
uint16_t vDAC,var;					//--Измеренное значения;
uint8_t  run;
//=================================================================================================
void setParam(uint8_t veeprom, uint8_t vAdr, uint8_t vBus, uint32_t vSpeed){ //++++НАСТРОЙКА параметров
if(custom==0){	//++++Однократная настройка параметров---------------------------------------------
vEEPROM=veeprom; adr=vAdr; bus=vBus; speed=vSpeed; custom=1;}	//--Настройка адреса устройства,номера шины,скорости шины;
};	//+++++END setParam()==========================================================================
void direct(){
//-------------------------------------------------------------------------------------------------
if(run==1){                  vDAC=var; cmdRun=1;} 
if(run==2){if(vDAC!=var)    {vDAC=var; cmdRun=1;}} 
//-------------------------------------------------------------------------------------------------
if(ddr==0) {	//++++Начальная настройка----------------------------------------------------------	
workDelay=err=codeErr=cntErr=cntFind=initDevice=0; 		//--Инициализация рабочих параметров;
fresh=1; ok=0; vDAC=0;									//--Инициализация выходных параметров; 
            ddr=90; sizeDelay=50; pointDelay=10;		//--Переход на продолжение через 50ms;
}	//---------------------------------------------------------------------------------------------
if(ddr==10){	//++++Переход на инициализацию или на ожидание run---------------------------------
if(!cmdRun){return;} cmdRun=0; 
if(!initDevice){ddr=20;} else{ddr=30;}	
}	//---------------------------------------------------------------------------------------------
if(ddr==20){	//++++Инициализация шины-----------------------------------------------------------
if(!RT_HW_Base.i2cInitDevice(codeErr,adr,bus)){return;}     	//--Инициализация шины;
if(codeErr){ddr=10; err=1; codeErr=80; return;}			//--Выход по ошибке инициализации шины; 
else       {ddr=25;       cntFind=0; cntErr=0;}			//--Безусловный переход на продолжение;
}	//---------------------------------------------------------------------------------------------
if(ddr==25){	//++++Поиск устройства на шине i2c-------------------------------------------------
if(!RT_HW_Base.i2cFindAdr(codeErr,adr,bus,speed)){return;};		//--Поиск устройства на на шине i2c;     
//codeErr=RT_HW_Base.i2cGetCodeErr(bus);					//--Получение кода ошибки;  	
if(codeErr){ddr=85;                pointDelay=25; cntFind=0;}//--При ошибке переход на динамическую задержку; 
else       {ddr=90; sizeDelay=25;  pointDelay=25; cntErr=0;  //--Переход на повторение поиска с задержкой 50ms;
            if(++cntFind>=3){ddr=30;  initDevice=1;}}   //--Переход на продолжение в следующем цикле после 3-кратного обнаружения;
}	//--------------------------------------------------------------------------------------------
if(ddr==30){	//++++Ожидание cmdRun и подготовка параметров-------------------------------------
if(vEEPROM){bf[0]=0x60;} else{bf[0]=0x40;}    bf[1]= (vDAC / 16);  bf[2]=((vDAC % 16) <<4);
ddr=35;
}	//-------------------------------------------------					
if(ddr==35){
if(!RT_HW_Base.i2cSendBytes(codeErr,bf,3,adr,bus,speed)){return;}//--Запись команды записи; 	  
//codeErr=RT_HW_Base.i2cGetCodeErr(bus);					//--Получение кода ошибки; 
if(codeErr){ddr=85;               pointDelay=20;}		//--При ошибке повтор через динамическую задержку; 
else       {ddr=90; sizeDelay=10; pointDelay=10; cntErr=0;}//-При ok переход через фиксированную задержку 10ms;
}	//-------------------------------------------------------------------------------------------------
if(ddr==85){	//++++Динамическая задержка с выходом при многократной ошибке----------------------
if(++cntErr>3){cntErr=3; codeErr=84; err=1;} sizeDelay=cntErr*cntErr*RT_HW_DEVICE_DELAY; ddr=90;
}	//---------------------------------------------------------------------------------------------
if(ddr==90){	//++++Фиксированная задержка-------------------------------------------------------
if(!RT_HW_Base.timeDelay(startDelay,workDelay,sizeDelay)){return;} ddr=pointDelay;
}	//---------------------------------------------------------------------------------------------
};	//++++END direct()=============================================================================
};	//++++END class RT_HW_MCP4725==================================================================
#endif
//=================================================================================================

