/**************************************************************************************************
 *       БИБЛИОТЕКА ДЛЯ РАСШИРИТЕЛЯ ВЫВОДА
 *					74HC595  
 ***********************************************************
  Написана ecoins (ecoins@mail.ru) 
   2021.07.29: Полностью переработанная версия под библиотеку RT_HW_BASE.h; 
 ******************************************************************/
#ifndef RT_HW_CAR_UDP_h
#define RT_HW_CAR_UDP_h
#include "RT_HW_BASE.h"			//--Подключение библиотеки RT_HW_BASE.h
#define RT_HW_CAR__UDP_VER 	11		//--Номер версии библиотеки;
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//	СТРУКТУРА RT_HW_CAR
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
struct RT_HW_STRUCT_CAR_UDP{
//-----------------Параметр используемый для отладки-----------------------------------------------
uint8_t  custom=0;
uint8_t  step=0;
uint8_t  uart=0;				//--Номер порта UART (0-8 аппаратный, 9 программный);
uint16_t direct=0;				//--Биты управления;
uint8_t  speed=0;				//--Скорость в %;
char	 sign;					//--Код последнего принятого символа. Если связь отсутствует, то '#';
uint8_t  code;
uint8_t  errCode=0;
uint8_t  errCnt=0;
int32_t  speedUart=115200;		//--Скорость UART;
uint16_t timeOut=1000;			//--Тайм-аут на разрыв связи;
uint32_t timeStart;			//--Рабочий регистр;
};
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//		КЛАСС: RT_HW_HC595 	
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
class RT_HW_CAR_UDP{
public:
void setID    (RT_HW_STRUCT_CAR_UDP &id);
void getSign  (RT_HW_STRUCT_CAR_UDP &id);
void vectorCar(RT_HW_STRUCT_CAR_UDP &id);
};  //---END 
//==============  Конец класса ======================================================
extern RT_HW_CAR_UDP RT_HW_car_UDP; 	//--Создание объекта LCD типа HC595
//===================================================================================
#endif //---RT_HW_CAR_UDP_h



